/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/* artex71H src/artex/usr/include/artexerr.h 1.14.2.1                     */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* Restricted Materials of IBM                                            */
/*                                                                        */
/* COPYRIGHT International Business Machines Corp. 2008,2011              */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
/* @(#)94     1.14.2.1  src/artex/usr/include/artexerr.h, artex, artex71H, 1151A_71H 12/6/11 03:52:30 */

#ifndef _H_ARTEXERR
#define _H_ARTEXERR

typedef enum {
	ERR_NOERR = 0,
	ERR_INVAL,
	ERR_BADPROF,	/* Bad profile */
	ERR_BADCATL,	/* Bad catalog */
	ERR_PARSER,	/* XML Parser internal error */
	ERR_CMDFAIL,	/* External command failed */
	ERR_NOATTR,
	ERR_DIFF,
	ERR_MERGE,
	ERR_ALREADY,
        ERR_READONLY,
	ERR_LIST,	/* Error listing profile or catalog files */
	ERR_LOCK,	/* Error trying to acquire ARTEX lock */
	ERR_LOCKED,	/* Another ARTEX command is already running */
	ERR_BUILD,	/* Error while building profile files */
	ERR_PH2BIN,	/* Error while translating profile handle */
	ERR_PH2XML,	/* Error while translating profile into XML */
        ERR_OUT,        /* Out of range value for a call parameter */
	ERR_USAGE,
	ERR_MEM,
        ERR_MISSCMD,    /* Requested operation not defined in catalog */
        ERR_VERSION,    /* Error due to incompatible versions */
	ERR_LDAP,       /* LDAP error */
        ERR_DISCOVERY,  /* Target discovery error */
	ERR_MISSTARGET, /* Target mismatch */
	ERR_NOMEM,	/* Not enough memory */
	ERR_AUTH,	/* Not authorized to run command  */
	ERR_CHECK,	/* Check found differences */
} artexErr_t;

typedef enum {
	WARN_NOWARN = 0,
	WARN_CATSYNTAX,
	WARN_EXEC,
        WARN_NOCMD,
	WARN_PROF,	/* Recoverable error in profile */
	WARN_PARSER,	/* Profile and catalog parsing warning */
	WARN_VALID_XML,	/* Fail validating XML */
        WARN_SETPOSTOP,
        WARN_SET_CONTROLS,
	WARN_LIST,	/* Error listing profile or catalog files */
	WARN_DIFF,
	WARN_THREAD,
	WARN_MERGE,
	WARN_BUILD,	/* Recoverable error while building profile files */
	WARN_PH2XML,	/* Recoverable error while translating profile into XML */
	WARN_LDAP,      /* LDAP warning */
	WARN_VERSION,   /* Version warning */
        WARN_DISCOVERY,  /* Target discovery warning */
        WARN_FAILEDDISC, /* Target discovery warning */
	WARN_CATVERSION, /* Discrepancy between profile and catalog versions */
	WARN_CONF,	/* Problem with configuration file */
	WARN_PREREQ,	/* Prereq failed */
	WARN_EXCLUDE	/* Parameters exluced from output profile */
} artexWarn_t;


#endif

