/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/* bos71N src/bos/kernel/sys/cdli_entuser.lncent.h 1.5                    */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* Restricted Materials of IBM                                            */
/*                                                                        */
/* COPYRIGHT International Business Machines Corp. 2012,2013              */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */

#ifndef _H_CDLI_ENTUSER_LNCENT
#define _H_CDLI_ENTUSER_LNCENT

#include <sys/cdli_entuser.h>

#define ENT_LNC_TYPE                       0x10000000      /* Lancer            */
#define ENT_LNC_VF                         0x80000000      /* VF Type           */

#define ENT_LNC_10G_SR       (ENT_LNC_TYPE|0x00000001)     /* 10GbE SFP+SR      */
#define ENT_LNC_10G_BT       (ENT_LNC_TYPE|0x00000002)     /* 10GBaseT          */
#define ENT_LNC_10G_KR       (ENT_LNC_TYPE|0x00000004)     /* 10GbE KR          */
#define ENT_LNC_1G_BT        (ENT_LNC_TYPE|0x00000008)     /* 1GBaseT           */
#define ENT_LNC_10G_CU       (ENT_LNC_TYPE|0x00000010)     /* 10Gb SFP+Copper   */
#define ENT_LNC_10G_LR       (ENT_LNC_TYPE|0x00000020)     /* 10Gb SFP+LR      */


#define ENT_LNC_10G_SR_VF    (ENT_LNC_VF|ENT_LNC_10G_SR)   /* 10G SFP+SR VF     */
#define ENT_LNC_10G_BT_VF    (ENT_LNC_VF|ENT_LNC_10G_BT)   /* 10GBaseT VF       */
#define ENT_LNC_10G_KR_VF    (ENT_LNC_VF|ENT_LNC_10G_KR)   /* 10GbE KR VF       */
#define ENT_LNC_1G_BT_VF     (ENT_LNC_VF|ENT_LNC_1G_BT)    /* 1GBaseT VF        */
#define ENT_LNC_10G_CU_VF    (ENT_LNC_VF|ENT_LNC_10G_CU)   /* 10Gb SFP+CU VF    */
#define ENT_LNC_10G_LR_VF    (ENT_LNC_VF|ENT_LNC_10G_LR)   /* 10Gb SFP+LR VF     */


/* This structure is used for retrieving all the statistics for the device */

typedef  union {
    struct{
        ndd_genstats_t     ent_ndd_stats;
        ent_genstats_t     ent_gen_stats;
    };
    uint8_t reserved[8192];
} lncent_all_stats_t;

#ifndef  dd_all_stats_t
    #define  dd_all_stats_t     lncent_all_stats_t
#endif


#define HKWD_LNCENT_OTHER     (0x103c)
#define HKWD_LNCENT_RESPONSE  (0x103d)
#define HKWD_LNCENT_TRANSMIT  (0x103e)
#define HKWD_LNCENT_RECEIVE   (0x103f)

#endif /* _H_CDLI_ENTUSER_LNCENT */
