/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/* bos610 src/bos/kernext/disp/inc/voo_defs.h 1.1                         */
/*                                                                        */
/*                                                                        */
/*                                                                        */
/* OBJECT CODE ONLY SOURCE MATERIALS                                      */
/*                                                                        */
/* COPYRIGHT International Business Machines Corp. 1993,1994              */
/* All Rights Reserved                                                    */
/*                                                                        */
/* The source code for this program is not published or otherwise         */
/* divested of its trade secrets, irrespective of what has been           */
/* deposited with the U.S. Copyright Office.                              */
/*                                                                        */
/* @(#)88	1.1  src/bos/kernext/disp/inc/voo_defs.h, rcmrby, bos610 2/16/94 15:32:26 */
/* IBM_PROLOG_END_TAG                                                     */
/*
 * COMPONENT_NAME: rcmrby
 *
 * FUNCTIONS: Video defines and structures
 *
 * ORIGINS: 27
 *
 * (C) COPYRIGHT International Business Machines Corp. 1993
 * All Rights Reserved
 * Licensed Materials - Property of IBM
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */
#ifndef _H_VOO_DEFS
#define _H_VOO_DEFS

#include <sys/types.h>
#include <sys/param.h>
#include <stdio.h>
#include <sys/rcm_win.h>
#include <sys/aixgsc.h>

#include <sys/voo_info.h>

/*----------------------------------------------------------------------*/
/* Return codes                                                         */
/*----------------------------------------------------------------------*/
#define VID_SUCCESS              0      /* success - no problems        */
#define VID_IN_USE               16     /* Video already in-use         */
#define VID_VOO_GENLOCK_LOST     17     /* interrupted - Genlock_lost   */
#define VID_NOT_SUPPORTED        18     /* incorrect adapter            */
#define VID_VOO_NOT_INSTALLED    19     /* VOO not installed            */
#define VID_PCF_ACCESS_FAILED    20     /* write to pcfa failed         */
#define VID_BAD_CLUTBP_VALUE     32     /* clutbp value invalid         */
#define VID_BAD_GENLOCK_VALUE    33     /* genlock value invalid        */
#define VID_BAD_FORMAT_VALUE     34     /* format value invalid         */
#define VID_BAD_COLOR_VALUE      35     /* color value invalid          */
#define VID_BAD_CHROM_VALUE      36     /* chrom value invalid          */
#define VID_BAD_PHASE_VALUE      37     /* phase value invalid          */
#define VID_BAD_FREQ_VALUE       38     /* freq value invalid           */
#define VID_BAD_SIGNAL_VALUE     39     /* signal value invalid         */
#define VID_BAD_MODE             40     /* mode field invalid           */
#define VID_BAD_CLUT_POINTER     41     /* CLUT pointer is NULL         */
#define VID_BAD_OPTIONS_POINTER  42     /* options pointer is NULL      */
#define VID_MAX_ENTRIES_EXCEEDED 64     /* no monitor array slots avail */
/*----------------------------------------------------------------------*/
/* "valuemask" values for VidSetVooOptions                              */
/*----------------------------------------------------------------------*/
#define VidVooOptCLUTBP         (1L << 0)
#define VidVooOptGenlock        (1L << 1)
#define VidVooOptFormat         (1L << 2)
#define VidVooOptColor          (1L << 3)
#define VidVooOptChrom          (1L << 4)
#define VidVooOptPhase          (1L << 5)
#define VidVooOptFreq           (1L << 6)

#endif /* _H_VOO_DEFS */

