/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/* bos71c src/bos/kernel/sys/trchkid.h 1.96.37.27                         */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* COPYRIGHT International Business Machines Corp. 1988,2018              */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
/* @(#)08	1.96.37.27  src/bos/kernel/sys/trchkid.h, systrace, bos71c, c2018_49B1 8/24/18 14:44:15 */
/*
 * COMPONENT_NAME:            include/sys/trchkid.h
 *
 * FUNCTIONS: header file for system trace hookwords
 *
 * ORIGINS: 27, 83
 *
 * LEVEL 1, 5 Years Bull Confidential Information
 */

/* All major hook id's should begin with HKWD_, and all minor hook id's
   should begin with hkwd_.
*/

#ifndef _H_TRCHKID
#define _H_TRCHKID

#include "sys/trcmacros.h"

#define HKWD_TRACE                0x00000000
#define HKWD_TRACE_SYNC           0x00000000
#define HKWD_TRACE_TRCON          0x00100000
#define HKWD_TRACE_TRCOFF         0x00200000
#define HKWD_TRACE_HEADER         0x00300000
#define HKHDR_UTS		  0x1	/* uts data */
#define HKHDR_CMD		  0x2	/* trace command */
#define HKHDR_ALL		  0x3	/* tracing all hooks */
#define HKHDR_INCL		  0x4	/* tracing only these hooks */
#define HKHDR_EXCL		  0x5	/* Exclude these hooks */
#define HKHDR_HKBM1		  0x6	/* traced hooks bit map, part 1 */
#define HKHDR_HKBM2		  0x7	/* traced hooks bit map, part 2 */
#define HKHDR_MSG 		  0xff	/* message */

#define HKWD_TRACE_NULL           0x00400000
#define HKWD_TRACE_LWRAP          0x00500000
#define HKWD_TRACE_TWRAP          0x00600000
#define HKWD_TRACE_UNDEFINED      0x00700000
#define HKWD_TRACE_DEFAULT        0x00800000
#define HKWD_TRACE_ERR            0x00900000
#define HKWD_TRACE_UTIL           0x00A00000
#define HKWD_TRACE_UNMANAGED      0x100B0000
/* Utility hook types */
#define HKUT_TSYNC 		  0x0	/* Timer sync, 32-bit only */
#define HKUT_PID		  0x1	/* process info */
#define HKUT_LDR		  0x2	/* loader info */
#define HKUT_CPID		  0x3	/* current pid info */
#define HKUT_DEV		  0x4	/* device info */
#define HKUT_IP			  0x5	/* IP addr */
#define HKUT_BUFF		  0x6	/* buffer allocation scheme */
#define HKUT_CPUMAP  		  0x7	/* cpu usage map */
#define HKUT_SYM		  0xc	/* symbol address */
#define HKUT_TIME		  0x25c	/* Time conversion data */
#define HKUT_CPUFILE		  0x10	/* id/name for cpu file */
#define HKUT_CPUF2  		  0x11	/* base logfile for this cpu file */
#define HKUT_CPUS		  0x12	/* total and traced # cpus */
#define HKUT_LDT 		  0x13	/* indicate large data types */
#define HKUT_REGS 		  0x14	/* programmable registers */
#define HKUT_IVALS 		  0x15	/* initial register values */
#define HKUT_LONGPID      	  0x16  /* process info with long process name */
#define HKUT_CTFILE               0x17  /* name for component trace file */
#define HKUT_CTF2                 0x18  /* base logfile for this CT file */
#define HKUT_MTRC_TSYNC           0x19  /* LMT Timestamp, 32-bit only */
#define HKUT_MTRC_SUSPEND         0x1a  /* LMT Suspend,   32-bit only */
#define HKUT_MTRC_RESTART         0x1b  /* LMT Restart,   32-bit only */
#define HKUT_PROC_SLIB            0x1c  /* proc info with named slib */
#define HKUT_VSID_NAME            0x1d  /* VSID to name mapping for slibs */
#define HKUT_DAEMON               0x1e  /* force trace daemon ident into buffer */
#define HKUT_LDR_PROC_LDINFO      0x1f  /* Process memory mapping */
#define HKUT_PROC_WPAR            0x20  /* proc info with WPARs cid */
#define HKUT_WPAR                 0x21  /* id/name of active wpars */

#define HKWD_6432	          0x00B00000	/* 64-bit hook in 32-bit trc */

#define HKWD_USER1                0x01000000
#define HKWD_USER2                0x02000000
#define HKWD_USER3                0x03000000
#define HKWD_USER4                0x04000000
#define HKWD_USER5                0x05000000
#define HKWD_USER6                0x06000000
#define HKWD_USER7                0x07000000
#define HKWD_USER8                0x08000000
#define HKWD_USER9                0x09000000
#define HKWD_USERA                0x0a000000
#define HKWD_USERB                0x0b000000
#define HKWD_USERC                0x0c000000
#define HKWD_USERD                0x0d000000
#define HKWD_USERE                0x0e000000
#define HKWD_USERAIX              0x0f000000

#define HKWD_KERN_FLIH            0x10000000
#define HKWD_KERN_SVC             0x10100000    /* common SVC entry */
#define HKWD_KERN_SLIH            0x10200000
#define HKWD_KERN_SLIHRET         0x10300000
#define HKWD_KERN_SYSCRET         0x10400000    /* common SVC return */
#define HKWD_KERN_LVM             0x10500000    /* LVM bad blk/resync flow */
#define HKWD_KERN_DISPATCH        0x10600000
#define HKWD_KERN_DISPATCH_SRAD   0x101D0000    /* SRAD information */
#define HKWD_KERN_DISP_AFFIN   	  0x101E0000    /* Affinity dispatch changes */
#define HKWD_KERN_UNDISP          0x4B000000
#define HKWD_KERN_LVMSIMP         0x10B00000    /* LVM simple request flow */
#define HKWD_KERN_IDLE            0x10C00000    /* Dispatching idle process */
#define HKWD_KERN_RELOCK          0x10e00000	/* ownership games wi RQ lock */
#define HKWD_KERN_EOF             0x10f00000
#define HKWD_KERN_STDERR          0x11000000
#define HKWD_KERN_LOCKF           0x11100000
#define HKWD_KERN_LOCK            0x11200000	
#define HKWD_KERN_UNLOCK          0x11300000	
#define HKWD_KERN_LOCKALLOC       0x11400000	
#define HKWD_KERN_SETRECURSIVE    0x11500000	

#define HKWD_KERN_XMALLOC         0x11600000
#define HKWD_KERN_XMFREE          0x11700000
#define HKWD_KERN_FORKCOPY        0x11800000
#define HKWD_KERN_PIDSIG          0x11900000
#define HKWD_KERN_RCVSIGNAL       0x11a00000
#define HKWD_KERN_P_SLIH          0x11c00000
#define HKWD_KERN_SIG_SLIH        0x11d00000
#define HKWD_KERN_ISSIG           0x11e00000
#define HKWD_KERN_SORQ            0x11f00000
#define HKWD_KERN_RESUME          0x20000000
#define HKWD_KERN_HFT             0x20100000
#define HKWD_KERN_KTSM            0x20200000
#define HKWD_KERN_CON             0x20300000
#define HKWD_KERN_SCHED_SWAPIN	  0X20400000
#define HKWD_KERN_SCHED_SWAPOUT   0X20500000
#define HKWD_KERN_SCHED_POST	  0x20600000
#define HKWD_KERN_SCHED		  0x20700000
#define HKWD_KERN_SCHED_STAT	  0x20800000
#define HKWD_KERN_SCHED_STAT1	  0x20900000
#define HKWD_KERN_SCRUB_DISABLE	  0x20A00000
#define HKWD_KERN_SCRUB_ENABLE	  0x20B00000
#define HKWD_KERN_SCRUB_SEG	  0x20C00000
#define HKWD_KERN_SCRUB_SOFT	  0x20D00000
#define HKWD_KERN_LOCKL           0x20E00000
#define HKWD_KERN_UNLOCKL         0x20F00000
#define HKWD_KERN_INITP		  0x21000000
#define HKWD_KERN_PHANTOM_EXTINT  0x47F00000
#define HKWD_KERN_IOPATH_DATA	  0x49100000
#define HKWD_KERN_VPM		  0x63C00000
#define HKWD_KERN_IODONE	  0x10440000

/*
 * "sub-hookids"
 */
#define hkwd_VMUIOMOVE_READ	0
#define hkwd_VMUIOMOVE_WRITE	1

#define LOCK_TAKEN          1
#define LOCK_MISS           2
#define LOCK_RECURSIVE      3
#define LOCK_BUSY      	    4

#define SETRECURSIVE        1
#define CLEARRECURSIVE      2

/* KERN_SORQ sub-hookids */
#define hkwd_IDLE_SIB_FOUND	    0x01
#define hkwd_IDLE_SIB_NOTFOUND	    0x02
#define hkwd_LATENCY_WAITER	    0x03

/* *** START FILESYSTEM HOOKS *** */

/* Note: All filesystem related subhooks for kernel filesystem
 * components are in fs_subhook.h
 *
 * AIO related subhooks are in sysxaio_trc.h
 */
#ifdef _KERNEL
#include <sys/fs_subhook.h>
#endif

/*
 * LFS hook and sub-hook ids (Component syslfs)
 */

/* All vnops should appear in the following list: */ 
#define HKWD_VNOP_ACCESS	0x12000000      /* vnop_access */
#define HKWD_VNOP_CLOSE         0x12e00000      /* vnop_close */
#define HKWD_VNOP_CREATE        0x13000000	/* vnop_create,
						   vnop_create_attr,
						   vnop_mknod */
#define HKWD_VNOP_FCLEAR        0x13600000      /* vnop_fclear */
#define HKWD_VNOP_FID           0x4cb00000      /* vnop_fid */
#define HKWD_VNOP_FINFO         0x4f100000      /* vnop_finfo */
#define HKWD_VNOP_FSYNC         0x13c00000      /* vnop_fsync,
						   vnop_fsync_range */
#define HKWD_VNOP_FTRUNC        0x13d00000      /* vnop_ftrunc */
#define HKWD_VNOP_GETACL        0x4cc00000      /* vnop_getacl,
						   vnop_getxacl */
#define HKWD_VNOP_GETATTR       0x13a00000      /* vnop_getattr */
#define HKWD_VNOP_GETEA         0x4ce00000      /* vnop_getea */
#define HKWD_VNOP_GETPCL        0x4d200000      /* vnop_getpcl */
#define HKWD_VNOP_IOCTL         0x14c00000      /* vnop_ioctl */
#define HKWD_VNOP_LINK          0x15000000      /* vnop_link */
#define HKWD_VNOP_LISTEA        0x4d000000      /* vnop_listea */
#define HKWD_VNOP_LOCKCTL       0x15200000      /* vnop_lockctl */
#define HKWD_VNOP_LOOKUP	0x10700000      /* vnop_lookup,
						   lookuppn */
#define HKWD_VNOP_MAP           0x4ef00000      /* vnop_map */
#define HKWD_VNOP_MEMCNTL       0x4d500000      /* vnop_memcntl */
#define HKWD_VNOP_MKDIR         0x15600000      /* vnop_mkdir */
#define HKWD_VNOP_OPEN          0x15b00000      /* vnop_open */
#define HKWD_VNOP_READDIR       0x1a000000      /* vnop_readdir */
#define HKWD_VNOP_READLINK      0x16400000      /* vnop_readlink */
#define HKWD_VNOP_REMOVEEA      0x4d100000      /* vnop_removeea */
#define HKWD_VNOP_RENAME        0x16700000      /* vnop_rename */
#define HKWD_VNOP_REVOKE        0x4d400000      /* vnop_revoke */
#define HKWD_VNOP_RDWR_READ     0x16300000      /* vnop_rdwr (read),
						   vnop_rdwr_attr (read) */
#define HKWD_VNOP_RDWR_WRITE    0x19c00000      /* vnop_rdwr (write),
						   vnop_rdwr_attr (write) */
#define HKWD_VNOP_RMDIR         0x16800000      /* vnop_rmdir */
#define HKWD_VNOP_SEEK          0x15400000      /* vnop_seek */
#define HKWD_VNOP_SETACL        0x4cd00000      /* vnop_setacl */
#define HKWD_VNOP_SETATTR	0x12900000      /* vnop_setattr */
#define HKWD_VNOP_SETEA         0x4cf00000      /* vnop_setea */
#define HKWD_VNOP_SETPCL        0x4d300000      /* vnop_setpcl */
#define HKWD_VNOP_STATEA        0x4f200000      /* vnop_statea */
#define HKWD_VNOP_SYMLINK       0x18b00000      /* vnop_symlink */
#define HKWD_VNOP_REMOVE        0x19400000      /* vnop_remove */
#define HKWD_VNOP_UNMAP         0x4f000000      /* vnop_unmap */
#define HKWD_VNOP_HOLD          0x4db00000      /* vnop_hold,
						   vnop_rele */
#define HKWD_LOCK_DUMP          0x10860000      /* lock_dump in lockctl.c */

/* Ignored:                                        vnop_select,
 *                                                 vnop_strategy
 */
/* end vnops */
#define HKWD_KCOPYFILE          0x67300000      /* kcopyfile */


/* All vfsops should appear in the following list: */
#define HKWD_VFS_ACLXCNTL       0x4da00000      /* vfs_aclxcntl */
#define HKWD_VFS_CNTL           0x4d800000      /* vfs_cntl */
#define HKWD_VFS_MOUNT          0x15900000      /* vfs_mount */
#define HKWD_VFS_QUOTACTL       0x4d900000      /* vfs_quotactl */
#define HKWD_VFS_ROOT           0x4d600000      /* vfs_root */
#define HKWD_VFS_STATFS         0x13b00000      /* vfs_statfs, vfs_statfsvp */
#define HKWD_VFS_SYNC           0x4d700000      /* vfs_sync, vfs_syncvfs */
#define HKWD_VFS_UNMOUNT        0x19100000      /* vfs_unmount */
#define HKWD_VFS_VGET		0x3ec00000	/* vfs_vget, vnode_cache */
/* end vfsops */

#define HKWD_PILE               0x4dc00000      /* pile subsystem */
#define HKWD_NLC                0x4dd00000      /* nlc subsystem */

/*
 * J2 hook and sub-hook ids (Component sysj2)
 */    
#define HKWD_J2_BUFMGR          0x4de00000      /* metadata cache */
#define HKWD_J2_ICACHE          0x4df00000      /* inode cache */
#define HKWD_J2_SNAPSHOT        0x4e000000      /* snapshot ops */
#define HKWD_J2_DMAP            0x4e100000      /* block map */
#define HKWD_J2_GLOBAL          0x4e200000      /* global events */
#define HKWD_J2_LOGMGR          0x4e300000      /* log manager */
#define HKWD_J2_TXNMGR          0x4e400000      /* transaction manager */
#define HKWD_J2_IO              0x59b00000      /* userdata ops */
#define HKWD_J2_XTREE           0x10770000      /* xtree manager */

/*
 * KDM operations (Component syskdm)
 */
#define HKWD_KDM                0x4e500000      /* kdm operations */

/*
 * AIO operations (Component sysxaio)
 */
#define HKWD_AIO                0x38d00000      /* aio operations */

/*
 * JFS hook and sub-hook ids (Component syspfs)
 */
#define HKWD_KERN_PFS     0x10a00000
#define HKWD_KERN_VFSINO  0x10d00000

#define HKWD_DIO	  0x3b100000	/* JFS: General Direct IO events   */
#define HKWD_DIO_IO	  0x3b200000	/* JFS: Direct IO startio/iodone   */
#define HKWD_DIO_PSEG	  0x3b300000	/* JFS: Direct IO requests demoted */

/* GRAVEYARD: All FS hooks past here are deprecated or unused, or
 * these are old names for current hooks. Do NOT use these names or
 * these hookids without first consulting the syslfs owner.
 *
 * NOTE: Do not define any real FS hook after the graveyard. The first
 * #define for a given hookid must be the main one for kdb_trace.h to
 * be effective.
 */
#define HKWD_LFS_LOOKUP	        HKWD_VNOP_LOOKUP      /* deprecated old name */
#define HKWD_SYSC_ACCESS        HKWD_VNOP_ACCESS      /* deprecated old name */
#define HKWD_SYSC               HKWD_VNOP_ACCESS      /* deprecated old name */
#define HKWD_SYSC_CHMOD	        HKWD_VNOP_SETATTR     /* deprecated old name */
#define HKWD_SYSC_CHOWN         HKWD_VNOP_SETATTR     /* deprecated old name */
#define HKWD_SYSC_CHOWNX        HKWD_VNOP_SETATTR     /* deprecated old name */
#define HKWD_SYSC_FCHMOD        HKWD_VNOP_SETATTR     /* deprecated old name */
#define HKWD_SYSC_FCHOWN        HKWD_VNOP_SETATTR     /* deprecated old name */
#define HKWD_SYSC_CLOSE         HKWD_VNOP_CLOSE       /* deprecated old name */
#define HKWD_SYSC_CLOSEX        HKWD_VNOP_CLOSE       /* deprecated old name */
#define HKWD_SYSC_CREAT         HKWD_VNOP_CREATE      /* deprecated old name */
#define HKWD_SYSC_MKNOD         HKWD_VNOP_CREATE      /* deprecated old name */
#define HKWD_SYSC_FCLEAR        HKWD_VNOP_FCLEAR      /* deprecated old name */
#define HKWD_SYSC_FSTAT         HKWD_VNOP_GETATTR     /* deprecated old name */
#define HKWD_SYSC_FFULLSTAT     HKWD_VNOP_GETATTR     /* deprecated old name */
#define HKWD_SYSC_FULLSTAT      HKWD_VNOP_GETATTR     /* deprecated old name */
#define HKWD_SYSC_STAT          HKWD_VNOP_GETATTR     /* deprecated old name */
#define HKWD_SYSC_STATX         HKWD_VNOP_GETATTR     /* deprecated old name */
#define HKWD_SYSC_LSTAT         HKWD_VNOP_GETATTR     /* deprecated old name */
#define HKWD_SYSC_FSYNC         HKWD_VNOP_FSYNC       /* deprecated old name */
#define HKWD_SYSC_FTRUNCATE     HKWD_VNOP_FTRUNC      /* deprecated old name */
#define HKWD_SYSC_IOCTL         HKWD_VNOP_IOCTL       /* deprecated old name */
#define HKWD_SYSC_IOCTLX        HKWD_VNOP_IOCTL       /* deprecated old name */
#define HKWD_SYSC_LINK          HKWD_VNOP_LINK        /* deprecated old name */
#define HKWD_SYSC_LOCKF         HKWD_VNOP_LOCKCTL     /* deprecated old name */
#define HKWD_SYSC_LSEEK         HKWD_VNOP_SEEK        /* deprecated old name */
#define HKWD_SYSC_MKDIR         HKWD_VNOP_MKDIR       /* deprecated old name */
#define HKWD_SYSC_OPEN          HKWD_VNOP_OPEN        /* deprecated old name */
#define HKWD_SYSC_OPENX         HKWD_VNOP_OPEN        /* deprecated old name */
#define HKWD_SYSC_READ          HKWD_VNOP_RDWR_READ   /* deprecated old name */
#define HKWD_SYSC_READX         HKWD_VNOP_RDWR_READ   /* deprecated old name */
#define HKWD_SYSC_WRITE         HKWD_VNOP_RDWR_WRITE  /* deprecated old name */
#define HKWD_SYSC_WRITEX        HKWD_VNOP_RDWR_WRITE  /* deprecated old name */
#define HKWD_SYSC_READLINK      HKWD_VNOP_READLINK    /* deprecated old name */
#define HKWD_SYSC_RENAME        HKWD_VNOP_RENAME      /* deprecated old name */
#define HKWD_SYSC_RMDIR         HKWD_VNOP_RMDIR       /* deprecated old name */
#define HKWD_SYSC_SYMLINK       HKWD_VNOP_SYMLINK     /* deprecated old name */
#define HKWD_SYSC_UNLINK        HKWD_VNOP_REMOVE      /* deprecated old name */
#define HKWD_SYSC_GETDIRENTRIES HKWD_VNOP_READDIR     /* deprecated old name */

#define HKWD_SYSC_MOUNT         HKWD_VFS_MOUNT        /* deprecated old name */
#define HKWD_SYSC_VMOUNT        HKWD_VFS_MOUNT        /* deprecated old name */
#define HKWD_SYSC_FSTATFS       HKWD_VFS_STATFS       /* deprecated old name */
#define HKWD_SYSC_STATFS        HKWD_VFS_STATFS       /* deprecated old name */
#define HKWD_SYSC_USTAT         HKWD_VFS_STATFS       /* deprecated old name */
#define HKWD_SYSC_SYNC          HKWD_VFS_SYNC         /* deprecated old name */
#define HKWD_SYSC_UMOUNT        HKWD_VFS_UNMOUNT      /* deprecated old name */
#define HKWD_SYSC_UVMOUNT       HKWD_VFS_UNMOUNT      /* deprecated old name */
#define HKWD_JFS_VNC		HKWD_VFS_VGET         /* deprecated old name */

#define HKWD_KERN_LFS           0x10900000    /* XXX: UNUSED */
#define HKWD_SYSC_CHDIR         0x12700000    /* XXX: UNUSED */
#define HKWD_OLD_CHOWN          0x12a00000    /* XXX: UNUSED */
#define HKWD_OLD_CHOWNX         0x12b00000    /* XXX: UNUSED */
#define HKWD_SYSC_CHROOT        0x12d00000    /* XXX: UNUSED */
#define HKWD_OLD_CLOSEX         0x12f00000    /* XXX: UNUSED */
#define HKWD_SYSC_DUP           0x13300000    /* XXX: UNUSED */
#define HKWD_SYSC_FCNTL         0x13700000    /* XXX: UNUSED */
#define HKWD_OLD_FFULLSTAT      0x13800000    /* XXX: UNUSED */
#define HKWD_OLD_FULLSTAT       0x13e00000    /* XXX: UNUSED */
#define HKWD_OLD_IOCTLX         0x14d00000    /* XXX: UNUSED */
#define HKWD_OLD_MKNOD          0x15700000    /* XXX: UNUSED */
#define HKWD_SYSC_MNTCTL        0x15800000    /* XXX: UNUSED */
#define HKWD_OLD_STAT           0x18600000    /* XXX: UNUSED */
#define HKWD_OLD_STATX          0x18800000    /* XXX: UNUSED */
#define HKWD_OLD_OPENX          0x15c00000    /* XXX: UNUSED */
#define HKWD_OLD_READX          0x16500000    /* XXX: UNUSED */
#define HKWD_OLD_STATFS         0x18700000    /* XXX: UNUSED */
#define HKWD_OLD_SYNC           0x18c00000    /* XXX: UNUSED */
#define HKWD_SYSC_UNAME         0x19200000    /* XXX: UNUSED */
#define HKWD_SYSC_UNAMEX        0x19300000    /* XXX: UNUSED */
#define HKWD_OLD_USTAT          0x19600000    /* XXX: UNUSED */
#define HKWD_OLD_UVMOUNT        0x19900000    /* XXX: UNUSED */
#define HKWD_OLD_VMOUNT         0x19a00000    /* XXX: UNUSED */
#define HKWD_OLD_WRITEX         0x19d00000    /* XXX: UNUSED */
#define HKWD_OLD_FCHMOD         0x19e00000    /* XXX: UNUSED */
#define HKWD_OLD_FCHOWN         0x19f00000    /* XXX: UNUSED */
#define HKWD_OLD_LSTAT          0x1a100000    /* XXX: UNUSED */
#define HKWD_JFS_DNLC           0x3ed00000    /* XXX: UNUSED */

#define HKWD_SYSC_PIPE          0x15f00000    /* Deprecated */

/* NOTE: HKWD_SYSC_LFS is deprecated. Use specific hookids for each
 * vnop or use the "lfs" trace group.
 */
#define HKWD_SYSC_LFS     0x10800000    /* file system system call */

/* NOTE: HKWD_KERN_J2 is dead. The subhooks have been entirely
 * replaced by full vnode op hooks in the LFS layer.
 */
#define HKWD_KERN_J2      0x3f700000    /* JFS2: vnode operation events */

/* NOTE: HKWD_KERN_J2PAGER is dead. Use 59b (HKWD_IO_J2) to track
 * userdata I/O and other hookwords to track other I/O.
 */
#define HKWD_KERN_J2PAGER 0x3f800000 	/* JFS2: pager events */

/* NOTE: HKWD_DIO_J2 is dead. Use 59b (HKWD_IO_J2) to track userdata
 * I/O, including DIO.
 */
#define HKWD_DIO_J2       0x59c00000	/* JFS2: direct I/O */

#define HKWD_IO_J2        HKWD_J2_IO    /* deprecated old name */

/* *** STOP FILESYSTEM HOOKS *** */


/*--------------------------------------------------------------
 * LVM device driver hooks and sub-hookids
 */

/* LVM Hooks
 *     NOTE: 2 LVM Hooks are defined above (105 and 10B).
 *     NOTE: LVM sub-hooks are defined in lvdd_trchkid.h
 */

#define HKWD_KERN_LVM_NONIO     0x39300000      /* LVM non-I/O hook ID    */
#define HKWD_KERN_LVM_CFG       0x5D400000      /* LVM config operations  */
#define HKWD_KERN_LVM_CONC      0x5D500000      /* LVM concurrent ops     */
#define HKWD_KERN_LVM_D         0x5D600000      /* LVM general debug hook */
#define HKWD_KERN_LVM_ERR       0x5D700000      /* LVM error path         */

#include <sys/lvdd_trchkid.h>
/*
 * END LVM Hooks...
 *----------------------------------------------------------------------*/



#define HKWD_SYSC_ACCT            0x12100000
#define HKWD_SYSC_ALARM           0x12200000
#define HKWD_SYSC_AUDIT           0x12300000
#define HKWD_SYSC_AUDITLOG        0x12400000
#define HKWD_SYSC_AUDITPROC       0x12500000
#define HKWD_SYSC_AUDITSYS        0x12600000
#define HKWD_SYSC_CHMAC           0x12800000
#define HKWD_SYSC_CHPRIV          0x12c00000
#define HKWD_SYSC_DISCLAIM        0x13100000
#define HKWD_SYSC_DISCLAIM64	  0x13100010
#define HKWD_SYSC_EXECVE          0x13400000
#define HKWD_SYSC__EXIT           0x13500000
#define HKWD_SYSC_FORK		  0x13900000
#define hkwd_SYSC_FORK_LIMIT      	0x01  /* Subhook for exceeding process limit */
#define hkwd_SYSC_FORK_PREPARE      	0x02  /* Subhook for ld_fork_prepare failure */
#define hkwd_SYSC_FORK_TM		0x03  /* Subhook for calling
					       * fork while in a
					       * transaction. */
#define HKWD_SYSC_GETEGID         0x13f00000
#define HKWD_SYSC_GETEPRIV        0x14000000
#define HKWD_SYSC_GETEUID         0x14100000
#define HKWD_SYSC_GETGID          0x14200000
#define HKWD_SYSC_GETGROUPS       0x14300000
#define HKWD_SYSC_GETMPRIV        0x14400000
#define HKWD_SYSC_GETPGRP         0x14500000
#define HKWD_SYSC_GETPID          0x14600000
#define HKWD_SYSC_GETPPID         0x14700000
#define HKWD_SYSC_GETPRIV         0x14800000
#define HKWD_SYSC_GETTSTATE       0x14900000
#define HKWD_SYSC_GETUID          0x14a00000
#define HKWD_SYSC_GTTY            0x14b00000
#define HKWD_SYSC_KILL            0x14e00000
#define HKWD_SYSC_KPRINTF         0x14f00000
#define HKWD_SYSC_LOADTBL         0x15100000
#define HKWD_SYSC_LOCKX           0x15300000
#define HKWD_SYSC_MACCTL          0x15500000
#define HKWD_SYSC_NICE            0x15a00000
#define HKWD_SYSC_OUNAME          0x15d00000
#define HKWD_SYSC_PAUSE           0x15e00000
#define HKWD_SYSC_PLOCK           0x16000000
#define HKWD_SYSC_PROFIL          0x16100000
#define HKWD_SYSC_PTRACE          0x16200000
#define HKWD_SYSC_REBOOT          0x16600000
#define HKWD_SYSC_SBREAK          0x16900000
#define HKWD_SYSC_SELECT          0x16a00000
#define HKWD_SYSC_SETGID          0x16b00000
#define HKWD_SYSC_SETGROUPS       0x16c00000
#define HKWD_SYSC_SETMAC          0x16d00000
#define HKWD_SYSC_SETPGRP         0x16e00000
#define HKWD_SYSC_SETPRIO         0x16f00000
#define HKWD_SYSC_SETPRIV         0x17000000
#define HKWD_SYSC_SETREUID        0x17100000
#define HKWD_SYSC_SETTSTATE       0x17200000
#define HKWD_SYSC_SETUID          0x17300000
#define HKWD_SYSC_SIGACTION       0x18000000
#define HKWD_SYSC_SIGCLEANUP      0x18100000
#define HKWD_SYSC_SIGPROCMASK     0x18200000
#define HKWD_SYSC_SIGRETURN       0x18300000
#define HKWD_SYSC_SIGSTACK        0x18400000
#define HKWD_SYSC_SIGSUSPEND      0x18500000
#define HKWD_SYSC_STIME           0x18900000
#define HKWD_SYSC_STTY            0x18a00000
#define HKWD_SYSC_TIME            0x18d00000
#define HKWD_SYSC_TIMES           0x18e00000
#define HKWD_SYSC_ULIMIT          0x18f00000
#define HKWD_SYSC_UMASK           0x19000000
#define HKWD_SYSC_USRINFO         0x19500000
#define HKWD_SYSC_UTIME           0x19700000
#define HKWD_SYSC_UTSSYS          0x19800000
#define HKWD_SYSC_WAIT            0x19b00000
#define HKWD_SYSC_UTIMES          0x1a200000
#define HKWD_SYSC_SLOOKUP         0x1a300000
#define HKWD_SYSC_GETRLIMIT       0x1a400000
#define HKWD_SYSC_SETRLIMIT       0x1a500000
#define HKWD_SYSC_GETRUSAGE       0x1a600000
#define HKWD_SYSC_GETPRIORITY     0x1a700000
#define HKWD_SYSC_SETPRIORITY     0x1a800000
#define HKWD_SYSC_ABSINTERVAL     0x1a900000
#define HKWD_SYSC_GETINTERVAL     0x1aa00000
#define HKWD_SYSC_GETTIMER        0x1ab00000
#define HKWD_SYSC_INCINTERVAL     0x1ac00000
#define HKWD_SYSC_RESTIMER        0x1ad00000
#define HKWD_SYSC_RESABS          0x1ae00000
#define HKWD_SYSC_RESINC          0x1af00000
#define HKWD_SYSC_SETTIMER        0x1f000000
#define HKWD_SYSC_GETARGS         0x1f100000


/* GETPROC trace hooks */
#define HKWD_SYSC_GETPROC         0x1f200000
#define hkwd_SYSC_GETPROC_ARGS    	0x01
#define hkwd_SYSC_GETPROC_SIZPROC 	0x02
#define hkwd_SYSC_GETPROC_SIZPROC64	0x03
#define hkwd_SYSC_GETPROC_SIZFD		0x04
#define hkwd_SYSC_GETPROC_SIZFD64	0x05

#define HKWD_SYSC_GETUSER         0x1f300000
#define HKWD_SYSC_KNLIST          0x1f400000
#define HKWD_SYSC_SETSID          0x1f500000
#define HKWD_SYSC_SETPGID         0x1f600000
#define HKWD_SYSC_SETREGID        0x1f700000
#define HKWD_SYSC_SETPRI          0x1f800000

#define HKWD_VMM                  0x1b000000
#define HKWD_VMM_ASSIGN           0x1b000000
#define HKWD_VMM_DELETE           0x1b100000
#define HKWD_VMM_PGEXCT           0x1b200000
#define HKWD_VMM_PGEXCT_WORKLIM   0x1b200001
#define HKWD_VMM_PGEXCT_FILELIM   0x1b200002
#define HKWD_VMM_PGEXCT_NOSPACE   0x1b200003
#define HKWD_VMM_PGEXCT_FAIL      0x1b200004
#define HKWD_VMM_PGEXCT_HAND	  0x1b200005
#define HKWD_VMM_PROTEXCT         0x1b300000
#define HKWD_VMM_XMEMCNT	  0x1b400000
#define HKWD_VMM_RECLAIM          0x1b500000
#define HKWD_VMM_GETPARENT        0x1b600000
#define HKWD_VMM_COPYPARENT       0x1b700000
#define HKWD_VMM_MAPPARENT        0x1b700001
#define HKWD_VMM_COWRELOAD        0x1b700002
#define HKWD_VMM_VMAP             0x1b800000
#define HKWD_VMM_ZFOD             0x1b900000
#define HKWD_VMM_ZFOD_PSPA        0x1b900001
#define HKWD_VMM_SIO              0x1ba00000
#define HKWD_VMM_PAGEOUT          0x1ba00000
#define HKWD_VMM_PAGEIN           0x1ba00001
#define HKWD_VMM_SIO_PPIN         0x1ba00002
#define HKWD_VMM_SIO_PPOUT        0x1ba00003
#define HKWD_VMM_SIO_THRPGIO      0x1ba00004
#define HKWD_VMM_SEGCREATE        0x1bb00000
#define HKWD_VMM_SEGDELETE        0x1bc00000
#define HKWD_VMM_DALLOC           0x1bd00000
#define HKWD_VMM_DALLOC_PP        0x1bd00001
#define HKWD_VMM_DFREE            0x1bd00002
#define HKWD_VMM_DFREE_PPNFR      0x1bd00003
#define HKWD_VMM_DFREE_PPXPT      0x1bd00004
#define HKWD_VMM_PFENDOUT         0x1be00000
#define HKWD_VMM_PFENDIN          0x1be00001
#define HKWD_VMM_PFENDOUT_PP      0x1be00002
#define HKWD_VMM_PFENDIN_PP       0x1be00003
#define HKWD_VMM_PFEND_CKSUM	  0x1be00004
#define HKWD_VMM_VTIOL_ENQUEUE    0x1be00005
#define HKWD_VMM_VTIOL_DEQUEUE    0x1be00006
#define HKWD_VMM_VTIOL_CHACTIVE   0x1be00007
#define HKWD_VMM_EXCEPT           0x1bf00000
#define HKWD_VMM_ZERO_0		  0x1d900000
#define HKWD_VMM_ZERO_1		  0x1d900001
#define HKWD_VMM_MKP		  0x1da00000
#define HKWD_VMM_FPGIN		  0x1db00000
#define HKWD_VMM_SPACEOK_0        0x1dc00000
#define HKWD_VMM_SPACEOK_1        0x1dc00001
#define HKWD_VMM_SPACEOK_PSM	  0x1dc00002
#define HKWD_VMM_SPACEOK_LRUREQ   0x1dc00003
#define HKWD_VMM_SPACEOK_FSTATS   0x1dc00004

#define HKWD_VMM_COW_FREE_COUNTS  0x10520001
#define HKWD_VMM_COW_SCALE_COUNTS 0x10520002
#define HKWD_VMM_COW_COUNTS	  0x10520003

#define HKWD_VMM_WRITE            0x91900000
#define HKWD_VMM_FLUSH            0x91900001
#define HKWD_VMM_REL_RANGE        0x91900002
#define HKWD_VMM_IOACCESS         0x91900003

#define HKWD_VMM_RELALIAS         0x104F0000
#define hkwd_VMM_RELALIAS_LOCK         0x0
#define hkwd_VMM_RELALIAS_UNLOCK       0x1
#define hkwd_VMM_RELALIAS_LOCK_SW      0x2
#define hkwd_VMM_RELALIAS_UNLOCK_SW    0x3

#define HKWD_VMM_RESERVATION      0x4F900000
#define hkwd_VMM_GET_RESV0              0
#define hkwd_VMM_GET_RESV1              1
#define hkwd_VMM_USE_RESV0              2
#define hkwd_VMM_USE_RESV1              3
#define hkwd_VMM_FREE_RESV0             4
#define hkwd_VMM_FREE_RESV1             5
#define hkwd_VMM_GETFREE                6
#define hkwd_VMM_GET_RESV2              7
#define hkwd_VMM_USE_RESV2              8
#define hkwd_VMM_USE_MPSS_RESV0         9
#define hkwd_VMM_USE_MPSS_RESV1        10 

#define HKWD_VMM_MPSS		  0x5FE00000
#define	hkwd_VMM_MPSS_RESERVE		0
#define	hkwd_VMM_MPSS_PSPA		1
#define	hkwd_VMM_MPSS_ALLOCATE		2
#define	hkwd_VMM_MPSS_PROMOTE_PTE	3
#define	hkwd_VMM_MPSS_DEMOTE		4
#define	hkwd_VMM_MPSS_UNRESERVE		5
#define	hkwd_VMM_MPSS_RESERVE_16M	6
#define	hkwd_VMM_MPSS_ALLOCATE_16M	7
#define	hkwd_VMM_MPSS_MAKE_16M		8

/* More frequent VMM LRU events */
#define HKWD_VMM_LRU_START		0x1dd00000
#define HKWD_VMM_LRU_END		0x1dd00001
#define HKWD_VMM_LRU_MAIN_LOOP		0x1dd00002
#define HKWD_VMM_LRU_PAGE_STEAL		0x1dd00003
#define HKWD_VMM_LRU_SKIP_CCB		0x1dd00004
#define HKWD_VMM_LRU_TIMER_START	0x1dd00005
#define HKWD_VMM_LRU_TIMER_STOP		0x1dd00006
#define HKWD_VMM_LRU_TIMER_POLL		0x1dd00007
#define HKWD_VMM_LRU_TIMER_TMOUT	0x1dd00008
#define HKWD_VMM_LRU_DLATIMER_START	0x1dd00009
#define HKWD_VMM_LRU_DLATIMER_STOP	0x1dd0000A
#define HKWD_VMM_LRU_DLATIMER_TMOUT	0x1dd0000B
#define HKWD_VMM_LRU_DLA_DONE		0x1dd0000C
#define HKWD_VMM_LRU_NOWORK		0x1dd0000D
#define HKWD_VMM_LRU_MPSS		0x1dd0000E
#define HKWD_VMM_LRU_MPSS2		0x1dd0000F
#define HKWD_VMM_LRU_START1		0x1dd00010
#define HKWD_VMM_LRU_ABANDON		0x1dd00011
#define HKWD_VMM_LRU_MPSS3		0x1dd00012

/* Less frequent VMM LRU events */
#define HKWD_VMM_LRU_CYCLE		0x4a500000
#define HKWD_VMM_LRU_NO_XMEMOK		0x4a500001
#define HKWD_VMM_LRU_NEXT_LRULIST	0x4a500002
#define HKWD_VMM_LRU_COMP_LRULIST	0x4a500003
#define HKWD_VMM_LRU_NEW_CCB		0x4a500004
#define HKWD_VMM_LRU_UPD_CRITERIA	0x4a500005
#define HKWD_VMM_LRU_NEW_PASS		0x4a500006
#define HKWD_VMM_LRU_DLAMODE		0x4a500007
#define HKWD_VMM_LRU_DLA_WAKEALL	0x4a500008
#define HKWD_VMM_LRU_DLA_UPDATE		0x4a500009
#define HKWD_VMM_LRU_GET_KLK_PGS0	0x4a50000a
#define HKWD_VMM_LRU_GET_KLK_PGS1	0x4a50000b
#define HKWD_VMM_LRU_GET_KLK_PGS2	0x4a50000c

/* VMM page size management hooks */
#define HKWD_VMM_PSIZE_INC		0x4C100000
#define HKWD_VMM_PSIZE_DEC		0x4C100001

#define HKWD_VMM_PSM_PROM		0x4C200000
#define HKWD_VMM_PSM_PROM_SCAN		0x4C200001
#define HKWD_VMM_PSM_PCHANGE		0x4C200002
#define HKWD_VMM_PSM_LWPROM		0x4C200003
#define HKWD_VMM_PSM_LWMIG		0x4C200004
#define HKWD_VMM_PSM_HWPROM		0x4C200005
#define HKWD_VMM_PSM_DEM		0x4C200006
#define HKWD_VMM_PSM_DEM_SCAN		0x4C200007
#define HKWD_VMM_PSM_REQ		0x4C200008
#define HKWD_VMM_PSM_FAIL_LIMIT		0x4C200009
#define HKWD_VMM_PSM_ABORT_PASS		0x4C20000A
#define HKWD_VMM_PSM_PIN_TH		0x4C20000B
#define HKWD_VMM_PSM_FREE_TH0		0x4C20000C
#define HKWD_VMM_PSM_FREE_TH1		0x4C20000D
#define HKWD_VMM_PSM_TGT		0x4C20000E
#define HKWD_VMM_PSM_TMR_START		0x4C20000F
#define HKWD_VMM_PSM_TMR_TMOUT		0x4C200010
#define HKWD_VMM_PSM_TMR_STOP		0x4C200011
#define HKWD_VMM_PSM_START_LRU		0x4C200012
#define HKWD_VMM_PSM_NOPROG_TMOUT	0x4C200013
#define HKWD_VMM_PSM_MK_PIN_REQ		0x4C200014
#define HKWD_VMM_PSM_HW_MIGABLE		0x4C200015
#define HKWD_VMM_PSM_LW_MIGABLE		0x4C200016
#define HKWD_VMM_PSM_PROM_SCAN2		0x4C200017
#define HKWD_VMM_PSM_16M_START		0x4C200018
#define HKWD_VMM_PSM_16M_END		0x4C200019
#define HKWD_VMM_PSM_16M_ISO_FAIL	0x4C20001A
#define HKWD_VMM_PSM_16M_ISO_INFO1	0x4C20011A
#define HKWD_VMM_PSM_16M_ISO_INFO2	0x4C20021A
#define HKWD_VMM_PSM_16M_ISO_INFO3	0x4C20031A
#define HKWD_VMM_PSM_16M_ISO_INFO4	0x4C20041A
#define HKWD_VMM_PSM_16M_ISO_INFO5	0x4C20051A
#define HKWD_VMM_PSM_16M_ISO_INFO6	0x4C20061A
#define HKWD_VMM_PSM_16M_ISO_INFO7	0x4C20071A
#define HKWD_VMM_PSM_16M_ISO_INFO8	0x4C20081A
#define HKWD_VMM_PSM_16M_ISO_INFO9	0x4C20091A
#define HKWD_VMM_PSM_16M_ISO_INFOA	0x4C200A1A
#define HKWD_VMM_PSM_16M_ISO_INFOB	0x4C200B1A
#define HKWD_VMM_PSM_16M_ISO_INFOC	0x4C200C1A
#define HKWD_VMM_PSM_16M_ISO_INFOD	0x4C200D1A
#define HKWD_VMM_PSM_16M_ISOLATED	0x4C200F1A
#define HKWD_VMM_PSM_16M_POP_INFO1	0x4C20011B
#define HKWD_VMM_PSM_16M_POP_INFO2	0x4C20021B
#define HKWD_VMM_PSM_16M_REL_INFO1	0x4C20011C
#define HKWD_VMM_PSM_16M_REL_INFO2	0x4C20021C
#define HKWD_VMM_PSM_16M_REL_INFO3	0x4C20031C
#define HKWD_VMM_PSM_16M_REL_INFO4	0x4C20041C
#define HKWD_VMM_PSM_16M_REL_INFO5	0x4C20051C

/* VMM error trace hooks */
#define HKWD_VMM_ERR_REL_ALIGN    0x4CA00000
#define HKWD_VMM_ERR_PROT_ALIGN   0x4CA00001
#define HKWD_VMM_ERR_IGNORE       0x4CA00002

/* Excessive time VMM trace hooks */
#define HKWD_VMM_EXC_BT_VCS       0x4CA00101	/* excessive back track vcs */
#define HKWD_VMM_EXC_FS_VCS       0x4CA00102	/* excessive fixed stack vcs */
#define HKWD_VMM_EXC_PCS          0x4CA00103	/* excessive pcs call */
#define HKWD_VMM_EXC_DR_PCS       0x4CA00104	/* DR trace */

#define HKWD_VMM_VWAIT            0x2FC00000
#define HKWD_VMM_WRITE_0          0x4C300000
#define HKWD_VMM_WRITE_1          0x4C300001
#define HKWD_VMM_MVC_0            0x4C300002

/* VMM Service trace hooks */
#define HKWD_VMSVC_PIN            0x62400000
#define HKWD_VMSVC_UNPIN          0x62400002
#define HKWD_VMSVC_XLATE_PIN      0x62400004
#define HKWD_VMSVC_XLATE_UNPIN    0x62400006
#define HKWD_VMSVC_PIN_FORCED	  0x62400008
#define HKWD_VMSVC_RMLMB_KERNEL   0x62500000
#define HKWD_VMSVC_ADDLMB_KERNEL  0x62500002
#define HKWD_VMSVC_VM_ADDMEM      0x62500004
#define HKWD_VMSVC_VM_FREEMEM     0x62500006
#define HKWD_VMSVC_CHLMB_KERNEL   0x62500008
#define HKWD_VMSVC_CHLMB_POST     0x6250000A
#define HKWD_VMSVC_VM_GFREE       0x62600000
#define HKWD_VMSVC_VM_GALLOC_ATT  0x62600002
#define HKWD_VMSVC_VM_GPTEPIN     0x62600004
#define HKWD_VMSVC_VMS_DELETE     0x62700000
#define HKWD_VMSVC_VM_RELEASE     0x62700002
#define HKWD_VMSVC_VM_RELEASEP    0x62700004
#define HKWD_VMSVC_VM_DISCLAIM    0x62700006
#define HKWD_VMSVC_SETSEG_HKEY    0x62700008
#define HKWD_VMSVC_SETSEG_KKEY    0x6270000A
#define HKWD_VMSVC_VM_INVALIDATEP 0x6270000C
#define HKWD_VMSVC_VMS_IOWAITF    0x62800000
#define HKWD_VMSVC_VM_PROTECT     0x62900000
#define HKWD_VMSVC_VM_M_PROTECT   0x62900002
#define HKWD_VMSVC_VM_WRITE       0x62A00000
#define HKWD_VMSVC_VM_XWRITEP     0x62A00002 
#define HKWD_VMSVC_VM_IOACCESSP   0x62A00004
#define HKWD_VMSVC_VM_WRITEP      0x62A00006
#define HKWD_VMSVC_VM_XWRITE2     0x62A00008 
#define HKWD_VMSVC_VM_READP       0x62A0000A
#define HKWD_VMSVC_VM_FLUSHP      0x62A0000C
#define HKWD_VMSVC_AS_ATT64       0x62B00000
#define HKWD_VMSVC_AS_DET64       0x62B00002 
#define HKWD_VMSVC_AS_SETH64      0x62B00004 
#define HKWD_VMSVC_AS_LW_ATT64    0x62B00006
#define HKWD_VMSVC_AS_LW_DET64    0x62B00008
#define HKWD_VMSVC_AS_LW_POOL     0x62B0000A
#define HKWD_VMSVC_VMS_LIMITS     0x62B0000C
#define HKWD_VMSVC_MPC_SEND       0x62B0000E
#define HKWD_VMSVC_TID_SRAD_ATCH  0x62B00010

#define HKWD_VMSVC_SETDEVID       0x63400000
#define HKWD_VMSVC_UMOUNTX        0x63400002
#define HKWD_VMSVC_MOUNTX         0x63400004
#define HKWD_VMSVC_XP_MODFLAGS	  0x63400006

#define HKWD_VMSVC_XMEM           0x5CA00000
#define HKWD_VMSVC_XMSETHKEY      0x5CA00000
#define HKWD_VMSVC_XMGETHKEY      0x5CA00002
#define HKWD_VMSVC_XM_IO_OK       0x5CA00004
#define HKWD_VMSVC_XMATTACH       0x5CA00006
#define HKWD_VMSVC_XMATT_REMIO    0x5CA00008
#define HKWD_VMSVC_XMEMOUTX       0x5CA0000A
#define HKWD_VMSVC_XMDETACH       0x5CA0000C
#define HKWD_VMSVC_XMEMIN         0x5CA0000E
#define HKWD_VMSVC_XMEMPIN        0x5CA00010
#define HKWD_VMSVC_XMEMUNPIN      0x5CA00012
#define HKWD_VMSVC_XL_CREATE      0x5CA00014
#define HKWD_VMSVC_XL_REMOVE      0x5CA00016
#define HKWD_VMSVC_XM_MAPIN       0x5CA00018
#define HKWD_VMSVC_XM_DET         0x5CA0001A
#define HKWD_VMSVC_XMEMDMA        0x5CA0001C
#define HKWD_VMSVC_XMEMDMA_LIST   0x5CA0001E
#define HKWD_VMSVC_XMEMZERO       0x5CA00020
#define HKWD_VMSVC_XM_GETH        0x5CA00022
#define HKWD_VMSVC_XMEMPSIZE      0x5CA00024
#define HKWD_VMSVC_XM_MAXMAP      0x5CA00026
#define HKWD_VMSVC_XM_AIO_OK      0x5CA00028
#define HKWD_VMSVC_XL_ADDR        0x5CA0002A
#define HKWD_VMSVC_XL_UPDATE      0x5CA0002C

/* DR page migration trace hooks */
#define HKWD_VMM_MIG_DR           0x62C00000
#define HKWD_VMM_MIG_DR_ERR       0x62C00001
#define HKWD_VMM_MIG_PG_DR        0x62C00002
#define HKWD_VMM_MIG_PG_DR_ERR    0x62C00003
#define HKWD_VMM_MIG_SERV_DR      0x62C00004
#define HKWD_VMM_MIG_SERV_DR_ERR  0x62C00005
#define HKWD_VMM_REAFFIN	  0x62C00006
#define HKWD_VMM_REAFFIN_ERR	  0x62C00007
#define HKWD_VMM_DR_UPD_MEMSZ	  0x62C00008
#define HKWD_VMM_MIG_INFO         0x62C00009

/* Thread Reaffin trace hooks */
#define HKWD_VMM_THRD_REAFFIN	  0x10270000
#define HKWD_VMM_MEM_REAFFIN	  0x10280000

/* vm_pattr() trace hooks */
#define HKWD_SYSC_VMM_VMPATTR	  0x10470000
#define hkwd_SYSC_VMM_VMPATTR_ENTRY	0x00
#define hkwd_SYSC_VMM_VMPATTR_EXIT	0x01
#define hkwd_SYSC_VMM_VMPATTR_CHUNK_PRO 0x02
#define hkwd_SYSC_VMM_VMPATTR_CHUNK_RET 0x03

/* LMB Reaffinitization trace hooks */
#define HKWD_CHLMB                           0x10480000
#define hkwd_chlmb_reg_lock                  0x0001
#define hkwd_chlmb_reg_lock_err              0x0002
#define hkwd_chlmb_post                      0x0003
#define hkwd_chlmb_post_err                  0x0004
#define hkwd_chlmb_aff01                     0x0005
#define hkwd_chlmb_aff02                     0x0006
#define hkwd_chlmb_aff_out                   0x0007
#define hkwd_chlmb_reassgn_nfrs              0x0008
#define hkwd_chlmb_reassgn_nfrs_prolog       0x0009
#define hkwd_chlmb_offl_memp                 0x000a
#define hkwd_chlmb_reassgn_pgs01             0x000b
#define hkwd_chlmb_reassgn_pgs02             0x000c
#define hkwd_chlmb_reassgn_pgs03             0x000d
#define hkwd_chlmb_ksp_only_vmp              0x000e
#define hkwd_chlmb_aff_post                  0x000f
#define hkwd_chlmb_reassgn_memp              0x0010
#define hkwd_chlmb_reassgn_nolru             0x0011
#define hkwd_chlmb_xfer_nolru                0x0012
#define hkwd_chlmb_reassgn_lgpg01            0x0013
#define hkwd_chlmb_reassgn_lgpg02            0x0014
#define hkwd_chlmb_reassgn_lgpg03            0x0015

/* Dynamic PVLIST trace hooks */
#define HKWD_VMM_PVLIST		0x5C000000
#define hkwd_VMM_PVLIST_KPROC_WAKE	0x0
#define hkwd_VMM_PVLIST_LALLOC_FAIL	0x1
#define hkwd_VMM_PVLIST_HALLOC_PINFAIL	0x2
#define hkwd_VMM_PVLIST_HALLOC_NFR	0x3
#define hkwd_VMM_PVLIST_ADDPAGE		0x4
#define hkwd_VMM_PVLIST_LESS		0x5
#define hkwd_VMM_PVLIST_REMPAGE		0x6

/* Virtual Real Memory Entitlement (VRME) trace hooks */
#define HKWD_VRME_CREATE_POOL     0x5F600000
#define HKWD_VRME_DEL_POOL        0x5F600001
#define HKWD_VRME_RSV0            0x5F600002
#define HKWD_VRME_RSV1            0x5F600003
#define HKWD_VRME_ALLOC_WAIT      0x5F600004
#define HKWD_VRME_ALLOC_SUCC      0x5F600005
#define HKWD_VRME_ALLOC_FAIL0     0x5F600006
#define HKWD_VRME_ALLOC_FAIL1     0x5F600007
#define HKWD_VRME_FREE            0x5F600008
#define HKWD_VRME_RESET_HWMARKS   0x5F600009
#define HKWD_VRME_DR_ADD          0x5F60000A
#define HKWD_VRME_DR_RM           0x5F60000B

/* VMM VRM hooks */
#define HKWD_VMM_VRM			0x5FF00000
#define HKWD_VMM_VRM_MKPAGES		0x5FF00001
#define HKWD_VMM_VRM_UNLOANPGS		0x5FF00002
#define HKWD_VMM_VRM_PINLIM		0x5FF00003
#define HKWD_VMM_VRM_PSM_DEM_UNLOAN	0x5FF00004
#define HKWD_VMM_VRM_PSM_UNLOAN		0x5FF00005
#define HKWD_VMM_VRM_LRU_UNLOAN		0x5FF00006
#define HKWD_VMM_VRM_LRU_UNLOAN_FR	0x5FF00007
#define HKWD_VMM_VRM_LOANPAGE		0x5FF00008
#define HKWD_VMM_VRM_UNLOANPAGE		0x5FF00009

/* VMM Compressed Memory hook. */
#define HKWD_VMM_CMEM			0x64F00000

/* VMM TMM Hooks */
#define HKWD_SYSC_TMMRESERVEW  0x100C0000
#define HKWD_SYSC_TMMRESERVEWX 0x100C0001
#define HKWD_SYSC_TMMRELEASEW  0x100C0002
#define HKWD_SYSC_TMMRELEASEWX 0x100C0003
#define HKWD_SYSC_TMMEXCPREG   0x100C0004
#define HKWD_SYSC_TMMEXCPREGX  0x100C0005

#define HKWD_SYSC_TMMCREATW    0x100D0000
#define HKWD_SYSC_TMMCREATWX   0x100D0001
#define HKWD_SYSC_TMMDELETEW   0x100D0002
#define HKWD_SYSC_TMMDELETEWX  0x100D0003

#define HKWD_SYSC_TMMMAPW      0x100E0000
#define HKWD_SYSC_TMMMAPWX     0x100E0001
#define HKWD_SYSC_TMMUNMAPW    0x100E0002
#define HKWD_SYSC_TMMUNMAPWX   0x100E0003

#define HKWD_SYSC_TMMMAP       0x100F0000
#define HKWD_SYSC_TMMMAPX      0x100F0001
#define HKWD_SYSC_TMMUNMAP     0x100F0002
#define HKWD_SYSC_TMMUNMAPX    0x100F0003
#define HKWD_SYSC_TMMUNMAPALL  0x100F0004
#define HKWD_SYSC_TMMUNMAPALLX 0x100F0005
#define HKWD_SYSC_TMMPROTECT   0x100F0006
#define HKWD_SYSC_TMMPROTECTX  0x100F0007

/* VMM PGZ hook */
#define HKWD_VMM_PGZ		0x10730000

/* VMM LSA hook */
#define HKWD_VMM_LSA		0x65500000

/* System V IPC Trace Hooks */
#define HKWD_SYSC_IPCACCESS       0x3c500000
#define HKWD_SYSC_IPCGET          0x3c600000

/* System V Message Queue Trace Hooks */
#define HKWD_SYSC_MSGCONV         0x3c700000
#define HKWD_SYSC_MSGCTL          0x3c800000
#define HKWD_SYSC_MSGGET          0x3c900000
#define HKWD_SYSC_MSGRCV          0x3ca00000
#define HKWD_SYSC_MSGSELECT       0x3cb00000
#define HKWD_SYSC_MSGSND          0x3cc00000
#define HKWD_SYSC_MSGXRCV         0x3cd00000

/* System V Semaphore Sets Trace Hooks */
#define HKWD_SYSC_SEMCONV         0x3ce00000
#define HKWD_SYSC_SEMCTL          0x3cf00000
#define HKWD_SYSC_SEMGET          0x3d000000
#define HKWD_SYSC_SEMOP           0x3d100000
#define HKWD_SYSC_SEM_OP          0x3d200000

/* System V Shared Memory Region Trace Hooks */
#define HKWD_SYSC_SHMAT           0x3d300000
#define HKWD_SYSC_SHMCONV         0x3d400000
#define HKWD_SYSC_SHMCTL          0x3d500000
#define HKWD_SYSC_SHMDT           0x3d600000
#define HKWD_SYSC_SHMGET          0x3d700000

/* mmap Services Trace Hooks */
#define HKWD_SYSC_MADVISE         0x3d800000
#define HKWD_SYSC_MINCORE         0x3d900000
#define HKWD_SYSC_MMAP            0x3da00000
#define HKWD_SYSC_MPROTECT        0x3db00000
#define HKWD_SYSC_MSYNC           0x3dc00000
#define HKWD_SYSC_MUNMAP          0x3dd00000
#define HKWD_SYSC_MVALID          0x3de00000
#define HKWD_SYSC_UKEY_PROTECT    0x60c00000
#define HKWD_SYSC_UKEY_GETKEY     0x60d00000

/* msemaphore Services Trace Hooks */
#define HKWD_SYSC_MSEM_INIT       0x3df00000
#define HKWD_SYSC_MSEM_LOCK       0x3e000000
#define HKWD_SYSC_MSEM_REMOVE     0x3e100000
#define HKWD_SYSC_MSEM_UNLOCK     0x3e200000

#define HKWD_DD                   0x1c000000
#define HKWD_DD_STRATEGY          0x1c000000
#define HKWD_DD_START             0x1c100000
#define HKWD_DD_INTR              0x1c200000
#define HKWD_DD_GETBLK            0x1c300000
#define HKWD_DD_IOWAIT            0x1c400000
#define HKWD_DD_IODONE            0x1c500000
#define HKWD_DD_PHYSIO            0x1c600000
#define HKWD_DD_ATTACH            0x1c700000
#define HKWD_DD_PPDD              0x1c800000    /* parallel printer DD */
#define HKWD_DD_CDDD              0x1c900000    /* cdrom DD */
#define HKWD_DD_TAPEDD            0x1ca00000    /* tape DD */
#define HKWD_DD_CIODD             0x1cb00000    /* cio DD */
#define HKWD_DD_ETHDD             0x1cc00000    /* cio PC  ethernet DD */
#define HKWD_DD_ENTDD             0x1cd00000    /* cio MCA ethernet DD */
#define HKWD_DD_TOKDD             0x1ce00000    /* cio MCA tokenring DD */
#define HKWD_DD_C327DD            0x1cf00000    /* 3270 DD */

#define HKWD_DD_FDDD              0x22000000    /* diskette DD */
#define HKWD_DD_SCDISKDD          0x22100000    /* SCSI Disk DD */
#define HKWD_DD_BADISKDD          0x22200000    /* Bus Attached Disk DD */
#define HKWD_DD_SCSIDD            0x22300000    /* SCSI Adapter DD    */
#define HKWD_DD_MPQPDD            0x22400000    /* multi-protocol     */
#define HKWD_DD_X25DD             0x22500000    /* X.25 Device Driver */
#define HKWD_DD_GIO               0x22600000    /* G.I. Joe */
#define HKWD_DD_X25PRF            0x22700000    /* X.25 performance  */
#define HKWD_DD_SERDASDD          0x22800000    /* Serial DASD Subsystem */
#define HKWD_DD_TMSCSIDD          0x22900000    /* SCSI Target Mode DD */
#define	HKWD_DD_SOL		  0x24800000	/* optic 2-port */
#define HKWD_DD_CATDD             0x35000000    /* S/370 Channel */
#define HKWD_DD_SISADD            0x38E00000    /* SIS based SCSI DD */
#define HKWD_DD_SISRAID           0x39000000    /* SIS based SCSI (RAID) DD */
#define HKWD_USBCDROM		  0x47c00000	/* USB CD-ROM client driver */
#define HKWD_DD_SISSAS            0x5BD00000    /* SIS based SAS (RAID) DD */
#define HKWD_DD_NVME              0x10890000    /* NVMe adapter system trace */
#define HKWD_DD_NVME_DISK         0x108B0000    /* NVMe disk system trace */
#define HKWD_NVME_BASE            0x108D0000    /* NVMe common system base */
#define CT_HKWD_DD_NVME           0x10880000    /* adapter component trace */
#define CT_HKWD_DD_NVME_DISK      0x108A0000    /* disk component trace */
#define CT_HKWD_NVME_BASE         0x108C0000    /* common component base */

#define HKWD_DDSPEC               0x1d000000
#define HKWD_DDSPEC_GRAPHIO       0x1d000000
#define HKWD_RAS_ERRLG            0x1d100000
#define HKWD_RAS_DUMP             0x1d200000
#define HKWD_RAS_DUMPTIME         0x63300000
#define HKWD_RAS_LDMP		  0x5CB00000
#define HKWD_RAS_TRACE		  0x5E600000
#define HKWD_RAS_INFRA		  0x5F100000

#define HKWD_LPP_PCSIM            0x1d300000
#define hkwd_PCSIM_FILE   1
#define hkwd_PCSIM_DISP   2
#define hkwd_PCSIM_CNTL   3
#define hkwd_PCSIM_PCAT   4
#define hkwd_PCSIM_DSKT   5

#define HKWD_WHIP_API             0x1d400000
#define HKWD_WHIP_DAEMON          0x1d500000
#define HKWD_WHIP_DRIVER          0x1d600000
#define HKWD_WHIP_EMUL            0x1d700000
#define HKWD_WHIP_FILE            0x1d800000

#define HKWD_COMM                 0x1e000000
#define HKWD_COMM_EM78            0x1e000000

/*
 * Socket, Network, and Network Interface hook id and sub-hook id's
 */

#define HKWD_NETPERF		0x25000000

#define HKWD_NETERR		0x25100000 

#define HKWD_SOCKET		0x25200000
#define hkwd_accept_in			1
#define hkwd_accept_out			2
#define hkwd_bind_in			3
#define hkwd_bind_out			4
#define hkwd_connect_in			5
#define hkwd_connect_out		6
#define hkwd_getkerninfo_in		7
#define hkwd_getkerninfo_out		8
#define hkwd_getpeername_in		9
#define hkwd_getpeername_out		10
#define hkwd_getsockname_in		11
#define hkwd_getsockname_out		12
#define hkwd_getsockopt_in		13
#define hkwd_getsockopt_out		14
#define hkwd_listen_in			15
#define hkwd_listen_out			16
#define hkwd_recv_in			17
#define hkwd_recv_out			18
#define hkwd_recvfrom_in		19
#define hkwd_recvfrom_out		20
#define hkwd_recvit_in			21
#define hkwd_recvit_out			22
#define hkwd_recvmsg_err		23
#define hkwd_recvmsg_in			24
#define hkwd_recvmsg_out		25
#define hkwd_rmsock_in			26
#define hkwd_rmsock_out			27
#define hkwd_sbwakeup_in		28
#define hkwd_sbwakeup_out		29
#define hkwd_send_in			30
#define hkwd_send_out			31
#define hkwd_sendfile_in		32
#define hkwd_sendfile_out		33
#define hkwd_sendit_in			34
#define hkwd_sendit_out			35
#define hkwd_sendmsg_in			36
#define hkwd_sendmsg_out		37
#define hkwd_sendto_in			38
#define hkwd_setsockopt_in		39
#define hkwd_setsockopt_out		40
#define hkwd_shutdown_in		41
#define hkwd_shutdown_out		42
#define hkwd_soabort_in			43
#define hkwd_soabort_out		44
#define hkwd_soaccept_in		45
#define hkwd_soaccept_out		46
#define hkwd_soaccessfailure_in		47
#define hkwd_soaccessfailure_out	48
#define hkwd_sobind_in			49
#define hkwd_sobind_out			50
#define hkwd_sockargs_in		51
#define hkwd_sockargs_out		52
#define hkwd_socket_aio_dequeue_in	53
#define hkwd_socket_aio_dequeue_out	54
#define hkwd_socket_in			55
#define hkwd_socket_out			56
#define hkwd_socketpair_err		57
#define hkwd_socketpair_in		58
#define hkwd_socketpair_out		59
#define hkwd_socksetup_in		60
#define hkwd_socksetup_out		61
#define hkwd_soclose_in			62
#define hkwd_soclose_out		63
#define hkwd_soconnect2_in		64
#define hkwd_soconnect2_out		65
#define hkwd_soconnect_in		66
#define hkwd_soconnect_out		67
#define hkwd_socreate_err		68
#define hkwd_socreate_in		69
#define hkwd_socreate_out		70
#define hkwd_socreategroup_err		71
#define hkwd_socreategroup_in		72
#define hkwd_socreategroup_out		73
#define hkwd_sodisconn_in		74
#define hkwd_sodisconn_out		75
#define hkwd_sodisconnect_in		76
#define hkwd_sodisconnect_out		77
#define hkwd_sofree_err			78
#define hkwd_sofree_in			79
#define hkwd_sofree_out			80
#define hkwd_sogetopt_in		81
#define hkwd_sogetopt_out		82
#define hkwd_sohasoutofband_in		83
#define hkwd_sohasoutofband_out		84
#define hkwd_soisconnected_in		85
#define hkwd_soisconnected_out		86
#define hkwd_soisdisconnected_in	87
#define hkwd_soisdisconnected_out	88
#define hkwd_solisten_in		89
#define hkwd_solisten_out		90
#define hkwd_sonewsock_in		91
#define hkwd_sonewsock_out		92
#define hkwd_soo_close_in		93
#define hkwd_soo_close_out		94
#define hkwd_soo_ioctl_in		95
#define hkwd_soo_ioctl_out		96
#define hkwd_soo_read_in		97
#define hkwd_soo_read_out		98
#define hkwd_soo_select_in		99
#define hkwd_soo_select_out		100
#define hkwd_soo_stat_in		101
#define hkwd_soo_stat_out		102
#define hkwd_soo_write_in		103
#define hkwd_soo_write_out		104
#define hkwd_soreceive_in		105
#define hkwd_soreceive_out		106
#define hkwd_soreserve_in		107
#define hkwd_soreserve_out		108
#define hkwd_sorflush_in		109
#define hkwd_sorflush_out		110
#define hkwd_sosbwait_in		111
#define hkwd_sosbwait_out		112
#define hkwd_sosend_in			113
#define hkwd_sosend_out			114
#define hkwd_sosetopt_in		115
#define hkwd_sosetopt_out		116
#define hkwd_soshutdown_in		117
#define hkwd_soshutdown_out		118
#define hkwd_sosleep_in			119
#define hkwd_sosleep_out		120
#define hkwd_sosplice_in		121
#define hkwd_sosplice_out		122
#define hkwd_sowakeup_in		123
#define hkwd_sowakeup_out		124
#define hkwd_splice_in			125
#define hkwd_splice_out			126
#define hkwd_gethostid_in		127
#define hkwd_sethostid_in		128
#define hkwd_gethostname_in		129
#define hkwd_sethostname_in		130
#define hkwd_getdomainname_in		131
#define hkwd_setdomainname_in		132
#define hkwd_getdomainname_out		133
#define hkwd_getpeereid_in              134
#define hkwd_getpeereid_out             135
#define hkwd_ksodebug_in                136
#define hkwd_ksodebug_err               137
#define hkwd_sbwakeup_out_lmt		138
#define hkwd_socreate_err1              140
#define hkwd_socreate_err2              141
#define hkwd_socreate_err3              142
#define hkwd_socreate_err4              143
#define hkwd_socreate_err5              144
#define hkwd_socreate_err6              145
#define hkwd_socreate_err7              146
#define hkwd_socreate_err8              147
#define hkwd_socreate_err9              148
#define hkwd_socreate_err10             149
#define hkwd_socreate_err11             150
#define hkwd_soclose2_err1              151
#define hkwd_soclose2_err2              152
#define hkwd_soconnect_err1             153
#define hkwd_sosend_err1                154
#define hkwd_sosend_err2                155
#define hkwd_sosend_err3                156
#define hkwd_sosend_err4                157
#define hkwd_sosend_err5                158
#define hkwd_sosend_err6                159
#define hkwd_sosend_err7                160
#define hkwd_sosend_err8                161
#define hkwd_sosend_err9                162
#define hkwd_sosend_err10               163
#define hkwd_sosend_err11               164
#define hkwd_sosend_err12               165
#define hkwd_sokernrecv_err1            166
#define hkwd_sokernrecv_err2            167
#define hkwd_sokernrecv_msgwaitall1     168
#define hkwd_sokernrecv_msgwaitall2	169
#define hkwd_sosetopt_err1              170
#define hkwd_sosetopt_err2              171
#define hkwd_sosetopt_err3              172
#define hkwd_sosetopt_err4              173
#define hkwd_sosetopt_err5              174
#define hkwd_sosetopt_err6              175
#define hkwd_sosetopt_err7              176
#define hkwd_sosetopt_err8              177
#define hkwd_sosetopt_err9              178
#define hkwd_sosetopt_err10             179
#define hkwd_sosetopt_err11             180
#define hkwd_sosetopt_err12             181
#define hkwd_sogetopt_err1              182
#define hkwd_sogetopt_err2              183
#define hkwd_sodequeue_err1             184
#define hkwd_sodequeue_err2             185
#define hkwd_sodequeue_err3             186
#define hkwd_sodequeue_err4             187
#define hkwd_sodequeue_err5             188
#define hkwd_sogetaddr_err1             189
#define hkwd_sogetaddr_err2             190

#define hkwd_socreategroup_err2         192
#define hkwd_socreategroup_err3         193
#define hkwd_socreategroup_err4         194
#define hkwd_sosplice_err1              195
#define hkwd_sosplice_err2              196
#define hkwd_sodisconnectreuse_in       197
#define hkwd_sodisconnectreuse_out      198
#define hkwd_sonewsock_err1             199
#define hkwd_sonewsock_err2             200
#define hkwd_sonewsock_err3             201
#define hkwd_sonewsock_err4             202
#define hkwd_sonewsock_err5             203
#define hkwd_sonewsock_err6             204
#define hkwd_sonewsock_err7             205
#define hkwd_sosbwait_err1              206
#define hkwd_soqaio_err1                207
#define hkwd_soqaio_err2                208
#define hkwd_soreserve_err1             209
#define hkwd_soreserve_err2             210
#define hkwd_sbinsertoob_err1           211
#define hkwd_sbappendaddr_err1          212
#define hkwd_sbdrop_in                  213
#define hkwd_sbdrop_out                 214
#define hkwd_sbdroprecord_in            215
#define hkwd_sbdroprecord_out           216
#define hkwd_so_exit_in                 217
#define hkwd_so_exit_out                218
#define hkwd_soiskernconnected_in       219
#define hkwd_soiskernconnected_out      220
#define hkwd_soiskerndisconnected_in    221
#define hkwd_soiskerndisconnected_out   222
#define hkwd_sndbufpool_dr_cpu_add_in   223
#define hkwd_sndbufpool_dr_cpu_add_out  224
#define hkwd_sndbufpool_dr_cpu_remove_in        225
#define hkwd_sndbufpool_dr_cpu_remove_out       226
#define hkwd_soo_read_err1              227
#define hkwd_soo_write_err1             229
#define hkwd_soo_ioctl_err1             230
#define hkwd_soo_ioctl_err2             231
#define hkwd_soo_ioctl_err3             232
#define hkwd_soo_ioctl_err4             233
#define hkwd_soo_ioctl_err5             234
#define hkwd_soo_ioctl_err6             235
#define hkwd_soo_ioctl_err7             236
#define hkwd_soo_ioctl_err8             237
#define hkwd_soo_ioctl_err9             238
#define hkwd_soo_ioctl_err10            239
#define hkwd_soo_ioctl_err11            240
#define hkwd_soo_ioctl_err12            241
#define hkwd_soo_ioctl_err13            242
#define hkwd_soo_ioctl_err14            243
#define hkwd_soo_ioctl_err15            244
#define hkwd_soo_ioctl_err16            245
#define hkwd_soo_ioctl_err17            246
#define hkwd_soo_ioctl_err18            247
#define hkwd_soo_ioctl_err19            248
#define hkwd_soo_ioctl_err20            249
#define hkwd_rmsock_err1                250
#define hkwd_rmsock_err2                251
#define hkwd_connect_err1               252
#define hkwd_connext_err1               253
#define hkwd_socket_err1                254
#define hkwd_bind_err1                  255
#define hkwd_bind_err2                  256
#define hkwd_bind_err3                  257
#define hkwd_accept1_err1               258
#define hkwd_accept1_err2               259
#define hkwd_accept1_err3               260
#define hkwd_accept1_err4               261
#define hkwd_accept1_err5               262
#define hkwd_accept1_err6               263
#define hkwd_accept1_err7               264
#define hkwd_accept1_err8               265
#define hkwd_accept1_err9               266
#define hkwd_accept1_err10              267
#define hkwd_accept1_err11              268
#define hkwd_accept1_err12              269
#define hkwd_accept1_err13              270
#define hkwd__connect_err1              271
#define hkwd__connect_err2              272
#define hkwd__connect_err3              273
#define hkwd_socketpair_err1            274
#define hkwd_socketpair_err2            275
#define hkwd_socketpair_err3            276
#define hkwd_socketpair_err4            277
#define hkwd_socketpair_err5            278
#define hkwd_socketpair_err6            279
#define hkwd_socketpair_err7            280
#define hkwd_socketpair_err8            281
#define hkwd_socketpair_err9            282
#define hkwd_socketpair_err10           283
#define hkwd_socketpair_err11           284
#define hkwd_sendto_err1                285
#define hkwd_sendto_err2                286
#define hkwd_send_err1                  287
#define hkwd_send_err2                  288
#define hkwd_sendmsg_err1               289
#define hkwd_sendmsg_err2               290
#define hkwd_sendmsg_err3               291
#define hkwd_sendmsg_err4               292
#define hkwd_sendmsg_err5               293
#define hkwd_sendmsg_err6               294
#define hkwd_sendmsg_err7               295
#define hkwd_sendmsg_err8               296
#define hkwd_sendmsg_err9               297
#define hkwd_sendmsg_err10              298
#define hkwd_sendmsg_err11              299
#define hkwd_sendmsg_err12              300
#define hkwd_sendmsg_err13              301
#define hkwd_sendmsg_err14              302
#define hkwd_sendmsg_err15              303
#define hkwd_sendmsg_err16              304
#define hkwd_sendmsg_err17              305
#define hkwd_sendmsg_err18              306
#define hkwd_nsendmsg_err1              307
#define hkwd_nsendmsg_err2              308
#define hkwd_nsendmsg_err3              309
#define hkwd_nsendmsg_err4              310
#define hkwd_nsendmsg_err5              311
#define hkwd_nsendmsg_err6              312
#define hkwd_nsendmsg_err7              313
#define hkwd_nsendmsg_err8              314
#define hkwd_nsendmsg_err9              315
#define hkwd_nsendmsg_err10             316
#define hkwd_nsendmsg_err11             317
#define hkwd_nsendmsg_err12             318
#define hkwd_nsendmsg_err13             319
#define hkwd_nsendmsg_err14             320
#define hkwd_nsendmsg_err15             321
#define hkwd_nsendmsg_err16             322
#define hkwd_nsendmsg_err17             323
#define hkwd_nsendmsg_err18             324
#define hkwd_sendit_err1                325
#define hkwd_sendit_err2                326
#define hkwd_sendit_err3                327
#define hkwd_sendit_err4                328
#define hkwd_sendit_err5                329
#define hkwd_sendit_err6                330
#define hkwd_sendit_err7                331
#define hkwd_sendit_err8                332
#define hkwd_sendit_err9                333
#define hkwd_sendit_out1                334
#define hkwd_nrecvfrom_err1             335
#define hkwd_nrecvfrom_err2             336
#define hkwd_nrecvfrom_err3             337
#define hkwd_nrecvfrom_err4             338
#define hkwd_recv_err1                  339
#define hkwd_recv_err2                  340
#define hkwd_recv_err3                  341
#define hkwd_soclose2_abort_call1      	342
#define hkwd_soclose2_abort_call2      	343
#define hkwd_sodisconn_err1   		346
#define hkwd_sodisconn_err2            	347
#define hkwd_soreceive_err1            	348
#define hkwd_soreceive_err2            	349
#define hkwd_soshutdown_err1          	350 
#define hkwd_sonewsock_out1          	351
#define hkwd_sonewsock_out2            	352
#define hkwd_sosbwait_out1            	353
#define hkwd_sosbwait_out2             	354
#define hkwd_soo_select_out1           	355
#define hkwd_soo_select_out2           	356
#define hkwd_sendmsg_out1              	357
#define hkwd_sendmsg_out2              	358
#define hkwd_sendmsg_out3              	359
#define hkwd_sendmsg_out4              	360
#define hkwd_nsendmsg_in               	361
#define hkwd_nsendmsg_out1             	362
#define hkwd_nsendmsg_out2             	363
#define hkwd_nsendmsg_out3            	364
#define hkwd_nsendmsg_out4             	365
#define hkwd_recvmsg_err1               366
#define hkwd_recvmsg_err2               367
#define hkwd_recvmsg_err3               368
#define hkwd_recvmsg_err4               369
#define hkwd_recvmsg_err5               370
#define hkwd_recvmsg_err6               371
#define hkwd_recvmsg_err7               372
#define hkwd_recvmsg_err8               373
#define hkwd_recvmsg_err9               374
#define hkwd_recvmsg_err10              375
#define hkwd_recvmsg_err11              376
#define hkwd_recvmsg_err12              377
#define hkwd_recvmsg_err13              378
#define hkwd_recvmsg_err14              379
#define hkwd_recvmsg_err15              380
#define hkwd_recvmsg_err16              381
#define hkwd_recvmsg_err17              382
#define hkwd_recvmsg_err18              383
#define hkwd_recvmsg_err19              384
#define hkwd_recvmsg_err20              385
#define hkwd_recvmsg_err21              386
#define hkwd_recvmsg_err22              387
#define hkwd_recvmsg_err23              388
#define hkwd_recvmsg_out1               389
#define hkwd_recvmsg_out2               390
#define hkwd_recvmsg_out3               391
#define hkwd_recvmsg_out4               392
#define hkwd_nrecvmsg_in                393
#define hkwd_nrecvmsg_err1              394
#define hkwd_nrecvmsg_err2                    	395
#define hkwd_nrecvmsg_err3                    	396
#define hkwd_nrecvmsg_err4                      397
#define hkwd_nrecvmsg_err5                      398
#define hkwd_nrecvmsg_err6                      399
#define hkwd_nrecvmsg_err7                      400
#define hkwd_nrecvmsg_err8                      401
#define hkwd_nrecvmsg_err9                      402
#define hkwd_nrecvmsg_err10                     403
#define hkwd_nrecvmsg_err11                     404
#define hkwd_nrecvmsg_err12                     405
#define hkwd_nrecvmsg_err13                     406
#define hkwd_nrecvmsg_err14                     407
#define hkwd_nrecvmsg_err15                     408
#define hkwd_nrecvmsg_err16                     409
#define hkwd_nrecvmsg_err17                     410
#define hkwd_nrecvmsg_err18                     411
#define hkwd_nrecvmsg_err19                     412
#define hkwd_nrecvmsg_err20                     413
#define hkwd_nrecvmsg_err21                     414
#define hkwd_nrecvmsg_err22                     415
#define hkwd_nrecvmsg_err23                     416
#define hkwd_nrecvmsg_err24                     417
#define hkwd_nrecvmsg_err25                     418
#define hkwd_nrecvmsg_err26                     419
#define hkwd_nrecvmsg_err27                     420
#define hkwd_nrecvmsg_err28                     421
#define hkwd_nrecvmsg_out1                      422
#define hkwd_nrecvmsg_out2                      423
#define hkwd_nrecvmsg_out3                      424
#define hkwd_recvit_err1                        425
#define hkwd_recvit_err2                        426
#define hkwd_recvit_err3                        427
#define hkwd_recvit_err4                        428
#define hkwd_recvit_err5                        429
#define hkwd_recvit_err6                        430
#define hkwd_recvit_err7                        431
#define hkwd_shutdown_err1                      432
#define hkwd_setsockopt_err1                    433
#define hkwd_setsockopt_err2                    434
#define hkwd_setsockopt_err3                    435
#define hkwd_setsockopt_err4                    436
#define hkwd_setsockopt_err5                    437
#define hkwd_getsockopt_err1                    438
#define hkwd_getsockopt_err2                    439
#define hkwd_getsockopt_err3                    440
#define hkwd_getsockopt_err4                    441
#define hkwd_getsockopt_err5                    442
#define hkwd_getsockopt_err6                    443
#define hkwd_getsockopt_err7                    444
#define hkwd_getsockname_err1                   445
#define hkwd_getsockname_err2                   446
#define hkwd_getsockname_err3                   447
#define hkwd_getsockname_err4                   448
#define hkwd_getsockname_err5                   449
#define hkwd_getsockname_err6                   450
#define hkwd_getsockname_err7                   451
#define hkwd_getsockname_err8                   452
#define hkwd_getpeername_err1                   453
#define hkwd_getpeername_err2                   454
#define hkwd_getpeername_err3                   455
#define hkwd_getpeername_err4                   456
#define hkwd_getpeername_err5                   457
#define hkwd_getpeername_err6                   458
#define hkwd_getpeername_err7                   459
#define hkwd_getpeername_err8                   460
#define hkwd_getpeername_err9                   461
#define hkwd_getpeereid_err1                    462
#define hkwd_getpeereid_err2                    463
#define hkwd_getpeereid_err3                    464
#define hkwd_getpeereid_err4                    465
#define hkwd_getpeereid_err5                    466
#define hkwd_getpeereid_err6                    467
#define hkwd_getpeereid_err7                    468
#define hkwd_sockargs_err1                      469
#define hkwd_sockargs_err2                      470
#define hkwd_sockargs_err3                      471
#define hkwd_sockargs_err4                      472
#define hkwd_socksetup_err1                     473
#define hkwd_socksetup_err2                     474
#define hkwd_getkerninfo_err1                   476
#define hkwd_getkerninfo_err2                   477
#define hkwd_getkerninfo_err3                   478
#define hkwd_getkerninfo_err4                   479
#define hkwd_getkerninfo_err5                   480
#define hkwd_getkerninfo_err6                   481
#define hkwd_getkerninfo_err7                   482
#define hkwd_getkerninfo_err8                   483
#define hkwd_getkerninfo_err9                   484
#define hkwd_getkerninfo_err10                  485
#define hkwd_getkerninfo_err11                  486
#define hkwd_getkerninfo_err12                  487
#define hkwd_getkerninfo_err13                  488
#define hkwd_getkerninfo_err14                  489
#define hkwd_getkerninfo_err15                  490
#define hkwd_getkerninfo_err16                  491
#define hkwd_getkerninfo_err17                  492
#define hkwd_getkerninfo_err18                  493
#define hkwd_getkerninfo_err19                  494
#define hkwd_getkerninfo_err20                  495
#define hkwd_socket_aio_dequeue_err1            496
#define hkwd_socket_aio_dequeue_err2            497
#define hkwd_kinfo_read_err1                    498
#define hkwd_kinfo_read_err2                    499
#define hkwd_kinfo_write_err1                   500
#define hkwd_kinfo_write_err2                   501
#define hkwd_splice_err1                        502
#define hkwd_splice_err2                        503
#define hkwd_sctp_opt_info_err1                 504
#define hkwd_sctp_opt_info_err2                 505
#define hkwd_sctp_opt_info_err3                 506
#define hkwd_sctp_opt_info_err4                 507
#define hkwd_sctp_opt_info_err5                 508
#define hkwd_sctp_opt_info_err6                 509
#define hkwd_sctp_peeloff_err1                  510
#define hkwd_sctp_peeloff_err2                  511
#define hkwd_sctp_peeloff_err3                  512
#define hkwd_sctp_peeloff_err4                  513
#define hkwd_sctp_peeloff_err5                  514
#define hkwd_sctp_peeloff_err6                  515
#define hkwd_sctp_peeloff_err7                  516
#define hkwd_sctp_peeloff_err8                  517
#define hkwd_k_getgroups_err1           	518
#define hkwd_k_getgroups_err2           	519
#define hkwd_sosplice_err3              	520	
#define hkwd_sodisconnectreuse_err1		521	
#define hkwd_sosbwait_err2              	522	
#define hkwd_soo_ioctl_err21            	523	
#define hkwd_soo_ioctl_err22            	524	
#define hkwd_soo_ioctl_err23            	525	
#define hkwd_soo_ioctl_err24           		526 
#define hkwd_soo_ioctl_err25           		527 
#define hkwd_socket_err2                	528	
#define hkwd_bind_err4                 	 	529
#define hkwd_listen_err1               		530 
#define hkwd__connect_err4              	531	
#define hkwd__connect_err5              	532	
#define hkwd__connect_err6              	533	
#define hkwd_send_err3                 		534	
#define hkwd_kinfo_avenrun_err			535
#define hkwd_kinfo_ipl_err			536
#define hkwd_kinfo_tick_err			537
#define hkwd_kinfo_sctp_err			538
#define hkwd_kinfo_mbstat_err			539
#define hkwd_kinfo_rtstat_err			540
#define hkwd_kinfo_icmpstat_err			541
#define hkwd_k_soaccept_err1                    542
#define hkwd_k_soaccept_err2                    543
#define hkwd_k_soaccept_err3                    544
#define hkwd_k_soaccept_err4                    545
#define hkwd_k_soaccept_err5                    546
#define hkwd_k_soaccept_err6                    547
#define hkwd_k_soaccept_err7                    548
#define hkwd_bind2addrsel_in			549
#define hkwd_bind2addrsel_out			550
#define hkwd_bind2addrsel_err1			551
#define hkwd_bind2addrsel_err2			552
#define hkwd_bind2addrsel_err3			553
#define hkwd_bind2addrsel_err4			554
#define hkwd_inet6_is_srcaddr_in		555
#define hkwd_inet6_is_srcaddr_out		556
#define hkwd_inet6_is_srcaddr_err1		557
#define hkwd_inet6_is_srcaddr_err2		558
#define hkwd_inet6_is_srcaddr_err3		559
#define hkwd_inet6_is_srcaddr_err4		560
#define hkwd_inet6_is_srcaddr_err5		561
#define hkwd_bind2addrsel_err5			562
#define hkwd_bind2addrsel_err6			563
#define hkwd_kern_socreate_af_err		564
#define hkwd_kern_socreate_type_err		565
#define hkwd_kern_socreate_proto_err		566
#define hkwd_kern_socreate_out			567
#define hkwd_kern_sobind_mem_err		568
#define hkwd_kern_sobind_af_err			569
#define hkwd_kern_sobind_addrlen_err		570
#define hkwd_kern_sobind_out			571
#define hkwd_kern_soconnect_mem_err		572
#define hkwd_kern_soconnect_af_err		573
#define hkwd_kern_soconnect_addrlen_err		574
#define hkwd_kern_soconnect_out1		575
#define hkwd_kern_soconnect_out2		576
#define hkwd_kern_soconnect_out3		577
#define hkwd_kern_soconnect_out4		578
#define hkwd_kern_soconnect_out5		579
#define hkwd_kern_solisten_backlog_err		580
#define hkwd_kern_solisten_out			581
#define hkwd_kern_soaccept_out			582
#define hkwd_kern_sogetopt_out			583
#define hkwd_kern_sosetopt_out			584
#define hkwd_kern_soreserve_out			585
#define hkwd_kern_soshutdown_out		586
#define hkwd_kern_soclose_out			587
#define hkwd_kern_soreceive_len_err		588
#define hkwd_kern_soreceive_out			589
#define hkwd_kern_sosend_mem_err		590
#define hkwd_kern_sosend_af_err			591
#define hkwd_kern_sosend_addrlen_err		592
#define hkwd_kern_sosend_out			593
#define hkwd_soclose2_err3			594
#define hkwd_soclose2_err4			595
#define hkwd_sohasoutofband_err1		596
#define hkwd_k_soaccept_err8			597
#define hkwd_soshutdown_err2			598
#define hkwd_soshutdown_err3			599
#define hkwd_sodequeue_info1			600
#define hkwd_sosetopt_sofilter_err1		601
#define hkwd_sosetopt_sofilter_err2 		602
#define hkwd_sosetopt_sofilter_err3		603
#define hkwd_sosetopt_sofilter_out		604
#define hkwd_sosetopt_sofilterdebug_err1	605
#define hkwd_sosetopt_sofilterdebug_err2	606
#define hkwd_sosetopt_sofilterdebug_out 	607
#define hkwd_sogetopt_err3			608
#define hkwd_sosend_err13			609
#define hkwd_rmsock_err3			610
#define hkwd_rmsock_err4			611
#define hkwd_rmsock_err5			612
#define hkwd_rmsock_err6			613
#define hkwd_rmsock_err7			614
#define hkwd_soclose_out1			615
#define hkwd_sendit_err10               	616
#define hkwd_socreate_err12             	617
#define hkwd_recvmmsg_in			618
#define hkwd_recvmmsg_err1			619
#define hkwd_recvmmsg_err2			620
#define hkwd_recvmmsg_err3			621
#define hkwd_recvmmsg_err4			622
#define hkwd_recvmmsg_err5			623
#define hkwd_recvmmsg_err6			624
#define hkwd_recvmmsg_err7			625
#define hkwd_recvmmsg_err8			626
#define hkwd_recvmmsg_err9			627
#define hkwd_recvmmsg_err10			628
#define hkwd_recvmmsg_err11			629
#define hkwd_recvmmsg_err12			630
#define hkwd_recvmmsg_out			631
#define hkwd_sosbwait_timeout_in		632
#define hkwd_sosbwait_timeout_err1		633
#define hkwd_sosbwait_timeout_err2		634
#define hkwd_sosbwait_timeout_out		635		
#define hkwd_sosetopt_sotimestampns_err1	636
#define hkwd_sosetopt_sotimestampns_err2	637
#define hkwd_sogetopt_sotimestampns_err1	638
#define hkwd_sogetopt_sotimestampns_err2	639

#define HKWD_TCP			0x53500000
#define hkwd_isprivport_in			1
#define hkwd_reroute_in				2
#define hkwd_splice_forward_in			3
#define hkwd_splice_forward_out			4
#define hkwd_tcp_SACKFastRecovery_in		5
#define hkwd_tcp_UpSACKInfo_in			6
#define hkwd_tcp_UpSACKInfo_out			7
#define hkwd_tcp_achalloc_in			8
#define hkwd_tcp_achfree_in			9
#define hkwd_tcp_achref_out			10
#define hkwd_tcp_achset_out			11
#define hkwd_tcp_acladd_in			12
#define hkwd_tcp_acladd_out			13
#define hkwd_tcp_aclbind_in			14
#define hkwd_tcp_aclclear_nolock_in		15
#define hkwd_tcp_acldel_in			16
#define hkwd_tcp_acldel_out			17
#define hkwd_tcp_aclflush_in			18
#define hkwd_tcp_aclls_in			19
#define hkwd_tcp_aclls_out			20
#define hkwd_tcp_adjust_buffers_in		21
#define hkwd_tcp_adjust_buffers_out		22
#define hkwd_tcp_attach_in			23
#define hkwd_tcp_attach_out			24
#define hkwd_tcp_auth0_in			25
#define hkwd_tcp_auth0_out1			26
#define hkwd_tcp_auth0_out2			27
#define hkwd_tcp_auth_in			28
#define hkwd_tcp_auth_out1			29
#define hkwd_tcp_auth_out2			30
#define hkwd_tcp_build_sacks_err		31
#define hkwd_tcp_build_sacks_in			32
#define hkwd_tcp_build_sacks_out		33
#define hkwd_tcp_canceltimers			34
#define hkwd_tcp_close_in			35
#define hkwd_tcp_close_out			36
#define hkwd_tcp_ctlinput_in			37
#define hkwd_tcp_ctlinput_out			38
#define hkwd_tcp_ctloutput_in			39
#define hkwd_tcp_ctloutput_out			40
#define hkwd_tcp_delayack_set_in		41
#define hkwd_tcp_delayack_set_out		42
#define hkwd_tcp_disconnect_in			43
#define hkwd_tcp_disconnect_out			44
#define hkwd_tcp_dooptions_in			45
#define hkwd_tcp_dooptions_out			46
#define hkwd_tcp_drop_in			47
#define hkwd_tcp_ephemeral_high_change_in	48
#define hkwd_tcp_ephemeral_high_change_out	49
#define hkwd_tcp_ephemeral_low_change_in	50
#define hkwd_tcp_ephemeral_low_change_out	51
#define hkwd_tcp_fasttimo_in			52
#define hkwd_tcp_fasttimo_out			53
#define hkwd_tcp_init_in			54
#define hkwd_tcp_init_out			55
#define hkwd_tcp_input0_in			56
#define hkwd_tcp_input0_out1			57
#define hkwd_tcp_input0_out2			58
#define hkwd_tcp_input0_out3			59
#define hkwd_tcp_input0_out4			60
#define hkwd_tcp_input0_out5			61
#define hkwd_tcp_input0_out6			62
#define hkwd_tcp_input0_out7			63
#define hkwd_tcp_input0_out8			64
#define hkwd_tcp_input0_out9			65
#define hkwd_tcp_input_in			66
#define hkwd_tcp_input_out			67
#define hkwd_tcp_lspriv_in			68
#define hkwd_tcp_lspriv_out			69
#define hkwd_tcp_map_pseg_in			70
#define hkwd_tcp_map_pseg_out			71
#define hkwd_tcp_mss_in				72
#define hkwd_tcp_mss_out			73
#define hkwd_tcp_newtcpcb_in			74
#define hkwd_tcp_newtcpcb_out			75
#define hkwd_tcp_notify_in			76
#define hkwd_tcp_notify_out			77
#define hkwd_tcp_output_in			78
#define hkwd_tcp_output_out			79
#define hkwd_tcp_pmtuchange_in			80
#define hkwd_tcp_process_sackopt_in		81
#define hkwd_tcp_process_sackopt_out1		82
#define hkwd_tcp_process_sackopt_out2		83
#define hkwd_tcp_pulloutofband_in		84
#define hkwd_tcp_pulloutofband_out		85
#define hkwd_tcp_quench_in			86
#define hkwd_tcp_reass_in			87
#define hkwd_tcp_reass_out1			88
#define hkwd_tcp_reass_out2			89
#define hkwd_tcp_reass_out3			90
#define hkwd_tcp_reass_out4			91
#define hkwd_tcp_reass_out5			92
#define hkwd_tcp_resend_in			93
#define hkwd_tcp_resend_out			94
#define hkwd_tcp_resprst_err			95
#define hkwd_tcp_resprst_in			96
#define hkwd_tcp_resprst_out			97
#define hkwd_tcp_send_and_disconnect_err	98
#define hkwd_tcp_send_and_disconnect_in		99
#define hkwd_tcp_send_and_disconnect_out	100
#define hkwd_tcp_send_and_kern_disconnect_err	101
#define hkwd_tcp_send_and_kern_disconnect_in	102
#define hkwd_tcp_send_and_kern_disconnect_out	103
#define hkwd_tcp_sendkeep_err			104
#define hkwd_tcp_sendkeep_in			105
#define hkwd_tcp_sendkeep_out			106
#define hkwd_tcp_setmss_in			107
#define hkwd_tcp_setmss_out			108
#define hkwd_tcp_setpersist_in			109
#define hkwd_tcp_setpersist_out			110
#define hkwd_tcp_setpriv_in			111
#define hkwd_tcp_setpriv_out			112
#define hkwd_tcp_slowtimo_in			113
#define hkwd_tcp_slowtimo_out			114
#define hkwd_tcp_splice_in			115
#define hkwd_tcp_splice_out			116
#define hkwd_tcp_template_in			117
#define hkwd_tcp_time_wait_timer_in		118
#define hkwd_tcp_time_wait_timer_out		119
#define hkwd_tcp_timer_init_in			120
#define hkwd_tcp_timers_in			121
#define hkwd_tcp_timers_out			122
#define hkwd_tcp_unsetpriv_in			123
#define hkwd_tcp_unsetpriv_out			124
#define hkwd_tcp_update_sacks_in		125
#define hkwd_tcp_update_sacks_out		126
#define hkwd_tcp_usrclosed_in			127
#define hkwd_tcp_usrclosed_out			128
#define hkwd_tcp_usrreq_err			129
#define hkwd_tcp_usrreq_in			130
#define hkwd_tcp_usrreq_out			131
#define hkwd_tcp_xmit_timer_in			132
#define hkwd_tcp_xmit_timer_out			133
#define hkwd_tcp_UpSACKInfo_out1                134
#define hkwd_tcp_build_sacks_out1               136
#define hkwd_tcp_build_sacks_out2               137
#define hkwd_tcp_build_sacks_out3               138
#define hkwd_tcp_build_sacks_out4               139
#define hkwd_tcp_input0_out10                   140
#define hkwd_tcp_input0_out11                   141
#define hkwd_tcp_input0_out12                   142
#define hkwd_tcp_input0_out13                   143
#define hkwd_tcp_input0_out14                   144
#define hkwd_tcp_input0_out15                   145
#define hkwd_tcp_input0_out16                   146
#define hkwd_tcp_input0_out17                   147
#define hkwd_tcp_input0_out18                   148
#define hkwd_tcp_input0_out19                   149
#define hkwd_tcp_input0_out20                   150
#define hkwd_tcp_input0_out21                   151
#define hkwd_tcp_input0_out22                   152
#define hkwd_tcp_input0_out23                   153
#define hkwd_tcp_input0_out24                   154
#define hkwd_tcp_input0_out25                   155
#define hkwd_tcp_input0_out26                   156
#define hkwd_tcp_input0_out27                   157
#define hkwd_tcp_input0_out28                   158
#define hkwd_tcp_input0_out29                   159
#define hkwd_tcp_input0_out30                   160
#define hkwd_tcp_input0_out31                   161
#define hkwd_tcp_input0_out32                   162
#define hkwd_tcp_input0_out33                   163
#define hkwd_tcp_input0_out34                   164
#define hkwd_tcp_input0_out35                   165
#define hkwd_tcp_input0_out36                   166
#define hkwd_tcp_input0_out37                   167
#define hkwd_tcp_input0_out38                   168
#define hkwd_tcp_input0_out39                   169
#define hkwd_tcp_input0_out40                   170
#define hkwd_tcp_input0_out41                   171
#define hkwd_tcp_input0_out42                   172
#define hkwd_tcp_input0_out43                   173
#define hkwd_tcp_input0_out44                   174
#define hkwd_tcp_input0_out45                   175
#define hkwd_tcp_input0_out46                   176
#define hkwd_tcp_input0_out47                   177
#define hkwd_tcp_input0_out48                   178
#define hkwd_tcp_input0_out49                   179
#define hkwd_tcp_input0_out50                   180
#define hkwd_tcp_input0_out51                   181
#define hkwd_tcp_input0_out52                   182
#define hkwd_tcp_input0_out53                   183
#define hkwd_tcp_input0_out54                   184
#define hkwd_tcp_input0_out55                   185
#define hkwd_tcp_input0_out56                   186
#define hkwd_tcp_input0_out57                   187
#define hkwd_tcp_input0_win1                    188
#define hkwd_tcp_process_sackopt_out3           191
#define hkwd_tcp_process_sackopt_out4           192
#define hkwd_tcp_auth_out3                      193
#define hkwd_tcp_mss_out1                       194
#define hkwd_tcp_setmss_out1                    195
#define hkwd_tcp_map_pseg_out1                  197
#define hkwd_tcp_output_sack_enabled1           198
#define hkwd_tcp_output_sack_enabled2           199
#define hkwd_tcp_output_update_snd_lowat	203
#define hkwd_tcp_output_out1                    204
#define hkwd_tcp_output_out2                    205
#define hkwd_tcp_output_out3                    206
#define hkwd_tcp_output_out4                    207
#define hkwd_tcp_output_out5                    208
#define hkwd_tcp_output_out6                    209
#define hkwd_tcp_output_out7                    210
#define hkwd_tcp_output_out8                    211
#define hkwd_tcp_output_out9                    212
#define hkwd_tcp_output_out10                   213
#define hkwd_tcp_output_out11                   214
#define hkwd_tcp_output_out12                   215
#define hkwd_tcp_newtcpcb_out1                  217
#define hkwd_tcp_notify_out1                    218
#define hkwd_tcp_ctlinput_out1                  220
#define hkwd_tcp_ctlinput_out2                  221
#define hkwd_tcp_ctlinput_out3                  222
#define hkwd_tcp_delayack_set_out1              223
#define hkwd_tcp_delayack_set_out2              224
#define hkwd_tcp_delayack_set_out3              225
#define hkwd_tcp_delayack_set_out4              226
#define hkwd_tcp_timers_out1                    227
#define hkwd_tcp_usrreq_err1                    228
#define hkwd_tcp_usrreq_err2                    229
#define hkwd_tcp_usrreq_err3                    230
#define hkwd_tcp_usrreq_err4                    231
#define hkwd_tcp_usrreq_err5                    232
#define hkwd_tcp_usrreq_out1                    233
#define hkwd_tcp_usrreq_out2                    234
#define hkwd_tcp_usrreq_out3                    235
#define hkwd_tcp_usrreq_out4                    236
#define hkwd_tcp_usrreq_out5                    237
#define hkwd_tcp_usrreq_out6                    238
#define hkwd_tcp_usrreq_out7                    239
#define hkwd_tcp_usrreq_out8                    240
#define hkwd_tcp_usrreq_out9                    241
#define hkwd_tcp_usrreq_out10                   242
#define hkwd_tcp_usrreq_err6                    243
#define hkwd_tcp_acladd_out1                    244
#define hkwd_tcp_acladd_out2                    245
#define hkwd_tcp_acladd_out3                    246
#define hkwd_tcp_acladd_out4                    247
#define hkwd_tcp_acldel_out1                    248
#define hkwd_tcp_acldel_out2                    249
#define hkwd_tcp_acldel_out3                    250
#define hkwd_tcp_aclls_out1                     251
#define hkwd_tcp_aclls_out2                     252
#define hkwd_tcp_aclls_out3                     253
#define hkwd_tcp_lspriv_out1                    254
#define hkwd_tcp_ctloutput_err			255
#define hkwd_tcp_attach_out1                    256
#define hkwd_tcp_attach_out2                    257
#define hkwd_tcp_attach_out3                    258
#define hkwd_tcp_splice_out1                    259
#define hkwd_tcp_splice_out2                    260
#define hkwd_tcp_reroute_out			261
#define hkwd_tcp_UpSACKInfo_out2		262
#define hkwd_tcp_reass_out			263
#define hkwd_tcp_input0_out58			264
#define hkwd_tcp_output_out13			265
#define hkwd_tcp_output_out14			266
#define hkwd_tcp_output_out15			267
#define hkwd_tcp_output_pmtu_alloc_fail		268
#define hkwd_tcp_usrreq_err7			269
#define hkwd_tcp_usrreq_err8			270
#define hkwd_tcp_usrreq_err9			271
#define hkwd_tcp_usrreq_err10			272
#define hkwd_tcp_usrreq_err11			273
#define hkwd_tcp_usrreq_err12			274
#define hkwd_tcp_usrreq_err13			275
#define hkwd_tcp_usrreq_err14			276
#define hkwd_tcp_usrreq_err15			277
#define hkwd_tcp_usrreq_err16			278
#define hkwd_tcp_usrreq_err17			279
#define hkwd_tcp_usrreq_pru_abort		280
#define hkwd_timer_wheel_init_in                281
#define hkwd_timer_wheel_init_out               282
#define hkwd_timer_wheel_slot_ins_in            283
#define hkwd_timer_wheel_slot_ins_out           284
#define hkwd_timer_wheel_slot_del_in            285
#define hkwd_timer_wheel_slot_del_out           286
#define hkwd_timer_wheel_sched_timer_in         287
#define hkwd_timer_wheel_sched_timer_out        288
#define hkwd_timer_wheel_resched_timer_in       289
#define hkwd_timer_wheel_resched_timer_out      290
#define hkwd_timer_wheel_cancel_timer_in        291
#define hkwd_timer_wheel_cancel_timer_out       292
#define hkwd_timer_wheel_tick_timeout_in        293
#define hkwd_timer_wheel_tick_timeout_out       294
#define hkwd_twheelsched_in                     295
#define hkwd_twheelsched_out                    296
#define hkwd_tcp_disconnect_out_error           297
#define hkwd_fastlo_waitconn1                   298
#define hkwd_fastlo_waitconn2                   299
#define hkwd_fastlo_waitconn3                   300
#define hkwd_fastlo_lookup                      301
#define hkwd_fastlo_setup                       302
#define hkwd_fastlo_setup_out1                  303
#define hkwd_fastlo_setup_out2                  304
#define hkwd_fastlo_setup_out3                  305
#define hkwd_fastlo_setup_out4                  306
#define hkwd_fastlo_setup_out5                  307
#define hkwd_fastlo_send                        308
#define hkwd_fastlo_rcvd                        309
#define hkwd_fastlo_trace                       311
#define hkwd_fastlo_terminate                   312
#define hkwd_fastlo_iseligible                  313
#define hkwd_fastlo_cflow                       314
#define hkwd_fastlo_setup_out0                  315
#define hkwd_newrenorxmt_out1			316
#define hkwd_newrenorxmt_out2			317
#define hkwd_fstrxmt_out			318
#define hkwd_fastlo_send_error			319

#define HKWD_UDP			0x53600000
#define hkwd_delay_sbdroprecord   		1
#define hkwd_udp_cksum_and_move_in   		2
#define hkwd_udp_cksum_and_move_out   		3
#define hkwd_udp_ctlinput_in   			4
#define hkwd_udp_ctlinput_out   		5
#define hkwd_udp_ephemeral_high_change_in   	6
#define hkwd_udp_ephemeral_low_change_in   	7
#define hkwd_udp_findmac_in   			8
#define hkwd_udp_findmac_out1   		9
#define hkwd_udp_findmac_out2   		10
#define hkwd_udp_init_in   			11
#define hkwd_udp_init_out   			12
#define hkwd_udp_input0_in   			13
#define hkwd_udp_input0_out1   			14
#define hkwd_udp_input0_out2   			15
#define hkwd_udp_input0_out3   			16
#define hkwd_udp_input0_out4   			17
#define hkwd_udp_input0_out5   			18
#define hkwd_udp_input1_in   			19
#define hkwd_udp_input1_out   			20
#define hkwd_udp_input_in   			21
#define hkwd_udp_input_out   			22
#define hkwd_udp_output_in   			23
#define hkwd_udp_output_out   			24
#define hkwd_udp_receive_in   			25
#define hkwd_udp_receive_out   			26
#define hkwd_udp_saveopt_in   			27
#define hkwd_udp_saveopt_out1   		28
#define hkwd_udp_saveopt_out2   		29
#define hkwd_udp_saveopt_out3   		30
#define hkwd_udp_saveopt_out4   		31
#define hkwd_udp_usrreq_in   			32
#define hkwd_udp_usrreq_out   			33
#define hkwd_udpsend_in   			34
#define hkwd_udpsend_out   			35
#define hkwd_udp_ephemeral_low_change_err1      36
#define hkwd_udp_ephemeral_high_change_err1     37
#define hkwd_udp_input0_err1                    38
#define hkwd_udp_input0_err2                    39
#define hkwd_udp_input0_err3                    40
#define hkwd_udp_input0_err4                    41
#define hkwd_udp_input0_err5                    42
#define hkwd_udp_input0_err6                    43
#define hkwd_udp_input0_err7                    44
#define hkwd_udp_input0_err8                    45
#define hkwd_udp_input0_err9                    46
#define hkwd_udp_input0_err10                   47
#define hkwd_udp_ctlinput_err1                  48
#define hkwd_udp_output_err1                    49
#define hkwd_udp_output_err2                    50
#define hkwd_udp_output_err3                    51
#define hkwd_udp_output_err4                    52
#define hkwd_udp_output_err5                    53
#define hkwd_udp_output_err6                    54
#define hkwd_udp_output_err7                    55
#define hkwd_udp_output_err8                    56
#define hkwd_udp_output_err9                    57
#define hkwd_udp_output_err10                   58
#define hkwd_udp_usrreq_err1                    59
#define hkwd_udp_usrreq_err2                    60
#define hkwd_udp_usrreq_err3                    61
#define hkwd_udp_usrreq_err4                    62
#define hkwd_udp_usrreq_err5                    63
#define hkwd_udpsend_err1                       64
#define hkwd_udpsend_err2                       65
#define hkwd_udpsend_err3                       66
#define hkwd_udpsend_err4                       67
#define hkwd_udpsend_err5                       68
#define hkwd_udpsend_err6                       69
#define hkwd_udpsend_err7                       70
#define hkwd_udpsend_err8                       71
#define hkwd_udpsend_err9                       72
#define hkwd_udpsend_err10                      73
#define hkwd_udpsend_err11                      74
#define hkwd_udpsend_err12                      75
#define hkwd_udpsend_err13                      76
#define hkwd_udpsend_err14                      77
#define hkwd_udpsend_err15                      78
#define hkwd_udpsend_err16                      79
#define hkwd_udpsend_err17                      80
#define hkwd_udpsend_err18                      81
#define hkwd_udpsend_err19                      82
#define hkwd_udp_receive_err1                   83
#define hkwd_udp_receive_err2                   84
#define hkwd_udp_receive_err3                   85
#define hkwd_udp_receive_err4                   86
#define hkwd_udp_receive_err5                   87
#define hkwd_udp_receive_err6                   88
#define hkwd_udp_receive_err7                   89
#define hkwd_udp_receive_err8                   90
#define hkwd_udp_receive_err9                   91
#define hkwd_udp_receive_err10                  92
#define hkwd_udp_receive_err11                  93
#define hkwd_udp_usrreq_abort                   94
#define hkwd_udp_notify_in                      95
#define hkwd_udp_output_ip_output               96
#define hkwd_udp_send_ip_output                 97
#define hkwd_udp_usrreq_err6			98
#define hkwd_udp_usrreq_out1			99
#define hkwd_udp_usrreq_out2			100
#define hkwd_udp_usrreq_out3			101
#define hkwd_udp_usrreq_out4			102
#define hkwd_udpsend_err20                      103
#define hkwd_udpsend_err21                      104
#define hkwd_udp_receive_err12                  105


#define HKWD_IP			0x53700000
#define hkwd_add_mfc_in			1
#define hkwd_add_mfc_out		2
#define hkwd_add_vif_in			3
#define hkwd_add_vif_out		4
#define hkwd_del_mfc_in			5
#define hkwd_del_mfc_out		6
#define hkwd_del_vif_in			7
#define hkwd_del_vif_out		8
#define hkwd_dequeue_pfctlinput_in	9
#define hkwd_dequeue_pfctlinput_out	10
#define hkwd_doghash_in			11
#define hkwd_doghash_out1		12
#define hkwd_doghash_out2		13
#define hkwd_doginit_in			14
#define hkwd_doginit_out1		15
#define hkwd_doginit_out2		16
#define hkwd_doginit_out3		17
#define hkwd_doginit_out4		18
#define hkwd_dogisr_in			19
#define hkwd_dogisr_out			20
#define hkwd_dogproc_in			21
#define hkwd_dogproc_out		22
#define hkwd_dogthread_in		23
#define hkwd_dogthread_out		24
#define hkwd_encap_send_in		25
#define hkwd_encap_send_out		26
#define hkwd_expire_upcalls_in		27
#define hkwd_expire_upcalls_out		28
#define hkwd_get_sg_cnt_in		29
#define hkwd_get_sg_cnt_out		30
#define hkwd_get_vif_cnt_in		31
#define hkwd_get_vif_cnt_out		32
#define hkwd_gids_ok_in			33
#define hkwd_gids_ok_out		34
#define hkwd_icmp_error_in		35
#define hkwd_icmp_error_out		36
#define hkwd_icmp_input_in		37
#define hkwd_icmp_input_out		38
#define hkwd_icmp_reflect_in		39
#define hkwd_icmp_reflect_out		40
#define hkwd_icmp_send_in		41
#define hkwd_icmp_send_out		42
#define hkwd_in_flip_and_run_in		43
#define hkwd_in_flip_and_run_out	44
#define hkwd_inbound_fw_free_args_in	45
#define hkwd_inbound_fw_save_args_in	46
#define hkwd_inbound_fw_save_args_out	47
#define hkwd_ip_changeversion_in	48
#define hkwd_ip_changeversion_out	49
#define hkwd_ip_ctloutput_in		50
#define hkwd_ip_ctloutput_out		51
#define hkwd_ip_dootions_in		52
#define hkwd_ip_drain_in		53
#define hkwd_ip_flush_packet_in		54
#define hkwd_ip_flush_packet_out	55
#define hkwd_ip_forward_in		56
#define hkwd_ip_forward_out1		57
#define hkwd_ip_forward_out2		58
#define hkwd_ip_forward_out3		59
#define hkwd_ip_forward_out4		60
#define hkwd_ip_forward_out5		61
#define hkwd_ip_freef_in		62
#define hkwd_ip_freemoptions_in		63
#define hkwd_ip_freemoptions_out	64
#define hkwd_ip_getmoptions_in		65
#define hkwd_ip_getmoptions_out		66
#define hkwd_ip_init_in			67
#define hkwd_ip_init_out		68
#define hkwd_ip_intr_in			69
#define hkwd_ip_intr_out		70
#define hkwd_ip_insertoptions_in	71
#define hkwd_ip_insertoptions_out	72
#define hkwd_ip_mdq_in			73
#define hkwd_ip_mdq_out			74
#define hkwd_ip_mforward_in		75
#define hkwd_ip_mforward_out		76
#define hkwd_ip_mloopback_in		77
#define hkwd_ip_mloopback_out		78
#define hkwd_ip_mrouter_done_in		79
#define hkwd_ip_mrouter_done_out	80
#define hkwd_ip_mrouter_get_in		81
#define hkwd_ip_mrouter_init_in		82
#define hkwd_ip_mrouter_init_out	83
#define hkwd_ip_mrouter_set_in		84
#define hkwd_ip_output_in		85
#define hkwd_ip_output_post_fw_in	86
#define hkwd_ip_output_post_fw_out	87
#define hkwd_ip_pcbopts_in		88
#define hkwd_ip_pcbopts_out1		89
#define hkwd_ip_pcbopts_out2		90
#define hkwd_ip_pmtu_start_in		91
#define hkwd_ip_pmtu_start_out		92
#define hkwd_ip_pmtu_stopt_in		93
#define hkwd_ip_pmtu_stopt_out		94
#define hkwd_ip_pmtu_timeout_in		95
#define hkwd_ip_pmtu_timeout_out	96
#define hkwd_ip_reass_in		97
#define hkwd_ip_reass_out1		98
#define hkwd_ip_reass_out2		99
#define hkwd_ip_rsvp_force_done_in	100
#define hkwd_ip_rsvp_force_done_out	101
#define hkwd_ip_rsvp_vif_done_in	102
#define hkwd_ip_rsvp_vif_done_out	103
#define hkwd_ip_rsvp_vif_init_in	104
#define hkwd_ip_rsvp_vif_init_out	105
#define hkwd_ip_rtaddr_in		106
#define hkwd_ip_rtaddr_out		107
#define hkwd_ip_setdupmtu_in		108
#define hkwd_ip_setdupmtu_out		109
#define hkwd_ip_setmoptions_in		110
#define hkwd_ip_setmoptions_out		111
#define hkwd_ip_slowtimo_in		112
#define hkwd_ip_srcroute_in		113
#define hkwd_ip_srcroute_out		114
#define hkwd_ip_stripoptions_in		115
#define hkwd_ip_stripoptions_out	116
#define hkwd_ipintr_noqueue_in		117
#define hkwd_ipintr_noqueue_out		118
#define hkwd_ipintr_noqueue_post_fw_in	119
#define hkwd_ipintr_noqueue_post_fw_out	120
#define hkwd_ipip_input_in		121
#define hkwd_ipip_input_out		122
#define hkwd_localaddr_notcast_in	123
#define hkwd_localaddr_notcast_out	124
#define hkwd_mroute_init_in		125
#define hkwd_mrt_ioctl_in		126
#define hkwd_outbound_fw_free_args_in	127
#define hkwd_outbound_fw_free_args_out	128
#define hkwd_outbound_fw_save_args_in	129
#define hkwd_outbound_fw_save_args_out	130
#define hkwd_phyint_send_in		131
#define hkwd_phyint_send_out		132
#define hkwd_pmtu_default_age_init_in	133
#define hkwd_pmtu_default_age_upd_in	134
#define hkwd_pmtu_default_age_upd_out	135
#define hkwd_pmtu_redis_intrvl_init_in	136
#define hkwd_pmtu_rtrequest_in		137
#define hkwd_pmtu_rtrequest_out		138
#define hkwd_priority_in		139
#define hkwd_priority_out		140
#define hkwd_queue_pfctlinput_in	141
#define hkwd_queue_pfctlinput_out	142
#define hkwd_raw_saveif_in		143
#define hkwd_raw_saveif_out		144
#define hkwd_rip_ctloutput_in		145
#define hkwd_rip_ctloutput_out		146
#define hkwd_rip_init_in		147
#define hkwd_rip_init_out		148
#define hkwd_rip_input_in		149
#define hkwd_rip_output_in		150
#define hkwd_rip_output_out		151
#define hkwd_rip_usrreq_in		152
#define hkwd_rip_usrreq_out		153
#define hkwd_rsvp_input_in		154
#define hkwd_rsvp_input_out		155
#define hkwd_save_rte_in		156
#define hkwd_save_rte_out		157
#define hkwd_socket_send_in		158
#define hkwd_socket_send_out		159
#define hkwd_tbf_control_in		160
#define hkwd_tbf_control_out		161
#define hkwd_tbf_dq_sel_in		162
#define hkwd_tbf_dq_sel_out		163
#define hkwd_tbf_process_q_in		164
#define hkwd_tbf_process_q_out		165
#define hkwd_tbf_reprocess_q_in		166
#define hkwd_tbf_reprocess_q_out	167
#define hkwd_tbf_send_packet_in		168
#define hkwd_tbf_send_packet_out	169
#define hkwd_tcp_pmtu_discover_init_in	170
#define hkwd_tcp_pmtu_discover_init_out	171
#define hkwd_tcp_pmtu_discover_upd_in	172
#define hkwd_tcp_pmtu_discover_upd_out	173
#define hkwd_udp_pmtu_discover_init_in	174
#define hkwd_udp_pmtu_discover_init_out	175
#define hkwd_udp_pmtu_discover_upd_in	176
#define hkwd_udp_pmtu_discover_upd_out	177
#define hkwd_outbound_fw_save_args_out1		178
#define hkwd_outbound_fw_save_args_out2		179
#define hkwd_outbound_fw_save_args_out3		180
#define hkwd_ip_output_post_fw_err1		181
#define hkwd_ip_output_post_fw_err2		182
#define hkwd_ip_output_post_fw_err3		183
#define hkwd_ip_output_post_fw_err4		184
#define hkwd_ip_output_post_fw_err5		185
#define hkwd_ip_output_post_fw_err6		186
#define hkwd_ip_output_post_fw_err7		187
#define hkwd_ip_output_post_fw_err8		188
#define hkwd_ip_output_post_fw_err9		189
#define hkwd_ip_output_post_fw_err10		190
#define hkwd_ip_output_post_fw_err11		191
#define hkwd_ip_output_post_fw_err12		192
#define hkwd_ip_output_post_fw_err13		193
#define hkwd_ip_output_post_fw_err14		194
#define hkwd_ip_output_post_fw_err15		195
#define hkwd_ip_output_post_fw_err16		196
#define hkwd_ip_output_post_fw_err17		197
#define hkwd_ip_output_post_fw_err18		198
#define hkwd_ip_output_post_fw_err19		199
#define hkwd_ip_insertoptions_out1		200
#define hkwd_ip_ctloutput_err1			201
#define hkwd_ip_ctloutput_err2			202	
#define hkwd_ip_ctloutput_err3			203
#define hkwd_ip_changeversion_err1		204
#define hkwd_ip_changeversion_err2		205
#define hkwd_ip_changeversion_err3		206
#define hkwd_ip_changeversion_err4		207
#define hkwd_localaddr_notcast_out1		208
#define hkwd_localaddr_notcast_out2		209
#define hkwd_localaddr_notcast_out3		210
#define hkwd_localaddr_notcast_out4		211
#define hkwd_ip_setmoptions_err1		212
#define hkwd_ip_setmoptions_err2		213
#define hkwd_ip_setmoptions_err3		214
#define hkwd_ip_setmoptions_err4		215
#define hkwd_ip_setmoptions_err5		216
#define hkwd_ip_getmoptions_err1		217
#define hkwd_ip_getmoptions_err2		218
#define hkwd_ip_getmoptions_out1		219
#define hkwd_ip_getmoptions_out2		220
#define hkwd_ip_getmoptions_out3		221
#define hkwd_ip_pcbopts_err1			222
#define hkwd_ip_pcbopts_err2			223
#define hkwd_ip_pcbopts_err3			224
#define hkwd_ip_pcbopts_err4			225
#define hkwd_ip_pcbopts_err5			226
#define hkwd_ip_intr_out1		227	
#define hkwd_ip_intr_out2		228
#define hkwd_inbound_fw_save_args_out1	229
#define hkwd_ip_dooptions_out		230
#define hkwd_ip_dooptions_out1		231
#define hkwd_ip_dooptions_out2		232
#define hkwd_ip_rtaddr_out1		233
#define hkwd_ip_rtaddr_out2		234
#define hkwd_gids_ok_out1		235
#define hkwd_gids_ok_out2		236
#define hkwd_gids_ok_out3		237
#define hkwd_save_rte_out1		238
#define hkwd_ip_srcroute_out1		239
#define hkwd_ip_srcroute_out2		240
#define hkwd_ip_forward_out6		241
#define hkwd_dogisr_out1		242
#define hkwd_dogisr_out2		243
#define hkwd_doghash_out3		244
#define hkwd_doghash_out4		245
#define hkwd_doghash_out5		246
#define hkwd_doghash_out6		247
#define hkwd_doghash_out7		248
#define hkwd_doghash_out8		249
#define hkwd_doghash_out9		250
#define hkwd_doghash_out10		251
#define hkwd_doghash_out11		252
#define hkwd_doghash_out12		253
#define hkwd_doghash_out13		254
#define hkwd_doghash_out14		255
#define hkwd_doghash_out15		256
#define hkwd_doghash_out16		257
#define hkwd_ip_reass_err1		258
#define hkwd_ip_reass_out3		259
#define hkwd_ip_reass_out4		260
#define hkwd_ip_insertoptions_out2		261
#define hkwd_udp_pmtu_discover_init_out1	262	
#define hkwd_tcp_pmtu_discover_init_out1	263
#define hkwd_pmtu_delete_not_found		264
#define hkwd_pmtu_delete_in			265
#define hkwd_pmtu_delete_out			266
#define hkwd_pmtu_expire_init_in		267
#define hkwd_pmtu_expire_init_out		268
#define hkwd_ip_pmtu_timeout_out1		269
#define hkwd_ip_pmtu_timeout_out2		270
#define hkwd_ip_pmtu_timeout_out3		271
#define hkwd_ip_pmtu_timeout_out4		272
#define hkwd_pmtu_equalifmtu_in         	273
#define hkwd_pmtu_setmtu_in             	274
#define hkwd_pmtu_del_request_usr            	275
#define hkwd_pmtu_del_request_route            	276
#define hkwd_pmtu_rediscover_v4         	277
#define hkwd_pmtu_rediscover_v6         	278
#define hkwd_pmtu_expire_upd_in			279
#define hkwd_pmtu_expire_upd_out		280
#define hkwd_pmtu_alloc_in			281
#define hkwd_pmtu_alloc_out			282
#define hkwd_pmtu_alloc_out1			283
#define hkwd_pmtu_alloc_out2			284
#define hkwd_pmtu_alloc_out3			285
#define hkwd_pmtu_alloc_out4			286
#define hkwd_ipintr_noqueue_post_fw_err1	287
#define hkwd_ipintr_noqueue_post_fw_err2	288
#define hkwd_ipintr_noqueue_post_fw_err3	289
#define hkwd_ipintr_noqueue_post_fw_err4	290
#define hkwd_ipintr_noqueue_post_fw_err5	291
#define hkwd_ipintr_noqueue_post_fw_err6	292
#define hkwd_ipintr_noqueue_post_fw_err7	293
#define hkwd_ipintr_noqueue_post_fw_err8	294
#define hkwd_ipintr_noqueue_post_fw_err9	295
#define hkwd_ipintr_noqueue_post_fw_err10	296
#define hkwd_ipintr_noqueue_post_fw_err11	297
#define hkwd_ip_dooptions_err1			298	
#define hkwd_ip_dooptions_err2			299	
#define hkwd_ip_dooptions_err3			300	
#define hkwd_ip_dooptions_err4			301	
#define hkwd_ip_dooptions_err5			302	
#define hkwd_ip_dooptions_err6			303	
#define hkwd_ip_dooptions_err7			304	
#define hkwd_ip_dooptions_err8			305	
#define hkwd_ip_dooptions_err9			306	
#define hkwd_ip_dooptions_err10			307	
#define hkwd_ip_dooptions_err11			308	
#define hkwd_ip_dooptions_err12			309	
#define hkwd_ip_dooptions_err13			310
#define hkwd_set_add_membership_in		311
#define hkwd_set_add_membership_out		312
#define hkwd_set_add_source_membership_in	313
#define hkwd_set_add_source_membership_out	314
#define hkwd_set_source_filter_in		315
#define hkwd_set_source_filter_out		316
#define hkwd_ip_setmoptions_err6		317
#define hkwd_ip_ctloutput_err4			318
#define hkwd_pmtu_get_list_in			319
#define hkwd_pmtu_get_list_out			320
#define hkwd_pmtu_get_list_err1			321
#define hkwd_pmtu_get_list_err2			322
#define hkwd_pmtu_get_list_err3			323
#define hkwd_pmtu_get_list_err4			324
#define hkwd_pmtu_get_list_err5			325
#define hkwd_pmtu_get_list_err6			326
#define hkwd_pmtu_get_list_info1		327
#define hkwd_ip_ctloutput_err5			328
#define hkwd_ip_ctloutput_err6			329

#define HKWD_IP6			0x53800000
#define hkwd_dopt6_input_in			1
#define hkwd_dopt6_input_out			2
#define hkwd_end6_input_in			3
#define hkwd_frg6_drain				4
#define hkwd_frg6_freef_in			5
#define hkwd_frg6_input_in			6
#define hkwd_frg6_input_out			7
#define hkwd_frg6_slowtimo_in			8
#define hkwd_hd6_inoptions_in			9
#define hkwd_hd6_inoptions_out			10
#define hkwd_hd6_outoptions			11
#define hkwd_hop6_input_in			12
#define hkwd_hop6_input_out			13
#define hkwd_icmp6_error_in			14
#define hkwd_icmp6_error_out1			15
#define hkwd_icmp6_error_out2			16
#define hkwd_icmp6_errparam_in			17
#define hkwd_icmp6_fasttimo_in			18
#define hkwd_icmp6_init_in			19
#define hkwd_icmp6_input_in			20
#define hkwd_icmp6_input_out			21
#define hkwd_icmp6_joingroup			22
#define hkwd_icmp6_leavegroup			23
#define hkwd_icmp6_reflect_in			24
#define hkwd_icmp6_reflect_out			25
#define hkwd_icmp6_send_in			26
#define hkwd_icmp6_send_out			27
#define hkwd_icmp6_sendmld_in			28
#define hkwd_icmp6_sendmld_out1			29
#define hkwd_icmp6_sendmld_out2			30
#define hkwd_icmp6_sendmld_out3			31
#define hkwd_icmp6_sendmld_out4			32
#define hkwd_ip6_copyoptions_in			33
#define hkwd_ip6_copyoptions_out		34
#define hkwd_ip6_ctloutput_in			35
#define hkwd_ip6_ctloutput_out			36
#define hkwd_ip6_deloption			37
#define hkwd_ip6_dropoption_in			38
#define hkwd_ip6_forward_in			39
#define hkwd_ip6_forward_out			40
#define hkwd_ip6_freemoptions_in		41
#define hkwd_ip6_getmoptions_in			42
#define hkwd_ip6_getmoptions_out		43
#define hkwd_ip6_getoptions_in			44
#define hkwd_ip6_getoptions_out			45
#define hkwd_ip6_init_in			46
#define hkwd_ip6_init_out			47
#define hkwd_ip6_input_in			48
#define hkwd_ip6_input_out			49
#define hkwd_ip6_insertoption_in		50
#define hkwd_ip6_insertoption_out		51
#define hkwd_ip6_mforward_in			52
#define hkwd_ip6_mforward_out			53
#define hkwd_ip6_mloopback_in			54
#define hkwd_ip6_mloopback_out			55
#define hkwd_ip6_output_in			56
#define hkwd_ip6_output_out			57
#define hkwd_ip6_reass_in			58
#define hkwd_ip6_reass_out			59
#define hkwd_ip6_saveoption_in			60
#define hkwd_ip6_saveoption_out			61
#define hkwd_ip6_setcontrol_in			62
#define hkwd_ip6_setcontrol_out			63
#define hkwd_ip6_setmoptions_in			64
#define hkwd_ip6_setmoptions_out		65
#define hkwd_ip6_setoptions_in			66
#define hkwd_ip6_setoptions_out			67
#define hkwd_ip6rttimeout_in			68
#define hkwd_ip6rttimeout_out			69
#define hkwd_ip6rttimer_in			70
#define hkwd_ip6rttimer_sched_in		71
#define hkwd_mfc_addqueue_in			72
#define hkwd_mfc_addqueue_out			73
#define hkwd_mfc_requeue_in			74
#define hkwd_mfc_requeue_out			75
#define hkwd_mfctimer_in			76
#define hkwd_mfctimer_out			77
#define hkwd_mroute6_init			78
#define hkwd_multicast_send_in			79
#define hkwd_multicast_send_out			80
#define hkwd_opt6_ctlinput_in			81
#define hkwd_opt6_ctlinput_out			82
#define hkwd_opt6_ferr_input			83
#define hkwd_opt6_haddr_input			84
#define hkwd_opt6_haddr_output			85
#define hkwd_opt6_init_in			86
#define hkwd_opt6_oerr_input			87
#define hkwd_opt6_reverse_in			88
#define hkwd_opt6_rtalert_input			89
#define hkwd_real_ip6_output_in			90	/* Unused */
#define hkwd_real_ip6_output_out		91	/* Unused */
#define hkwd_rt6_input_in			92
#define hkwd_rt6_input_out			93
#define hkwd_rt6_reverse_in			94
#define hkwd_rt6_reverse_out			95
#define hkwd_ip6_output_cachedroute        	96
#define hkwd_ip6_output_cachedroute_free   	97
#define hkwd_ip6_output_routetoif          	98
#define hkwd_ip6_output_netunreach         	99
#define hkwd_ip6_output_hostunreach        	100
#define hkwd_ip6_output_route_gwroute      	101
#define hkwd_ip6_output_mcast              	102
#define hkwd_ip6_output_mcast_noxface      	103
#define hkwd_ip6_output_mcast_hoplimit     	104
#define hkwd_ip6_output_sendit             	105
#define hkwd_ip6_output_nofrag_sent        	106
#define hkwd_ip6_output_frag_sent          	107
#define hkwd_ip6_output_bad                 	108
#define hkwd_llink_resolve_in                   109
#define hkwd_llink_resolve_out                  110
#define hkwd_ndp6_rtrequest_in                  111
#define hkwd_ndp6_rtrequest_out                 112
#define hkwd_ndp6_resolve_in                    113
#define hkwd_ndp6_resolve_out                   114
#define hkwd_ndsol6_output_in                   115
#define hkwd_ndsol6_output_out                  116
#define hkwd_ndadv6_output_in                   117
#define hkwd_ndadv6_output_out                  118
#define hkwd_redirect6_output_in                119
#define hkwd_redirect6_output_out               120
#define hkwd_ndsol6_input_in                    121
#define hkwd_ndsol6_input_out                   122
#define hkwd_ndadv6_input_in                    123
#define hkwd_ndadv6_input_out                   124
#define hkwd_rtsol6_input_in                    125
#define hkwd_rtsol6_input_out                   126
#define hkwd_rtadv6_input_in                    127
#define hkwd_rtadv6_input_out                   128
#define hkwd_redirect6_input_in                 129
#define hkwd_redirect6_input_out                130
#define hkwd_ip6_reachhint_in                   131
#define hkwd_ip6_reachhint_out                  132
#define hkwd_ndplookup_in                       133
#define hkwd_ndplookup_out                      134
#define hkwd_ndp6_ifinit_in                     135
#define hkwd_ndp6_ifinit_out                    136
#define hkwd_ndp6_rtlost_in                     137
#define hkwd_ndp6_rtlost_out                    138
#define hkwd_rip6_input_in                      139
#define hkwd_rip6_input_out                     140
#define hkwd_raw6_saverecv_in                   141
#define hkwd_raw6_saverecv_out                  142
#define hkwd_rip6_output_in                     143
#define hkwd_rip6_output_out                    144
#define hkwd_rip6_ctloutput_in                  145
#define hkwd_rip6_ctloutput_out                 146
#define hkwd_rip6_usrreq_in                     147
#define hkwd_rip6_usrreq_out                    148
#define hkwd_rip6_ctlinput_in                   149
#define hkwd_rip6_ctlinput_out1                 150
#define hkwd_rip6_ctlinput_out2                 151
#define hkwd_rip6_ctlinput_out3                 152
#define hkwd_rip6_ctlinput_out4                 153
#define hkwd_ip6_getctrlinfo_in			154
#define hkwd_ip6_getctrlinfo_out		155
#define hkwd_source_address_select_in		156
#define hkwd_source_address_select_out		157
#define hkwd_rip6_output_ancillary_in		158
#define hkwd_rip6_output_ancillary_out		159
#define hkwd_llink_resolve_nolock_in		160
#define hkwd_llink_resolve_nolock_out		161
#define hkwd_ip6_rtexpire_timeout_setup_in	162
#define hkwd_ip6_rtexpire_timeout_setup_out 	163
#define hkwd_ip6_rtexpire_netisr_in		164
#define hkwd_ip6_rtexpire_netisr_out		165
#define hkwd_ip6_ndsol_netisr_in                166
#define hkwd_ip6_ndsol_netisr_out1              167
#define hkwd_ip6_ndsol_netisr_out2              168
#define hkwd_in6_recvpathmtu_in                 169
#define hkwd_in6_recvpathmtu_bad                170
#define hkwd_in6_recvpathmtu_out                171
#define hkwd_in6_pcbnotifymtu_in                172
#define hkwd_in6_pcbnotifymtu_out               173
#define hkwd_ip6_setexthdroption_in             174
#define hkwd_ip6_setexthdroption_out            175
#define hkwd_ip6_getexthdroption_in             176
#define hkwd_ip6_getexthdroption_out            177
#define hkwd_raw6_saveopt_in                    178
#define hkwd_raw6_saveopt_bad                   179
#define hkwd_raw6_saveopt_out                   180
#define hkwd_mh6_input_in                       181
#define hkwd_mh6_input_out                      182
#define hkwd_ip6_reroute_in                     183
#define hkwd_ip6_reroute_out                    184
#define hkwd_set_source_filter6_in              185
#define hkwd_set_source_filter6_out             186
#define hkwd_ip6_input_out_err                  187

/* SEND starts at 0x200 */
#define send_hashit_hash_len                    200
#define send_clic_context                       201
#define send_clic_shainit                       202
#define send_hashit_sha                         203
#define send_config_inet_clic_init		204

#define cga_param_validation_in                 210
#define cga_param_validation_collision          211
#define cga_param_validation_prefix             212
#define cga_param_validation_local_cga          213
#define cga_param_validation_hash1              214
#define cga_param_validation_hash1_ifid         215
#define cga_param_validation_hash2              216
#define cga_param_validation_hash2_mask2        217
#define cga_param_validation_out                218
#define rsa_sig_generation_in                   219
#define rsa_sig_generation_ctx                  220
#define rsa_sig_generation_keyobj               221
#define rsa_sig_generation_local                222
#define rsa_sig_generation_signed               223
#define rsa_sig_generation_max_len              224
#define rsa_sig_generation_out                  225
#define rsa_sig_validation_in                   226
#define send_validate_options_failed            227
#define rsa_sig_validation_keyobj               228
#define rsa_sig_validation_malloc               229
#define rsa_sig_validation_signature            230
#define rsa_sig_validation_out                  231
#define key_hash_validate_in                    232
#define key_hash_validate_hash                  233
#define key_hash_validate_out                   234
#define key_hash_generate_in                    235
#define key_hash_generate_hash                  236
#define key_hash_generate_out                   237
#define nonce_validate_in                       238
#define nonce_validate_failed                   239
#define nonce_validate_out                      240
#define nonce_genereate_in                      241
#define nonce_genereate_out                     242
#define timestamp_validate_in                   243
#define timestamp_validate_failed               244
#define timestamp_validate_out                  245
#define timestamp_generate_in                   246
#define timestamp_generate_out                  247
#define send_validate_options_in                248
#define send_validate_options_invalid_msgtype   249
#define send_validate_options_req               250
#define send_validate_options_not_allowed       251
#define send_validate_options_err               252
#define send_validate_options_opt_undef         253
#define send_validate_options_out               254
#define send_generate_options_in                255
#define send_generate_options_invalid_msgtype   256
#define send_generate_options_opt_undef         257
#define send_generate_options_out               258
#define rx_cga_in                               259
#define rx_cga_rs_unsolicited_unspec_address    260
#define rx_cga_failed                           261
#define rx_cga_out                              262
#define rx_rsa_sig_keyobj                       263
#define rx_rsa_sig_keylen                       264
#define send_extractoptions_trunc               265
#define send_extractoptions_unknown_opt         266
#define send_extractoptions_extlen_icmplen      267
#define send_extractoptions_dup_opt             268

#define ip6_ctloutput_sec_send_clic             280
#define ip6_ctloutput_sec_send_len              281
#define ip6_ctloutput_sec_send_no_addr          282
#define ip6_ctloutput_sec_send_sic_malloc       283
#define ip6_ctloutput_sec_send_pub_key          284
#define ip6_ctloutput_sec_send_priv_key         285
#define ip6_ctloutput_sec_send_cga              286
#define ip6_ctloutput_sec_send_no_sic           287
#define ip6_ctloutput_sec_m                     288
#define ip6_ctloutput_sec_mcl                   289

/* IPv6 Zones (if_zone.c) starts at 300 */
#define hkwd_if6zone_init		300
#define hkwd_if6zone_attach_in		301
#define hkwd_if6zone_attach_err		302
#define hkwd_if6zone_attach_out		303
#define hkwd_if6zone_detach_in		304
#define hkwd_if6zone_detach_err		305
#define hkwd_if6zone_detach_out		306
#define hkwd_if6zone_getzone_in		307
#define hkwd_if6zone_getzone_err	308
#define hkwd_if6zone_getzone_out	309
#define hkwd_if6zone_setzone_in		310
#define hkwd_if6zone_setzone_err	311
#define hkwd_if6zone_setzone_out	312
#define hkwd_if6zone_lookup_in		313
#define hkwd_if6zone_lookup_err		314
#define hkwd_if6zone_lookup_out		315
#define hkwd_if6zone_join_zone		316

#define hkwd_flags6_passq_in   		317
#define hkwd_flags6_passq_info1		318
#define hkwd_flags6_passq_info2		319
#define hkwd_flags6_passq_out1		320
#define hkwd_flags6_passq_out2		321
#define hkwd_flags6_passq_out3		322
#define hkwd_flags6_passq_out4		323
#define hkwd_flags6_passq_out5		324
#define hkwd_flags6_passq_out6		325
#define hkwd_flags6_passq_out7		326
#define hkwd_flags6_passq_out8		327
#define hkwd_flags6_passq_out9		328
#define hkwd_flags6_passq_out10		329
#define hkwd_flags6_passq_out11		330
#define hkwd_flags6_passq_out12		331
#define hkwd_flags6_passq_out13		332
#define hkwd_flags6_passq_out14		333
#define hkwd_flags6_passq_out15		334
#define hkwd_flags6_passq_out16		335
#define hkwd_flags6_passq_out17		336
#define hkwd_flags6_passq_out18		337
#define hkwd_flags6_passq_out19		338
#define hkwd_flags6_passq_out20		339
#define hkwd_flags6_passq_out21		340


#define HKWD_PCB			0x53900000
#define hkwd_add_gateway_in			1
#define hkwd_add_gateway_out			2
#define hkwd_clear_ping_flags_in		3
#define hkwd_clear_ping_flags_out		4
#define hkwd_config_inet_in			5
#define hkwd_config_inet_out			6
#define hkwd_del_gateway_in			7
#define hkwd_del_gateway_nolock_in		8
#define hkwd_del_gateway_nolock_out		9
#define hkwd_del_gateway_out			10
#define hkwd_dgd_init_in			11
#define hkwd_dgd_init_out			12
#define hkwd_dgd_input6_in			13
#define hkwd_dgd_input6_out			14
#define hkwd_dgd_input_in			15
#define hkwd_dgd_input_out			16
#define hkwd_dgdretry_in			17
#define hkwd_dgdretry_out			18
#define hkwd_dgdretrysched_in			19
#define hkwd_dgdretrysched_out			20
#define hkwd_dgdsched_in			21
#define hkwd_dgdsched_out			22
#define hkwd_in6_addmulti_in			23
#define hkwd_in6_addmulti_out			24
#define hkwd_in6_control_in			25
#define hkwd_in6_control_out			26
#define hkwd_in6_delete_addrs_in		27
#define hkwd_in6_delete_addrs_out		28
#define hkwd_in6_delmulti_in			29
#define hkwd_in6_delmulti_out			30
#define hkwd_in6_ifattach_in			31
#define hkwd_in6_ifattach_out			32
#define hkwd_in6_ifinit_in			33
#define hkwd_in6_ifinit_out			34
#define hkwd_in6_ifscrub_in			35
#define hkwd_in6_ifscrub_out			36
#define hkwd_in6_pcbbind_dyn_in			37
#define hkwd_in6_pcbbind_dyn_out		38
#define hkwd_in6_pcbbind_in			39
#define hkwd_in6_pcbbind_out			43
#define hkwd_in6_pcbconnect_in			44
#define hkwd_in6_pcbconnect_out			47
#define hkwd_in6_pcblookup_in			48
#define hkwd_in6_pcblookup_out			51
#define hkwd_in6_pcbmatch_in			52
#define hkwd_in6_pcbmatch_out			53
#define hkwd_in6_pcbnotify_in			54
#define hkwd_in6_pcbnotify_out			55
#define hkwd_in6_pcbrebind_in			56
#define hkwd_in6_pcbrebind_out			57
#define hkwd_in6_rtalloc_in			58
#define hkwd_in6_rtalloc_out			59
#define hkwd_in6_rthost_in			60
#define hkwd_in6_rthost_out			61
#define hkwd_in6_setifa_in			62
#define hkwd_in6_setifa_out			63
#define hkwd_in_addmulti_in			64
#define hkwd_in_addmulti_out			65
#define hkwd_in_allpcbs_in			66
#define hkwd_in_allpcbs_out			67
#define hkwd_in_arpintr_in			68
#define hkwd_in_arpintr_out			69
#define hkwd_in_arpresolve_in			70
#define hkwd_in_control_in			71
#define hkwd_in_control_out			72
#define hkwd_in_delete_addrs_in			73
#define hkwd_in_delete_addrs_out		74
#define hkwd_in_delmulti_in			75
#define hkwd_in_delmulti_out			76
#define hkwd_in_hash_add_in			77
#define hkwd_in_hash_add_out			78
#define hkwd_in_hash_remove_in			79
#define hkwd_in_ifattach_in			80
#define hkwd_in_ifattach_out			81
#define hkwd_in_ifdetach_in			82
#define hkwd_in_ifdetach_out			83
#define hkwd_in_ifinit_in			84
#define hkwd_in_ifinit_out			85
#define hkwd_in_ifscrub_in			86
#define hkwd_in_losing_in			87
#define hkwd_in_losing_lock_in			88
#define hkwd_in_losing_lock_out			89
#define hkwd_in_losing_out			90
#define hkwd_in_pcb_hash_del_in			91
#define hkwd_in_pcb_hash_del_out		92
#define hkwd_in_pcb_hash_ins_in			93
#define hkwd_in_pcb_hash_ins_out		94
#define hkwd_in_pcb_tcp_hash_del_in		95
#define hkwd_in_pcb_tcp_hash_del_out		96
#define hkwd_in_pcb_tcp_lport_hash_ins_in	97
#define hkwd_in_pcb_tcp_lport_hash_ins_out	98
#define hkwd_in_pcballoc_in			99
#define hkwd_in_pcballoc_out			100
#define hkwd_in_pcbbind_in			101
#define hkwd_in_pcbbind_out			104
#define hkwd_in_pcbconnect_in			105
#define hkwd_in_pcbconnect_out			108
#define hkwd_in_pcbdetach_in			109
#define hkwd_in_pcbdetach_out			112
#define hkwd_in_pcbdisconnect_in		113
#define hkwd_in_pcbdisconnect_out		116
#define hkwd_in_pcbhashlookup2_in		121
#define hkwd_in_pcbhashlookup2_out		122
#define hkwd_in_pcbhashlookup_in		123
#define hkwd_in_pcbinit_in			124
#define hkwd_in_pcbinit_out			125
#define hkwd_in_pcblookup_in			126
#define hkwd_in_pcblookup_out			129
#define hkwd_in_pcbmatch_in			130
#define hkwd_in_pcbmatch_out			131
#define hkwd_in_pcbmovetotimewait_in		132
#define hkwd_in_pcbmovetotimewait_out		133
#define hkwd_in_pcbnotify_in			134
#define hkwd_in_pcbnotify_out			135
#define hkwd_in_pcbnotifyall_in			136
#define hkwd_in_pcbnotifyall_out		137
#define hkwd_in_rawpcbs_in			138
#define hkwd_in_rawpcbs_out			139
#define hkwd_in_rtchange_in			140
#define hkwd_in_rtchange_out			141
#define hkwd_in_rtinvalidate_in			142
#define hkwd_in_rtinvalidate_out		143
#define hkwd_in_setpeeraddr			144
#define hkwd_in_setsockaddr_in			145
#define hkwd_init_common_mtus_in		146
#define hkwd_mark_gateway_down_in		147
#define hkwd_mark_gateway_down_out		148
#define hkwd_ping_gateways_in			149
#define hkwd_ping_gateways_out			150
#define hkwd_ping_one_gateway_in		151
#define hkwd_ping_one_gateway_out		152
#define hkwd_set_ping_flag_in			153
#define hkwd_set_ping_flag_out			154
#define hkwd_tcp_bad_port_limit_init_in		155
#define hkwd_tcp_sendspace_change		156
#define hkwd_udp_bad_port_limit_init_in		157
#define hkwd_udp_sendspace_change		158
#define hkwd_in_pcbbind_sin			159
#define hkwd_in6_pcbbind_dyn_sin6		160
#define hkwd_in6_pcbbind_dyn_addr6		161
#define hkwd_in_pcb_pseudoconnect_in		162
#define hkwd_in_pcb_pseudoconnect_out		163
#define hkwd_in_pcb_pseudobind_in		164
#define hkwd_in_pcb_pseudobind_out		165
#define hkwd_in_pcb_pseudobind_sin		166
#define hkwd_in6_pcb_pseudoconnect_in		167
#define hkwd_in6_pcb_pseudoconnect_out		168
#define hkwd_in6_pcb_pseudobind_in		169
#define hkwd_in6_pcb_pseudobind_out		170
#define hkwd_in6_pcb_pseudobind_sin6		171
#define hkwd_in6_pcb_pseudobind_addr6		172
#define hkwd_in6_pcb_pseudorebind_in		173
#define hkwd_in6_pcb_pseudorebind_out		174
#define hkwd_in6_pcbnotifyall_in		176
#define hkwd_in6_pcbnotifyall_out               177
#define hkwd_in6_pcbnotifyall_err_out           178
#define hkwd_in6_setmss_in                      179
#define hkwd_in6_setmss_out                     180
#define hkwd_in6_pmtuclone_in                   181
#define hkwd_in6_pmtuclone_out                  182
#define hkwd_in_pcblocalipnotify_in             183
#define hkwd_in_pcblocalipnotify_out            184
#define hkwd_inet_dr_cpu_add_in			185
#define hkwd_inet_dr_cpu_add_out		186
#define hkwd_inet_dr_cpu_add_err1		187
#define hkwd_in_arpresolve_out1			188
#define hkwd_in_arpresolve_out2			189
#define hkwd_config_inet_err1			190
#define hkwd_in_pcbdetach_soputonfreelist      	191 
#define reserved192				192
#define hkwd_pmignet_hd_in			193
#define reserved194				194
#define hkwd_pmignet_hd_out			195
#define hkwd_pmignet_tx_in			196
#define hkwd_pmignet_tx_sa_family		197
#define hkwd_pmignet_tx_out			198
#define hkwd_pmignet_hd_enomen			199
#define hkwd_pmignet_register_list		200
#define hkwd_in_addmulti_sources_in		201
#define hkwd_in_addmulti_sources_out		202
#define hkwd_in_changemulti_sources_nolock_in	203
#define hkwd_in_changemulti_sources_nolock_out	204
#define hkwd_in6_addmulti_sources_in		205
#define hkwd_in6_addmulti_sources_out		206
#define hkwd_in6_changemulti_sources_nolock_in	207
#define hkwd_in6_changemulti_sources_nolock_out	208
#define hkwd_chk_dom_port_in 209
#define hkwd_chk_dom_port_out 210
#define hkwd_chk_dom_port_err 211
#define hkwd_in_pcbbind_err9			212
#define hkwd_prog_list_add_in_ipv4              213
#define hkwd_prog_list_add_err_ipv4             214
#define hkwd_prog_list_add_out_ipv4             215
#define hkwd_prog_list_search_in_ipv4           216
#define hkwd_prog_list_search_no_match_out_ipv4 217
#define hkwd_prog_list_search_match_out_ipv4    218
#define hkwd_prog_list_delete_in_ipv4           219
#define hkwd_prog_list_delete_err_ipv4          220
#define hkwd_prog_list_delete_out_ipv4          221
#define hkwd_prog_list_add_in_ipv6              222
#define hkwd_prog_list_add_err_ipv6             223
#define hkwd_prog_list_add_out_ipv6             224
#define hkwd_prog_list_search_in_ipv6           225
#define hkwd_prog_list_search_no_match_out_ipv6 226
#define hkwd_prog_list_search_match_out_ipv6    227
#define hkwd_prog_list_delete_in_ipv6           228
#define hkwd_prog_list_delete_err_ipv6          229
#define hkwd_prog_list_delete_out_ipv6          230
#define hkwd_in_pcbbind_err1a			231
#define hkwd_in_pcbbind_err2a			232
#define hkwd_in_pcbbind_err3a			233
#define hkwd_in_pcbbind_err4a			234
#define hkwd_in_pcbbind_err5a			235
#define hkwd_in_pcbbind_err6a			236
#define hkwd_in_pcbbind_err7a			237
#define hkwd_in_pcbbind_err8a			238
#define hkwd_in_pcbconnect_err1a		239
#define hkwd_in_pcbconnect_err2a		240
#define hkwd_in_pcbconnect_err3a		241
#define hkwd_in_pcbconnect_err4a		242
#define hkwd_in_pcbconnect_err5a		243
#define hkwd_in_pcbconnect_err6a		244
#define hkwd_in_pcbconnect_err7a		245
#define hkwd_in_pcbconnect_err8a		246
#define hkwd_in_pcbconnect_err9a		247
#define hkwd_in_pcb_pseudoconnect_err1a		248
#define hkwd_in_pcb_pseudoconnect_err2a		249
#define hkwd_in_pcb_pseudoconnect_err3a		250
#define hkwd_in_pcb_pseudoconnect_err4a		251
#define hkwd_in_pcb_pseudoconnect_err5a		252
#define hkwd_in_pcb_pseudoconnect_err6a		253
#define hkwd_in_pcb_pseudoconnect_err7a		254
#define hkwd_in_pcb_pseudoconnect_err8a		255
#define hkwd_in_pcb_pseudoconnect_err9a		256
#define hkwd_in_pcb_pseudobind_err1a 		257
#define hkwd_in_pcb_pseudobind_err2a		258
#define hkwd_in_pcb_pseudobind_err3a		259		
#define hkwd_in_pcb_pseudobind_err4a		260
#define hkwd_in_pcb_pseudobind_err5a		261
#define hkwd_in_pcb_pseudobind_err6a		262
#define hkwd_in_pcb_pseudobind_err7a		263
#define hkwd_in_pcb_pseudobind_err8a		264
#define hkwd_in_pcbnotify_out1a			265
#define hkwd_in_pcbnotify_out2a			266
#define hkwd_in_pcbnotify_out3a			267
#define hkwd_in_pcbnotifyall_out1a		268
#define hkwd_in_pcbnotifyall_out2a		269
#define hkwd_in_pcbnotifyall_out3a		270
#define hkwd_in_pcblocalipnotify_out1a		271
#define hkwd_in_pcblocalipnotify_out2a		272
#define hkwd_in_pcblocalipnotify_out3a		273



#define HKWD_MBUF		0x25400000
#define hkwd_m_get_in				1
#define hkwd_m_get_out				2
#define hkwd_m_getclr_in			3
#define hkwd_m_getclr_out			4
#define hkwd_m_free_in				5
#define hkwd_m_free_out				6
#define hkwd_m_copy_in				7
#define hkwd_m_copy_out				8
#define hkwd_m_copydata_in			9
#define hkwd_m_copydata_out			10
#define hkwd_m_pullup_1				11
#define hkwd_m_pullup_2				12
#define hkwd_mlowintr_in			13
#define hkwd_mlowintr_out			14
#define hkwd_m_low_test				15
#define hkwd_m_clgetm_in			16
#define hkwd_m_clgetm_out			17
#define hkwd_m_getclustm_in			18
#define hkwd_m_getclustm_out			19
#define hkwd_m_clattach_in			20
#define hkwd_m_clattach_out			21
#define hkwd_m_prepend_get_in			22
#define hkwd_m_prepend_get_out			23
#define hkwd_m_pullup_get_in			24
#define hkwd_m_pullup_get_out			25
#define hkwd_m_copy_get_in			26
#define hkwd_m_copy_get_out			27
#define hkwd_m_adj_in           		28
#define hkwd_m_pullup_in        		29
#define hkwd_m_retry_err1       		30
#define hkwd_m_pullup_err1      		31
#define hkwd_m_clattach_err1    		32
#define hkwd_m_getclustm_err1   		33
#define hkwd_m_getclustm_err2   		34
#define hkwd_m_collapse_err1    		35
#define hkwd_m_copymext_err1    		36
#define hkwd_m_copymext_err2    		37
#define hkwd_m_create_clustpool_err1            38
#define hkwd_m_create_clustpool_err2            39
#define hkwd_m_get_from_clustpool_nolock_err1   40
#define hkwd_mpool_grow_err1                    41
#define hkwd_mpool_grow_err2                    42
#define hkwd_mpool_clattach_err1                43
#define hkwd_mpool_clattach_err2                44
#define hkwd_mpool_clattach_err3                45
#define hkwd_m_copymext_in			46
#define hkwd_m_copymext_out			47
#define hkwd_m_create_clustpool_in		48
#define hkwd_m_create_clustpool_out		49
#define hkwd_mpool_grow_in			50	
#define hkwd_mpool_grow_out			51
#define hkwd_mpool_shrink_in			52
#define hkwd_mpool_shrink_out			53
#define hkwd_m_free_clustpool_in		54
#define hkwd_m_free_clustpool_out		55
#define hkwd_m_copy_out1				56
#define hkwd_m_copy_out2				57
#define hkwd_m_copy_err1				58
#define hkwd_m_copymext_out1			59
#define hkwd_m_copymext_out2			60
#define hkwd_m_copymext_err3			61
#define hkwd_m_free_to_clustpool_err1   62
#define hkwd_m_gethdr_in                        63
#define hkwd_m_gethdr_out                       64

/* These hook id's and sub hook id's are for Network Interface's */
#define HKWD_IFEN		0x25500000
#define HKWD_IFTR		0x25600000
#define HKWD_IFET		0x25700000
#define HKWD_IFXT		0x25800000
#define HKWD_IFSL		0x25900000
#define hkwd_statintr_in	1
#define hkwd_statintr_out	2	
#define hkwd_netintr_in		3
#define hkwd_netintr_out	4	
#define hkwd_attach_in		5
#define hkwd_attach_out		6
#define hkwd_detach_in		7
#define hkwd_detach_out		8
#define hkwd_init_in		9
#define hkwd_init_out		10
#define hkwd_ioctl_in		11
#define hkwd_ioctl_out		12
#define hkwd_output_in		13
#define hkwd_output_out		14
#define hkwd_reset_in		15
#define hkwd_reset_out		16
#define hkwd_rcv_in		17
#define hkwd_rcv_out		18
#define hkwd_incall_in		19
#define hkwd_incall_out		20	
#define hkwd_callcomp_in	21	
#define hkwd_callcomp_out	22
#define hkwd_clrind_in		23
#define hkwd_clrind_out		24
#define hkwd_slhiwat		25
#define hkwd_expand_table_or_add_row_out1       26
#define hkwd_expand_table_or_add_row_out2       27
#define hkwd_expand_table_or_add_row_out3       28
#define hkwd_config_en_in                       29
#define hkwd_config_en_out1                     30
#define hkwd_config_en_out2                     31
#define hkwd_config_en_out3                     32
#define hkwd_config_en_out4                     33
#define hkwd_config_en_out5                     34
#define hkwd_config_en_out6                     35
#define hkwd_config_en_out7                     36
#define hkwd_config_en_out8                     37
#define hkwd_config_en_out9                     38
#define hkwd_en_attach_in                       39
#define hkwd_en_ioctl_in                        40
#define hkwd_en_ioctl_out1                      41
#define hkwd_en_ioctl_err1                      42
#define hkwd_en_ioctl_err2                      43
#define hkwd_en_ioctl_err3                      44
#define hkwd_en_ioctl_err4                      45
#define hkwd_en_ioctl_err5                      46
#define hkwd_en_ioctl_err6                      47
#define hkwd_en_ioctl_err7                      48
#define hkwd_en_ioctl_debug1                    49
#define hkwd_en_ioctl_debug2                    50
#define hkwd_en_ioctl_debug3                    51
#define hkwd_en_ioctl_debug4                    52
#define hkwd_en_ioctl_out                       53
#define hkwd_en_output_in                       54
#define hkwd_en_output_out1                     55
#define hkwd_en_output_out2                     56
#define hkwd_en_output_out3                     57
#define hkwd_en_output_out4                     58
#define hkwd_en_output_out5                     59
#define hkwd_en_output_out6                     60
#define hkwd_en_output_out7                     61
#define hkwd_en_output_out8                     62
#define hkwd_en_output_out9                     63
#define hkwd_en_output_out10                    64
#define hkwd_en_output_out11                    65
#define hkwd_en_output_out12                    66
#define hkwd_en_output_out13                    67
#define hkwd_en_output_out14                    68
#define hkwd_en_output_out15                    69
#define hkwd_en_output_out16                    70
#define hkwd_en_output_out17                    71
#define hkwd_en_output_out18                    72
#define hkwd_en_output_out19                    73
#define hkwd_arpresolve_out1                    74
#define hkwd_arpresolve_out2                    75
#define hkwd_arpresolve_out3                    76
#define hkwd_arpresolve_out4                    77
#define hkwd_arpresolve_out5                    78
#define hkwd_arpresolve_out6                    79
#define hkwd_arpresolve_out7                    80
#define hkwd_arpresolve_out                     81
#define hkwd_arpinput_in                        82
#define hkwd_arpinput_out1                      83
#define hkwd_arpinput_out2                      84
#define hkwd_arpinput_out3                      85
#define hkwd_arpinput_out4                      86
#define hkwd_arpinput_out5                      87
#define hkwd_arpinput_out                       88
#define hkwd_in_arpinput_in                     89
#define hkwd_in_arpinput_out1                   90
#define hkwd_in_arpinput_out2                   91
#define hkwd_in_arpinput_out3                   92
#define hkwd_in_arpinput_out4                   93
#define hkwd_in_arpinput_out5                   94
#define hkwd_in_arpinput_out6                   95
#define hkwd_in_arpinput_out                    96
#define hkwd_config_en_out10                    97
#define hkwd_en_status_handler			98
#define hkwd_en_status_failover_error		99
#define hkwd_en_selfarp_tx			100
#define hkwd_en_attach_err1                     101

/* HOOK Ids for GIF interface */
#define	HKWD_IFGIF		0x26400000
#define	hkwd_config_gif_in				1
#define	hkwd_config_gif_err1			2
#define	hkwd_config_gif_err2			3
#define	hkwd_config_gif_err3			4
#define	hkwd_config_gif_err4			5
#define	hkwd_config_gif_err5			6
#define	hkwd_config_gif_out				7
#define	hkwd_gif_attach_in				8
#define	hkwd_gif_attach_err1			9
#define	hkwd_gif_attach_err2			10
#define	hkwd_gif_attach_out				11
#define	hkwd_gif_ioctl_in				12
#define	hkwd_gif_ioctl_err1				13
#define	hkwd_gif_ioctl_err2				14
#define	hkwd_gif_ioctl_err3				15
#define	hkwd_gif_ioctl_err4				16
#define	hkwd_gif_ioctl_err5				17
#define	hkwd_gif_ioctl_err6				18
#define	hkwd_gif_ioctl_err7				19
#define	hkwd_gif_ioctl_err8				20
#define	hkwd_gif_ioctl_err9				21
#define	hkwd_gif_ioctl_err10			22
#define	hkwd_gif_ioctl_err11			23
#define	hkwd_gif_ioctl_out				24
#define	hkwd_gif_output_in				25
#define	hkwd_gif_output_err1			26
#define	hkwd_gif_output_err2			27
#define	hkwd_gif_output_err3			28
#define	hkwd_gif_output_err4			29
#define	hkwd_gif_output_err5			30
#define	hkwd_gif_output_err6			31
#define	hkwd_gif_output_out				32
#define	hkwd_gif_output_out2			33
#define	hkwd_gif_input_in				34
#define	hkwd_gif_input_err1				35
#define	hkwd_gif_input_trc1				36
#define	hkwd_gif_input_trc2				37
#define	hkwd_gif_input_out				38
#define	hkwd_gif_input_out1				39
#define	hkwd_gif_input_out2				40
#define	hkwd_verify_tunl_addr_in		41
#define	hkwd_verify_tunl_addr_err1		42
#define	hkwd_verify_tunl_addr_out		43
#define	hkwd_gifstat_sync_in			44
#define	hkwd_gifstat_sync_out			45
#define	hkwd_gif_getrealif_in			46
#define	hkwd_gif_getrealif_err1			47
#define	hkwd_gif_getrealif_out			48
#define	hkwd_gif_getaddr_in				49
#define	hkwd_gif_getaddr_out1			50
#define	hkwd_gif_getaddr_out2			51




/* This hook id is for TCP debug */
#define HKWD_TCPDBG		0x25a00000

#define HKWD_NET_MALLOC		0x34000000

#define hkwd_net_malloc						1
#define hkwd_net_free						2
#define hkwd_net_kmem_inslist_in			3
#define hkwd_net_kmem_inslist_out			4
#define	hkwd_net_kmem_rmlist_in				5
#define	hkwd_net_kmem_rmlist_out			6
#define	hkwd_ostd_mem_expand_in				7
#define	hkwd_ostd_mem_expand_out			8
#define	hkwd_ostd_mem_del_in				9
#define	hkwd_ostd_mem_del_out1				10
#define	hkwd_ostd_mem_del_out2				11
#define	hkwd_ostd_mem_add_in				12
#define	hkwd_ostd_mem_add_out1				13
#define	hkwd_ostd_mem_add_out2				14
#define	hkwd_log_police_event_in			15
#define	hkwd_log_police_event_out1			16
#define	hkwd_log_police_event_out2			17
#define	hkwd_log_police_event_out3			18
#define	hkwd_log_police_event_out4			19
#define	hkwd_log_police_event_out5			20
#define	hkwd_log_police_event_out6			21
#define	hkwd_init_police_usage_in			22
#define	hkwd_init_police_usage_out1			23
#define	hkwd_init_police_usage_out2			24
#define	hkwd_init_police_usage_out3			25
#define	hkwd_free_police_usage_all_in		26
#define	hkwd_free_police_usage_all_out		27
#define	hkwd_net_malloc_police_station_in	28
#define	hkwd_net_malloc_police_station_out1	29
#define	hkwd_net_malloc_police_station_out2	30
#define	hkwd_net_malloc_police_station_out3	31
#define	hkwd_net_buf_type_nofct_in			32
#define	hkwd_net_buf_type_nofct_out1		33
#define	hkwd_net_buf_type_nofct_out2		34
#define	hkwd_net_buf_type_nofct_out3		35
#define	hkwd_net_buf_type_nofct_out4		36
#define	hkwd_net_buf_type_nofct_out5		37
#define	hkwd_net_buf_size_nofct_in			38
#define	hkwd_net_buf_size_nofct_out1		39
#define hkwd_net_buf_size_nofct_out2		40
#define	hkwd_net_buf_size_nofct_out3		41
#define	hkwd_net_buf_size_nofct_out4		42
#define	hkwd_net_malloc_frag_init_in		43
#define	hkwd_net_malloc_frag_init_out1		44
#define	hkwd_net_malloc_frag_init_out2		45
#define hkwd_net_malloc_frag_init_out3		46
#define	hkwd_netm_page_promote_init_in		47
#define	hkwd_netm_page_promote_init_out		48
#define	hkwd_net_malloc_in					49
#define	hkwd_net_malloc1					50
#define	hkwd_net_malloc2					51
#define	hkwd_net_malloc3					52
#define	hkwd_net_malloc4					53
#define	hkwd_net_malloc5					54
#define	hkwd_net_malloc6					55
#define	hkwd_net_malloc7					56
#define	hkwd_net_malloc_out1				57
#define	hkwd_net_malloc_out2				58
#define	hkwd_large_alloc_in					59
#define	hkwd_large_alloc_out1				60
#define	hkwd_large_alloc_out2				61
#define	hkwd_empty_bucket_in				62
#define	hkwd_empty_bucket_out1				63
#define	hkwd_empty_bucket_out2				64
#define	hkwd_net_free_in					65
#define	hkwd_net_free1						66
#define	hkwd_net_free2						67
#define	hkwd_net_free_out1					68
#define	hkwd_net_free_out2					69
#define	hkwd_net_free_out3					70
#define	hkwd_large_free_in					71
#define	hkwd_large_free_out					72
#define	hkwd_coalesce_in					73
#define	hkwd_coalesce_out					74
#define	hkwd_malloc_loan_in					75
#define	hkwd_malloc_loan_out1				76
#define	hkwd_malloc_loan_out2				77
#define	hkwd_malloc_thread_in				78
#define	hkwd_malloc_thread1					79
#define	hkwd_malloc_thread_out				80
#define	hkwd_coalesce_pages_in				81
#define	hkwd_coalesce_pages_out				82
#define	hkwd_prime_the_buckets_cpu_in		83
#define	hkwd_prime_the_buckets_cpu_out1		84
#define	hkwd_prime_the_buckets_cpu_out2		85
#define	hkwd_log_inuse_in					86
#define	hkwd_log_inuse_out					87
#define	hkwd_aix_kmem_alloc_in				88
#define	hkwd_aix_kmem_alloc_out1			89
#define	hkwd_aix_kmem_alloc_out2			90
#define	hkwd_aix_kmem_alloc_out3			91
#define	hkwd_aix_kmem_alloc2_in				92
#define	hkwd_aix_kmem_alloc2_out1			93
#define	hkwd_aix_kmem_alloc2_out2			94
#define	hkwd_aix_kmem_free_in				95
#define	hkwd_aix_kmem_free_out				96
#define	hkwd_net_malloc_cpudata_in			97
#define	hkwd_net_malloc_cpudata_out1		98
#define	hkwd_net_malloc_cpudata_out2		99
#define	hkwd_kmem_set_highwat_in			100
#define	hkwd_kmem_set_highwat_out			101
#define	hkwd_netkmem_dr_handler_in			102
#define	hkwd_netkmem_dr_handler_out1		103
#define	hkwd_netkmem_dr_handler_out2		104
#define	hkwd_netkmem_dr_handler_out3		105
#define	hkwd_netkmem_dr_handler_out4		106
#define	hkwd_netkmem_dr_handler_out5		107
#define	hkwd_netkmem_dr_handler_out6		108
#define	hkwd_netkmem_dr_handler_out7		109
#define	hkwd_netkmem_dr_handler_out8		110
#define	hkwd_netkmem_dr_handler_out9		111
#define	hkwd_netkmem_dr_handler_out10		112
#define	hkwd_netkmem_dr_handler_out11		113
#define	hkwd_netkmem_dr_cpu_remove_in		114
#define	hkwd_netkmem_dr_cpu_remove_out		115
#define	hkwd_netkmem_dr_cpu_add_in			116
#define	hkwd_netkmem_dr_cpu_add_out			117
#define	hkwd_netkmem_dr_mem_remove_in		118
#define	hkwd_netkmem_dr_mem_remove_out		119
#define	hkwd_netkmem_dr_mem_add_in			120
#define	hkwd_netkmem_dr_mem_add_out			121
#define	hkwd_ostd_init_in					122
#define	hkwd_ostd_init_out1					123
#define	hkwd_ostd_init_out2					124
#define	hkwd_log_ostd_event_in				125
#define	hkwd_log_ostd_event_out1			126
#define	hkwd_log_ostd_event_out2			127
#define	hkwd_log_ostd_event_out3			128
#define	hkwd_set_netm_errlevel_in			129
#define	hkwd_set_netm_errlevel_out			130
#define	hkwd_net_malloc_frag_timer_in		131
#define	hkwd_net_malloc_frag_timer_out1		132
#define	hkwd_net_malloc_frag_timer_out2		133
#define	hkwd_net_malloc_frag_timer_out3		134
#define	hkwd_net_malloc_frag_timer_stop_in	135
#define	hkwd_net_malloc_frag_timer_stop_out1	140
#define	hkwd_net_malloc_page_timer_in		141
#define	hkwd_net_malloc_page_timer_out		142
#define	hkwd_net_malloc_page_timer_stop_in	143
#define	hkwd_net_malloc_page_timer_stop_out1	144
#define	hkwd_net_malloc_page_timer_stop_out2	145
#define	hkwd_netkmem_dr_cpu_add_err1		146
#define	hkwd_netkmem_dr_cpu_add_err2		147
#define hkwd_net_malloc_frag_timer_stop_out2	148
#define	hkwd_log_illegal_mem_access_in		149
#define	hkwd_log_illegal_mem_access_out		150
#define hkwd_net_malloc_out                             151
#define hkwd_net_malloc_cpu_in                          152
#define hkwd_net_malloc_cpu1                            153
#define hkwd_net_malloc_cpu2                            154
#define hkwd_net_malloc_cpu3                            155
#define hkwd_net_malloc_cpu4                            156
#define hkwd_net_malloc_cpu5                            157
#define hkwd_net_malloc_cpu6                            158
#define hkwd_net_malloc_cpu7                            159
#define hkwd_net_malloc_cpu_out1                        160
#define hkwd_net_malloc_cpu_out2                        161
#define hkwd_net_malloc_srad_in                         162
#define hkwd_net_malloc_srad_out1                       163
#define hkwd_net_malloc_srad_out2                       164
#define hkwd_net_malloc_srad_out3                       165
#define hkwd_net_malloc_srad_out4                       166
#define hkwd_kmem_get_seg_in                            167
#define hkwd_kmem_get_seg_out1                          168
#define hkwd_kmem_get_seg_out2                          169
#define hkwd_kmem_get_seg_out3                          170
#define hkwd_netaddr2srad_in                            171
#define hkwd_netaddr2srad_out1                          172
#define hkwd_netaddr2srad_out2                          173
#define hkwd_netaddr2srad_out3                          174
#define hkwd_police_lock_init_in                        175
#define hkwd_police_lock_init_out1                      176
#define hkwd_police_lock_init_out2                      177
#define hkwd_police_lock_init_out3                      178
#define hkwd_baddr2netkmem_in                           179
#define hkwd_baddr2netkmem_out1                         180
#define hkwd_baddr2netkmem_out2                         181
#define hkwd_bucket2usagep_in                           182
#define hkwd_bucket2usagep_out1                         183
#define hkwd_bucket2usagep_out2                         184
#define hkwd_addr2segidx_in                             185
#define hkwd_addr2segidx_out1                           186
#define hkwd_addr2segidx_out2                           187
#define hkwd_addr2segidx_and_heap_in                    188
#define hkwd_addr2segidx_and_heap_out1                  189
#define hkwd_addr2segidx_and_heap_out2                  190
#define hkwd_kmem_search_in                             191
#define hkwd_kmem_search_out1                           192
#define hkwd_kmem_search_out2                           193
#define hkwd_start_netm_thread_in                       194
#define hkwd_start_netm_thread_out1                     195
#define hkwd_start_netm_thread_out2                     196
#define hkwd_start_netm_thread_out3                     197
#define hkwd_start_netm_thread_out4                     198
#define hkwd_start_netm_thread_out5                     199
#define hkwd_netkmem_dr_handler_out12                   200
#define hkwd_netkmem_dr_handler_out13                   201
#define hkwd_netkmem_dr_handler_out14                   202
#define hkwd_netkmem_dr_handler_out15                   203
#define hkwd_netkmem_dr_handler_out16                   204
#define hkwd_netkmem_dr_handler_out17                   205
#define hkwd_log_police_event_out7			206
#define hkwd_log_police_event_out8			207
#define hkwd_log_police_event_out9			208
#define	hkwd_netkmem_dr_handler_out18			209
#define	hkwd_netkmem_dr_handler_out19			210
#define hkwd_netkmem_dr_handler_out20                   211
#define hkwd_netkmem_dr_handler_out21                   212
#define hkwd_netkmem_dr_handler_out22                   213
#define hkwd_netkmem_dr_handler_out23                   214
#define hkwd_netkmem_dr_mem_removed                     215


/* This hook id is for ATM Socket Extensions */

#define HKWD_ATMSOCK		0x3A500000

#define HKWD_RDS		0x5EC00000  /* Reliable Datagram Sockets */
#define HKWD_RDS_ERROR		0x5F500000  /* Reliable Datagram Sockets */

#define HKWD_GRE_GENERAL	0x5F400000  /* Generic Routing Encapsulation */

/* These are TCPIP/FDDI related */
#define HKWD_IFCA		0x26000000
#define HKWD_IFSO		0x26100000
#define HKWD_IFFD		0x26200000
#define HKWD_DD_FDDIDD		0x26300000


/*
 * Data Link Control
 */
#define HKWD_SYSX_DLC_START       0x24000000 /* start link station    */
#define HKWD_SYSX_DLC_HALT        0x24100000 /* halt  link station    */
#define HKWD_SYSX_DLC_TIMER       0x24200000 /* timer                 */
#define HKWD_SYSX_DLC_XMIT        0x24300000 /* transmit packet       */
#define HKWD_SYSX_DLC_RECV        0x24400000 /* receive  packet       */
#define HKWD_SYSX_DLC_PERF        0x24500000 /* performance           */
#define HKWD_SYSX_DLC_MONITOR     0x24600000 /* monitor               */

#define HKWD_ODM_LIB              0x30000000 /* ODM code              */

/* hooks for STTY */
#define HKWD_STTY 		  0x40000000 
#define HKWD_STTY_STRTTY	  0x40100000 /* stream head tty */
#define HKWD_STTY_LDTERM 	  0x40200000 /* line discipline module */
#define HKWD_STTY_SPTR 		  0x40300000 /* serial printer discipline module */
#define HKWD_STTY_NLS 		  0x40400000 /* NLS mapping discipline module */
#define HKWD_STTY_PTY 		  0x40500000 /* pseudo tty driver */
#define HKWD_STTY_RS 		  0x40600000 /* RS driver */
#define HKWD_STTY_LION 		  0x40700000 /* LION driver */
#define HKWD_STTY_CXMA 		  0x40800000 /*  */
#define HKWD_STTY_ISA		  0x40900000 /* PCI/ISA native ports */
#define HKWD_STTY_JAS		  0x40a00000 /* Jasmine 2-port driver */

/* hooks till 0x40f00000 are reserved to stty for further use */

#define HKWD_VIRT_CONS            0x41700000 /* virtual console driver */

/* subhooks  for stty */
#define hkwd_TTY_CONFIG      0x01
#define hkwd_TTY_OPEN        0x02
#define hkwd_TTY_CLOSE       0x03
#define hkwd_TTY_WPUT        0x04
#define hkwd_TTY_RPUT        0x05
#define hkwd_TTY_WSRV        0x06
#define hkwd_TTY_RSRV        0x07
#define hkwd_TTY_REVOKE      0x08    /* for streamhead tty                   */
#define hkwd_TTY_IOCTL       0x09    /* for ioctls                           */
#define hkwd_TTY_PROC        0x0a    /* for drivers                          */
#define hkwd_TTY_SERVICE     0x0b    /* for drivers                          */
#define hkwd_TTY_SLIH        0x0c    /* for drivers                          */
#define hkwd_TTY_OFFL        0x0d    /* for drivers                          */
#define hkwd_TTY_LAST        0x0e    /* can be used for any specific entry   */

#define HKWD_CPU_PREEMPT 0x41900000	/* PHYP CPU preemption hook. */
/* Macros for the subhook */
#define _PRMT_REALLOC_M 0x8000		/* memory re-allocated */
#define _PRMT_WRAP_M 0x4000		/* preemption buffer wrapped */
#define _PRMT_CPUID_M 0xfff		/* cpu id */

/***********************************************************************/
/*************** DISPLAY SUBSYSTEM TRACE HOOK DEFINITIONS ************-*/
/***********************************************************************/
/*
 *  DISPLAY SUBSYSTEM MAJOR TRACE HOOKS
 *
 *  The display subsystem is divided into functional components.
 *  Each functional component is given two trace hooks.  The first
 *  trace hook is designated HKWD_xxx_P and is for performance trace.
 *  The second hook is designated HKWD_xxx_D and is for debug trace.
 *  The components of the display subsystem, for tracing purposes,
 *  are: Virtual Terminal Subsystem (VTSS); Rendering Context
 *  Manager (RCM); Device Dependent Functions of VTSS and RCM (DDF);
 *  Graphics Adapter Interface (GAI), which is divided into its
 *  subcomponents, 2D (GAI2DM1), Resource Management (GAIRMS),
 *  3D Model 1 (GAI3DM1), and 3D Model 2 (GAI3DM2); Enhanced X-Windows
 *  (X11); IBM's extensions to X (X11EXT); the SGI-like GL API (GL);
 *  and IBM graPHIGS (GRAPHIGS).
 *
 *  The trace hooks for display occupy the range 500 to 51F.  Further,
 *  the range 520-52F has been set aside in case the display subsystem
 *  requires additional growth.
 *
 *
 */

#define  HKWD_DISPLAY_VTSS_P           0x50000000  /*  display group  */
#define  HKWD_DISPLAY_VTSS_D           0x50100000
#define  HKWD_DISPLAY_RCM_P            0x50200000
#define  HKWD_DISPLAY_RCM_D            0x50300000
#define  HKWD_DISPLAY_DDF_P            0x50400000
#define  HKWD_DISPLAY_DDF_D            0x50500000
#define  HKWD_DISPLAY_GAIRMS_P         0x50600000
#define  HKWD_DISPLAY_GAIRMS_D         0x50700000
#define  HKWD_DISPLAY_GAI2DM1_P        0x50800000
#define  HKWD_DISPLAY_GAI2DM1_D        0x50900000
#define  HKWD_DISPLAY_GAI3DM1_P        0x50a00000
#define  HKWD_DISPLAY_GAI3DM1_D        0x50b00000
#define  HKWD_DISPLAY_GAI3DM2_P        0x50c00000
#define  HKWD_DISPLAY_GAI3DM2_D        0x50d00000
#define  HKWD_DISPLAY_X11_P            0x50e00000
#define  HKWD_DISPLAY_X11_D            0x50f00000
#define  HKWD_DISPLAY_X11EXT_P         0x51000000
#define  HKWD_DISPLAY_X11EXT_D         0x51100000
#define  HKWD_DISPLAY_GL_P             0x51200000
#define  HKWD_DISPLAY_GL_D             0x51300000
#define  HKWD_DISPLAY_GRAPHIGS_P       0x51400000
#define  HKWD_DISPLAY_GRAPHIGS_D       0x51500000
#define  HKWD_ACPA_P                   0x51600000
#define  HKWD_ACPA_D                   0x51700000
#define  HKWD_DISPLAY_RESERVED_518     0x51800000
#define  HKWD_DISPLAY_RESERVED_519     0x51900000
#define  HKWD_DISPLAY_RESERVED_51A     0x51a00000
#define  HKWD_DISPLAY_RESERVED_51B     0x51b00000
#define  HKWD_DISPLAY_RESERVED_51C     0x51c00000
#define  HKWD_DISPLAY_RESERVED_51D     0x51d00000
#define  HKWD_DISPLAY_RESERVED_51E     0x51e00000
#define  HKWD_DISPLAY_RESERVED_51F     0x51f00000

/*----------------------------------------------------------------
 *  DISPLAY SUBSYSTEM MINOR TRACE HOOKS
 *
 *  Each hookword occupies 32 bits.  The most significant 12 bits are
 *  the major hook ID.  The next four bits are reserved.  The least
 *  significant 16 bits are for component use.  The Display Subsystem
 *  uses the 16 bits to encode certain flags and to encode a minor
 *  hook ID.
 *
 *  The general format for the 16 bits of the minor hook ID is:
 *
 *  +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
 *  |           routine ID              | func ID|ex|
 *  +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
 *    0  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15
 *
 *
 *  The first twelve bits are a routine ID, giving a maximum of
 *  4096 routines per component.  The next three bits are the
 *  function ID within the component.  Function 000 is always
 *  reserved for the main entry/exit to the routine.  Functions
 *  001 to 110 are for internal functions within the routine.
 *  In this sense, function can be used to encode data as well.
 *  Function 111 is a special code that permits the first word
 *  of trace data to hold an expanded internal function code.
 *
 *  Bit 15, "ex", is set to 0 upon entry to the routine/function.
 *  The bit is set to 1 upon exit of the function.  This permits
 *  entry/exit tracing without reuse of the routine ID.
 *
 */

/*------------------------------------------------------------------
 *  VTSS MINOR TRACE HOOK DEFINITION
 *
 *  The VTSS component is has several major functional pieces, including
 *  the HFT (an AIX character device driver), the Screen Manager, the
 *  Mode Processor, the Virtual Display Driver, the Keyboard Device
 *  Driver, and other input device drivers.
 *
 *-----------------------------------------------------------------*/

#define  hkwd_DISPLAY_VTSS_HFT_OPEN          ( 0x001 << 4 )
#define  hkwd_DISPLAY_VTSS_HFT_CLOSE         ( 0x002 << 4 )
#define  hkwd_DISPLAY_VTSS_HFT_IOCTL         ( 0x003 << 4 )
#define  hkwd_DISPLAY_VTSS_HFT_CONFIG        ( 0x004 << 4 )
#define  hkwd_DISPLAY_VTSS_HFT_MULTIPLEX     ( 0x005 << 4 )
#define  hkwd_DISPLAY_VTSS_HFT_SELECT        ( 0x006 << 4 )
#define  hkwd_DISPLAY_VTSS_HFT_READ          ( 0x007 << 4 )
#define  hkwd_DISPLAY_VTSS_HFT_WRITE         ( 0x008 << 4 )
#define  hkwd_DISPLAY_VTSS_HFT_REVOKE        ( 0x009 << 4 )
#define  hkwd_DISPLAY_VTSS_HFT_INPUT         ( 0x00a << 4 )
#define  hkwd_DISPLAY_VTSS_HFT_OUTPUT        ( 0x00b << 4 )

#define  hkwd_DISPLAY_VTSS_VDD_ACT           ( 0x101 << 4 )
#define  hkwd_DISPLAY_VTSS_VDD_CFL           ( 0x102 << 4 )
#define  hkwd_DISPLAY_VTSS_VDD_CLR           ( 0x103 << 4 )
#define  hkwd_DISPLAY_VTSS_VDD_CPL           ( 0x104 << 4 )
#define  hkwd_DISPLAY_VTSS_VDD_DACT          ( 0x105 << 4 )
#define  hkwd_DISPLAY_VTSS_VDD_DEFC          ( 0x106 << 4 )
#define  hkwd_DISPLAY_VTSS_VDD_TERM          ( 0x107 << 4 )
#define  hkwd_DISPLAY_VTSS_VDD_INIT          ( 0x108 << 4 )
#define  hkwd_DISPLAY_VTSS_VDD_MOVC          ( 0x109 << 4 )
#define  hkwd_DISPLAY_VTSS_VDD_RDS           ( 0x10a << 4 )
#define  hkwd_DISPLAY_VTSS_VDD_TEXT          ( 0x10b << 4 )
#define  hkwd_DISPLAY_VTSS_VDD_SCR           ( 0x10c << 4 )
#define  hkwd_DISPLAY_VTSS_VDD_SETM          ( 0x10d << 4 )
#define  hkwd_DISPLAY_VTSS_VDD_STCT          ( 0x10e << 4 )

/*------------------------------------------------------------------
 *  GAI 2D Model 1 (GAI2DM1) MINOR TRACE HOOK DEFINITION
 *
 *  The minor IDs listed below are performance trace hooks
 *  for GAI 2D Model 1.
 *
 *  These functions are listed in the order specified in the             /
 *  2D Graphics Context Procedures structure.
 *
 *-----------------------------------------------------------------*/

#define  hkwd_DISPLAY_GAI2DM1_DESTROYGC             ( 1 << 4 )
#define  hkwd_DISPLAY_GAI2DM1_ANALYZEGC             ( 2 << 4 )
#define  hkwd_DISPLAY_GAI2DM1_COPYPIXTOWIN          ( 3 << 4 )
#define  hkwd_DISPLAY_GAI2DM1_COPYWINTOPIX          ( 4 << 4 )
#define  hkwd_DISPLAY_GAI2DM1_COPYWINTOWIN          ( 5 << 4 )
#define  hkwd_DISPLAY_GAI2DM1_COPYPIXBPTOWIN        ( 6 << 4 )
#define  hkwd_DISPLAY_GAI2DM1_COPYWINBPTOPIX        ( 7 << 4 )
#define  hkwd_DISPLAY_GAI2DM1_COPYWINBPTOWIN        ( 8 << 4 )
#define  hkwd_DISPLAY_GAI2DM1_POLYPOINT             ( 9 << 4 )
#define  hkwd_DISPLAY_GAI2DM1_POLYLINES             ( 10 << 4 )
#define  hkwd_DISPLAY_GAI2DM1_POLYSEGMENT           ( 11 << 4 )
#define  hkwd_DISPLAY_GAI2DM1_POLYRECTANGLE         ( 12 << 4 )
#define  hkwd_DISPLAY_GAI2DM1_POLYARC               ( 13 << 4 )
#define  hkwd_DISPLAY_GAI2DM1_FILLPOLYGON           ( 14 << 4 )
#define  hkwd_DISPLAY_GAI2DM1_POLYFILLRECT          ( 15 << 4 )
#define  hkwd_DISPLAY_GAI2DM1_POLYFILLARC           ( 16 << 4 )
#define  hkwd_DISPLAY_GAI2DM1_PUTIMAGE              ( 17 << 4 )
#define  hkwd_DISPLAY_GAI2DM1_IMAGETEXT8            ( 18 << 4 )
#define  hkwd_DISPLAY_GAI2DM1_POLYTEXT8             ( 19 << 4 )
#define  hkwd_DISPLAY_GAI2DM1_IMAGETEXT16           ( 20 << 4 )
#define  hkwd_DISPLAY_GAI2DM1_POLYTEXT16            ( 21 << 4 )
#define  hkwd_DISPLAY_GAI2DM1_PUSHPIXELS            ( 22 << 4 )

/*------------------------------------------------------------------
 *  M-ACPA/A MINOR TRACK HOOK DEFINITION
 *
 *  The minor IDs listed below are performance trace hooks
 *  for the Mulitmedia Audio Capture and Playback Adapter.
 *
 *-----------------------------------------------------------------*/

#define  hkwd_ACPA_CFGINIT                      ( 1 << 4 )
#define  hkwd_ACPA_CFGTERM                      ( 2 << 4 )
#define  hkwd_ACPA_OPEN                         ( 3 << 4 )
#define  hkwd_ACPA_CLOSE                        ( 4 << 4 )
#define  hkwd_ACPA_INTERRUPT                    ( 5 << 4 )
#define  hkwd_ACPA_READ                         ( 6 << 4 )
#define  hkwd_ACPA_WRITE                        ( 7 << 4 )
#define  hkwd_ACPA_IOCTL                        ( 8 << 4 )
#define  hkwd_ACPA_MPX                          ( 9 << 4 )
#define  hkwd_ACPA_SELECT                       ( 10 << 4 )
#define  hkwd_ACPA_INIT                         ( 11 << 4 )
#define  hkwd_ACPA_CHANGE                       ( 12 << 4 )
#define  hkwd_ACPA_START                        ( 13 << 4 )
#define  hkwd_ACPA_STOP                         ( 14 << 4 )
#define  hkwd_ACPA_PAUSE                        ( 15 << 4 )
#define  hkwd_ACPA_RESUME                       ( 16 << 4 )
#define  hkwd_ACPA_STATUS                       ( 17 << 4 )
#define  hkwd_ACPA_WAIT                         ( 18 << 4 )
#define  hkwd_ACPA_BUFFER                       ( 19 << 4 )
#define  hkwd_ACPA_LOAD                         ( 20 << 4 )
#define  hkwd_ACPA_DEVSTART                     ( 21 << 4 )
#define  hkwd_ACPA_DEVSTOP                      ( 22 << 4 )
#define  hkwd_ACPA_INITZ                        ( 23 << 4 )
#define  hkwd_ACPA_TIMEDOUT                     ( 24 << 4 )

/***********************************************************************/
/************ END OF DISPLAY SUBSYSTEM TRACE HOOK DEFINITIONS ********-*/
/***********************************************************************/

/* Netbios */

#define HKWD_NB_TRACE_NCB 		0x28300000
#define HKWD_NB_TRACE_IOB		0x28400000
#define HKWD_NB_TRACE_OPEN 	 	0x28500000
#define HKWD_NB_TRACE_COMM	 	0x28600000
#define HKWD_NB_TRACE_WRITE 		0x28700000
#define HKWD_NB_TRACE_READ 		0x28800000
#define HKWD_NB_TRACE_DATA	 	0x28900000
#define HKWD_NB_TRACE_MIF	 	0x28a00000
#define HKWD_NB_TRACE_VALUE		0x28b00000

/* Hook for detection of excessive interrupt disablement */
#define HKWD_KERN_DISABLEMENT	0x4AF00000

/* Hook for kernel profiling */
#define HKWD_KERN_PROF		0x23400000  /* capture iar at clock intr */
/* MSR bit tprof hooks modifier */
#define hkwd_PROF_HV	0x00008000
/* PR bit tprof hook modifier */
#define hkwd_PROF_PR	0x00004000

/* Hook for tprof events profiling */
#define HKWD_KERN_TPROF         0x2FF00000
/* Subhooks for HKWD_KERN_TPROF hook */
#define hkwd_tprof_cmd          1
#define hkwd_tprof_util         2
#define hkwd_tprof_hwevts       3
#define hkwd_tprof_swalign      4
#define hkwd_tprof_swemu        5
#define hkwd_tprof_swislbmiss   6
#define hkwd_tprof_swdslbmiss   7
#define hkwd_tprof_dataprof     8
#define hkwd_tprof_too_rapid    9
#define hkwd_tprof_usercmd      0xa
#define hkwd_tprof_lparmig      0xb

/* Hooks for COBOL */
#define HKWD_COB                        0x23500000
#define HKWD_COB_RTE                    0x23600000
#define HKWD_COB_APPL                   0x23700000

/* Hooks for PSLA */
#define HKWD_PSLA_OPEN                  0x27200000
#define HKWD_PSLA_CLOSE                 0x27300000
#define HKWD_PSLA_READ                  0x27400000
#define HKWD_PSLA_WRITE                 0x27500000
#define HKWD_PSLA_IOCTL                 0x27600000
#define HKWD_PSLA_INTR                  0x27700000
#define HKWD_PSLA_CONF			0x27800000

/* Hook for NCS */
#define HKWD_NCS_NCK                    0x27900000

/* Hooks for SNA */
#define HKWD_SNA_COMM                   0x27000000
#define HKWD_SNA_API                    0x27100000
#define HKWD_GSNA_API                   0x28100000
#define HKWD_SNALIB_API                 0x28200000

/* Hooks for SYSXMSLA */
#define HKWD_HIA			0x28000000

/* Hook for Netview */
#define HKWD_NETVIEW_6000               0x29000000

/* Hook for Hursley */
#define HKWD_HSTC_PRD                   0x29100000

/* Hook for SYSXVCA */
#define HKWD_VCA_DD			0x29200000

/* VCA sub hook ids */
#define hkwd_VCA_ENTRY_OPEN			0x1
#define hkwd_VCA_EXIT_OPEN			0x2
#define hkwd_VCA_ENTRY_CLOSE			0x3
#define hkwd_VCA_EXIT_CLOSE			0x4
#define hkwd_VCA_ENTRY_READ			0x5
#define hkwd_VCA_EXIT_READ			0x6
#define hkwd_VCA_ENTRY_WRITE			0x7
#define hkwd_VCA_EXIT_WRITE			0x8
#define hkwd_VCA_ENTRY_CONFIG			0x9
#define hkwd_VCA_EXIT_CONFIG			0xA
#define hkwd_VCA_ENTRY_IOCTL			0xB
#define hkwd_VCA_EXIT_IOCTL			0xC
#define hkwd_VCA_ENTRY_VCA_SETUP		0xD
#define hkwd_VCA_EXIT_VCA_SETUP			0xE
#define hkwd_VCA_ENTRY_VCA_MEMCOPY		0xF
#define hkwd_VCA_EXIT_VCA_MEMCOPY		0x10
#define hkwd_VCA_ENTRY_MEM_SETUP		0x11
#define hkwd_VCA_EXIT_MEM_SETUP			0x12
#define hkwd_VCA_ENTRY_MEM_UNSET		0x13
#define hkwd_VCA_EXIT_MEM_UNSET			0x14
#define hkwd_VCA_ENTRY_GETSTATUS		0x15
#define hkwd_VCA_EXIT_GETSTATUS			0x16
#define hkwd_VCA_ENTRY_SETMASK			0x17
#define hkwd_VCA_EXIT_SETMASK			0x18
#define hkwd_VCA_ENTRY_CAPTURE_WAIT		0x19
#define hkwd_VCA_EXIT_CAPTURE_WAIT		0x1A
#define hkwd_VCA_ENTRY_INTR_ENABLE		0x1B
#define hkwd_VCA_EXIT_INTR_ENABLE		0x1C
#define hkwd_VCA_ENTRY_INTR_DISABLE		0x1D
#define hkwd_VCA_EXIT_INTR_DISABLE		0x1E
#define hkwd_VCA_ENTRY_VCA_SET_MODE		0x1F
#define hkwd_VCA_EXIT_VCA_SET_MODE		0x20
#define hkwd_VCA_ENTRY_VCA_SET_CONTROLS		0x21
#define hkwd_VCA_EXIT_VCA_SET_CONTROLS		0x22
#define hkwd_VCA_ENTRY_VCA_SET_CURSOR		0x23
#define hkwd_VCA_EXIT_VCA_SET_CURSOR		0x24
#define hkwd_VCA_ENTRY_VCA_SET_WINDOW		0x25
#define hkwd_VCA_EXIT_VCA_SET_WINDOW		0x26
#define hkwd_VCA_ENTRY_VCA_SET_DACS		0x27
#define hkwd_VCA_EXIT_VCA_SET_DACS		0x28
#define hkwd_VCA_ENTRY_ALTDAC			0x29
#define hkwd_VCA_EXIT_ALTDAC			0x2A
#define hkwd_VCA_ENTRY_VCA_GET_MODE		0x2B
#define hkwd_VCA_EXIT_VCA_GET_MODE		0x2C
#define hkwd_VCA_ENTRY_VCA_GET_CONTROLS		0x2D
#define hkwd_VCA_EXIT_VCA_GET_CONTROLS		0x2E
#define hkwd_VCA_ENTRY_VCA_GET_CURSOR		0x2F
#define hkwd_VCA_EXIT_VCA_GET_CURSOR		0x30
#define hkwd_VCA_ENTRY_VCA_GET_WINDOW		0x31
#define hkwd_VCA_EXIT_VCA_GET_WINDOW		0x32
#define hkwd_VCA_ENTRY_VCA_GET_DACS		0x33
#define hkwd_VCA_EXIT_VCA_GET_DACS		0x34
#define hkwd_VCA_ENTRY_READDAC			0x35
#define hkwd_VCA_EXIT_READDAC			0x36
#define hkwd_VCA_ENTRY_VCA_SET_DAC_DEFAULTS	0x37
#define hkwd_VCA_EXIT_VCA_SET_DAC_DEFAULTS	0x38
#define hkwd_VCA_ENTRY_VCA_INTR			0x39
#define hkwd_VCA_EXIT_VCA_INTR			0x3A
#define hkwd_VCA_ENTRY_VCA_OUTB			0x3B
#define hkwd_VCA_EXIT_VCA_OUTB			0x3C
#define hkwd_VCA_ENTRY_VCA_INB			0x3D
#define hkwd_VCA_EXIT_VCA_INB			0x3E
#define hkwd_VCA_ENTRY_VCA_TIMED_OUT		0x3F
#define hkwd_VCA_EXIT_VCA_TIMED_OUT		0x40
#define hkwd_VCA_ENTRY_VCA_ALTREG		0x41
#define hkwd_VCA_EXIT_VCA_ALTREG		0x42
#define hkwd_VCA_ENTRY_VCA_READREG		0x43
#define hkwd_VCA_EXIT_VCA_READREG		0x44
#define hkwd_VCA_ENTRY_VCA_KSET_CURSOR		0x45
#define hkwd_VCA_EXIT_VCA_KSET_CURSOR		0x46
#define hkwd_VCA_ENTRY_VCA_KGET_CURSOR		0x47
#define hkwd_VCA_EXIT_VCA_KGET_CURSOR		0x48
#define hkwd_VCA_ENTRY_VCA_DELAY		0x49
#define hkwd_VCA_EXIT_VCA_DELAY			0x4A
#define hkwd_VCA_ENTRY_VCA_INITIALIZE		0x4B
#define hkwd_VCA_EXIT_VCA_INITIALIZE		0x4C
#define hkwd_VCA_ENTRY_VCAERR			0x4D
#define hkwd_VCA_EXIT_VCAERR			0x4E

/*
 * STREAMS (PSE) Hookwords
 */

#define	HKWD_PSE		0x7FF00000

/* system calls */
#define	hkwd_pse_getmsg_in	0x01
#define	hkwd_pse_getmsg_out	0x02
#define	hkwd_pse_getpmsg_in	0x03
#define	hkwd_pse_getpmsg_out	0x04
#define	hkwd_pse_putmsg_in	0x05
#define	hkwd_pse_putmsg_out	0x06
#define	hkwd_pse_putpmsg_in	0x07
#define	hkwd_pse_putpmsg_out	0x08

/* driver entry points */
#define	hkwd_pse_open_in	0x09
#define	hkwd_pse_open_out	0x0a
#define	hkwd_pse_clone_in	0x0b
#define	hkwd_pse_clone_out	0x0c
#define	hkwd_pse_close_in	0x0d
#define	hkwd_pse_close_out	0x0e
#define	hkwd_pse_read_in	0x0f
#define	hkwd_pse_read_out	0x10
#define	hkwd_pse_write_in	0x11
#define	hkwd_pse_write_out	0x12
#define	hkwd_pse_ioctl_in	0x13
#define	hkwd_pse_ioctl_out	0x14
#define	hkwd_pse_poll_in	0x15
#define	hkwd_pse_poll_out	0x16
#define hkwd_pse_revoke_in      0x17
#define hkwd_pse_revoke_out     0x18

/* pse : mblks sub_hooks */
#define hkwd_pse_allocb_in                 0x19
#define hkwd_pse_allocb_out_bad            0x1a
#define hkwd_pse_allocb_out_ok             0x1b
#define hkwd_pse_freeb_in                  0x1c
#define hkwd_pse_flushband_in              0x1d
#define hkwd_pse_flushq_in                 0x1e
#define hkwd_pse_freemsg_in                0x1f

#define hkwd_pse_getq_in                   0x20
#define hkwd_pse_getq_out                  0x21
#define hkwd_pse_insq_in                   0x22
#define hkwd_pse_insq_out                  0x23
#define hkwd_pse_putq_in                   0x24
#define hkwd_pse_putq_out                  0x25
#define hkwd_pse_putbq_in                  0x26
#define hkwd_pse_putbq_out                 0x27
#define hkwd_pse_putctl_comm_in            0x28
#define hkwd_pse_putctl_comm_out           0x29
#define hkwd_pse_str_putnext_in            0x2a
#define hkwd_pse_qreply_in                 0x2b
#define hkwd_pse_rmvq_in                   0x2c
#define hkwd_pse_putnext_in                0x2d
#define hkwd_pse_strqget_in                0x2e
#define hkwd_pse_strqget_out               0x2f

#define hkwd_pse_strqset_in                0x30
#define hkwd_pse_strqset_out               0x31
#define hkwd_pse_insqband_in               0x32
#define hkwd_pse_insqband_out              0x33
#define hkwd_pse_putbqband_in              0x34
#define hkwd_pse_putbqband_out             0x35
#define hkwd_pse_puthere_in                0x36
#define hkwd_pse_putqband_in               0x37
#define hkwd_pse_putqband_out              0x38
#define hkwd_pse_str_strtune_module_info   0x39
#define hkwd_pse_str_strtune_modsw         0x3a
#define hkwd_pse_str_strtune_queue         0x3b

/* pse : minimum trace level sub hooks */ 
#define hkwd_pse_add_device_1              0x3c
#define hkwd_pse_add_device_2              0x3d
#define hkwd_pse_add_device_3              0x3e
#define hkwd_pse_add_device_4              0x3f

#define hkwd_pse_bufcall_configure         0x40
#define hkwd_pse_clone_configure           0x41
#define hkwd_pse_close_wrapper             0x42
#define hkwd_pse_del_device_1              0x43
#define hkwd_pse_del_device_2              0x44
#define hkwd_pse_dmodsw_install_1          0x45
#define hkwd_pse_dmodsw_install_2          0x46
#define hkwd_pse_dmodsw_install_3          0x47
#define hkwd_pse_dmodsw_remove             0x48
#define hkwd_pse_dmodsw_search             0x49
#define hkwd_pse_do_ioctl_job_control_1    0x4a
#define hkwd_pse_do_ioctl_job_control_2    0x4b
#define hkwd_pse_do_ioctl_job_control_3    0x4c
#define hkwd_pse_do_read_job_control_1     0x4d
#define hkwd_pse_do_read_job_control_2     0x4e
#define hkwd_pse_do_write_job_control_1    0x4f

#define hkwd_pse_do_write_job_control_2    0x50
#define hkwd_pse_do_write_job_control_3    0x51
#define hkwd_pse_drv_priv                  0x52
#define hkwd_pse_fd_alloc                  0x53
#define hkwd_pse_fmodsw_install_1          0x54
#define hkwd_pse_fmodsw_install_2          0x55
#define hkwd_pse_fmodsw_install_3          0x56
#define hkwd_pse_fmodsw_remove             0x57
#define hkwd_pse_funnel_init               0x58
#define hkwd_pse_get_sth_from_fd_1         0x59
#define hkwd_pse_get_sth_from_fd_2         0x5a
#define hkwd_pse_get_sth_from_fd_3         0x5b
#define hkwd_pse_get_sth_from_fd_4         0x5c
#define hkwd_pse_get_sth_from_fd_5         0x5d
#define hkwd_pse_get_sth_from_fd_6         0x5e
#define hkwd_pse_getmsg                    0x5f

#define hkwd_pse_getpmsg                   0x60
#define hkwd_pse_init_funnel               0x61
#define hkwd_pse_log_configure_1           0x62
#define hkwd_pse_log_configure_2           0x63
#define hkwd_pse_log_open_1                0x64
#define hkwd_pse_log_open_2                0x65
#define hkwd_pse_mi_offset_param_mblk_1    0x66
#define hkwd_pse_mi_offset_param_mblk_2    0x67
#define hkwd_pse_mi_offset_param_mblk_3    0x68
#define hkwd_pse_mi_open_comm_1            0x69
#define hkwd_pse_mi_open_comm_2            0x6a
#define hkwd_pse_mi_open_comm_3            0x6b
#define hkwd_pse_nd_get_default            0x6c
#define hkwd_pse_nd_get_names              0x6d
#define hkwd_pse_nd_set_long               0x6e
#define hkwd_pse_open_wrapper              0x6f

#define hkwd_pse_osr_atmark                0x70
#define hkwd_pse_osr_bufcall               0x71
#define hkwd_pse_osr_canput                0x72
#define hkwd_pse_osr_ckband                0x73
#define hkwd_pse_osr_close_subr_2          0x74
#define hkwd_pse_osr_fdinsert              0x75
#define hkwd_pse_osr_fifo                  0x76
#define hkwd_pse_osr_find                  0x77
#define hkwd_pse_osr_flush                 0x78
#define hkwd_pse_osr_flushband             0x79
#define hkwd_pse_osr_flushdata_1           0x7a
#define hkwd_pse_osr_flushdata_2           0x7b
#define hkwd_pse_osr_flushdata_3           0x7c
#define hkwd_pse_osr_getband               0x7d
#define hkwd_pse_osr_getmsg                0x7e
#define hkwd_pse_osr_getmsg_subr           0x7f

#define hkwd_pse_osr_getpmsg               0x80
#define hkwd_pse_osr_getsig                0x81
#define hkwd_pse_osr_link                  0x82
#define hkwd_pse_osr_list                  0x83
#define hkwd_pse_osr_look                  0x84
#define hkwd_pse_osr_peek                  0x85
#define hkwd_pse_osr_pipe                  0x86
#define hkwd_pse_osr_pipestat              0x87
#define hkwd_pse_osr_pop                   0x88
#define hkwd_pse_osr_putmsg                0x89
#define hkwd_pse_osr_putmsg_subr           0x8a
#define hkwd_pse_osr_putpmsg               0x8b
#define hkwd_pse_osr_read                  0x8c
#define hkwd_pse_osr_recvfd                0x8d
#define hkwd_pse_osr_revoke_1              0x8e
#define hkwd_pse_osr_revoke_2              0x8f

#define hkwd_pse_osr_run                   0x90
#define hkwd_pse_osr_sendfd                0x91
#define hkwd_pse_osr_setcltime             0x92
#define hkwd_pse_osr_setsig                0x93
#define hkwd_pse_osr_sleep                 0x94
#define hkwd_pse_osr_srdopt_1              0x95
#define hkwd_pse_osr_srdopt_2              0x96
#define hkwd_pse_osr_srdopt_3              0x97
#define hkwd_pse_osr_srdopt_4              0x98
#define hkwd_pse_osr_str                   0x99
#define hkwd_pse_osr_swropt                0x9a
#define hkwd_pse_osr_tcsak_1               0x9b
#define hkwd_pse_osr_tcsak_2               0x9c
#define hkwd_pse_osr_tcskep                0x9d
#define hkwd_pse_osr_tctrust_1             0x9e
#define hkwd_pse_osr_tctrust_2             0x9f

#define hkwd_pse_osr_tctrust_3             0xa0
#define hkwd_pse_osr_tctrust_4             0xa1
#define hkwd_pse_osr_tcxonc                0xa2
#define hkwd_pse_osr_tioccons_1            0xa3
#define hkwd_pse_osr_tioccons_2            0xa4
#define hkwd_pse_osr_tiocgpgrp             0xa5
#define hkwd_pse_osr_tiocgsid              0xa6
#define hkwd_pse_osr_tiocknopgrp           0xa7
#define hkwd_pse_osr_tiocknosess           0xa8
#define hkwd_pse_osr_tiocsctty_1           0xa9
#define hkwd_pse_osr_tiocsctty_2           0xaa
#define hkwd_pse_osr_unlink_subr           0xab
#define hkwd_pse_osr_write                 0xac
#define hkwd_pse_pse_clone_open_2          0xad
#define hkwd_pse_pse_close_2               0xae
#define hkwd_pse_pse_ctb_callback          0xaf

#define hkwd_pse_pse_init_1                0xb0
#define hkwd_pse_pse_init_2                0xb1
#define hkwd_pse_pse_ioctl_1               0xb2
#define hkwd_pse_pse_open_4                0xb3
#define hkwd_pse_pse_read_2                0xb4
#define hkwd_pse_pse_revoke_2              0xb5
#define hkwd_pse_pse_select                0xb6
#define hkwd_pse_pse_write_2               0xb7
#define hkwd_pse_psebufcalls_init          0xb8
#define hkwd_pse_psetimers_init            0xb9
#define hkwd_pse_putmsg                    0xba
#define hkwd_pse_putpmsg                   0xbb
#define hkwd_pse_sad_configure             0xbc
#define hkwd_pse_sth_fattach_1             0xbd
#define hkwd_pse_sth_fattach_2             0xbe
#define hkwd_pse_sth_fattach_3             0xbf

#define hkwd_pse_sth_fd_to_sth_1           0xc0
#define hkwd_pse_sth_fd_to_sth_2           0xc1
#define hkwd_pse_sth_read_seek_1           0xc2
#define hkwd_pse_sth_read_seek_2           0xc3
#define hkwd_pse_sth_test_and_set_sth      0xc4
#define hkwd_pse_sth_tiocspgrp_1           0xc5
#define hkwd_pse_sth_tiocspgrp_2           0xc6
#define hkwd_pse_sth_tiocspgrp_3           0xc7
#define hkwd_pse_sth_tiocspgrp_4           0xc8
#define hkwd_pse_sth_tiocspgrp_5           0xc9
#define hkwd_pse_str_config                0xca
#define hkwd_pse_str_init                  0xcb
#define hkwd_pse_str_install               0xcc
#define hkwd_pse_str_term                  0xcd
#define hkwd_pse_strinfo_1                 0xce
#define hkwd_pse_strinfo_2                 0xcf

#define hkwd_pse_strinfo_3                 0xd0
#define hkwd_pse_strinfo_4                 0xd1
#define hkwd_pse_strlog_1                  0xd2
#define hkwd_pse_strlog_2                  0xd3
#define hkwd_pse_strlog_3                  0xd4
#define hkwd_pse_strlog_4                  0xd5
#define hkwd_pse_strmod_add_1              0xd6
#define hkwd_pse_strmod_add_2              0xd7
#define hkwd_pse_strmod_add_3              0xd8
#define hkwd_pse_strmod_del_1              0xd9
#define hkwd_pse_strmod_del_2              0xda
#define hkwd_pse_strmod_del_3              0xdb
#define hkwd_pse_strqget_1                 0xdc
#define hkwd_pse_strqget_2                 0xdd
#define hkwd_pse_strqset_1                 0xde
#define hkwd_pse_strqset_2                 0xdf

#define hkwd_pse_strreset                  0xe0
#define hkwd_pse_unweldq_1                 0xe1
#define hkwd_pse_unweldq_2                 0xe2
#define hkwd_pse_unweldq_3                 0xe3
#define hkwd_pse_weldq_1                   0xe4
#define hkwd_pse_weldq_2                   0xe5
#define hkwd_pse_weldq_3                   0xe6
#define hkwd_pse_weldq_comm                0xe7

/* pse : flag change sub hooks */
#define hkwd_pse_alloc_qband               0xe8
#define hkwd_pse_bcanput                   0xe9
#define hkwd_pse_bufcall_init_1            0xea
#define hkwd_pse_bufcall_init_2            0xeb
#define hkwd_pse_canput                    0xec
#define hkwd_pse_csq_lateral               0xed
#define hkwd_pse_csq_run_1                 0xee
#define hkwd_pse_csq_run_2                 0xef

#define hkwd_pse_csq_run_3                 0xf0
#define hkwd_pse_csq_run_4                 0xf1
#define hkwd_pse_enableok                  0xf2
#define hkwd_pse_flushband_1               0xf3
#define hkwd_pse_flushband_2               0xf4
#define hkwd_pse_flushq_1                  0xf5
#define hkwd_pse_flushq_2                  0xf6
#define hkwd_pse_funnel_putp               0xf7
#define hkwd_pse_funnelq_run_1             0xf8
#define hkwd_pse_funnelq_run_2             0xf9
#define hkwd_pse_funnelq_run_3             0xfa
#define hkwd_pse_funnelq_run_4             0xfb
#define hkwd_pse_getq_1                    0xfc
#define hkwd_pse_getq_2                    0xfd
#define hkwd_pse_getq_3                    0xfe
#define hkwd_pse_getq_4                    0xff

#define hkwd_pse_getq_5                    0x100
#define hkwd_pse_insq                      0x101
#define hkwd_pse_insqband                  0x102
#define hkwd_pse_mult_sqh_acquire          0x103
#define hkwd_pse_mult_sqh_release          0x104
#define hkwd_pse_noenable                  0x105
#define hkwd_pse_osr_add_modules           0x106
#define hkwd_pse_osr_alloc                 0x107
#define hkwd_pse_osr_close_subr_1          0x108
#define hkwd_pse_osr_open_1                0x109
#define hkwd_pse_osr_open_2                0x10a
#define hkwd_pse_osr_open_3                0x10b
#define hkwd_pse_osr_open_4                0x10c
#define hkwd_pse_osr_pipe_1                0x10d
#define hkwd_pse_osr_pipe_2                0x10e
#define hkwd_pse_osr_pop_subr_1            0x10f

#define hkwd_pse_osr_pop_subr_2            0x110
#define hkwd_pse_osr_pop_subr_3            0x111
#define hkwd_pse_osr_push_1                0x112
#define hkwd_pse_osr_push_2                0x113
#define hkwd_pse_osr_push_3                0x114
#define hkwd_pse_osr_str_1                 0x115
#define hkwd_pse_osr_str_2                 0x116
#define hkwd_pse_osr_str_3                 0x117
#define hkwd_pse_osr_str_4                 0x118
#define hkwd_pse_pse_clone_open_1          0x119
#define hkwd_pse_pse_close_1               0x11a
#define hkwd_pse_pse_ioctl_2               0x11b
#define hkwd_pse_pse_open_1                0x11c
#define hkwd_pse_pse_open_2                0x11d
#define hkwd_pse_pse_open_3                0x11e
#define hkwd_pse_pse_read_1                0x11f

#define hkwd_pse_pse_revoke_1              0x120
#define hkwd_pse_pse_write_1               0x121
#define hkwd_pse_putbq                     0x122
#define hkwd_pse_putbqband                 0x123
#define hkwd_pse_putq                      0x124
#define hkwd_pse_putqband                  0x125
#define hkwd_pse_q_alloc_1                 0x126
#define hkwd_pse_q_alloc_2                 0x127
#define hkwd_pse_rmvq_1                    0x128
#define hkwd_pse_rmvq_2                    0x129
#define hkwd_pse_rmvq_3                    0x12a
#define hkwd_pse_rmvq_4                    0x12b
#define hkwd_pse_sqh_set_parent_1          0x12c
#define hkwd_pse_sqh_set_parent_3          0x12d
#define hkwd_pse_sqh_set_parent_4          0x12e
#define hkwd_pse_sqh_set_parent_5          0x12f

#define hkwd_pse_sqh_set_parent_6           0x130
#define hkwd_pse_sqh_set_parent_7          0x131
#define hkwd_pse_sq_wrapper                0x132
#define hkwd_pse_sqh_set_parent_2          0x133
#define hkwd_pse_unweldq_cnx               0x134
#define hkwd_pse_unweldq_exec              0x135
#define hkwd_pse_weldq_cnx                 0x136
#define hkwd_pse_weldq_exec                0x137

#define HKWD_DLPI		0x4A700000
/* DLPI subhook */
#define hkwd_dlpi_open_in            1
#define hkwd_dlpi_open_error_1       2
#define hkwd_dlpi_open_out           3

#define hkwd_dlpi_close_in           4
#define hkwd_dlpi_close_1            5
#define hkwd_dlpi_close_err1         6
#define hkwd_dlpi_close_err2         7

#define hkwd_dlpi_wput_in            8
#define hkwd_dlpi_wput_type          9

#define hkwd_dlpi_rsrv_in            10
#define hkwd_dlpi_wsrv_in            11
#define hkwd_dlpi_wsrv_type          12
#define hkwd_dlpi_wsrv_data          13
#define hkwd_dlpi_wsrv_prim          14

#define hkwd_dlpi_dlattach_err1      15
#define hkwd_dlpi_dlattach_err2      16
#define hkwd_dlpi_dlattach_err3      17

#define hkwd_dlpi_dlunbindsap_err    18
#define hkwd_dlpi_dladdfilter_err    19
#define hkwd_dlpi_dldelfilter_err    20

#define hkwd_dlpi_dl_bind            21
#define hkwd_dlpi_dl_subs_bind       22
#define hkwd_dlpi_dl_add_filter      23
#define hkwd_dlpi_dl_add_filter_def  24

#define hkwd_dlpi_dl_connind         25 /* rx_sabme: discard dup dlb */
#define hkwd_dlpi_dl_connind_1       26 /* rx_sabme: discard pend table full dlb */ 
#define hkwd_dlpi_dl_connind_2       27 /* not use */
#define hkwd_dlpi_dl_connreq         28 /* not use */
#define hkwd_dlpi_dl_datareq         29 /* dl_datareq: state %d drop */
#define hkwd_dlpi_dl_rexmit          30 /* dl_rexmit: retransmitting I-frames */
#define hkwd_dlpi_dl_rexmit_1        31 /* dl_rexmit: cannot dup */
#define hkwd_dlpi_dl_rexmit_2        32 /* dl_rexmit: no outstanding I-frames */
#define hkwd_dlpi_tx_i_err1          33 /* tx_i: mkframe failed */
#define hkwd_dlpi_tx_i_err2          34 /* tx_i: tx_frame failed %d */
#define hkwd_dlpi_tx_super_err       35 /* tx_super: tx_frame failed %d */
#define hkwd_dlpi_rx_i               36 /* rx_i: reject drop (t = %d) */
#define hkwd_dlpi_rx_i_1             37 /* rx_i: sent reject ended */
#define hkwd_dlpi_rx_i_2             38 /* rx_i: mbuf convert drop */
#define hkwd_dlpi_chktimers_T1       39 /* chktimers: why is T1 still running */
#define hkwd_dlpi_chktimers_T2       40 /* chktimers: why is T2 still running */
#define hkwd_dlpi_expired_t1         41 /* expired_t1: retry %d */
#define hkwd_dlpi_expired_t1_1       42 /* expired_t1: retry exhausted */
#define hkwd_dlpi_expired_t2         43 /* expired_t2: retry %d */
#define hkwd_dlpi_expired_t2_1       44 /* expired_t2: retry exhausted */
#define hkwd_dlpi_expired_ti         45 /* expired_ti: retry %d */
#define hkwd_dlpi_expired_ti_1       46 /* expired_ti: busy retry exhausted */

#define hkwd_dlpi_rsrv_type          47

#define hkwd_dlpi_rx_xtauto          50 /* rx_xtauto: unsolicited response drop */
#define hkwd_dlpi_tx_frame2          51 /* dans tx.c */
#define hkwd_dlpi_tq_start           52 /* tq_start: %s tenths %d */

#define hkwd_dlpi_rx_ua              57 /* rx_ua: p%d f%d, dropped UA */
#define hkwd_dlpi_rx_ua_err          58 /* rx_ua: state %d dropped UA */
#define hkwd_dlpi_rx_dm_err          59 /* rx_dm: state %d dropped DM */
#define hkwd_dlpi_rx_disc_err        60 /* rx_disc: state %d dropped DISC */
#define hkwd_dlpi_rx_ui              61 /* rx_ui: flow control drop */
#define hkwd_dlpi_local_busy         62 /* local_busy */
#define hkwd_dlpi_local_okay         63 /* local_okay */
#define hkwd_dlpi_dlpillc            64 /* dlpillc: sap 0x%x: no stream drop */
#define hkwd_dlpi_dlpillc_1          65 /* dlpillc: multi drop"*/
#define hkwd_dlpi_dlpillc_2          66 /* 1: dlpillc: ctl 0x%x: bad LLC drop"
					   2 dlpillc: ctl 0x%x: codls mode drop
					   3 dlpillc: ctl 0x%x: listen DM
					   4 dlpillc: ctl 0x%x: listen drop
 				        */
#define hkwd_dlpi_dlpillc_3          67
#define hkwd_dlpi_drd_bind           68 /* drd_bind: ndd 0x%x ppa %d sap 0x%x */
#define hkwd_dlpi_drd_bind_err       69 /* drd_bind: cannot bind; ppa %d, err %d */
#define hkwd_dlpi_drd_unbind         70 /* drd_unbind: ndd 0x%x ppa %d sap 0x%x */
#define hkwd_dlpi_drd_unbind_err     71 /* drd_unbind: cannot bind; ppa %d, err %d */

#define hkwd_dlpi_drd_update         72

#define hkwd_dlpi_drd_timer          73
#define hkwd_dlpi_drd_timeout1       74
#define hkwd_dlpi_drd_timeout2       75
#define hkwd_dlpi_drd_intr1          76 
#define hkwd_dlpi_drd_intr2          77
#define hkwd_dlpi_drd_intr3          78
#define hkwd_dlpi_drd_intr4          79

#define hkwd_dlpi_config_init        80
#define hkwd_dlpi_config_stop        81

#define hkwd_dlpi_nddrele            82



#define HKWD_XTISO		0x4A800000
/* XTI subhookid */
#define hkwd_xti_config_in		1
#define hkwd_xti_config_out		2
#define hkwd_xti_open_in		3
#define hkwd_xti_open_clone             4
#define hkwd_xti_open_noclone           5
#define hkwd_xti_open_noclone1          6
#define hkwd_xti_open_1                 7
#define hkwd_xti_open_2                 8
#define hkwd_xti_open_3                 9
#define hkwd_xti_wput_in		10
#define hkwd_xti_wput_prim              11
#define hkwd_xti_wput_in_type           12
#define hkwd_xti_wput_error             13
#define hkwd_xti_wput_error5            14
#define hkwd_xti_wput_error6            15
#define hkwd_xti_wput_error7            16
#define hkwd_xti_close_in		17
#define hkwd_xti_rsrv_in		18
#define hkwd_xti_wsrv_in		20
#define hkwd_xti_wsrv_in1               21
#define hkwd_xti_wsrv_in2               22
#define hkwd_xti_wsrv_in3               23
#define hkwd_xti_wsrv_in4               24
#define hkwd_xti_event_state		25
#define hkwd_xti_event_state1		26
#define hkwd_xti_addr_req               30
#define hkwd_xti_addrreq_error		31
#define hkwd_xti_bind_req		35
#define hkwd_xti_bindreq_error		36
#define hkwd_xti_bind_req1		37
#define hkwd_xti_bindreq_error1		38
#define hkwd_xti_bind_req2              39
#define hkwd_xti_bindreq_err            40
#define hkwd_xti_bind_req3		41
#define hkwd_xti_unbind_req             46
#define hkwd_xti_unbind_req1            47
#define hkwd_xti_unbindreq_error	48
#define hkwd_xti_optmgmt_req     	49
#define hkwd_xti_optmgmtreq_error	50
#define hkwd_xti_optmgmtreq_error1	51
#define hkwd_xti_listen_req             52
#define hkwd_xti_listenreq_error1	57
#define hkwd_xti_listenreq_error2	58
#define hkwd_xti_listenreq_error3	59
#define hkwd_xti_connreq_error	        60
#define hkwd_xti_conn_req               61
#define hkwd_xti_conn_res               62
#define hkwd_xti_discon_req             63
#define hkwd_xti_data_req               64
#define hkwd_xti_exdata_req             65
#define hkwd_xti_unitdata_req           66
#define hkwd_xti_ordrel_req             67
#define hkwd_xti_info_req               68
#define hkwd_xti_unitdata_req_1         69
#define hkwd_xti_connreq_connect        71
#define hkwd_xti_connres_error          72
#define hkwd_xti_disconreq_error        73
#define hkwd_xti_datareq_error          74
#define hkwd_xti_exdatareq_error        75
#define hkwd_xti_unitdatareq_error      76
#define hkwd_xti_ordrelreq_error        77
#define hkwd_xti_startup_bind           82
#define hkwd_xti_startup_binderr        83
#define hkwd_xti_startup_error          84
#define hkwd_xti_startup_error1         85
#define hkwd_xti_disconind_error        86
#define hkwd_xti_dataind_error          87
#define hkwd_xti_unitdataind_error      88
#define hkwd_xti_ordrelind_error        89
#define hkwd_xti_solisten1              90
#define hkwd_xti_solisten2              91
#define hkwd_xti_ordrelind_error1       92
#define hkwd_xti_send                   93
#define hkwd_xti_send1                  95
#define hkwd_xti_send_err               96
#define hkwd_xti_send_error             98
#define hkwd_xti_rcv                    97
#define hkwd_xti_finished_error         99
#define hkwd_xti_dumpso                 100
#define hkwd_xti_dumpproto              101
#define hkwd_xti_dumpiocblk             102
#define hkwd_xti_dumpproto_2            103
#define hkwd_xti_setopt_error           104
#define hkwd_xti_rcv_1                  105
#define hkwd_xti_rcv_2                  106
#define hkwd_xti_rcv_3                  107
#define hkwd_xti_prec_insq              110
#define hkwd_xti_prec_insq1             111
#define hkwd_xti_output                 112
#define hkwd_xti_input                  113
#define hkwd_xti_input1                 114
#define hkwd_xti_new_tp_ind             115
#define hkwd_xti_conn_ind               116
#define hkwd_xti_conn_con               117
#define hkwd_xti_discon_ind             118
#define hkwd_xti_data_ind               119 
#define hkwd_xti_ordrel_ind             120 
#define hkwd_xti_unitdata_ind           121  
#define hkwd_xti_uderror_ind            122
#define hkwd_xti_cleanup                123
#define hkwd_xti_finished               124
#define hkwd_xti_snd_error_ack          125
#define hkwd_xti_snd_flushrw            126
#define hkwd_xti_snd_ok_ack             127
#define hkwd_xti_entryinit_err          128
#define hkwd_xti_entryinit              129
#define hkwd_xti_wqenable               130
#define hkwd_xti_rqenable               131
#define hkwd_xti_canput                 132
#define hkwd_xti_init_socket            133 
#define hkwd_xti_putnext                134
#define hkwd_xti_discon_ind_1           135

#define hkwd_xti_canput_1               137
#define hkwd_xti_canput_2               138
#define hkwd_xti_new_tp_ind1            140
#define hkwd_xti_new_tp_ind2            141
#define hkwd_xti_new_tp_ind3            142
#define hkwd_xti_new_tp_ind4            143
#define hkwd_xti_new_tp_ind5            146
#define hkwd_xti_new_tp_ind6            147
#define hkwd_xti_copytombuf             150
#define hkwd_xti_copytombuf1            151
#define hkwd_xti_copytombuf2            152

#define HKWD_TIMOD		0x4A900000
/* TIMOD subhook */
#define hkwd_timod_open_in            1
#define hkwd_timod_open_1             2
#define hkwd_timod_close_in           3
#define hkwd_timod_close_1            4
#define hkwd_timod_rput_in            5
#define hkwd_timod_rput_type          6
#define hkwd_timod_rput_prim          7
#define hkwd_timod_wput_in            8
#define hkwd_timod_wput_type          9
#define hkwd_timod_wput_prim1         10
#define hkwd_timod_wput_prim2         11

#define HKWD_TIRDWR		0x4AA00000
/* TIRDWR subhook */
#define hkwd_tirdwr_open_in            1
#define hkwd_tirdwr_open_error         2
#define hkwd_tirdwr_close_in           3  
#define hkwd_tirdwr_close_in_1         4
#define hkwd_tirdwr_rput_in            5
#define hkwd_tirdwr_rput_type          6
#define hkwd_tirdwr_rput_prim          7
#define hkwd_tirdwr_wput_in            8
#define hkwd_tirdwr_wput_type          9

/* hooks for thread-based services */
#define HKWD_KERN_ASSERTWAIT		0x46000000
#define HKWD_KERN_CLEARWAIT		0x46100000
#define HKWD_KERN_THREADBLOCK		0x46200000
#define HKWD_KERN_EMPSLEEP		0x46300000
#define HKWD_KERN_EWAKEUPONE		0x46400000
#define HKWD_SYSC_CRTHREAD		0x46500000
#define hkwd_sysc_crthread_wpar               0x01
#define hkwd_SYSC_CRTHREAD_LIMIT	      0x02
#define HKWD_KERN_KTHREADSTART		0x46600000
#define HKWD_SYSC_TERMTHREAD  		0x46700000
#define HKWD_KERN_KSUSPEND    		0x46800000
#define HKWD_SYSC_THREADSETSTATE    	0x46900000
#define HKWD_SYSC_THREADTERM_ACK    	0x46A00000
#define HKWD_SYSC_THREADSETSCHED    	0x46B00000
#define HKWD_KERN_TIDSIG    		0x46C00000
#define HKWD_KERN_WAITLOCK  		0x46D00000
#define HKWD_KERN_WAKEUPLOCK		0x46E00000
#define HKWD_SYSC_THREADLOCKBOOST    	0x47600000
#define HKWD_KERN_WAITLOCKLOCAL         0x47700000

/* Hook for PCMCIA Socket Services */
#define	HKWD_PCMCIA_SS			0x23000000
/* Hook for PCMCIA Card Services */
#define	HKWD_PCMCIA_CS			0x34300000

/* Hooks for SECURITY */
#define HKWD_SEC			0x3B700000  /* Security major events */
#define HKWD_SEC_DATA			0x3B800000  /* Security data events  */
#define HKWD_SEC_CRED			0x52F00000  /* Security credential alloc/dealloc  */
#define HKWD_SEC_TRACE			0x5F200000  /* Security trace events */


/* Hook for Network Buffer Cache */
#define HKWD_NBC			0x2ED00000  /* Network Buffer Cache */

/* Hook Word for WLM */
#define HKWD_WLM_STAGE1			0x2F900000  /* Workload Management */

/*
 * RAS: high availability services
 */

#define HKWD_RPDP		0x2FD00000	    /* RPDP */
/* RPDP with sub-hook-ID-s */
#define HKWD_RPDP_START		(HKWD_RPDP | 0)	    /* RPDP start */
#define HKWD_RPDP_ABORT		(HKWD_RPDP | 1)	    /* RPDP aborted */
#define HKWD_RPDP_SUCCESS	(HKWD_RPDP | 2)	    /* RPDP successfully done */
#define HKWD_RPDP_HAEH		(HKWD_RPDP | 0x10)  /* HA handler: ACCEPTED */
#define HKWD_RPDP_HAEH_BAD	(HKWD_RPDP | 0x11)  /* HA handler: REFUSED */
#define HKWD_RPDP_IT_REROUTE	(HKWD_RPDP | 0x20)  /* Interrupt re-route */
#define HKWD_RPDP_CPUSWAP	(HKWD_RPDP | 0x30)  /* CPU swap takes place */
#define HKWD_RPDP_TRB_MIGR	(HKWD_RPDP | 0x40)  /* Timer migrated */
#define HKWD_RPDP_STOP_SELF	(HKWD_RPDP | 0x50)  /* pal_stop_myself() */

#define	HKWD_SYSFR		0x2FE00000	    /* System freeze */
/* System freeze with sub-hook-ID-s */
#define HKWD_SYSFR_START	(HKWD_SYSFR | 0)    /* System freeze start */
#define HKWD_SYSFR_END		(HKWD_SYSFR | 1)    /* System freeze end */
#define HKWD_SYSFR_MASTER_START	(HKWD_SYSFR | 0x20) /* Freeze master start */
#define HKWD_SYSFR_MASTER_END	(HKWD_SYSFR | 0x21) /* Freeze master end */
#define HKWD_SYSFR_SLAVE_START	(HKWD_SYSFR | 0x30) /* Fr. slave command start*/
#define HKWD_SYSFR_SLAVE_END	(HKWD_SYSFR | 0x31) /* Fr. slave command end */
#define HKWD_SYSFR_BLOCK_IT	(HKWD_SYSFR | 0x40) /* Block ext. interrupts */
#define HKWD_SYSFR_ENABLE_IT	(HKWD_SYSFR | 0x41) /* Enable ext. interrupts */
#define HKWD_SYSFR_DIS_PLVL	(HKWD_SYSFR | 0x50) /*Before pal_i_disableplvl*/
#define HKWD_SYSFR_DIS_PLVL_END	(HKWD_SYSFR | 0x51) /* After pal_i_disableplvl*/
#define HKWD_SYSFR_EN_PLVL	(HKWD_SYSFR | 0x60) /* Before pal_i_enableplvl*/
#define HKWD_SYSFR_EN_PLVL_END	(HKWD_SYSFR | 0x61) /* After pal_i_enableplvl */

/*
 * Dynamic Reconfiguration
 */
#define HKWD_DR			0x38F00000	    /* DR */

/* subhook ids */

#define hkwd_DR_REGISTER		0x01
#define hkwd_REGISTER_DR_EVENT		0x02
#define hkwd_DR_NOTIFY			0x03
#define hkwd_DR_UNREGISTER		0x04
#define hkwd_UNREGISTER_DR_EVENT	0x05
#define hkwd_DR_RECONFIG		0x06

#define hkwd_RECONFIG_REGISTER_ENTRY	0x14
#define hkwd_RECONFIG_REGISTER_EXIT	0x15
#define hkwd_RECONFIG_UNREGISTER_ENTRY	0x16
#define hkwd_RECONFIG_UNREGISTER_EXIT	0x17
#define hkwd_RECONFIG_COMPLETE_ENTRY	0x18
#define hkwd_RECONFIG_COMPLETE_HNAME	0x19
#define hkwd_RECONFIG_COMPLETE_EXIT	0x1A

#define hkwd_INVOKE_HANDLERS_ENTRY	0x28
#define hkwd_INVOKE_HANDLERS_SLEEP	0x29
#define hkwd_INVOKE_HANDLERS_AWAKE	0x2A

#define hkwd_MPC_REMOVE_HANDLER		0x32
#define hkwd_MPC_FREEZE_HANDLER		0x33

#define hkwd_SEND_SIGNAL		0x3C
#define hkwd_NPROC_POSTED		0x3D
#define hkwd_NPROC_NOTACKED             0x3E
#define hkwd_DR_SEND_SIGNAL_PID		0x3F
#define hkwd_DR_ACK_SIGNAL_PID		0x40

#define hkwd_GET_USER_DATA		0x46
#define hkwd_DR_CALLOUT			0x47
#define hkwd_VALIDATE_PHASE		0x48
#define hkwd_VALIDATE_NOTIFY		0x49
#define hkwd_RUN_NOTIFY			0x4A
#define hkwd_KERNEL_NOTIFY		0x4B
#define hkwd_CLEAR_DRPARMS		0x4C

#define hkwd_HA_PROC			0x5A
#define hkwd_HA_PROC_FAIL_LCPU		0x5B
#define hkwd_DR_FAIL_LCPU_STATUS	0x5C
#define hkwd_DR_MIGRATE_WDOGS		0x5D
#define hkwd_DR_SEND_SIGCPUFAIL		0x5E

#define hkwd_DR_REG_SYSRAD 		0x62
#define hkwd_DR_REG_SYSRAD_AFF		0x63
#define hkwd_ADDCPU_VALIDATE		0x64
#define hkwd_ADDCPU_PRE			0x65
#define hkwd_ADDCPU_CLEANUP		0x66
#define hkwd_ADDCPU_DOIT		0x67
#define hkwd_DR_START_CPU		0x68
#define hkwd_DR_MAIN_BS_PROC		0x69
#define hkwd_DR_VMM_INIT		0x6A
#define hkwd_DR_UPDATE_PNDA		0x6B
#define hkwd_DR_REROUTE_IT		0x6C
#define hkwd_DR_UNREG_SYSRAD		0x6D
#define hkwd_DR_UNREG_SYSRAD_AFF	0x6E

#define hkwd_DR_RM_ATTACH		0x78
#define hkwd_DR_MIGR_CLASS_ANY		0x79
#define hkwd_DR_STOP_LCPU		0x7A
#define hkwd_DR_MOVE_THREADS		0x7B
#define hkwd_RMCPU_VALIDATE		0x7C
#define hkwd_RMCPU_PRE			0x7D
#define hkwd_RMCPU_DOIT			0x7E
#define hkwd_RMCPU_CLEANUP		0x7F
#define hkwd_DR_CONTROLING_LCPU		0x80
#define hkwd_CALL_HA_HANDLERS		0x81
#define hkwd_DISABLE_DECR		0x82
#define hkwd_ENABLE_DECR		0x83
#define hkwd_DR_NEW_MASTER_LCPU		0x84
#define hkwd_RMCPU_STATUS		0x85
#define hkwd_DR_NEW_NODE_MASTER_LCPU	0x86

#define hkwd_FIND_DUMMY_PPDA		0x8C
#define hkwd_SCPU_VALIDATE		0x8D
#define hkwd_SCPU_DOIT			0x8E
#define hkwd_SCPU_START			0x8F
#define hkwd_SCPU_SUCCESS		0x90
#define hkwd_FAIL_CPU_STOPPED		0x91

#define hkwd_PMIG_PHIB_PRE_IN		0x96
#define hkwd_PMIG_PHIB_PRE_OUT		0x97
#define hkwd_PMIG_PHIB_POST_IN		0x98
#define hkwd_PMIG_PHIB_POST_OUT		0x99
#define hkwd_PMIG_PHIB_VALIDATE_IN	0x9A
#define hkwd_PMIG_PHIB_VALIDATE_OUT	0x9B
#define hkwd_PMIG_PHIB_DOIT_IN		0x9C
#define hkwd_PMIG_PHIB_DOIT_OUT		0x9D
#define hkwd_PMIG_PHIB_STATUS		0x9E

#define hkwd_TOPO_UPDATE_VALIDATE_IDATA 0xA0
#define hkwd_TOPO_UPDATE_REF_PNTS       0xA1
#define hkwd_TOPO_UPDATE_MAX_ASSOC      0xA2
#define hkwd_TOPO_UPDATE_REFRESH_CPUS   0xA3
#define hkwd_TOPO_UPDATE_REAFF_CPU_LIST 0xA4
#define hkwd_INVOKE_HANDLERS_ENTRY_DIS	0xA5
#define hkwd_INVOKE_HANDLERS_SLEEP_DIS	0xA6
#define hkwd_INVOKE_HANDLERS_AWAKE_DIS	0xA7
/*
 * Checkpoint/Restart
 */
#define HKWD_CR			0x49E00000

/* subhook ids */

#define hkwd_CHK_START			1
#define hkwd_ISSUE_CHKPT		2
#define hkwd_INVOKE_HANDLER		3
#define hkwd_CALL_COMMIT		4
#define hkwd_PROCESS_SUSP		5
#define hkwd_START_WRITE		6
#define hkwd_FINISH_WRITE		7
#define hkwd_EXIT_CHKPT			8
#define hkwd_CHK_FINISH			9


/* hooks for security development */

#define hkwd_SEC_GETCONFATTR_ENTRY	10
#define hkwd_SEC_GETCONFATTR_FAILURE	11
#define hkwd_SEC_GETCONFATTR_SUCCESS	12
#define hkwd_SEC_GETGROUPATTR_ENTRY	20
#define hkwd_SEC_GETGROUPATTR_FAILURE	21
#define hkwd_SEC_GETGROUPATTR_SUCCESS	22
#define hkwd_SEC_PUTGROUPATTR_ENTRY	30
#define hkwd_SEC_PUTGROUPATTR_FAILURE	31
#define hkwd_SEC_PUTGROUPATTR_SUCCESS	32
#define hkwd_SEC_IDTOGROUP_ENTRY	40
#define hkwd_SEC_IDTOGROUP_SUCCESS	41
#define hkwd_SEC_IDTOGROUP_FAILURE	42
#define hkwd_SEC_GROUPTOID_ENTRY	50
#define hkwd_SEC_GROUPTOID_SUCCESS	51
#define hkwd_SEC_GROUPTOID_FAILURE	52
#define hkwd_SEC_IDTOUSER_ENTRY		60
#define hkwd_SEC_IDTOUSER_FAILURE	61
#define hkwd_SEC_IDTOUSER_SUCCESS	62
#define hkwd_SEC_GETUSERATTR_ENTRY	70
#define hkwd_SEC_GETUSERATTR_FAILURE	71
#define hkwd_SEC_GETUSERATTR_SUCCESS	72
#define hkwd_SEC_PUTUSERATTR_ENTRY	80
#define hkwd_SEC_PUTUSERATTR_FAILURE	81
#define hkwd_SEC_PUTUSERATTR_SUCCESS	82
#define hkwd_SEC_GETUSERPW_ENTRY	90
#define hkwd_SEC_GETUSERPW_SUCCESS	91
#define hkwd_SEC_GETUSERPW_FAILURE	92
#define hkwd_SEC_PUTUSERPW_ENTRY	100
#define hkwd_SEC_PUTUSERPW_FAILURE	101
#define hkwd_SEC_PUTUSERPW_SUCCESS	102
#define hkwd_SEC_GETGENERICATTR_ENTRY	110
#define hkwd_SEC_GETGENERICATTR_RETURN	112
#define hkwd_SEC_PUTGENERICATTR_ENTRY	120
#define hkwd_SEC_PUTGENERICATTR_RETURN	122
#define hkwd_SEC_GETPENV_ENTRY		130
#define hkwd_SEC_GETPENV_FAILURE	131
#define hkwd_SEC_GETPENV_SUCCESS	132
#define hkwd_SEC_SETPENV_ENTRY		140
#define hkwd_SEC_SETPENV_FAILURE	141
#define hkwd_SEC_SETPENV_SUCCESS	142
#define hkwd_SEC_SETPCRED_ENTRY		150
#define hkwd_SEC_SETPCRED_FAILURE	151
#define hkwd_SEC_SETPCRED_SUCCESS	152
#define hkwd_SEC_GETPCRED_ENTRY		160
#define hkwd_SEC_GETPCRED_FAILURE	161
#define hkwd_SEC_GETPCRED_SUCCESS	162
#define hkwd_SEC_AUTHENTICATE_ENTRY	170
#define hkwd_SEC_AUTHENTICATE_MACRO	171
#define hkwd_SEC_AUTHENTICATE_GRAMMAR	173
#define hkwd_SEC_GETPWNAM_R_ENTRY	180
#define hkwd_SEC_GETPWNAM_R_RETURN	181
#define hkwd_SEC_GETPWUID_R_ENTRY	190
#define hkwd_SEC_GETPWUID_R_RETURN	191
#define hkwd_SEC_GETPWENT_R_ENTRY	200
#define hkwd_SEC_GETPWENT_R_RETURN	201
#define hkwd_SEC_GETGRNAM_R_ENTRY	210
#define hkwd_SEC_GETGRGID_R_ENTRY	220
#define hkwd_SEC_GETGRGID_R_RETURN	221
#define hkwd_SEC_GETGRENT_R_ENTRY	230
#define hkwd_SEC_BAD_STANZA		231

/* PKI Service Module Sub-hook IDs */
#define hkwd_SEC_PKIMQUERYVERSIONS_ENTRY	244
#define hkwd_SEC_PKIMQUERYVERSIONS_FAILURE	245
#define hkwd_SEC_PKIMQUERYVERSIONS_SUCCESS	246
#define hkwd_SEC_PKIMERRORMODTEXT_ENTRY		247
#define hkwd_SEC_PKIMERRORMODTEXT_FAILURE	248
#define hkwd_SEC_PKIMERRORMODTEXT_SUCCESS	249
#define hkwd_SEC_PKIMLISTBUILD_ENTRY		250
#define hkwd_SEC_PKIMLISTBUILD_FAILURE		251
#define hkwd_SEC_PKIMLISTBUILD_SUCCESS		252
#define hkwd_SEC_PKIMLISTFREE_ENTRY		253
#define hkwd_SEC_PKIMLISTFREE_SUCCESS		255
#define hkwd_SEC_PKIMLISTLOADSRV_ENTRY		256
#define hkwd_SEC_PKIMLISTLOADSRV_FAILURE	257
#define hkwd_SEC_PKIMLISTLOADSRV_SUCCESS	258
#define hkwd_SEC_PKIMCERTCREATE_ENTRY		260
#define hkwd_SEC_PKIMCERTCREATE_FAILURE		261
#define hkwd_SEC_PKIMCERTCREATE_SUCCESS		262
#define hkwd_SEC_PKIMCERTREVOKE_ENTRY		263
#define hkwd_SEC_PKIMCERTREVOKE_FAILURE		264
#define hkwd_SEC_PKIMCERTREVOKE_SUCCESS		265
#define hkwd_SEC_PKIMCERTVERIFY_ENTRY		266
#define hkwd_SEC_PKIMCERTVERIFY_FAILURE		267
#define hkwd_SEC_PKIMCERTVERIFY_SUCCESS		268
#define hkwd_SEC_PKIMKSCHPASSWD_ENTRY		269
#define hkwd_SEC_PKIMKSCHPASSWD_FAILURE		270
#define hkwd_SEC_PKIMKSCHPASSWD_SUCCESS		271
#define hkwd_SEC_PKIMKSPASSWDRULES_ENTRY	272
#define hkwd_SEC_PKIMKSPASSWDRULES_FAILURE	273
#define hkwd_SEC_PKIMKSPASSWDRULES_SUCCESS	274
#define hkwd_SEC_PKIMKSVRFYPASSWD_ENTRY		275
#define hkwd_SEC_PKIMKSVRFYPASSWD_FAILURE	276
#define hkwd_SEC_PKIMKSVRFYPASSWD_SUCCESS	277
#define hkwd_SEC_PKIMKSCPOBJECTS_ENTRY		278
#define hkwd_SEC_PKIMKSCPOBJECTS_FAILURE	279
#define hkwd_SEC_PKIMKSCPOBJECTS_SUCCESS	280
#define hkwd_SEC_PKIMKSLSOBJECTS_ENTRY		281
#define hkwd_SEC_PKIMKSLSOBJECTS_FAILURE	282
#define hkwd_SEC_PKIMKSLSOBJECTS_SUCCESS	283
#define hkwd_SEC_PKIMKSRMOBJECTS_ENTRY		284
#define hkwd_SEC_PKIMKSRMOBJECTS_FAILURE	285
#define hkwd_SEC_PKIMKSRMOBJECTS_SUCCESS	286
#define hkwd_SEC_PKIMUSERCREATE_ENTRY		287
#define hkwd_SEC_PKIMUSERCREATE_FAILURE		288
#define hkwd_SEC_PKIMUSERCREATE_SUCCESS		289
#define hkwd_SEC_PKIMUSERDISABLE_ENTRY		290
#define hkwd_SEC_PKIMUSERDISABLE_FAILURE	291
#define hkwd_SEC_PKIMUSERDISABLE_SUCCESS	292
#define hkwd_SEC_PKIMQUERYMETHODS_ENTRY		293
#define hkwd_SEC_PKIMQUERYMETHODS_FAILURE	294
#define hkwd_SEC_PKIMQUERYMETHODS_SUCCESS	295
#define hkwd_SEC_PKIMCTRLCLEANUP_ENTRY		296
#define hkwd_SEC_PKIMCTRLCLEANUP_FAILURE	297
#define hkwd_SEC_PKIMCTRLCLEANUP_SUCCESS	298


/* PKI Toolkit Library Sub-hook IDs */

#define hkwd_SEC_PKIT_FUNC_ENTRY	300
#define hkwd_SEC_PKIT_FUNC_INFO		301
#define hkwd_SEC_PKIT_FUNC_FAILURE	302
#define hkwd_SEC_PKIT_FUNC_SUCCESS	303

/* PKI Load Module Sub-hook IDs */

#define hkwd_SEC_PKIL_FUNC_ENTRY	304
#define hkwd_SEC_PKIL_FUNC_INFO		305
#define hkwd_SEC_PKIL_FUNC_FAILURE	306
#define hkwd_SEC_PKIL_FUNC_SUCCESS	307

/* PKI Certificate and Key Management Commands Sub-hook IDs */

#define hkwd_SEC_CERT_COMMANDS_FUNC_ENTRY	320
#define hkwd_SEC_CERT_COMMANDS_FUNC_SUCCESS	321
#define hkwd_SEC_CERT_COMMANDS_FUNC_FAIL	322
#define hkwd_SEC_CERT_COMMANDS_FUNC_INFO	323


#define hkwd_SEC_ACCESSX_ENTRY		10000
#define hkwd_SEC_ACCESSX_EXIT		10001
#define hkwd_SEC_FACCESSX_ENTRY		10010
#define hkwd_SEC_FACCESSX_EXIT		10011
#define hkwd_SEC_AUDIT_ENTRY		10020
#define hkwd_SEC_AUDIT_EXIT		10021
#define hkwd_SEC_AUDITBIN_ENTRY		10030
#define hkwd_SEC_AUDITBIN_EXIT		10031
#define hkwd_SEC_AUDITLOG_ENTRY		10040
#define hkwd_SEC_AUDITLOG_EXIT		10041
#define hkwd_SEC_AUDITEVENTS_ENTRY	10050
#define hkwd_SEC_AUDITEVENTS_EXIT	10051
#define hkwd_SEC_AUDITPROC_ENTRY	10060
#define hkwd_SEC_AUDITPROC_EXIT		10061
#define hkwd_SEC_AUDITPROC_ERROR	10062
#define hkwd_SEC_CHACL_ENTRY		10070
#define hkwd_SEC_CHACL_EXIT		10071
#define hkwd_SEC_FCHACL_ENTRY		10080
#define hkwd_SEC_FCHACL_EXIT		10081
#define hkwd_SEC_CHPRIV_ENTRY		10090
#define hkwd_SEC_CHPRIV_EXIT		10091
#define hkwd_SEC_FCHPRIV_ENTRY		10100
#define hkwd_SEC_FCHPRIV_EXIT		10101
#define hkwd_SEC_PRIVCHECK_ENTRY	10110
#define hkwd_SEC_PRIVCHECK_EXIT		10111
#define hkwd_SEC_REVOKE_ENTRY		10120
#define hkwd_SEC_REVOKE_EXIT		10121
#define hkwd_SEC_FREVOKE_ENTRY		10130
#define hkwd_SEC_FREVOKE_EXIT		10131
#define hkwd_SEC_STATACL_ENTRY		10140
#define hkwd_SEC_STATACL_EXIT		10141
#define hkwd_SEC_FSTATACL_ENTRY		10150
#define hkwd_SEC_FSTATACL_EXIT		10151
#define hkwd_SEC_STATPRIV_ENTRY		10160
#define hkwd_SEC_STATPRIV_EXIT		10161
#define hkwd_SEC_FSTATPRIV_ENTRY	10170
#define hkwd_SEC_FSTATPRIV_EXIT		10171
#define	hkwd_SEC_FSTATACLX_ENTRY	10172
#define	hkwd_SEC_FSTATACLX_EXIT		10173
#define	hkwd_SEC_FCHACLX_ENTRY		10174
#define	hkwd_SEC_FCHACLX_EXIT		10175
#define	hkwd_SEC_CHACLX_ENTRY		10176
#define	hkwd_SEC_CHACLX_EXIT		10177
#define hkwd_SEC_STATACLX_ENTRY		10178
#define	hkwd_SEC_STATACLX_EXIT		10179
#define	hkwd_SEC_FCHXACL_ENTRY		10180
#define	hkwd_SEC_FCHXACL_EXIT		10181
#define	hkwd_SEC_CHXACL_ENTRY		10182
#define	hkwd_SEC_CHXACL_EXIT		10183
#define	hkwd_SEC_FSTATXACL_ENTRY	10184
#define	hkwd_SEC_FSTATXACL_EXIT		10185
#define	hkwd_SEC_STATXACL_ENTRY		10186
#define	hkwd_SEC_STATXACL_EXIT		10187
#define	hkwd_SEC_ACLXCNTL_ENTRY		10188
#define	hkwd_SEC_ACLXCNTL_EXIT		10189
#define hkwd_SEC_PRIVREFMON_ENTRY	10190
#define hkwd_SEC_PRIVREFMON_EXIT	10191
#define hkwd_SEC_REFMON_ENTRY		10192
#define hkwd_SEC_REFMON_EXIT		10193

#define	hkwd_SEC_CRED_CRGET		10300
#define	hkwd_SEC_CRED_CRFREE		10301
#define	hkwd_SEC_CRED_CRDUP		10302
#define	hkwd_SEC_CRED_CRHOLD		10303
#define	hkwd_SEC_CRED_CRREF		10304
#define	hkwd_SEC_CRED_CRCOPY		10305

/* KST Sub-hook IDs */
#define hkwd_SEC_GETUSRKAT_ENTRY	10400
#define hkwd_SEC_GETUSRKAT_EXIT		10401
#define hkwd_SEC_GETKAT_ENTRY		10402
#define hkwd_SEC_GETKAT_EXIT		10403
#define hkwd_SEC_AUTHNAME_ENTRY		10404
#define hkwd_SEC_AUTHNAME_EXIT		10405
#define hkwd_SEC_AUTHID_ENTRY		10406
#define hkwd_SEC_AUTHID_EXIT		10407
#define hkwd_SEC_CHKAUTH_ENTRY		10408
#define hkwd_SEC_CHKAUTH_EXIT		10409
#define hkwd_SEC_CHKAUTHID_ENTRY	10410
#define hkwd_SEC_CHKAUTHID_EXIT		10411
#define hkwd_SEC_GETAUTHIDS_ENTRY	10412
#define hkwd_SEC_GETAUTHIDS_EXIT	10413
#define hkwd_SEC_CHKAUTH_ANY_ENTRY	10416
#define hkwd_SEC_CHKAUTH_ANY_EXIT	10417
#define hkwd_SEC_CHKAUTH_BITMAP_ENTRY	10418
#define hkwd_SEC_CHKAUTH_BITMAP_EXIT	10419

#define	hkwd_SEC_GETKRT_ENTRY		10422
#define	hkwd_SEC_GETKRT_EXIT		10423
#define	hkwd_SEC_GETROLEBYID_ENTRY	10424
#define	hkwd_SEC_GETROLEBYID_EXIT	10425
#define	hkwd_SEC_GETROLEBYNAME_ENTRY	10426
#define	hkwd_SEC_GETROLEBYNAME_EXIT	10427
#define hkwd_SEC_GETROLENAME_ENTRY	10428
#define hkwd_SEC_GETROLENAME_EXIT	10429
#define hkwd_SEC_GETROLEID_ENTRY	10430
#define hkwd_SEC_GETROLEID_EXIT		10431

#define hkwd_SEC_SETWASCID_ENTRY	10440
#define hkwd_SEC_SETWASCID_EXIT		10441
#define hkwd_SEC_GETWASCID_ENTRY	10442
#define hkwd_SEC_GETWASCID_EXIT		10443
#define hkwd_SEC_GETWAS_ENTRY		10444
#define hkwd_SEC_GETWAS_EXIT		10445

#define hkwd_SEC_SETWPSCID_ENTRY	10450
#define hkwd_SEC_SETWPSCID_EXIT		10451
#define hkwd_SEC_GETWPSCID_ENTRY	10452
#define hkwd_SEC_GETWPSCID_EXIT		10453
#define hkwd_SEC_GETWPS_ENTRY		10454
#define hkwd_SEC_GETWPS_EXIT		10455

#define hkwd_SEC_SETKST_ENTRY	        10456
#define hkwd_SEC_SETKST_EXIT		10457

#define	hkwd_SEC_GETKPCT_ENTRY		10462
#define	hkwd_SEC_GETKPCT_EXIT		10463
#define	hkwd_SEC_GETCMDATTRS_ENTRY	10464
#define	hkwd_SEC_GETCMDATTRS_EXIT	10465

#define	hkwd_SEC_GETKPDT_ENTRY		10472
#define	hkwd_SEC_GETKPDT_EXIT		10473
#define	hkwd_SEC_GETDEVATTRS_ENTRY	10474
#define	hkwd_SEC_GETDEVATTRS_EXIT	10475

#define	hkwd_SEC_GETAUDRANGE_ENTRY	10476
#define	hkwd_SEC_GETAUDRANGE_EXIT	10477
#define	hkwd_SEC_SETAUDRANGE_ENTRY	10478
#define	hkwd_SEC_SETAUDRANGE_EXIT	10479

#define hkwd_SEC_DATA1			1
#define hkwd_SEC_DATA2			2
#define hkwd_SEC_DATA3			3
#define hkwd_SEC_DATA4			4




/*
 *	HOOK ID's used by the PThreads instrumentation in
 *	"libpthreads.a".
 *
 */

#define HKWD_PTHREAD_SCHEDULER                                          0x60000000
#define HKWD_PTHREAD_TIMER                                              0x60300000
#define HKWD_PTHREAD_VPSLEEP                                            0x60500000
#define HKWD_PTHREAD_COND                                               0x60600000
#define HKWD_PTHREAD_MUTEX                                              0x60700000
#define HKWD_PTHREAD_SPINLOCK                                           0x48E00000
#define HKWD_PTHREAD_BARRIER                                            0x49600000
#define HKWD_PTHREAD_RWLOCK                                             0x60800000
#define HKWD_PTHREAD_GENERAL                                            0x60900000



/*
 *	Corresponding PThreads subhook declarations.
 *
 */

/* HKWD_PTHREAD_SCHEDULER subhooks.		*/
#define hkwd_PTHREAD_SCHED_KERN_SLEEP                              0x01
#define hkwd_PTHREAD_SCHED_KERN_AWAKE				   0x02
#define hkwd_PTHREAD_SCHED_YIELD                                   0x03
#define hkwd_PTHREAD_SCHED_SLEEP                                   0x04
#define hkwd_PTHREAD_SCHED_RUNQ_ADD                                0x05
#define hkwd_PTHREAD_SCHED_TIMESLICE_ENTRY                         0x06
#define hkwd_PTHREAD_SCHED_TIMESLICE_EXIT                          0x07
#define hkwd_PTHREAD_SCHED_TIMESLICE_EXIT_DISABLED                 0x08

/* HKWD_PTHREAD_TIMER subhooks.			*/
#define hkwd_PTHREAD_TIMER_SLEEP_NONEMPTY			   0x01
#define hkwd_PTHREAD_TIMER_SLEEP_EMPTY				   0x02
#define hkwd_PTHREAD_TIMER_AWAKE_NONEMPTY			   0x03
#define hkwd_PTHREAD_TIMER_AWAKE_EMPTY				   0x04

/* HKWD_PTHREAD_VPSLEEP subhooks.		*/
#define hkwd_PTHREAD_VPSLEEP_KERN_SLEEP	                           0x01
#define hkwd_PTHREAD_VPSLEEP_KERN_AWAKE	                           0x02
#define hkwd_PTHREAD_VPSLEEP_ENTRY                                 0x03
#define hkwd_PTHREAD_VPSLEEP_EXIT                                  0x04

/* HKWD_PTHREAD_COND subhooks.		*/
#define hkwd_PTHREAD_COND_INIT	                                   0x01
#define hkwd_PTHREAD_COND_DESTROY                                  0x02
#define hkwd_PTHREAD_COND_WAIT_ENTRY				   0x03
#define hkwd_PTHREAD_COND_WAIT_EXIT                                0x04
#define hkwd_PTHREAD_COND_TIMEDWAIT_ENTRY                          0x05
#define hkwd_PTHREAD_COND_TIMEDWAIT_EXIT                           0x06
#define hkwd_PTHREAD_COND_SIGNAL                                   0x07
#define hkwd_PTHREAD_COND_BROADCAST                                0x08

/* HKWD_PTHREAD_MUTEX subhooks.		*/
#define hkwd_PTHREAD_MUTEX_INIT					   0x01
#define hkwd_PTHREAD_MUTEX_DESTROY				   0x02
#define hkwd_PTHREAD_MUTEX_TAKEN_LOCAL				   0x03
#define hkwd_PTHREAD_MUTEX_TAKEN_GLOBAL				   0x04
#define hkwd_PTHREAD_MUTEX_MISS_LOCAL				   0x05
#define hkwd_PTHREAD_MUTEX_MISS_GLOBAL				   0x06
#define hkwd_PTHREAD_MUTEX_TRY_TAKEN_LOCAL			   0x07
#define hkwd_PTHREAD_MUTEX_TRY_TAKEN_GLOBAL			   0x08
#define hkwd_PTHREAD_MUTEX_TRY_MISS_LOCAL			   0x09
#define hkwd_PTHREAD_MUTEX_TRY_MISS_GLOBAL			   0x0A
#define hkwd_PTHREAD_MUTEX_RECURSIVE_TAKEN			   0x0B
#define hkwd_PTHREAD_MUTEX_RELEASE_LOCAL			   0x0C
#define hkwd_PTHREAD_MUTEX_RELEASE_GLOBAL			   0x0D
#define hkwd_PTHREAD_MUTEX_RECURSIVE_RELEASE		           0x0E
#define hkwd_PTHREAD_MUTEX_WAIT_LOCAL				   0x0F
#define hkwd_PTHREAD_MUTEX_WAIT_GLOBAL				   0x10
#define hkwd_PTHREAD_MUTEX_RUNQ_LOCK				   0x11
#define hkwd_PTHREAD_MUTEX_RUNQ_RELEASE				   0x12
#define hkwd_PTHREAD_MUTEX_BOOST				   0x13
#define hkwd_PTHREAD_MUTEX_UNBOOST				   0x14
#define hkwd_PTHREAD_MUTEX_CEILING_FAIL				   0x15
#define hkwd_PTHREAD_MUTEX_CAN_BOOST				   0x16
#define hkwd_PTHREAD_MUTEX_CAN_BOOST_LOCAL			   0x17
#define hkwd_PTHREAD_MUTEX_LOCAL_TIMEDOUT			   0x18
#define hkwd_PTHREAD_MUTEX_GLOBAL_TIMEDOUT			   0x19

/* HKWD_PTHREAD_RWLOCK subhooks.	*/
#define hkwd_PTHREAD_RWLOCK_INIT				   0x01
#define hkwd_PTHREAD_RWLOCK_DESTROY				   0x02
#define hkwd_PTHREAD_RWLOCK_UNLOCK				   0x03
#define hkwd_PTHREAD_RWLOCK_WRITE_TAKEN				   0x08
#define hkwd_PTHREAD_RWLOCK_WRITE_MISS				   0x09
#define hkwd_PTHREAD_RWLOCK_TRY_WRITE_TAKEN			   0x0A
#define hkwd_PTHREAD_RWLOCK_TRY_WRITE_MISS			   0x0B
#define hkwd_PTHREAD_RWLOCK_READ_TAKEN				   0x0C
#define hkwd_PTHREAD_RWLOCK_READ_MISS				   0x0D
#define hkwd_PTHREAD_RWLOCK_TRY_READ_TAKEN			   0x0E
#define hkwd_PTHREAD_RWLOCK_TRY_READ_MISS			   0x0F

/*
 * Posix Real Time Spinlocks
 * HKWD_PTHREAD_SPINLOCK subhooks
 */
#define hkwd_PTHREAD_SPINLOCK_INIT                                 0x01
#define hkwd_PTHREAD_SPINLOCK_DESTROY                              0x02
#define hkwd_PTHREAD_SPINLOCK_LOCK                                 0x03
#define hkwd_PTHREAD_SPINLOCK_TRYLOCK                              0x04
#define hkwd_PTHREAD_SPINLOCK_UNLOCK                               0x05

/*
 * Posix Real Time barriers
 * HKWD_PTHREAD_BARRIER subhooks
 */

#define hkwd_PTHREAD_BARRIER_INIT                                  0x01
#define hkwd_PTHREAD_BARRIER_DESTROY                               0x02
#define hkwd_PTHREAD_BARRIER_WAIT                                  0x03

/*	HKWD_PTHREAD_GENERAL subhooks.	*/
#define hkwd_PTHREAD_GEN_CREATE_ENTRY				   0x01
#define hkwd_PTHREAD_GEN_CREATE_EXIT_LOCAL			   0x02
#define hkwd_PTHREAD_GEN_CREATE_EXIT_GLOBAL			   0x03
#define hkwd_PTHREAD_GEN_EXIT					   0x04
#define hkwd_PTHREAD_GEN_KILL_ENTRY				   0x05
#define hkwd_PTHREAD_GEN_KILL_EXIT				   0x06
#define hkwd_PTHREAD_GEN_JOIN_ENTRY				   0x07
#define hkwd_PTHREAD_GEN_JOIN_EXIT				   0x08
#define hkwd_PTHREAD_GEN_DETACH_ENTRY				   0x09
#define hkwd_PTHREAD_GEN_DETACH_EXIT				   0x0A
#define hkwd_PTHREAD_GEN_CANCEL_ENTRY				   0x0B
#define hkwd_PTHREAD_GEN_CANCEL_EXIT				   0x0C
#define hkwd_PTHREAD_GEN_DISPATCH_ENTRY				   0x0D
#define hkwd_PTHREAD_GEN_DISPATCH_EXIT				   0x0E
#define hkwd_PTHREAD_GEN_ALLOCINITPTHREAD_ENTRY			   0x0F
#define hkwd_PTHREAD_GEN_ALLOCINITPTHREAD_EXIT_GLOBAL		   0x10
#define hkwd_PTHREAD_GEN_ALLOCINITPTHREAD_EXIT_LOCAL		   0x11
#define hkwd_PTHREAD_GEN_SETSCHEDPRIO			           0x12
#define hkwd_PTHREAD_GEN_CREATE_LIMIT				   0x13

/* libc malloc trace hooks */
#define HKWD_LIBC_MALL_SUBSYSTEM                            0x60A00000

/* STAGE 0 */
#define hkwd_LIBC_MALL_MALLOC_COMMON_SIZE_ZERO              0x00
#define hkwd_LIBC_MALL_FREE_COMMON_NULL_PTR                 0x01
#define hkwd_LIBC_MALL_FREE_COMMON_OUT_OF_RANGE_PTR         0x02
#define hkwd_LIBC_MALL_FREE_COMMON_MEMALIGN_SUCCESS         0x03
#define hkwd_LIBC_MALL_FREE_COMMON_MEMALIGN_FAILURE         0x04
#define hkwd_LIBC_MALL_REALLOC_COMMON_NULL_PTR              0x05
#define hkwd_LIBC_MALL_REALLOC_COMMON_SIZE_ZERO             0x06
#define hkwd_LIBC_MALL_REALLOC_COMMON_OUT_OF_RANGE_PTR      0x07
#define hkwd_LIBC_MALL_REALLOC_COMMON_MEMALIGN_FAILED       0x08
#define hkwd_LIBC_MALL_REALLOC_COMMON_MEMALIGN_SUCCESS      0x09
#define hkwd_LIBC_MALL_MEMALIGN_COMMON_SIZE_ZERO            0x0A
#define hkwd_LIBC_MALL_MEMALIGN_COMMON_ALIGN_ERROR          0x0B
#define hkwd_LIBC_MALL_MEMALIGN_COMMON_ENOMEM               0x0C
#define hkwd_LIBC_MALL_MEMALIGN_COMMON_SUCCESS              0x0D

/* STAGE 1 */
#define hkwd_LIBC_MALL_MALLOC_CATCH_OVERFLOW_ENOMEM         0x10
#define hkwd_LIBC_MALL_MALLOC_CATCH_OVERFLOW_SUCCESS        0x11
#define hkwd_LIBC_MALL_FREE_CATCH_OVERFLOW_SUCCESS          0x12
#define hkwd_LIBC_MALL_REALLOC_CATCH_OVERFLOW_SUCCESS       0x13
#define hkwd_LIBC_MALL_REALLOC_CATCH_OVERFLOW_ENOMEM        0x14

/* STAGE 2 */
#define hkwd_LIBC_MALL_MALLOC_THREADCACHE_SUCCESS           0x20
#define hkwd_LIBC_MALL_FREE_THREADCACHE_SUCCESS             0x21

/* STAGE 3 */
#define hkwd_LIBC_MALL_MALLOC_HEAPCACHE_SUCCESS             0x20
#define hkwd_LIBC_MALL_FREE_HEAPCACHE_SUCCESS               0x21

/* STAGE 4 */
#define hkwd_LIBC_MALL_MALLOC_BUCKETS_SUCCESS_FREELIST      0x40
#define hkwd_LIBC_MALL_MALLOC_BUCKETS_SUCCESS_BUCKET        0x41
#define hkwd_LIBC_MALL_FREE_BUCKETS_SUCCESS                 0x43
#define hkwd_LIBC_MALL_FREE_BUCKETS_PREFIX_CORRUPTED        0x44
#define hkwd_LIBC_MALL_REALLOC_BUCKETS_SUCCESS              0x46
#define hkwd_LIBC_MALL_REALLOC_BUCKETS_PREFIX_CORRUPTED     0x47
#define hkwd_LIBC_MALL_MALLOC_NEWBUCKETS                    0x48
#define hkwd_LIBC_MALL_FREE_NEWBUCKETS                      0x49
#define hkwd_LIBC_MALL_REALLOC_NEWBUCKETS                   0x4A

/* STAGE 5 */
#define hkwd_LIBC_MALL_MALLOC_Y_SUCCESS                     0x50
#define hkwd_LIBC_MALL_MALLOC_Y_ENOMEM                      0x51
#define hkwd_LIBC_MALL_FREE_Y_SUCCESS                       0x52
#define hkwd_LIBC_MALL_FREE_Y_UNALIGNED                     0x54
#define hkwd_LIBC_MALL_FREE_Y_PREFIX_CORRUPTED              0x55
#define hkwd_LIBC_MALL_FREE_Y_INVALID_OVERLAP               0x56
#define hkwd_LIBC_MALL_REALLOC_Y_SUCCESS                    0x57
#define hkwd_LIBC_MALL_REALLOC_Y_ENOMEM                     0x58
#define hkwd_LIBC_MALL_REALLOC_Y_UNALIGNED                  0x5A
#define hkwd_LIBC_MALL_REALLOC_Y_PREFIX_CORRUPTED           0x5B

#define hkwd_LIBC_MALL_MALLOC_W_SUCCESS                     0x60
#define hkwd_LIBC_MALL_MALLOC_W_ENOMEM                      0x61
#define hkwd_LIBC_MALL_FREE_W_SUCCESS                       0x63
#define hkwd_LIBC_MALL_FREE_W_UNALIGNED                     0x64
#define hkwd_LIBC_MALL_FREE_W_PREFIX_CORRUPTED              0x65
#define hkwd_LIBC_MALL_FREE_W_INVALID_OVERLAP               0x66
#define hkwd_LIBC_MALL_REALLOC_W_SUCCESS                    0x68
#define hkwd_LIBC_MALL_REALLOC_W_ENOMEM                     0x69
#define hkwd_LIBC_MALL_REALLOC_W_UNALIGNED                  0x6A
#define hkwd_LIBC_MALL_REALLOC_W_PREFIX_CORRUPTED           0x6B

#define hkwd_LIBC_MALL_MALLOC_31                            0x70
#define hkwd_LIBC_MALL_MALLOC_31_ENOMEM                     0x71 
#define hkwd_LIBC_MALL_FREE_31                              0x72
#define hkwd_LIBC_MALL_FREE_31_PREFIX_CORRUPTED             0x73
#define hkwd_LIBC_MALL_REALLOC_31                           0x74
#define hkwd_LIBC_MALL_REALLOC_31_ENOMEM                    0x75

#define hkwd_LIBC_MALL_MALLOC_USER                          0x80
#define hkwd_LIBC_MALL_FREE_USER                            0x81
#define hkwd_LIBC_MALL_REALLOC_USER                         0x82

#define hkwd_LIBC_MALL_MALLOC_WM2_SUCCESS                   0x90
#define hkwd_LIBC_MALL_MALLOC_WM2_ENOMEM                    0x91
#define hkwd_LIBC_MALL_FREE_WM2_SUCCESS                     0x92
#define hkwd_LIBC_MALL_REALLOC_WM2_SUCCESS                  0x93
#define hkwd_LIBC_MALL_REALLOC_WM2_ENOMEM                   0x94

#define HKWD_LIBC_MALL_INTERNAL                             0x60B00000

/* STAGE 2 */
#define hkwd_LIBC_MALL_MALLOC_THREADCACHE_CREATE_FAILED     0x20
#define hkwd_LIBC_MALL_MALLOC_THREADCACHE_FILL_FAILED       0x21
#define hkwd_LIBC_MALL_MALLOC_THREADCACHE_FILL_SUCCESS      0x22
#define hkwd_LIBC_MALL_FREE_THREADCACHE_HALVE_BUCKET        0x24
#define hkwd_LIBC_MALL_FREE_THREADCACHE_NOCACHE             0x25

/* libc spawn hooks */
#define HKWD_LIBC_SPAWN_FATHER                              0x60E00000
#define HKWD_LIBC_SPAWN_CHILD                               0x60F00000


#define HKWD_POLLCACHE		0x52600000	   /* poll cache */

/* subhook ids */
#define hkwd_PC_PENDING			1
#define hkwd_PC_REMOVE_PEND		2
#define hkwd_PC_PUSH_PEND		3
#define hkwd_PC_TIME_OUT		4
#define hkwd_PC_WAIT_START		5
#define hkwd_PC_WAIT_STOP		6
#define hkwd_PC_CLEANUP_FD		7
#define hkwd_PC_POLL			8
#define hkwd_PC_CLOSE			9
#define hkwd_PC_REGISTER		10
#define hkwd_PC_UNREGISTER		11
#define hkwd_PC_INIT			12
#define hkwd_PC_RELEASE			13
#define hkwd_PC_CACHE_ADD		14
#define hkwd_PC_CLEANUP			15
#define hkwd_PC_DEQUEUE_PEND		16
#define hkwd_PC_ENQUEUE_PEND		17
#define hkwd_PC_WAIT2_START		18
#define hkwd_PC_WAIT2_STOP		19


/* loader trace hooks */
#define HKWD_LDR                	0x5A000000
#define hkwd_LDR_LOAD_FILE		0x01
#define hkwd_LDR_LOAD_LIBPATH		0x02
#define hkwd_LDR_LOADMODULE_COUNT	0x03
#define hkwd_LDR_PURGE			0x20
#define hkwd_LDR_UNLOADMODULE_COUNT	0x30
#define hkwd_LDR_LIB_LIBPATH_PRE	0x50
#define hkwd_LDR_LIB_LIBPATH		0x51
#define hkwd_LDR_LIB_LIB		0x52	
#define hkwd_LDR_GET_DOMAIN             0x70
#define hkwd_LDR_CLEAN_DOMAIN_ENTRY     0x71
#define hkwd_LDR_UNLOAD_DOMAIN          0x72
#define hkwd_LDR_LD_UNLOAD_LE_FILE	0x80
#define hkwd_LDR_LD_UNLOAD_LE_ADDR      0x81
#define hkwd_LDR_LIBGETTEXT_LOADLIST	0x152
#define hkwd_LDR_LIBGETTEXT_LOADLIST_LE	0x153
#define hkwd_LDR_LIBLD_LOADLIST		0x154
#define hkwd_LDR_LIBLD_LOADLIST_LE	0x155
#define hkwd_LDR_SROINST_LOADLIST	0x156
#define hkwd_LDR_SROINST_LOADLIST_LE	0x157
#define hkwd_LDR_INSTANCE_LOADLIST	0x158
#define hkwd_LDR_INSTANCE_LOADLIST_LE	0x159
#define hkwd_LDR_PRIVGETTEXT_LOADLIST_LE	0x15A

#define HKWD_LDR_KMOD           	0x5A100000
#define hkwd_LDR_KMOD_LOAD_FILE		0x01
#define hkwd_LDR_KMOD_LOAD_LIBPATH	0x02
#define hkwd_LDR_KMOD_UNLOAD_FILE	0x03
#define hkwd_LDR_KMOD_LOAD_COUNT	0x04
#define hkwd_LDR_KMOD_UNLOAD_COUNT	0x05

#define HKWD_LDR_PROC           	0x5A200000
#define hkwd_LDR_PROC_FILE		0x01
#define hkwd_LDR_PROC_PID		0x02
#define hkwd_LDR_PROC_SID		0x03
#define hkwd_LDR_PROC_LOAD		0x04
#define hkwd_LDR_PROC_UNLOAD		0x05

#define HKWD_LDR_ERR            		0x5A300000
#define hkwd_LDR_ERR_LD_MOD			0x001
#define hkwd_LDR_ERR_KMOD_LOAD			0x002
#define hkwd_LDR_ERR_KMOD_UNLOAD		0x003
#define hkwd_LDR_ERR_EXECLOAD			0x004
#define hkwd_LDR_ERR_GET_DOMAIN			0x005
#define hkwd_LDR_ERR_RESOLVE_EBUF		0x006
#define hkwd_LDR_ERR_RESOLVE_REASON		0x007
#define hkwd_LDR_ERR_RELOCATE			0x008

#define hkwd_LDR_ARCH_MEMBER			0x00b
#define hkwd_LDR_FILE_NAME			0x00c
#define hkwd_LDR_IMPORT_FILE_NAME		0x00d
#define hkwd_LDR_EXPORT_FILE_NAME		0x00e
#define hkwd_LDR_SYMBOL_NAME			0x00f

#define hkwd_LDR_RES_TOOBIG			0x010
#define hkwd_LDR_TYPE_MISMATCH			0x011
#define hkwd_LDR_BUILD_ALLOC_SEARCHLIST		0x012
#define hkwd_LDR_EXEC_INITLE			0x013
#define hkwd_LDR_ALLOC_DYNLIST			0x014
#define hkwd_LDR_BUILD_SEARCHLIST		0x015
#define hkwd_LDR_ADD_LE_TO_DYNLIST		0x016
#define hkwd_LDR_INITLE_ALLOC_SEARCHLIST	0x017
#define hkwd_LDR_HASHFIND_DEFERRED		0x018
#define hkwd_LDR_HASHFIND_TYPECHECK		0x019
#define hkwd_LDR_PP_HASHFIND			0x01a
#define hkwd_LDR_PP_RESOLVE_RTL_IGNORED 	0x01b
#define hkwd_LDR_PP_RESOLVE_TLS_SYMBOL		0x01c
#define hkwd_LDR_PP_RESOLVE_XO_SYMBOL		0x01d
#define hkwd_LDR_PP_RESOLVE_DOTDOT_SYMBOL	0x01e
#define hkwd_LDR_PP_RESOLVE_PRELOAD_SYMBOL	0x01f
#define hkwd_LDR_PP_NEWDELTAS_ALLOC		0x020
#define hkwd_LDR_PP_POSTPASS_RESOLVE		0x021
#define hkwd_LDR_RESOLVE_ALLOC_DELTAS		0x022
#define hkwd_LDR_RESOLVE_BAD_SYMBOL1		0x023
#define hkwd_LDR_RESOLVE_BAD_SYMBOL2		0x024
#define hkwd_LDR_RESOLVE_BAD_IMPID		0x025
#define hkwd_LDR_RESOLVE_KERNEL_DEFERRED	0x026
#define hkwd_LDR_RESOLVE_DEFERRED		0x027
#define hkwd_LDR_RESOLVE_KERNEL_TLS		0x028
#define hkwd_LDR_RESOLVE_TOO_MANY		0x029
#define hkwd_LDR_RESOLVE_TLS_SYMBOL		0x02a
#define hkwd_LDR_RESOLVE_SVC_REF		0x02b
#define hkwd_LDR_RESOLVE_XO_SYMBOL		0x02c
#define hkwd_LDR_RESOLVE_UNRESOLVED		0x02d
#define hkwd_LDR_RESOLVE_BAD_SECTION		0x02e
#define hkwd_LDR_RESOLVE_NO_EXPORTS		0x02f
#define hkwd_LDR_RESOLVE_INITLE			0x030
#define hkwd_LDR_RESOLVE_DEFER_IMPEXP		0x031
#define hkwd_LDR_RESOLVE_ERROR			0x032
#define hkwd_LDR_RESOLVE_POSTPASS		0x033
#define hkwd_LDR_RESOLVE_RTL_ERROR		0x034
#define hkwd_LDR_RESOLVE_AIX_ERROR		0x035
#define hkwd_LDR_RLD_SECTION_NUMBER		0x036
#define hkwd_LDR_RLD_SYMBOL_INDEX		0x037
#define hkwd_LDR_TEXT_RELOCATION		0x038
#define hkwd_LDR_DATA_RELOCATION		0x039
#define hkwd_LDR_RLD_OFFSET			0x03a
#define hkwd_LDR_RLD_SIZE			0x03b
#define hkwd_LDR_IMPORTED_LOCAL			0x03c
#define hkwd_LDR_TLS_LOCAL			0x03d
#define hkwd_LDR_TLS_EXPORT			0x03e
#define hkwd_LDR_TLS_IMPORT			0x03f
#define hkwd_LDR_TLS_RELOC			0x040
#define hkwd_LDR_BAD_RELOCATION_TYPE		0x041
#define hkwd_LDR_RLD_TLS_RTYPE			0x042
#define hkwd_LDR_RELOCATE_SYMBOL		0x043
#define hkwd_LDR_RESOLVEREDO_ALLOC_DELTAS	0x044
#define hkwd_LDR_RESOLVEREDO_BAD_SYMBOL1	0x045
#define hkwd_LDR_RESOLVEREDO_BAD_SYMBOL2	0x046
#define hkwd_LDR_RESOLVEREDO_TLS_SYMBOL		0x047
#define hkwd_LDR_RESOLVEREDO_TYPE_MISMATCH	0x048
#define hkwd_LDR_RESOLVEREDO			0x049
#define hkwd_LDR_RELOCATE			0x04a
#define hkwd_LDR_REDO_DEFERRED_SYMBOL		0x04b
#define hkwd_LDR_REDO				0x04c
#define hkwd_LDR_SVC_EXPORT_CREATE		0x04d

#define hkwd_LDR_XMALLOC			0x060
#define hkwd_LDR_LIBPATH			0x061
#define hkwd_LDR_LIBRARIES0			0x062
#define hkwd_LDR_GETMOD0_READ			0x063
#define hkwd_LDR_GETKEXT0_PATHOPEN		0x064
#define hkwd_LDR_GETKEXT0_LOAD			0x065
#define hkwd_LDR_GETKEXT0_DEPENDS		0x066
#define hkwd_LDR_GETTEXT_TEXTREAD		0x067
#define hkwd_LDR_PGETTEXT_TEXTREAD		0x068
#define hkwd_LDR_SVC_SHARED			0x069
#define hkwd_LDR_SVC_SHLAP			0x06a
#define hkwd_LDR_PSVC_PRIVATE			0x06b
#define hkwd_LDR_LIB_GETSVCFD			0x06c
#define hkwd_LDR_LIB_CANNOT_LOAD		0x06d
#define hkwd_LDR_LIB_DATAINST			0x06e
#define hkwd_LDR_KERN_KTEXTREAD			0x06f
#define hkwd_LDR_PINST_GETSVCFD			0x070
#define hkwd_LDR_INST_GETSVCFD			0x071
#define hkwd_LDR_INST_DEFERRED			0x072
#define hkwd_LDR_INST_DOMAIN			0x073
#define hkwd_LDR_GETLIB_PATHOPEN		0x074
#define hkwd_LDR_GETLIB_EXEC			0x075
#define hkwd_LDR_GETLIB_KERNEL			0x076
#define hkwd_LDR_IMPID_TRUNCATE1		0x077
#define hkwd_LDR_DODDOT_NOLIB			0x078
#define hkwd_LDR_MAIN_NOLIB			0x079
#define hkwd_LDR_IMPID_TRUNCATE2		0x07a
#define hkwd_LDR_GET_FROM_IMIPD			0x07b
#define hkwd_LDR_GETLIB_NOLIB			0x07c
#define hkwd_LDR_DEPEND_NOLIB			0x07d
#define hkwd_LDR_SHARED_INST			0x07e
#define hkwd_LDR_PRIV_INST			0x07f
#define hkwd_LDR_READ_GETSVCFD			0x080
#define hkwd_LDR_PRIVINSTANCE			0x081
#define hkwd_LDR_SCC_PRELOC			0x082
#define hkwd_LDR_SCC_INSTANCE			0x083
#define hkwd_LDR_SEARCH_FAIL			0x084
#define hkwd_LDR_SCC_SEARCH			0x085
#define hkwd_LDR_PRERELOC_GETSVCFD		0x086
#define hkwd_LDR_PRERELOC_LIBINST		0x087
#define hkwd_LDR_PRERELOC_RESOLVE		0x088
#define hkwd_LDR_PRERELOC_RELOCATE		0x089
#define hkwd_LDR_PRERELOC_SHLAP_DIED		0x08a
#define hkwd_LDR_PRERELOC_SHLAP			0x08b
#define hkwd_LDR_NO_NEWSID			0x08c
#define hkwd_LDR_TEXT_LENGTH			0x08d
#define hkwd_LDR_TEXT_TRUNCATED			0x08e
#define hkwd_LDR_TEXT_EIO			0x08f
#define hkwd_LDR_RETEXT_FSIZE			0x090
#define hkwd_LDR_RETEXT_SANITY64		0x091
#define hkwd_LDR_RETEXT_SANITY32		0x092
#define hkwd_LDR_RETEXT_NOENTRY			0x093
#define hkwd_LDR_RETEXT_TOO_LARGE		0x094
#define hkwd_LDR_RETEXT_NEWSID			0x095
#define hkwd_LDR_RETEXT_READ			0x096
#define hkwd_LDR_UNTEXT_OPERAND			0x097

#define hkwd_LDR_NO_FIT				0x0b0
#define hkwd_LDR_SBRK_FAILED			0x0b1
#define hkwd_LDR_EXEC_SANITY			0x0b2
#define hkwd_LDR_MAPFILE			0x0b3
#define hkwd_LDR_ARCHIVE			0x0b4
#define hkwd_LDR_SANITY				0x0b5
#define hkwd_LDR_TEXTALLOC			0x0b6
#define hkwd_LDR_BAD_ALIGN			0x0b7
#define hkwd_LDR_READ_PRIVATE			0x0b8
#define hkwd_LDR_READ_SHARED			0x0b9
#define hkwd_LDR_MBE_CREATE_EXEC_SEG		0x0ba
#define hkwd_LDR_MBE_MAP_EXEC			0x0bb
#define hkwd_LDR_MBE_READ_EXEC			0x0bc
#define hkwd_LDR_MBE_MAP_LOADER			0x0bd
#define hkwd_LDR_MBE_READ_LOADER		0x0be
#define hkwd_LDR_MBE_IO_ERROR			0x0bf
#define hkwd_LDR_MHE_CREATE_EXEC_SEG		0x0c0
#define hkwd_LDR_MHE_MAP_EXEC			0x0c1
#define hkwd_LDR_MHE_READ_EXEC			0x0c2
#define hkwd_LDR_MHE_MAP_LOADER			0x0c3
#define hkwd_LDR_MHE_READ_LOADER		0x0c4
#define hkwd_LDR_MHE_IO_ERROR			0x0c5

#define hkwd_LDR_64_MAP_FATAL_ERROR		0x0d0
#define hkwd_LDR_64_EXEC_SANITY			0x0d1
#define hkwd_LDR_64_EXEC_TOOBIG			0x0d2
#define hkwd_LDR_64_MAPFILE			0x0d3
#define hkwd_LDR_64_ARCHIVE			0x0d4
#define hkwd_LDR_64_NOT_ARCHIVE			0x0d5
#define hkwd_LDR_64_SANITY			0x0d6
#define hkwd_LDR_64_MAP_LIBFULL			0x0d7
#define hkwd_LDR_64_MAP_PRIVATE			0x0d8
#define hkwd_LDR_64_MAP_SHARED			0x0d9
#define hkwd_LDR_64_READ_PRIVATE		0x0da
#define hkwd_LDR_64_READ_SHARED			0x0db
#define hkwd_LDR_NPT_CREATE_EXEC_SEG		0x0dc
#define hkwd_LDR_NPT_MAP_EXEC			0x0dd
#define hkwd_LDR_NPT_READ_EXEC			0x0de

#define hkwd_LDR_SYSCALL_OLD_EXPORTS		0x0f0
#define hkwd_LDR_SYSCALL_DELTAS_ALLOC		0x0f1
#define hkwd_LDR_SYSCALL_NEW_EXPORTS		0x0f2
#define hkwd_LDR_SVSFD_TEXTALLOC		0x0f3
#define hkwd_LDR_SVCFD_PRIVATE			0x0f4
#define hkwd_LDR_SVCFD_SHARED64			0x0f5
#define hkwd_LDR_SVCFD_SHARED32			0x0f6
#define hkwd_LDR_BASE_NO_LE			0x0f7
#define hkwd_LDR_BASE_NO_SVCS			0x0f8

#define HKWD_LDR_CHKPT			0x5A400000
#define hkwd_LDR_CHKPT_SID_32		0x01
#define hkwd_LDR_CHKPT_SID_64_TEXT	0x02
#define hkwd_LDR_CHKPT_SID_64_DATA	0x03
#define hkwd_LDR_CHKPT_LE_ADDR		0x04

#define HKWD_LDR_NAMEDSHLIB		0x5A500000
#define hkwd_LDR_NAMEDSHLIB_CREATE	0x01
#define hkwd_LDR_NAMEDSHLIB_DESTROY	0x02

/* trace hooks for MPIO path control modules */
#define HKWD_DD_PCMKE                   0x17B00000

/* POSIX Realtime clock */
#define HKWD_SYSC_RTCLOCK               0x5AA00000	
#define hkwd_SYSC_RTCLOCK_GETRES        0x01
#define hkwd_SYSC_RTCLOCK_GETTIME       0x02    
#define hkwd_SYSC_RTCLOCK_SETTIME       0x03
#define hkwd_SYSC_RTCLOCK_CPUCLOCKID    0x04
#define hkwd_SYSC_RTCLOCK_NANOSLEEP     0x05
#define hkwd_RTCLOCK_NANOSLEEP_END      0x06

/* POSIX Realtime timer */	
#define HKWD_SYSC_RTTIMER               0x5AB00000	
#define hkwd_SYSC_RTTIMER_CREATE        0x01
#define hkwd_SYSC_RTTIMER_DELETE        0x02
#define hkwd_SYSC_RTTIMER_GETOVERRUN    0x03
#define hkwd_SYSC_RTTIMER_GETTIME       0x04
#define hkwd_SYSC_RTTIMER_SETTIME       0x05
#define hkwd_RTTIMER_TRB_INTRVL_END     0x06
#define hkwd_RTTIMER_CPUTMR_INTRVL_END  0x07

/* Posix Realtime semaphores */
#define HKWD_SYSC_RTSEM                0x5B500000
#define hkwd_SYSC_RTSEM_OPEN           0x01
#define hkwd_SYSC_RTSEM_CLOSE          0x02
#define hkwd_SYSC_RTSEM_UNLINK         0x03
#define hkwd_SYSC_RTSEM_INIT           0x04
#define hkwd_SYSC_RTSEM_DESTROY        0x05
#define hkwd_SYSC_RTSEM_GETVALUE       0x06
#define hkwd_SYSC_RTSEM_POST           0x07
#define hkwd_SYSC_RTSEM_WAIT           0x08
#define hkwd_RTSEM_CREATE              0x09
#define hkwd_RTSEM_GET                 0x0A
#define hkwd_RTSEM_REMOVE              0x0B
#define hkwd_RTSEM_CLOSEDES            0x0C
/* Posix Real time message queues */ 
#define HKWD_SYSC_RTMQ                 0x5B600000 
#define hkwd_SYSC_RTMQ_OPEN            0x01 
#define hkwd_SYSC_RTMQ_CLOSE           0x02 
#define hkwd_SYSC_RTMQ_UNLINK          0x03 
#define hkwd_SYSC_RTMQ_GETATTR         0x04 
#define hkwd_SYSC_RTMQ_SETATTR         0x05 
#define hkwd_SYSC_RTMQ_NOTIFY          0x06 
#define hkwd_SYSC_RTMQ_SEND            0x07
#define hkwd_SYSC_RTMQ_RECEIVE         0x08 
#define hkwd_RTMQ_CREATE               0x09
#define hkwd_RTMQ_GET                  0x0A
#define hkwd_RTMQ_REMOVE               0x0B
#define hkwd_RTMQ_CLOSEDES             0x0C
/* Posix Real time shared memory */ 
#define HKWD_SYSC_RTSHM                0x5B700000 
#define hkwd_SYSC_RTSHM_OPEN           0x01 
#define hkwd_SYSC_RTSHM_UNLINK         0x02
#define hkwd_RTSHM_CREATE              0x03
#define hkwd_RTSHM_GET                 0x04
#define hkwd_RTSHM_REMOVE              0x05
#define hkwd_RTSHM_CLOSEDES            0x06
/* Posix Real time ipc name */
#define HKWD_RTIPC_NAME                0x5B800000
/* Posix Real time thread priority scheduling */
#define HKWD_SYSC_PRIO_REQUEUE         0x5AC00000
/* Posix Real time priority scheduling */
#define HKWD_SYSC_PRIO_SCHED             0x5AD00000
#define hkwd_PRIO_SCHED_GET_PRIORITY_MIN 0x01
#define hkwd_PRIO_SCHED_GET_PRIORITY_MAX 0x02
#define hkwd_PRIO_SCHED_RR_GET_INTERVAL  0x03
#define hkwd_PRIO_SCHED_SETPARAM         0x04
#define hkwd_PRIO_SCHED_SETSCHEDULER     0x05
#define hkwd_PRIO_SCHED_GETPARAM         0x06
#define hkwd_PRIO_SCHED_GETSCHEDULER     0x07


#define HKWD_NETWLM                             0x5B900000
#define hkwd_netwlm_connect_in                  1
#define hkwd_netwlm_connect_out                 2
#define hkwd_netwlm_connect_out_not_auth        3
#define hkwd_netwlm_connect_out_limit1_conn     4
#define hkwd_netwlm_connect_out_bad_version     5
#define hkwd_netwlm_disconnect_in               6
#define hkwd_netwlm_disconnect_out              7
#define hkwd_netwlm_disconnect_out_bad_version  8
#define hkwd_netwlm_disconnect_out_buffer_small 9
#define hkwd_netwlm_query_in                    10
#define hkwd_netwlm_query_out                   11
#define hkwd_netwlm_query_out_bad_request       12
#define hkwd_netwlm_set_ipaddrports_in          13
#define hkwd_netwlm_set_ipaddrports_out         14
#define hkwd_netwlm_set_ipaddrports_out_bad_version        15
#define hkwd_netwlm_get_ipaddrportsPID_in       16
#define hkwd_netwlm_get_ipaddrportsPID_out      17
#define hkwd_netwlm_proc_table_lookup_in        18
#define hkwd_netwlm_proc_table_lookup_out       19
#define hkwd_netwlm_fd_lookup_in                20
#define hkwd_netwlm_fd_lookup_out               21
#define hkwd_netwlm_get_proctable_lookup_in     22
#define hkwd_netwlm_get_proctable_lookup_out    23
#define hkwd_netwlm_get_verify_pid_in           24
#define hkwd_netwlm_get_verify_pid_out          25
#define hkwd_netwlm_get_fdlookup_in             26
#define hkwd_netwlm_get_fdlookup_out1           27
#define hkwd_netwlm_get_fdlookup_out2           28
#define hkwd_netwlm_get_fdlookup_out3           29
#define hkwd_netwlm_postbind_save_pid_in        30
#define hkwd_netwlm_postbind_save_pid_out       31
#define hkwd_netwlm_add_pid_in                  32
#define hkwd_netwlm_add_pid_out                 33
#define hkwd_netwlm_del_pid_in                  34
#define hkwd_netwlm_del_pid_out                 35
#define hkwd_netwlm_get_fdlookup_data1		36

/* trace hooks for memory locking routine */
#define HKWD_SYSC_MLOCK                 0x47B00000
#define hkwd_SYSC_MLOCK_LOCKALL         0x01
#define hkwd_SYSC_MLOCK_UNLOCKALL       0x02
#define hkwd_SYSC_MLOCK_LOCK            0x03
#define hkwd_SYSC_MLOCK_UNLOCK          0x04
#define hkwd_SYSC_MLOCK_FPGIN           0x05

/*
 * ACL Engine  hook and sub-hook ids
 */    
#define HKWD_ACLE                       0x47800000  
#define hkwd_ACLE_SET_ACL_ENTRY         0x01
#define hkwd_ACLE_SET_ACL_EXIT          0x02
#define hkwd_ACLE_VALIDATE_ACL          0x03
#define hkwd_ACLE_CHK_ACCESS_ENTRY      0x04
#define hkwd_ACLE_CHK_RWX               0x05
#define hkwd_ACLE_CHK_RWX_PRIVCHECK     0x06
#define hkwd_ACLE_CHK_MASKS             0x07
#define hkwd_ACLE_CHK_MASKS_PRIVCHECK   0x08
#define hkwd_ACLE_CHK_ONLY_PRIVCHECK    0x09
#define hkwd_ACLE_CHK_ACCESS_EXIT       0x0A
#define hkwd_ACLE_GET_ACL_ENTRY         0x0B
#define hkwd_ACLE_GET_ACL_EXIT          0x0C
#define hkwd_ACLE_GET_CHILD_ACL_ENTRY   0x0D
#define hkwd_ACLE_GET_CHILD_ACL_EXIT    0x0E

/*
 * Hypervisor Call hook and sub-hook ids
 */
#define HKWD_KERN_HCALL			0x49200000
#define hkwd_KERN_HCALL_START		1
#define hkwd_KERN_HCALL_END		2

/* Special defines for H_CEDE */
#define hkwd_KERN_HCEDE_START		1
#define hkwd_KERN_HCEDE_END_DC		2	/* Dispatch count changed */
#define hkwd_KERN_HCEDE_END_JOB		3	/* New job available	  */

/*
 * Advanced Accounting Trace Hooks.
 */
#define HKWD_AACCT			0x49A00000 /* AACCT - no _aacct_put */
#define HKWD_AACCT_DBG			0x49B00000 /* AACCT - _acct_put() */

/* subhook ids */

#define hkwd_AACCT_DR_HANDLER		1
#define hkwd_AACCT_INT_REGISTER		2
#define hkwd_AACCT_INT_REGISTER_EXIT	3
#define hkwd_AACCT_INT_UNREGISTER	4
#define hkwd_AACCT_INT_WALK		5
#define hkwd_AACCT_CMD_INT		6
#define hkwd_AACCT_CMD_ENABLE		7
#define hkwd_AACCT_CMD_DISABLE		8	

#define	hkwd_AACCT_REQ			9

#define hkwd_AACCT_STARTED		10
#define hkwd_AACCT_STOPPED		11
#define hkwd_AACCT_ADD_FILE		12
#define hkwd_AACCT_RM_FILE		13
#define hkwd_AACCT_SWITCH_FILE		14
#define hkwd_AACCT_ACK_FILE		15

#define hkwd_AACCT_TRID_DEFINED		16
#define hkwd_AACCT_TRID_ENABLED		17
#define hkwd_AACCT_TRID_DISABLED	18

#define hkwd_AACCT_ACF_FULL		19
#define hkwd_AACCT_ACF_TERMINATE	20
#define hkwd_AACCT_ACF_NOBUFS		21
#define hkwd_AACCT_ACF_NOFILES		22
#define hkwd_AACCT_ACF_WARN		23

#define hkwd_AACCT_SYSINT_SET		24
#define hkwd_AACCT_SYSINT_RESET		25
#define hkwd_AACCT_PROCINT_SET		26
#define hkwd_AACCT_PROCINT_RESET	27

#define hkwd_AACCT_AGGR_SET		28
#define hkwd_AACCT_AGGR_RESET		29


/* subhookid for HK_AACCT_DBG	*/

#define hkwd_AACCT_ACCTPUT		1
#define hkwd_AACCT_AGGR_PROC		2
#define hkwd_AACCT_AGGR_APP		3
#define hkwd_AACCT_AGGR_KE		4

/*
 * HOOK for RAS Error Checking service.
 */
#define HKWD_ERRHK			0x4AE00000 /* raschk_errhook() */

/*
 * PCI Bus Driver's Hookwords.
 */
#define HKWD_KERN_EEH			0x49C00000  /* EEH Kernel Services */
#define HKWD_KERN_DMA			0x49D00000  /* DMA Kernel Services */

/* PAL Driver's Hookwords. */
#define HKWD_RTAS_CALLS			0x5BC00000  /* RTAS call services  */

/* subhookids for HKWD_KERN_EEH */
#define EEH_INIT_ENTER			0x01
#define EEH_INIT_EXIT			0x0F
#define EEH_INIT_MULTIFUNC_ENTER	0x11
#define EEH_INIT_MULTIFUNC_EXIT		0x1F
#define EEH_CLEAR_ENTER			0x21
#define EEH_CLEAR_EXIT			0x2F
#define EEH_READ_SLOT_STATE1		0x34
#define EEH_READ_SLOT_STATE2		0x37
#define EEH_READ_SLOT_STATE3		0x39
#define EEH_READ_SLOT_STATE_EXIT	0x3F
#define EEH_RESET_SLOT_ENTER		0x41
#define EEH_RESET_SLOT_RTAS		0x45
#define EEH_RESET_SLOT_EXIT		0x4F
#define EEH_ENABLE_SLOT_ENTER		0x51
#define EEH_ENABLE_SLOT_RTAS		0x55
#define EEH_ENABLE_SLOT_EXIT		0x5F
#define EEH_DISABLE_SLOT_ENTER		0x61
#define EEH_DISABLE_SLOT_RTAS		0x65
#define EEH_DISABLE_SLOT_EXIT		0x6F
#define EEH_ENABLE_DMA_ENTER		0x71
#define EEH_ENABLE_DMA_RTAS		0x75
#define EEH_ENABLE_DMA_EXIT		0x7F
#define EEH_ENABLE_PIO_ENTER		0x81
#define EEH_ENABLE_PIO_RTAS		0x85
#define EEH_ENABLE_PIO_EXIT		0x8F
#define EEH_SLOT_ERROR_ENTER		0x91
#define EEH_SLOT_ERROR_RTAS		0x95
#define EEH_SLOT_ERROR_RTAS2		0x97
#define EEH_SLOT_ERROR_EXIT		0x9F
#define EEH_CONFIGURE_BRIDGE_ENTER	0xA1
#define EEH_CONFIGURE_BRIDGE_RTAS	0xA5
#define EEH_CONFIGURE_BRIDGE_EXIT	0xAF
#define EEH_ISSUE_CALLBACKS_ENTER	0xB1
#define EEH_ISSUE_CALLBACKS_ENTER2	0xB2
#define EEH_ISSUE_CALLBACKS_MASTER	0xB5
#define EEH_ISSUE_CALLBACKS_RESTR	0xB6
#define EEH_ISSUE_CALLBACKS_KCALL	0xB8
#define EEH_ISSUE_CALLBACKS_UCALL	0xB9
#define EEH_ISSUE_CALLBACKS_RET		0xBA
#define EEH_ISSUE_CALLBACKS_EXIT	0xBF
#define EEH_CALL_FIRMWARE		0xC1
#define EEH_CONFIGURE_PE_ENTER		0xD1
#define EEH_CONFIGURE_PE_RTAS		0xD5
#define EEH_CONFIGURE_PE_EXIT		0xDF

/*
 * VCM TRACE HOOKS 
 */
#define HKWD_VCM_MAIN  				0x48000000
#define hkwd_vcm_clientRegister_ENTER		0x001
#define hkwd_vcm_clientRegister_ERROR		0x002
#define hkwd_vcm_clientRegister_EXIT		0x003
#define hkwd_vcm_clientUnregister_ENTER		0x004
#define hkwd_vcm_clientUnregister_EXIT		0x005
#define hkwd_vcm_openVFS_ENTER			0x006
#define hkwd_vcm_openVFS_ERROR			0x007
#define hkwd_vcm_openVFS_EXIT			0x008
#define hkwd_vcm_closeVFS_ENTER			0x009
#define hkwd_vcm_closeVFS_EXIT			0x00a
#define hkwd_vcm_getOpRights_ENTER		0x00b
#define hkwd_vcm_getOpRights_ERROR1		0x00c
#define hkwd_vcm_getOpRights_ENTER2		0x00d
#define hkwd_vcm_getOpRights_ERROR2		0x00e
#define hkwd_vcm_getOpRights_EXIT1		0x00f
#define hkwd_vcm_returnOpRights_ENTER		0x010
#define hkwd_vcm_returnOpRights_EXIT		0x011
#define hkwd_vcm_beginCreate_ERROR		0x012
#define hkwd_vcm_beginCreate_ENTER		0x013
#define hkwd_vcm_beginCreate_EXIT2		0x014
#define hkwd_vcm_endCreate_ENTER		0x015
#define hkwd_vcm_endCreate_ERROR		0x016
#define hkwd_vcm_endCreate_EXIT1		0x017
#define hkwd_vcm_endCreate_EXIT2		0x018
#define hkwd_allocLocalObj_EXIT1    		0x019
#define hkwd_getLocalObj_ENTER    		0x01a
#define hkwd_getLocalObj_ERROR1    		0x01b
#define hkwd_getLocalObj_ERROR2    		0x01c
#define hkwd_getLocalObj_FINDLOCAL  		0x01d
#define hkwd_getLocalObj_EXIT  			0x01e
#define hkwd_localObjectRevoke_ENTER		0x01f
#define hkwd_localObjectRevoke_ERROR		0x020
#define hkwd_localObjectRevoke_CONFLICT_OPEN	0x021
#define hkwd_localObjectRevoke_CONFLICT_ACTIVE	0x022
#define hkwd_localObjectRevode_EXIT		0x023
#define hkwd_vcmi_localOpsInit_SIZES		0x024
#define hkwd_vcmi_localOpsInit_CLIENTADD	0x025
#define hkwd_vcm_localOpsGet_ENTER		0x026
#define hkwd_vcm_localOpsGet_ERROR		0x027
#define hkwd_vcm_localOpsGet_EXIT1		0x028
#define hkwd_vcm_localOpsGet_EXIT2		0x029
#define hkwd_vcm_localOpsPut_ENTER		0x02a
#define hkwd_vcm_localOpsPut_EXIT		0x02b
#define hkwd_vcm_localOpsOpen_ENTER		0x02c
#define hkwd_vcm_localOpsOpen_ERROR1		0x02d
#define hkwd_vcm_localOpsOpen_ERROR2		0x02e
#define hkwd_vcm_localOpsOpen_EXIT1		0x02f
#define hkwd_vcm_localOpsOpen_EXIT2		0x030
#define hkwd_vcm_localOpsClose_ENTER		0x031
#define hkwd_vcm_localOpsClose_ERROR1		0x032
#define hkwd_vcm_localOpsClose_ERROR2		0x033
#define hkwd_vcm_localOpsClose_ERROR4		0x035
#define hkwd_vcm_localOpsClose_ERROR5		0x036
#define hkwd_vcm_localOpsClose_ERROR6		0x037
#define hkwd_vcm_localOpsClose_EXIT		0x038
#define hkwd_vcm_localOpsBeginCreate_ENTER	0x039
#define hkwd_vcm_localOpsBeginCreate_NAME	0x03a
#define hkwd_vcm_localOpsBeginCreate_EXIT1	0x03b
#define hkwd_vcm_localOpsBeginCreate_EXIT2	0x03c
#define hkwd_vcm_localOpsEndCreate_ENTER	0x03d
#define hkwd_vcm_localOpsEndCreate_ERROR1	0x03e
#define hkwd_vcm_localOpsEndCreate_ERROR2	0x03f
#define hkwd_vcm_localOpsEndCreate_ERROR3	0x040
#define hkwd_vcm_localOpsEndCreate_ERROR4	0x041
#define hkwd_vcm_localOpsEndCreate_ERROR5	0x042
#define hkwd_vcm_localOpsEndCreate_EXIT1	0x043
#define hkwd_vcm_localOpsEndCreate_EXIT2	0x044
#define hkwd_vcm_init_EXIT_ERROR		0x045
#define hkwd_vcm_vnop_create_ENTER		0x046
#define hkwd_vcm_vnop_create_ERROR1		0x047
#define hkwd_vcm_vnop_create_ERROR2		0x048
#define hkwd_vcm_vnop_create_ERROR3		0x049
#define hkwd_vcm_vnop_create_EXIT		0x04a
#define hkwd_vcm_vnop_open_ERROR		0x04b
#define hkwd_vcm_vnop_create_attr_ENTER		0x04c
#define hkwd_vcm_vnop_create_attr_ERROR1	0x04d
#define hkwd_vcm_vnop_create_attr_ERROR2	0x04e
#define hkwd_vcm_vnop_create_attr_EXIT		0x04f
#define hkwd_chandleToClientRec_ERROR1		0x050
#define hkwd_chandleToClientRec_ERROR2		0x051
#define hkwd_vcmi_clientDelete_ERROR1		0x052
#define hkwd_vcmi_clientRevokeRights_ENTER1	0x053
#define hkwd_vcmi_clientRevokeRights_ENTER2	0x054
#define hkwd_vcmi_clientRevokeRights_EXIT	0x055
#define hkwd_vcmi_clientAddVFSOpen_ERROR1	0x056
#define hkwd_vcmi_clientAddVFSOpen_ERROR2	0x057
#define hkwd_vcmi_clientRemVFSOpen_ERROR1	0x058
#define hkwd_addVFS_ENTER			0x059
#define hkwd_closeVFS_ENTER			0x05a
#define hkwd_vcmi_vfsEndCreate_ERROR1		0x05b
#define hkwd_vcmi_vfsEndCreate_ERROR2		0x05c
#define hkwd_vcmi_vfsAddObjRef_ERROR1		0x05d
#define hkwd_vcmi_vfsAddObjRef_ERROR2		0x05e
#define hkwd_vcmi_vfsDelObjRef_ERROR1		0x05f
#define hkwd_vcmi_vfsDelObjRef_ERROR2		0x060
#define hkwd_vcmi_peerReturnObjHandle_ENTER	0x061
#define hkwd_vcmi_peerReturnObjHandle_EXIT	0x062
#define hkwd_vcmi_peerGetRights_ENTER		0x063
#define hkwd_vcmi_peerGetRights_EXIT1		0x064
#define hkwd_vcmi_peerGetRights_EXIT2		0x065
#define hkwd_vcmi_peerReturnRights_ENTER	0x066
#define hkwd_vcmi_peerReturnRights_EXIT		0x067
#define hkwd_vcmi_peerCreateObject_NAME		0x068
#define hkwd_vcmi_peerCreateObject_ENTER	0x069
#define hkwd_vcmi_peerCreateObject_EXIT		0x06a
#define hkwd_vcmi_peerOpenObject_ENTER		0x06b
#define hkwd_vcmi_peerOpenObject_EXIT		0x06c
#define hkwd_vcm_peerRegister_ENTER		0x06d
#define hkwd_vcm_peerRegister_ERROR1		0x06e
#define hkwd_vcm_peerRegister_EXIT		0x06f
#define hkwd_vcm_peerUnregister_ENTER		0x070
#define hkwd_vcm_peerUnregister_EXIT		0x071
#define hkwd_vcm_peerRevoke_ENTER		0x072
#define hkwd_vcm_peerRevoke_EXIT1		0x073
#define hkwd_removeRights_SUCCESS		0x074
#define hkwd_removeRights_TOPEER		0x075
#define hkwd_checkRevokeResponse_ERROR1		0x076
#define hkwd_checkRevokeResponse_ERROR2		0x077
#define hkwd_checkRevokeResponse_ERROR3		0x078
#define hkwd_checkRevokeResponse_ERROR4		0x079
#define hkwd_checkRevokeResponse_SETSTALE	0x07a
#define hkwd_objectRecGC_RESULTS		0x07b
#define hkwd_getHolder_NEW_HOLDER		0x07d
#define hkwd_getHolder_IS_LOCAL			0x07e
#define hkwd_getObjRec_NEWOBJ			0x07f
#define hkwd_objRecFromOpHandle_ERROR1		0x080
#define hkwd_getPeerRights_ERROR1		0x081
#define hkwd_resolveConflicts_INCREATE		0x082
#define hkwd_vcmi_rightsPeerRevoke_ERROR1	0x083
#define hkwd_vcmi_rightsPeerRevoke_ERROR2	0x084
#define hkwd_vcmi_rightsPeerRevoke_INCREATE	0x085
#define hkwd_vcmi_rightsFlushPeerState_ENTER	0x086
#define hkwd_vcmi_rightsFlushPeerState_EXIT	0x087
#define hkwd_vcmi_rightsGet_ESTALE		0x088
#define hkwd_vcmi_rightsPostCreate_ERROR	0x089
#define hkwd_vcmi_rightsFinishCreate_ERROR1	0x08a
#define hkwd_vcmi_rightsReturn_ERROR1		0x08b
#define hkwd_vcmi_rightsReturn_ERROR2		0x08c
#define hkwd_vcm_getOpRights_EXIT2		0x08d
#define hkwd_vcm_peerRevoke_EXIT2		0x08e
#define hkwd_vcm_beginCreate_EXIT1		0x08f
#define hkwd_localObjectRevoke_ERROR2		0x090
#define hkwd_vcm_localOpsClose_ERROR7		0x091
#define hkwd_objectRecGC_ENTER			0x092
#define hkwd_getHolder_OLD_RTAG			0x093
#define hkwd_vcmi_rightsGet_ENTER		0x094
#define hkwd_vcmi_rightsGet_BAD_RTAG		0x095
#define hkwd_vcmi_rightsGet_EXIT		0x096
#define hkwd_allocObj_ERROR_GCD			0x097
#define hkwd_vcmi_rightsPostCreate_XFER		0x098
#define hkwd_vcmi_rightsPostCreate_XFER_ERROR1	0x099
#define hkwd_vcmi_rightsGet_RESTART 		0x09a
#define hkwd_vcm_localOpsEnableObjRights_EXIT1	0x09b
#define hkwd_vcmi_disableObjectRights_ENTER	0x09c
#define hkwd_vcmi_disableObjectRights_EXIT	0x09d
#define hkwd_vcmi_enableObjectRights_ENTER	0x09e
#define hkwd_vcmi_enableObjectRights_EXIT	0x09f

#define hkwd_vcm_monitorRegister_ENTER		0x0a0
#define hkwd_vcm_monitorRegister_ERROR1		0x0a1
#define hkwd_vcm_monitorRegister_ERROR2		0x0a2
#define hkwd_vcm_monitorRegister_ERROR3		0x0a3
#define hkwd_vcm_monitorRegister_ERROR4		0x0a4
#define hkwd_vcm_monitorRegister_ERROR5		0x0a5
#define hkwd_vcm_monitorRegister_EXIT		0x0a6

#define hkwd_vcm_monitorUnregister_ENTER	0x0a7
#define hkwd_vcm_monitorUnregister_ERROR1	0x0a8
#define hkwd_vcm_monitorUnregister_ERROR2	0x0a9
#define hkwd_vcm_monitorUnregister_EXIT		0x0aa

#define hkwd_vcm_start_vfs_monitor_ENTER	0x0ab
#define hkwd_vcm_start_vfs_monitor_ERROR1	0x0ac
#define hkwd_vcm_start_vfs_monitor_ERROR2	0x0ad
#define hkwd_vcm_start_vfs_monitor_EXIT		0x0ae

#define hkwd_vcm_stop_vfs_monitor_ENTER		0x0af
#define hkwd_vcm_stop_vfs_monitor_ERROR1	0x0b0
#define hkwd_vcm_stop_vfs_monitor_ERROR2	0x0b1
#define hkwd_vcm_stop_vfs_monitor_EXIT		0x0b2

#define hkwd_vcm_monitor_CALLOUT		0x0b3
#define hkwd_vcm_monitor_RETURN			0x0b4


#define HKWD_VCM_DEBUG    			0x48100000
#define hkwd_releaseLocalObj_RETURN1		0x001
#define hkwd_releaseLocalObj_RETURN2		0x002
#define hkwd_releaseLocalObj_EXIT1		0x003
#define hkwd_releaseLocalObj_EXIT2		0x004
#define hkwd_getLocalRights_EXIT		0x005
#define hkwd_vcm_localOpsPut_ERROR		0x006
#define hkwd_findVFS_EXIT			0x007
#define hkwd_remVFS_ENTER			0x008
#define hkwd_vcmi_peerFind_RESULTS		0x009
#define hkwd_vcmi_peerGetObjHandle_ENTER	0x00a
#define hkwd_vcmi_peerGetObjHandle_EXIT1	0x00b
#define hkwd_vcmi_peerGetObjHandle_EXIT2	0x00c
#define hkwd_allocObj_STATS			0x00d
#define hkwd_getLocalRights_ENTER		0x00e
#define hkwd_getLocalRights_EXIT_ERROR		0x00f
#define hkwd_localObjectRevoke_INVALID_ERROR	0x010
#define hkwd_objectRecGC_STATS			0x011
#define hkwd_vcmi_enableObjectRights_freeobj	0x012

/*
 * TopSpin 1X/4X Infiniband Device Driver's Hookwords.
 */
#define HKWD_TSIB			0x4BD00000  /* TSIB DD Specific Library Services */
#define HKWD_TSIB_GENERAL		0x4BE00000  /* TSIB DD General Services */
#define HKWD_TSIB_ERROR			0x4BF00000  /* TSIB DD Error Services */
#define HKWD_TSIB_DEBUG			0x4C000000  /* TSIB DD Debugging Services */

#define HKWD_WPAR				0x4C900000

/* Hook for checkpoint/restart WPAR mobility */
#define	HKWD_WPARCR			0x4FC00000	/* WPAR CR  */
/* subhooks 0x001 - 0x021 used by sysproc	*/
/* subhooks 0x022 - 0x023 used by syscorral	*/
/* subhooks 0x101 - 0x128 used by sysuipc  (yes, there's overlap)	*/
/* subhooks 0x127 - 0x163 used by sysxinet (yes, there's overlap)	*/
/* subhooks 0x190 - 0x192 used by syssauth	*/
/* subhooks 0x201 - 0x28e used by sysvmm	*/
/* subhooks 0x501 - 0x53f used by syslfs	*/
#define hkwd_get_fdinfo_ENTER		0x501
#define hkwd_get_fdinfo_EXIT		0x502
#define hkwd_get_fdtype_EXIT		0x503
#define hkwd_get_fdusage_ENTER		0x504
#define hkwd_get_fdusage_GETF		0x505
#define hkwd_get_fdusage_EXIT		0x506
#define hkwd_get_fdpath_ENTER		0x507
#define hkwd_get_fdpath_EXIT		0x508
#define hkwd_get_flocks_ENTER		0x509
#define hkwd_get_flocks_GETLOCKS	0x50A
#define hkwd_get_flocks_EXIT		0x50B
#define hkwd_set_flocks_ENTER		0x50C
#define hkwd_set_flocks_SETBUF		0x50D
#define hkwd_set_flocks_EXIT		0x50E
#define hkwd_get_queued_aio_ENTER	0x50F
#define hkwd_get_queued_aio_EXIT	0x510
#define hkwd_put_queued_aio_ENTER	0x511
#define hkwd_put_queued_aio_EXIT	0x512
#define hkwd_get_pending_io_ENTER	0x513
#define hkwd_get_pending_io_EXIT	0x514
#define hkwd_put_pending_io_ENTER	0x515
#define hkwd_put_pending_io_EXIT	0x516
#define hkwd_wpar_mobility_oper_ENTER	0x517
#define hkwd_wpar_mobility_oper_CMDRC	0x518
#define hkwd_wpar_mobility_oper_EXIT	0x519
/* subhooks 0x601 - 0x622 used by sysxaio	*/
/* subhooks 0x623 - 0x675 used by sysipc	*/
/* subhooks 0x801 - 0x851 used by cormob	*/
/* subhooks 0x852 - 0x853 used by sysvmm	*/
/* subhooks 0x854 - 0x85a used by sysios	*/

/*
 * Hook for correlating WPAR IDs to the TID/PID tables
 */
#define HKWD_WPAR2TID				0x5D800000
#define hkwd_wpar2tid_brand			0x001
#define hkwd_wpar2tid_config			0x002
#define hkwd_wpar2tid_modify			0x003

#define HKWD_PMSVCS      0x4FD00000   /*for the pmsvcs debug traces */
#define HKWD_PM_SVC      0x4FE00000   /*for the pmsvcs syscalls traces */
#define HKWD_PM_INTR    0x4FF00000    /*for the pmsvcs interrupt traces */

#define HKWD_PM_NOTIFY  0x10970000      /* pmsvcs kernel notifications */
#define hkwd_pm_thread_dispatch         0x001           /* thread dispatch */
#define hkwd_pm_thread_undispatch       0x002           /* thread undispatch */
#define hkwd_pm_thread_nodispatch       0x004           /* thread no dispatch */
#define hkwd_pm_thread_init             0x010           /* create thread */
#define hkwd_pm_thread_term             0x020           /* terminate thread */
#define hkwd_pm_process_term            0x080           /* terminate process */
#define hkwd_pm_tlocal_init             0x100           /* create M:N thread */
#define hkwd_pm_tlocal_term             0x200           /* terminate M:N thread */
#define hkwd_pm_tlocal_mode             0x400           /* thread mode */
#define hkwd_pm_tlocal_dispatch         0x800           /* M:N thread dispatch */

/*
 * Encrypted FileSystem (EFS) hook.
 */
#define HKWD_EFS				0x5BE00000
/* subhooks are defined in kernext/efs/kxefs.h file */

/* hook and subhooks for kernel recovery */
#define HKWD_RMGR				0x5DA00000
#define hkwd_ermgr_enter			0x001
#define hkwd_ermgr_exit				0x002
#define hkwd_ermgr_epilog			0x003
#define hkwd_drmgr_enter			0x004
#define hkwd_drmgr_epilog			0x005
#define hkwd_reentry				0x006
#define hkwd_longjmpx				0x007
#define hkwd_excbranch				0x008
#define hkwd_transition				0x009
#define hkwd_frr_call				0x00a
#define hkwd_frr_ret				0x00b
#define hkwd_continue				0x00c
#define hkwd_lrmgr_epilog			0x00d
#define hkwd_rmgr_abend				0x00e
#define hkwd_rmgr_halt_system			0x00f



#define HKWD_NET                                0x61500000 
#define hkwd_ras_netinet_callback_err1          1
#define hkwd_ras_netinet_tcp_callback_err1      2
#define hkwd_ras_netinet_udp_callback_err1      3
#define hkwd_ras_netinet_ipv4_callback_err1     4
#define hkwd_ras_netinet_misc_callback_err1     5
#define hkwd_ras_if_en_callback_err1            6
#define hkwd_ras_ethchan_callback_err1          7
#define hkwd_ras_netmalloc_callback_err1        8
#define hkwd_ras_net_callback_err1              9
#define hkwd_ras_net_route_callback_err1        10
#define hkwd_ras_net_cdli_callback_err1         11
#define hkwd_ras_net_loop_callback_err1         12
#define hkwd_ras_mbuf_callback_err1             13
#define hkwd_ras_socket_callback_err1           14
#define hkwd_ras_socket_so_unix_callback_err1   15
#define hkwd_network_ras_unregister_err1        16
#define hkwd_network_ras_register_in		17
#define hkwd_network_ras_register_out		18
#define hkwd_network_ras_register_error1	19
#define hkwd_network_ras_register_error2	20
#define hkwd_network_ras_register_error3	21
#define hkwd_network_ras_register_error4	22
#define hkwd_network_ras_register_error5	23
#define hkwd_network_ras_register_error6	24
#define hkwd_network_ras_register_error7	25
#define hkwd_network_ras_register_error8	26
#define hkwd_network_ras_register_error9	27
#define hkwd_network_ras_unregister_in		28
#define hkwd_network_ras_unregister_out		29
#define hkwd_ras_callback_common_in		30	
#define hkwd_ras_callback_common_out		31	
#define hkwd_ras_callback_common_error1		32	
#define hkwd_ras_callback_common_error2		33	
#define hkwd_ras_callback_common_error3		34	
#define hkwd_ras_callback_common_error4		35	
#define hkwd_ras_callback_common_error5		36	
#define hkwd_ras_callback_common_error6		37	
#define hkwd_ras_callback_common_error7		38	
#define hkwd_ras_callback_common_error8		39	
#define hkwd_ras_callback_common_error9		40	
#define hkwd_ras_callback_common_error10	41	
#define hkwd_ras_callback_common_error11	42	
#define hkwd_ras_callback_common_error12	43	
#define hkwd_ras_callback_common_error13	44	
#define hkwd_ras_callback_common_error14	45	
#define hkwd_ras_netinet_callback_in		46
#define hkwd_ras_netinet_callback_out		47
#define hkwd_ras_netinet_tcp_callback_in	48
#define hkwd_ras_netinet_tcp_callback_out	49
#define hkwd_ras_netinet_udp_callback_in	50
#define hkwd_ras_netinet_udp_callback_out	51
#define hkwd_ras_netinet_ipv4_callback_in	52
#define hkwd_ras_netinet_ipv4_callback_out	53
#define hkwd_ras_netinet_misc_callback_in	54
#define hkwd_ras_netinet_misc_callback_out	55
#define hkwd_ras_if_en_callback_in		56
#define hkwd_ras_if_en_callback_out		57
#define hkwd_ras_ethchan_callback_in		58
#define hkwd_ras_ethchan_callback_out		59
#define hkwd_ras_netmalloc_callback_in		60
#define hkwd_ras_netmalloc_callback_out		61
#define hkwd_ras_net_callback_in		62
#define hkwd_ras_net_callback_out		63
#define hkwd_ras_net_route_callback_in		64
#define hkwd_ras_net_route_callback_out		65
#define hkwd_ras_net_cdli_callback_in		66
#define hkwd_ras_net_cdli_callback_out		67
#define hkwd_ras_net_loop_callback_in		68
#define hkwd_ras_net_loop_callback_out		69
#define hkwd_ras_mbuf_callback_in		70
#define hkwd_ras_mbuf_callback_out		71
#define hkwd_ras_socket_callback_in		72
#define hkwd_ras_socket_callback_out		73
#define hkwd_ras_socket_so_unix_callback_in	74
#define hkwd_ras_socket_so_unix_callback_out	75
#define hkwd_ras_callback_common_error15	76	
#define hkwd_ras_callback_common_error16	77	
#define hkwd_ras_callback_common_error17	78	
#define hkwd_ras_vasi_callback_in		79
#define hkwd_ras_vasi_callback_err1		80
#define hkwd_ras_vasi_callback_out		81
#define hkwd_ras_mover_callback_err1    	82
#define hkwd_ras_mover_callback_in      	83
#define hkwd_ras_mover_callback_out     	84
#define hkwd_ras_sea_callback_in  		85	
#define hkwd_ras_sea_callback_err1  		86
#define hkwd_ras_sea_callback_out  		87
#define hkwd_ras_seaha_callback_in  		88
#define hkwd_ras_seaha_callback_err1 		89
#define hkwd_ras_seaha_callback_out  		90
#define hkwd_ras_sea_gvrp_callback_in  		91
#define hkwd_ras_sea_gvrp_callback_err1  	92
#define hkwd_ras_sea_gvrp_callback_out  	93
#define hkwd_ras_netm_police_callback_in	94
#define	hkwd_ras_netm_police_callback_out	95
#define	hkwd_ras_netm_police_callback_err1	96
#define	hkwd_ras_netm_police_callback_err2	97
#define hkwd_ras_net_netisr_callback_in		98
#define hkwd_ras_net_netisr_callback_err1	99
#define hkwd_net_netisr_callback_out		100
#define hkwd_ras_netinet_ipv6_callback_in	101
#define hkwd_ras_netinet_ipv6_callback_err1	102
#define hkwd_ras_netinet_ipv6_callback_out	103
#define hkwd_ras_callback_common_error18	104
#define hkwd_ras_callback_common_error19	105
#define hkwd_network_ras_register_error10	106
#define hkwd_ras_sctp_callback_in		107
#define hkwd_ras_sctp_callback_err1		108
#define hkwd_ras_sctp_callback_out		109
#define hkwd_ras_qos_callback_in		110
#define hkwd_ras_qos_callback_err1		111
#define hkwd_ras_qos_callback_out		112
#define	hkwd_ras_if_gif_callback			113
#define	hkwd_ras_if_gif_callback_err1		114
#define	hkwd_ras_if_gif_callback_out		115
#define	hkwd_ras_mpool_callback_in		116
#define	hkwd_ras_mpool_callback_err1		117
#define	hkwd_ras_mpool_callback_out		118
#define hkwd_ras_kdapl_callback_err1		119
#define hkwd_ras_kdapl_callback_in		120
#define hkwd_ras_kdapl_callback_out		121

#define HKWD_ROUTE                      0x61700000
#define hkwd_rtinithead_in              1
#define hkwd_route_configure_in         2
#define hkwd_route_init_in              3
#define hkwd_rn_inithead_in             4
#define hkwd_rn_inithead_err1           5
#define hkwd_rn_init_in                 6
#define hkwd_rtredirect_in              7
#define hkwd_rtexpire_in                8
#define hkwd_rtexpire_out               9
#define hkwd_rtioctl_in                 10
#define hkwd_rtioctl_out                11
#define hkwd_dead_gateway               12
#define hkwd_gateway_up                 13
#define hkwd_raise_cost_1               14
#define hkwd_raise_cost_2               15
#define hkwd_restore_cost_1             16
#define hkwd_restore_cost_2             17
#define hkwd_rn_change_cost_in          18
#define hkwd_rn_change_cost_out         19
#define hkwd_rn_change_cost_out1        20
#define hkwd_rn_change_cost_out2        21
#define hkwd_rn_change_cost_out3        22
#define hkwd_rt_changegids_in           23
#define hkwd_rt_changegids_out          24
#define hkwd_rt_changegids_out1         25
#define hkwd_rt_changegids_err1         26
#define hkwd_rt_changegids_err2         27
#define hkwd_rt_changegids_err3         28
#define hkwd_route_output_in            29
#define hkwd_route_output_out           30
#define hkwd_route_output_err1          31
#define hkwd_route_output_err2          32
#define hkwd_route_output_err3          33
#define hkwd_route_output_err4          34
#define hkwd_route_output_err5          35
#define hkwd_route_output_err6          36
#define hkwd_route_output_err7          37
#define hkwd_route_output_err8          38
#define hkwd_route_output_err9          39
#define hkwd_route_output_err10         40
#define hkwd_route_output_err11         41
#define hkwd_route_output_err12         42
#define hkwd_route_output_err13         43
#define hkwd_route_output_err14         44
#define hkwd_route_output_err15         45
#define hkwd_route_output_err16         46
#define hkwd_route_output_err17         47
#define hkwd_route_output_err18         48
#define hkwd_route_output_err19         49
#define hkwd_route_output_err20         50
#define hkwd_route_output_err21         51
#define hkwd_route_output_err22         52
#define hkwd_route_output_err23         53
#define hkwd_route_output_err24         54
#define hkwd_route_output_err25         55
#define hkwd_route_output_err26         56
#define hkwd_route_output_err27         57
#define hkwd_route_output_err28         58
#define hkwd_route_output_err29         59
#define hkwd_route_output_err30         60
#define hkwd_rt_missmsg_in              61
#define hkwd_rt_missmsg_out1            62
#define hkwd_rt_missmsg_out2            63
#define hkwd_rn_select_in               64
#define hkwd_rn_select_out              65
#define hkwd_rn_select_out1             66
#define hkwd_rn_select_out2             67
#define hkwd_rn_lookup_in               68
#define hkwd_rn_lookup_out              69
#define hkwd_rn_lookup_out1             70
#define hkwd_rn_lookup_out2             71
#define hkwd_rn_lookup_out3             72
#define hkwd_rn_lookup_out4             73
#define hkwd_rn_genmatch_in             74
#define hkwd_rn_genmatch_out            75
#define hkwd_rn_genmatch_out1           76
#define hkwd_rn_genmatch_out2           77
#define hkwd_rn_genmatch_out3           78
#define hkwd_rn_genmatch_out4           79
#define hkwd_rn_genmatch_out5           80
#define hkwd_rn_genmatch_out6           81
#define hkwd_rn_addmask_err1            82
#define hkwd_rn_new_radix_mask_err1     83
#define hkwd_rn_addroute_in             84
#define hkwd_rn_addroute_out            85
#define hkwd_rn_addroute_out1           86
#define hkwd_rn_addroute_out2           87
#define hkwd_rn_addroute_out3           88
#define hkwd_rn_addroute_out4           89
#define hkwd_rn_addroute_out5           90
#define hkwd_rn_delete_in               91
#define hkwd_rn_delete_out              92
#define hkwd_rn_delete_out1             93
#define hkwd_rn_delete_out2             94
#define hkwd_rn_delete_out3             95
#define hkwd_rn_delete_out4             96
#define hkwd_rn_delete_out5             97
#define hkwd_rn_delete_out6             98
#define hkwd_rn_delete_out7             99
#define hkwd_rn_change_in               100
#define hkwd_rn_change_out              101
#define hkwd_rn_change_out1             102
#define hkwd_rn_change_out2             103
#define hkwd_rn_change_out3             104
#define hkwd_rn_change_out4             105
#define hkwd_rn_change_out5             106
#define hkwd_rn_walktree_in             107
#define hkwd_rn_walktree_out            108
#define hkwd_rn_walktree_out1           109
#define hkwd_rn_walktree_err1           110
#define hkwd_rn_walktree_err2           111
#define hkwd_rn_change_policy_in        112
#define hkwd_rn_change_policy_out       113
#define hkwd_rn_change_policy_out1      114
#define hkwd_rn_change_policy_out2      115
#define hkwd_rn_change_policy_out3      116
#define hkwd_rn_change_policy_out4      117
#define hkwd_rn_change_policy_out5      118
#define hkwd_rn_change_policy_out6      119
#define hkwd_rn_change_policy_out7      120
#define hkwd_nextroute_in               121
#define hkwd_nextroute_out              122
#define hkwd_nextroute_out1             123
#define hkwd_nextroute_out2             124
#define hkwd_rtalloc1_nolock_gr_in      125
#define hkwd_rtalloc1_nolock_gr_out     126
#define hkwd_rtalloc1_nolock_gr_err1    129
#define hkwd_rtalloc1_nolock_gr_err2    130
#define hkwd_rtalloc1_nolock_gr_err3    131
#define hkwd_rtfree_nolock_out1         132
#define hkwd_rtfree_nolock_out2         133
#define hkwd_rtredirect_err1            134
#define hkwd_rtredirect_err2            135
#define hkwd_rtredirect_err3            136
#define hkwd_rtredirect_err4            137
#define hkwd_rtioctl_err1               138
#define hkwd_rtioctl_err2               139
#define hkwd_rtioctl_err3               140
#define hkwd_ifa_ifwithroute_err1       141
#define hkwd_ifa_ifwithroute_err2       142
#define hkwd_ifa_ifwithroute_err3       143
#define hkwd_rtrequest_nolock_in        144
#define hkwd_rtrequest_nolock_out       145
#define hkwd_rtrequest_nolock_err1      146
#define hkwd_rtrequest_nolock_err2      147
#define hkwd_rtrequest_nolock_err3      148
#define hkwd_rtrequest_nolock_err4      149
#define hkwd_rtrequest_nolock_err5      150
#define hkwd_rtrequest_nolock_err6      151
#define hkwd_rtrequest_nolock_err7      152
#define hkwd_rtrequest_nolock_err8      153
#define hkwd_rtrequest_nolock_err9      154
#define hkwd_rtrequest_nolock_err10     155
#define hkwd_rtrequest_nolock_err11     156
#define hkwd_rtrequest_nolock_err12     157
#define hkwd_rtrequest_nolock_err13     158
#define hkwd_rt_setgate_in              159
#define hkwd_rt_setgate_err1            160
#define hkwd_rt_setgate_err2            161
#define hkwd_rtinit_in                  162
#define hkwd_rtinit_out                 163
#define hkwd_rtinit_err1                164
#define hkwd_rtinit_err2                165
#define hkwd_rtinit_err3                166
#define hkwd_rt_cleanclones_in          167
#define hkwd_rt_cleanclones_out         168
#define hkwd_adjust_gateways_in         169
#define hkwd_adjust_gateways_out        170
#define hkwd_route_usrreq_in            171
#define hkwd_route_usrreq_out           172
#define hkwd_route_usrreq_err1          173
#define hkwd_route_usrreq_err2          174
#define hkwd_route_usrreq_err3          175
#define hkwd_rt_setmetrics_in           176
#define hkwd_m_copyback_in              177
#define hkwd_m_copyback_out             178
#define hkwd_m_copyback_err1            179
#define hkwd_m_copyback_err2            180
#define hkwd_rt_msg1_in                 181
#define hkwd_rt_msg1_out                182
#define hkwd_rt_msg2_in                 183
#define hkwd_rt_msg2_out                184
#define hkwd_rt_ifmsg_err1              185
#define hkwd_raw_init_in                186
#define hkwd_raw_input_in               187
#define hkwd_raw_input_out              188
#define hkwd_raw_usrreq_in              189
#define hkwd_raw_usrreq_out             190
#define hkwd_raw_usrreq_err1            191
#define hkwd_raw_usrreq_err2            192
#define hkwd_raw_usrreq_err3            193
#define hkwd_raw_usrreq_err4            194
#define hkwd_raw_usrreq_err5            195
#define hkwd_raw_usrreq_err6            196
#define hkwd_raw_usrreq_err7            197
#define hkwd_raw_usrreq_err8            198
#define hkwd_raw_usrreq_err9            199
#define hkwd_raw_usrreq_err10           200
#define hkwd_raw_usrreq_err11           201
#define hkwd_raw_usrreq_err12           202
#define hkwd_raw_usrreq_err13           203
#define hkwd_raw_usrreq_err14           204
#define hkwd_raw_usrreq_err15           205
#define hkwd_raw_usrreq_err16           206
#define hkwd_raw_usrreq_err17           207
#define hkwd_raw_usrreq_err18           208
#define hkwd_rn_genmatch_out7		209
#define hkwd_rtexpire_delete		210
#define hkwd_rn_insert_in		211
#define hkwd_rn_insert_out		212
#define hkwd_route_output_err31         213
#define hkwd_route_output_err32         214
#define hkwd_route_output_err33         215

#define HKWD_LOOP                       0x61800000
#define hkwd_loinit_in                  1
#define hkwd_loattach_in                2
#define hkwd_looutput_in                3
#define hkwd_looutput_out               4
#define hkwd_loioctl_in                 5
#define hkwd_loioctl_out                6
#define hkwd_looutput_out1              7
#define hkwd_looutput_out2              8
#define hkwd_looutput_out3              9
#define hkwd_looutput_err1              10
#define hkwd_looutput_err2              11
#define hkwd_looutput_err3              12
#define hkwd_loioctl_err1               13
#define hkwd_loioctl_err2               14

#define HKWD_CDLI			0x61900000
#define hkwd_ifinit_in			1
#define hkwd_ifinit_out			2
#define hkwd_ifreset_in			3
#define hkwd_ifreset_out		4
#define hkwd_netif_handler_in		5
#define hkwd_netif_handler_out		6
#define hkwd_if_attach_in		7
#define hkwd_if_attach_out		8
#define hkwd_link_rtrequest_in		9
#define hkwd_link_rtrequest_out		10
#define hkwd_link_rtrequest_out1	11
#define hkwd_if_down_in			12
#define hkwd_if_down_out		13
#define hkwd_if_detach_in		14
#define hkwd_if_detach_out		15
#define hkwd_if_rt_delete_in		16
#define hkwd_if_rt_delete_out		17
#define hkwd_if_rt_updroute_in		19
#define hkwd_ifioctl_in			20
#define hkwd_ifioctl_err1		21
#define hkwd_ifioctl_err2		22
#define hkwd_ifioctl_err3		23
#define hkwd_ifioctl_err4		24
#define hkwd_ifioctl_err5		25
#define hkwd_ifioctl_err6		26
#define hkwd_ifioctl_err7		27
#define hkwd_ifioctl_err8		28
#define hkwd_ifioctl_err9		29
#define hkwd_ifioctl_err10		30
#define hkwd_ifioctl_err11		31
#define hkwd_ifioctl_err12		32
#define hkwd_ifioctl_err13		33
#define hkwd_ifioctl_err14		34
#define hkwd_ifioctl_err15		35
#define hkwd_ifioctl_err16		36
#define hkwd_ifioctl_err17		37
#define hkwd_ifioctl_err18		38
#define hkwd_ifioctl_err19		39
#define hkwd_ifioctl_err20		40
#define hkwd_ifioctl_err21		41
#define hkwd_ifioctl_err22		42
#define hkwd_ifioctl_err23		43
#define hkwd_ifioctl_err24		44
#define hkwd_ifioctl_err25		45
#define hkwd_ifioctl_err26		46
#define hkwd_ifioctl_err27		47
#define hkwd_ifioctl_err28		48
#define hkwd_ifioctl_err29		49
#define hkwd_ifioctl_err30		50
#define hkwd_ifioctl_err31		51
#define hkwd_ifioctl_err32		52
#define hkwd_ifioctl_err33		53
#define hkwd_ifioctl_err34		54
#define hkwd_ifioctl_err35		55
#define hkwd_ifioctl_err36		56
#define hkwd_ifioctl_err37		57
#define hkwd_ifioctl_err38		58
#define hkwd_ifioctl_err39		59
#define hkwd_ifioctl_err40		60
#define hkwd_ifioctl_err41		61
#define hkwd_ifioctl_err42		62
#define hkwd_ifioctl_err43		63	
#define hkwd_ifioctl_err44		64
#define hkwd_ifioctl_err45		65
#define hkwd_ifioctl_err46		66
#define hkwd_ifioctl_err47		67
#define hkwd_ifioctl_err48		68
#define hkwd_ifioctl_err49		69
#define hkwd_ifioctl_err50		70
#define hkwd_ifioctl_err51		71
#define hkwd_ifioctl_err52		72
#define hkwd_ifioctl_err53		73
#define hkwd_ifioctl_err54		74
#define hkwd_ifioctl_err55		75
#define hkwd_ifioctl_err56		76
#define hkwd_ifioctl_err57		77
#define hkwd_ifioctl_err58		78
#define hkwd_ifioctl_err59		79
#define hkwd_ifioctl_err60		80
#define hkwd_ifioctl_err61		81
#define hkwd_ifioctl_err62		82
#define hkwd_ifioctl_err63		83
#define hkwd_ifioctl_err64		84
#define hkwd_ifioctl_err65		85
#define hkwd_ifioctl_err66		86
#define hkwd_ifioctl_err67		87
#define hkwd_ifconf_err1		88
#define hkwd_ifconf_err2		89
#define hkwd_ifconf_err3		90
#define hkwd_insert_mtu_in		91
#define hkwd_insert_mtu_err1		92
#define hkwd_insert_mtu_err2		93
#define hkwd_insert_mtu_out		94
#define hkwd_delete_mtu_in		95
#define hkwd_delete_mtu_err1		96
#define hkwd_delete_mtu_err2		97
#define hkwd_delete_mtu_out		98
#define hkwd_next_mtu_in		99
#define hkwd_next_mtu_out		100
#define hkwd_listifvipa_in		101
#define hkwd_listifvipa_out		102
#define hkwd_setifvipa_in		103
#define hkwd_setifvipa_err1		104
#define hkwd_setifvipa_err2		105
#define hkwd_setifvipa_err3		106
#define hkwd_setifvipa_err4		107
#define hkwd_delifvipa_in		108
#define hkwd_delifvipa_err1		109
#define hkwd_delifvipa_err2		110
#define hkwd_delifvipa_err3		111
#define hkwd_delifvipa_err4		112
#define hkwd_delvipaxface		113
#define hkwd_if_attach_out1		114
#define hkwd_ifioctl_err68              115
#define hkwd_ifioctl_err69              116
#define hkwd_if_reset_route_addr	117
#define hkwd_if_rt_ifaddr_reset_in	118
#define hkwd_if_rt_ifaddr_reset_out	119
#define hkwd_ifioctl_err70		120
#define hkwd_ifioctl_err71		121
#define hkwd_ifioctl_err72		122
#define hkwd_ifioctl_err73		123
#define hkwd_ifioctl_err74		124
#define hkwd_ifioctl_err75		125
#define hkwd_ifioctl_err76		126
#define hkwd_if_rt_updroute_in_1	131


#define HKWD_NETINET_MISC               0x61A00000
#define hkwd_arpinit_in                 1
#define hkwd_arpinit_err1               2
#define hkwd_arptimer_init_in           3
#define hkwd_arpresolve_common_in       4
#define hkwd_vns_attach_err		127
#define hkwd_vns_detach_err		128
#define hkwd_vns_alloc_err		129
#define hkwd_vns_free_err		130

#define hkwd_arpresolve_common_out      5
#define hkwd_arpresolve_common_out1     6
#define hkwd_arpresolve_common_out2     7
#define hkwd_arpresolve_common_out3     8
#define hkwd_arpresolve_common_out4     9
#define hkwd_arpupdate_in               10
#define hkwd_arpupdate_out              11
#define hkwd_arpioctl_in                12
#define hkwd_arpioctl_out               13
#define hkwd_arptnew_in                 14
#define hkwd_arptnew_call_arptfree      15
#define hkwd_arpupdate_out1             16
#define hkwd_arpupdate_out2             17
#define hkwd_arpupdate_out3             18
#define hkwd_arpupdate_out4             19
#define hkwd_arpupdate_out5             20
#define hkwd_arpupdate_out6             21
#define hkwd_arpupdate_err1             22
#define hkwd_arpupdate_err2             23
#define hkwd_arpupdate_err3             24
#define hkwd_arpupdate_err4             25
#define hkwd_arpupdate_err5             26
#define hkwd_arpupdate_err6             27
#define hkwd_arpupdate_err7             28
#define hkwd_arpupdate_err8             29
#define hkwd_add_gateway_out1           30
#define hkwd_mark_gateway_down_out1     31
#define hkwd_in_control_err1		32	
#define hkwd_in_control_err2		33
#define hkwd_in_control_err3		34
#define hkwd_in_control_err4		35
#define hkwd_in_control_err5		36
#define hkwd_in_control_err6		37
#define hkwd_in_control_err7		38
#define hkwd_in_control_err8		39
#define hkwd_in_control_err9		40
#define hkwd_in_control_err10		41
#define hkwd_in_control_err11		42
#define hkwd_in_control_err12		43
#define hkwd_in_control_err13		44
#define hkwd_in_control_err14		45
#define hkwd_in_control_err15		46
#define hkwd_in_control_err16		47
#define hkwd_in_control_err17		48
#define hkwd_in_control_err18		49
#define hkwd_in_ifattach_err1		50
#define hkwd_in_ifattach_err2		51
#define hkwd_in_ifattach_err3		52
#define hkwd_in_ifattach_err4		53
#define hkwd_in_ifattach_err5		54
#define hkwd_in_ifinit_err1		55
#define hkwd_in_ifinit_out1		56
#define hkwd_in_ifinit_out2		57
#define hkwd_in_ifinit_out3		58
#define hkwd_in_addmulti_out1		59
#define hkwd_in_addmulti_out2		60
#define hkwd_in_hash_add_out1		61
#define hkwd_in_ifscrub_vipa            62
#define hkwd_in_ifscrub_out1            63
#define hkwd_in_pcballoc_err1			65

/*
 * Due to defect 870229, constant number between 66 to 108 is removed.
 * The number between 66 to 108 can be reused in the future if needed.
 */

#define hkwd_icmp_unreachable			109
#define hkwd_in_control_err19			110
#define hkwd_in_control_err20			111
#define hkwd_in_control_err21			112
#define hkwd_in_control_err22			113
#define hkwd_in_control_err23			114
#define hkwd_in_control_err24                   115
#define hkwd_in_control_err25                   116
#define hkwd_rt_ifa_reset_in                    117
#define hkwd_rt_ifa_reset_err                   118
#define hkwd_rt_ifa_reset_out                   119
#define hkwd_route_ifa_reset_in                 120
#define hkwd_route_ifa_reset_err                121
#define hkwd_route_ifa_reset_out                122
#define hkwd_route_ifa_reset_out1               123
#define hkwd_route_ifa_reset_out2               124
#define hkwd_route_ifa_reset_out3               125
#define hkwd_in_control_err26                   126
#define hkwd_in_addmulti_out3                   127
#define hkwd_in_control_err27                   128
#define hkwd_hw_timestamp_close_err1            129 
#define hkwd_hw_timestamp_disabled              130
#define hkwd_hw_timestamp_close_err2            131 
#define hkwd_hw_timestamp_enable_err1           132 
#define hkwd_hw_timestamp_enable_err2           133 
#define hkwd_hw_timestamp_enable_err3           134
#define hkwd_hw_timestamp_enabled               135
#define hkwd_hw_timestamp_callback_err1         136  
#define hkwd_hw_timestamp_callback_err2         137  
#define hkwd_hw_timestamp_control_err1          138 
#define hkwd_hw_timestamp_control_err2          139 
#define hkwd_hw_timestamp_control_err3          140
#define hkwd_hw_timestamp_control_err4          141
#define hkwd_hw_timestamp_control_err5          142
#define hkwd_hw_timestamp_control_err6          143
#define hkwd_hw_timestamp_control_err7          144
#define hkwd_hw_timestamp_control_err8          145
#define hkwd_hw_timestamp_control_err9          146

#define HKWD_SOCKET_UNIX			0x61B00000
#define hkwd_uipc_init_in			1
#define hkwd_unp_dispose			2
#define hkwd_unp_drop				3
#define hkwd_unp_externalize			4
#define hkwd_unp_internalize			5
#define hkwd_uipc_usrreq_err1			6
#define hkwd_uipc_usrreq_err2			7
#define hkwd_uipc_usrreq_err3			8
#define hkwd_uipc_usrreq_err4			9
#define hkwd_uipc_usrreq_err5			10	
#define hkwd_uipc_usrreq_err6			11
#define hkwd_uipc_usrreq_err7			12
#define hkwd_uipc_usrreq_err8			13
#define hkwd_uipc_usrreq_err9			14
#define hkwd_uipc_usrreq_err10			15
#define hkwd_uipc_usrreq_err11			16
#define hkwd_uipc_usrreq_err12			17
#define hkwd_uipc_usrreq_err13			18
#define hkwd_uipc_usrreq_err14			19
#define hkwd_uipc_usrreq_err15			20
#define hkwd_uipc_usrreq_err16			21
#define hkwd_uipc_usrreq_err17			22
#define hkwd_uipc_usrreq_err18			23
#define hkwd_uipc_usrreq_err19			24
#define hkwd_uipc_usrreq_err20			25
#define hkwd_uipc_usrreq_err21			26
#define hkwd_uipc_usrreq_err22			27
#define hkwd_uipc_usrreq_err23			28
#define hkwd_unp_attach_err1			29
#define hkwd_unp_attach_err2			30
#define hkwd_unp_bind_err1			31
#define hkwd_unp_bind_err2			32
#define hkwd_unp_bind_err3			33
#define hkwd_unp_bind_err4			34
#define hkwd_unp_bind_err5			35
#define hkwd_unp_bind_err6			36
#define hkwd_unp_bind_err7			37
#define hkwd_unp_bind_err8			38
#define hkwd_unp_bind_err9			39
#define hkwd_unp_bind_err10			40
#define hkwd_unp_connect_err1			41
#define hkwd_unp_connect_err2			42
#define hkwd_unp_connect_err3			43
#define hkwd_unp_connect_err4			44
#define hkwd_unp_connect_err5			45
#define hkwd_unp_connect_err6			46
#define hkwd_unp_connect_err7			47
#define hkwd_unp_connect_err8			48
#define hkwd_unp_connect_err9			49
#define hkwd_unp_connect2_err1			50
#define hkwd_unp_connect2_err2			51
#define hkwd_unp_internalize_err1		52
#define hkwd_unp_internalize_err2		53
#define hkwd_unp_internalize_err3		54
#define hkwd_unp_internalize_err4		55
#define hkwd_unp_connect_in			56
#define hkwd_unp_connect_out			57
#define hkwd_unp_bind_in			58
#define hkwd_unp_bind_out			59
#define hkwd_uipc_usrreq_in			60
#define hkwd_uipc_usrreq_out			61
#define hkwd_unp_detach_in			62
#define hkwd_unp_detach_out			63
#define hkwd_unp_attach_in			64
#define hkwd_unp_attach_out			65
#define hkwd_unp_shutdown_in			66
#define hkwd_unp_shutdown_out			67
#define hkwd_uipc_usrreq_err24			68
#define hkwd_uipc_usrreq_err25			69
#define hkwd_unp_connect2_err3			70
#define hkwd_unp_bind_err11				71
#define hkwd_unp_connect_err10			72

#define HKWD_NETISR		0x61C00000
#define hkwd_netisr_lookup_in		1
#define hkwd_netisr_lookup_out1		2
#define hkwd_netisr_lookup_out2		3
#define netisr_add_in				4
#define netisr_add_err1				5
#define netisr_add_err2				6
#define netisr_add_out				7
#define netisr_del_in				9
#define netisr_del_err1				10
#define netisr_del_out				11
#define netisr_input_in				12
#define netisr_input_out			13
#define hkwd_Netintr_in				14
#define hkwd_Netintr1				15
#define hkwd_Netintr_out			16

#define	HKWD_DIAG_ASYNC_PCI	0x63200000

#define HKWD_DSM_MAIN 0x5BA00000
#define hkwd_DSM_RELEASEPROVIDER_ENTER 1
#define hkwd_DSM_RELEASEPROVIDER_EXIT 2
#define hkwd_DSM_FINDPROVIDER_ENTER 3
#define hkwd_DSM_FINDPROVIDER_EXIT 4
#define hkwd_DSM_GETLOCATIONS_ENTER 5
#define hkwd_DSM_GETLOCATIONS_EXIT 6
#define hkwd_LMTDSM_GETLOCATIONS 7
#define hkwd_DSM_DBG_TRACE_UUID 8
#define hkwd_DSM_FREELOCATIONS_ENTER 9
#define hkwd_DSM_FREELOCATIONS_EXIT 10
#define hkwd_DSM_DSETINIT_ENTER 11
#define hkwd_DSM_DSETINIT_EXIT 12
#define hkwd_DSM_DSETSHUTDOWN_ENTER 13
#define hkwd_DSM_DSETSHUTDOWN_BUSY 14
#define hkwd_DSM_DSETSHUTDOWN_EXIT 15
#define hkwd_DSM_DSETGSVCSREGISTER_ENTER 16
#define hkwd_DSM_DSETGSVCSREGISTER_EXIT 17
#define hkwd_LMTDSM_DSETGSVCSREGISTER_EXIT 18
#define hkwd_DSM_DSETGSVCSUNREGISTER_ENTER 19
#define hkwd_DSM_DSETGSVCSUNREGISTER_EXIT 20
#define hkwd_LMTDSM_DSETGSVCSUNREGISTER_EXIT 21
#define hkwd_DSM_DSETPIREGISTER_ENTER 22
#define hkwd_DSM_DSETPIREGISTER_EXIT 23
#define hkwd_LMTDSM_DSETPIREGISTER_EXIT 24
#define hkwd_DSM_DSETPIUNREGISTER_ENTER 25
#define hkwd_DSM_DSETPIUNREGISTER_EXIT 26
#define hkwd_LMTDSM_DSETPIUNREGISTER_EXIT 27
#define hkwd_DSM_DSETALLOCMEM_ENTER 28
#define hkwd_LMTDSM_DSETALLOCMEM_EXIT 29
#define hkwd_DSM_DSETALLOCMEM_EXIT 30
#define hkwd_DSM_DSETFREEMEM_ENTER 31
#define hkwd_DSM_DSETFREEMEM_EXIT 32
#define hkwd_DSM_EVENTNOTIFY_ENTER 33
#define hkwd_DSM_EVENTNOTIFY_EXIT 34
#define hkwd_LMTDSM_EVENTNOTIFY_EXIT 35
#define hkwd_DSM_CALLNOTIFYFUNC 36
#define hkwd_DSM_NOTIFYFUNCDONE 37
#define hkwd_DSM_CIFINDPROVIDER_ENTER 38
#define hkwd_LMTDSM_CIFINDPROVIDER_EXIT 39
#define hkwd_DSM_CIFINDPROVIDER_EXIT 40
#define hkwd_DSM_CIRELEPROVIDER_ENTER 41
#define hkwd_LMTDSM_CIRELEPROVIDER_EXIT 42
#define hkwd_DSM_CIRELEPROVIDER_EXIT 43
#define hkwd_DSM_CIISDSETREF_ENTER 44
#define hkwd_DSM_CIISDSETREF_EXIT 45
#define hkwd_LMTDSM_CIISDSETREF_EXIT 46
#define hkwd_DSM_CIGETREFLOCS_ENTER 47
#define hkwd_LMTDSM_CIGETREFLOCS_EXIT 48
#define hkwd_DSM_CIGETREFLOCS_EXIT 49
#define hkwd_DSM_CIGETLOCS_ENTER 50
#define hkwd_LMTDSM_CIGETLOCS_EXIT 51
#define hkwd_DSM_CIGETLOCS_EXIT 52
#define hkwd_DSM_CIGETLOCSUUID_ENTER 53
#define hkwd_DSM_CIGETLOCSUUID_EXIT 54
#define hkwd_DSM_CIRGYNOTIFYHK_ENTER 55
#define hkwd_DSM_CIRGYNOTIFYHK_EXIT 56
#define hkwd_LMTDSM_CIRGYNOTIFYHK_EXIT 57
#define hkwd_DSM_CIRGYNOTIFY_EXIT 58
#define hkwd_DSM_CIRMNOTIFYHK_ENTER 59
#define hkwd_DSM_CIRMNOTIFYHK_EXIT 60
#define hkwd_DSM_CIFREELOCS_ENTER 61
#define hkwd_DSM_CIFREELOCS_EXIT 62
#define hkwd_DSM_PROPFINDDSET_ENTRY 63
#define hkwd_DSM_PROPFINDDSET_EXIT 64
#define hkwd_LMTDSM_PROPFINDDSET_EXIT 65
#define hkwd_DSM_PROPFINDDSETBYINTID_ENTER 66
#define hkwd_LMTDSM_PROPFINDDSETBYINTID_EXIT 67
#define hkwd_DSM_PROPFINDDSETBYINTID_EXIT 68
#define hkwd_DSM_FINDDSETBYUUID_ENTER 69
#define hkwd_LMTDSM_FINDDSETBYUUID_EXIT 70
#define hkwd_DSM_FINDDSETBYUUID_EXIT 71
#define hkwd_DSM_PROPFINDDSETBYUUID_ENTER 72
#define hkwd_DSM_PROPFINDDSETBYUUID_EXIT 73
#define hkwd_LMTDSM_PROPFINDDSETBYUUID_EXIT 74
#define hkwd_LMTDSM_DBG_TRACE_UUID 75
#define hkwd_DSM_PROPCREATEDSET_ENTER 76
#define hkwd_LMTDSM_PROPCREATEDSET_EXIT 77
#define hkwd_DSM_PROPCREATEDSET_EXIT 78
#define hkwd_DSM_PROPDIRTODSET_ENTER 79
#define hkwd_LMTDSM_PROPDIRTODSET_EXIT 80
#define hkwd_DSM_PROPDIRTODSET_EXIT 81
#define hkwd_DSM_PROPLISTDSETS_ENTER 82
#define hkwd_LMTDSM_PROPLISTDSETS_EXIT 83
#define hkwd_DSM_PROPLISTDSETS_EXIT 84
#define hkwd_DSM_PROPISDSETREF_ENTER 85
#define hkwd_LMTDSM_PROPISDSETREF_EXIT 86
#define hkwd_DSM_PROPISDSETREF_EXIT 87
#define hkwd_DSM_PROPGETDSETGENBYID_ENTER 88
#define hkwd_LMTDSM_PROPGETDSETGENBYID_EXIT 89
#define hkwd_DSM_PROPGETDSETGENBYID_EXIT 90
#define hkwd_DSM_DSOPHOLD_ENTER 91
#define hkwd_LMTDSM_DSOPHOLD_EXIT 92
#define hkwd_DSM_DSOPHOLD_EXIT 93
#define hkwd_DSM_DSOPRELE_ENTER 94
#define hkwd_LMTDSM_DSOPRELE_EXIT 95
#define hkwd_DSM_DSOPRELE_EXIT 96
#define hkwd_DSM_DSOPDSETROOT_ENTER 97
#define hkwd_LMTDSM_DSOPDSETROOT_EXIT 98
#define hkwd_DSM_DSOPDSETROOT_EXIT 99
#define hkwd_DSM_DSOPCREATEDSETREF_ENTER 100
#define hkwd_LMTDSM_DSOPCREATEDSETREF_EXIT 101
#define hkwd_DSM_DO_CREATEDSETREF_EXIT 102
#define hkwd_DSM_DSOPDELETEDSET_ENTER 103
#define hkwd_LMTDSM_DSOPDELETEDSET_EXIT 104
#define hkwd_DSM_DSOPDELETEDSET_EXIT 105
#define hkwd_DSM_DSOPDELETEDSETREF_ENTER 106
#define hkwd_LMTDSM_DSOPDELETEDSETREF_EXIT 107
#define hkwd_DSM_DSOPDELETEDSETREF_EXIT 108
#define hkwd_DSM_DSOPGETDSETGEN_ENTER 109
#define hkwd_LMTDSM_DSOPGETDSETGEN_EXIT 110
#define hkwd_DSM_DSOPGETDSETGEN_EXIT 111
#define hkwd_DSM_DSOPDSETTODIR_ENTER 112
#define hkwd_LMTDSM_DSOPDSETTODIR_EXIT 113
#define hkwd_DSM_DSOPDSETTODIR_EXIT 114
#define hkwd_DSM_DSOPGETDSETATTR_ENTER 115
#define hkwd_LMTDSM_DSOPGETDSETATTR_EXIT 116
#define hkwd_DSM_DSOPGETDSETATTR_EXIT 117

/* Hook and subhook ids for bufx tracing.
 * Each component in the stack receives a unique block of subhook ids as 
 * follows. Subhook ids 0x0001 to 0x999F are reserved for internal IBM use. 
 * Subhook ids from 0x999F to FFFF are reserved for 3rd party software. 
 * Subhook id of 0x0000 is unused and reserved.
 *
 * Subhook id Block	Component
 * ----------------     ---------
 * 0x0001 - 0x00FF	devstrat() and iodone()
 * 0x0100 - 0x01FF	VMM
 * 0x0200 - 0x02FF	LVM
 * 0x0300 - 0x03FF	Disk Driver
 * 0x0400 - 0x04FF	Protocol Driver
 * 0x0500 - 0x0580	Adapter Driver
 * 0x0581 - 0x06FF	JFS2
 * 0x0700 - 0x0780	Uphysio path
 * 0x0781 - 0x07FF	Buffer cache
 * 0x0800 - 0x0880	AIO
 * 0x0880 - 0x08FF	Reserved
 * 0x0900 - 0x09FF	VSCSI Initiator
 * 0x0A00 - 0x0AFF	VSCSI Target
 * 0x0B00 - 0x0B10	Loopback Device
 */
#define HKWD_BUFX		0x5CE00000
#define hkwd_devstrat		0x0001
#define hkwd_iodone		0x0005
#define hkwd_wlm_devstrat	0x0007

#define hkwd_vmmbufx_init		0x100
#define hkwd_vmmbufx_strat		0x110
#define hkwd_vmmbufx_stchg		0x120
#define hkwd_vmmbufx_error		0x1F0

#define hkwd_vmmbufx_v_init_pdtbufx	0x0
#define hkwd_vmmbufx_v_init_buf		0x1
#define hkwd_vmmbufx_v_pfend		0x2
#define hkwd_vmmbufx_v_pdtsio		0x3
#define hkwd_vmmbufx_v_cpfprot		0x4
#define hkwd_vmmbufx_v_cpfprotdone	0x5

/*
 * Disk head driver bufx sub hook ID macros
 * These subhooks are subhooks of HKWD_BUFX
 */
#define hkwd_diskbufx_init               0x300
#define hkwd_diskbufx_strategy           0x310
#define hkwd_diskbufx_start              0x320
#define hkwd_diskbufx_iodone             0x330
#define hkwd_diskbufx_coalesce           0x340
#define hkwd_diskbufx_error              0x3F0

/*
 * Subhook ids for the loopback device
 */
#define hkwd_loopback_strat	0xb00
#define hkwd_loopback_error	0xb01
#define hkwd_loopback_rwstrat	0xb02


#define HKWD_WDOG	0x5DC00000

/*
 * Trace hook for RTEC error trace entries generated by
 * components of the networking stack 
 */
#define HKWD_NETWORK_RTEC	0x5F000000

/*
 * Targeted Error Injection trace hooks
 */
#define HKWD_KERN_ERRINJ	0x63600000

#define hkwd_ERRINJ_HOOK                 1
#define hkwd_ERRINJ_REGISTER             2
#define hkwd_ERRINJ_UNREGISTER           3
#define hkwd_ERRINJ_CREATE               4
#define hkwd_ERRINJ_ENABLE               5
#define hkwd_ERRINJ_DISABLE              6
#define hkwd_ERRINJ_DELETE               7
#define hkwd_ERRINJ_SET_PTID             8
#define hkwd_ERRINJ_SET_CPUS             9
#define hkwd_ERRINJ_SET_MODE            10
#define hkwd_ERRINJ_SET_REPEAT          11
#define hkwd_ERRINJ_SET_LIMIT           12
#define hkwd_ERRINJ_QUERY_LIST          13
#define hkwd_ERRINJ_QUERY_PROP          14
#define hkwd_ERRINJ_PASSTHRU            15


/*
 * Hook ID for the loopback device
 */
#define HKWD_LOOPBACK	0x64A00000

/*
 * Subhook IDs for the loopback device
 */
#define hkwd_loopback_open_enter	0x0100
#define hkwd_loopback_open_bound	0x0101
#define hkwd_loopback_open_error	0x0199
#define hkwd_loopback_open_exit		0x01FF
#define hkwd_loopback_close_enter	0x0200
#define hkwd_loopback_close_error	0x0299
#define hkwd_loopback_close_exit	0x02FF
#define hkwd_loopback_read_enter	0x0300
#define hkwd_loopback_read_error	0x0399
#define hkwd_loopback_read_exit		0x03FF
#define hkwd_loopback_write_enter	0x0400
#define hkwd_loopback_write_error	0x0499
#define hkwd_loopback_write_exit	0x04FF
#define hkwd_loopback_ioctl_enter	0x0500
#define hkwd_loopback_ioctl_error	0x0599
#define hkwd_loopback_ioctl_exit	0x05FF
#define hkwd_loopback_strat_error	0x0699
#define hkwd_loopback_kproc_enter	0x0700
#define hkwd_loopback_kproc_exit	0x07FF

/* RBAC HOOK ids and sub hooks */
#define HKWD_RBAC                                       0x64C00000
#define hkwd_rbac_kat_callback_in                       1
#define hkwd_rbac_kat_callback_err                      2
#define hkwd_rbac_kat_callback_out                      3
#define hkwd_rbac_kpcdt_callback_in                     4
#define hkwd_rbac_kpcdt_callback_err                    5
#define hkwd_rbac_kpcdt_callback_out                    6
#define hkwd_rbac_kprt_callback_in                      7
#define hkwd_rbac_kprt_callback_err                     8
#define hkwd_rbac_kprt_callback_out                     9
#define hkwd_rbac_krt_callback_in                       10
#define hkwd_rbac_krt_callback_err                      11
#define hkwd_rbac_krt_callback_out                      12
#define hkwd_rbac_kst_callback_in                       13
#define hkwd_rbac_kst_callback_err                      14
#define hkwd_rbac_kst_callback_out                      15
#define hkwd_rbac_wpar_callback_in                      16
#define hkwd_rbac_wpar_callback_err                     17
#define hkwd_rbac_wpar_callback_out                     18


/* RBAC parent component : Reserved sub hook ids between 25 and 100 */
#define hkwd_rbac_get_secflags_var1			25
#define hkwd_rbac_get_secflags_ret1			26
#define hkwd_rbac_get_secflags_ret2			27
#define hkwd_rbac_wpar_run_mode_var1			28
#define hkwd_rbac_wpar_run_mode_ret			29
#define hkwd_rbac_getkst4cid_var1			30
#define hkwd_rbac_wpar_config_kst_in			31
#define hkwd_rbac_wpar_config_kst_ret1			32
#define hkwd_rbac_wpar_config_kst_ret2			33
#define hkwd_rbac_getkstcid_in				34
#define hkwd_rbac_getkstcid_ret1			35
#define hkwd_rbac_getkstcid_var1			36
#define hkwd_rbac_getkstcid_ret2			37	
#define hkwd_rbac_unlockkstcid_in			38

/* KAT sub component : Reserved sub hook ids between 101 and 299 */
#define hkwd_rbac_sort_auths_by_id_in			101	
#define hkwd_rbac_sort_auths_by_id_ret1			102
#define hkwd_rbac_sort_auths_by_name_in			103
#define hkwd_rbac_sort_auths_by_name_ret1		104
#define hkwd_rbac_getauth4num_in			105
#define hkwd_rbac_getauth4name_in			106
#define hkwd_rbac_get_auth_k_size_in			107
#define hkwd_rbac_get_auth_k_size_ret			108
#define hkwd_rbac_convert_2_auth_k_in			109
#define hkwd_rbac_convert_2_auth_k_ret			110
#define hkwd_rbac_get_usr_kat_ptrs_ret1			111
#define hkwd_rbac_get_usr_kat_ptrs_ret2			112
#define hkwd_rbac_get_auth_k_4_name_in			113
#define hkwd_rbac_get_auth_k_4_name_ret1		114
#define hkwd_rbac_get_auth_k_4_name_ret2		115
#define hkwd_rbac_get_auth_k_4_name_ret3		116
#define hkwd_rbac_get_auth_k_4_num_in			117
#define hkwd_rbac_get_auth_k_4_num_ret1			118
#define hkwd_rbac_get_auth_k_4_num_ret2			119
#define hkwd_rbac_get_auth_k_4_num_ret3			120
#define hkwd_rbac_get_proc_rids_in			121
#define hkwd_rbac_add_chkauth_in			122
#define hkwd_rbac___checkauth_in			123
#define hkwd_rbac__checkauth_ret1			124
#define hkwd_rbac__checkauth_ret2			125
#define hkwd_rbac__checkauth_ret3			126
#define hkwd_rbac__checkauth_ret4			127
#define hkwd_rbac_get_auths_k_in			128
#define hkwd_rbac_get_auths_k_ret1			129
#define hkwd_rbac_get_auths_k_ret2			130
#define hkwd_rbac_get_auths_k_ret3			131
#define hkwd_rbac__check_auths_any_in			132
#define hkwd_rbac__check_auths_any_ret1			133
#define hkwd_rbac__check_auths_any_ret2			134
#define hkwd_rbac__check_auths_bitmap_in		135
#define hkwd_rbac__check_auths_bitmap_ret4		136
#define hkwd_rbac__checkauthid_in			137
#define hkwd_rbac__checkauthid_ret1			138
#define hkwd_rbac__checkauthid_ret2			139
#define hkwd_rbac__checkauthid_ret3			140
#define hkwd_rbac__checkauthid_ret4			141
#define hkwd_rbac__checkauthid_ret5			142
#define hkwd_rbac_free_a_kat_in				143
#define hkwd_rbac_find_auth_in_array_in			144
#define hkwd_rbac_find_auth_in_array_ret		145
#define hkwd_rbac_setkat_in				146
#define hkwd_rbac_setkat_ret1				147
#define hkwd_rbac_setkat_ret2				148
#define hkwd_rbac_setkat_ret3				149
#define hkwd_rbac_setkat_ret4				150
#define hkwd_rbac_setkat_ret5				151
#define hkwd_rbac_setkat_ret6				152
#define hkwd_rbac_getauthname4num_in			153
#define hkwd_rbac_getauthname4num_ret			154
#define hkwd_rbac_sec_setkat_in				155
#define hkwd_rbac_sec_setkat_ret1			156
#define hkwd_rbac_sec_setkat_ret2			157
#define hkwd_rbac_sec_setkat_ret3			158
#define hkwd_rbac_sec_setkat_ret4			159
#define hkwd_rbac_sec_setkat_ret5			160
#define hkwd_rbac_sec_getkat_in				161
#define hkwd_rbac_sec_getkat_ret1			162
#define hkwd_rbac_sec_getkat_ret2			163
#define hkwd_rbac_sec_getkat_ret3			164
#define hkwd_rbac_sec_getkat_ret4			165
#define hkwd_rbac_sec_getkat_ret5			166
#define hkwd_rbac_sec_getkat_ret6			167
#define hkwd_rbac_sec_getkat_ret7			168
#define hkwd_rbac_sec_getkat_ret8			169
#define hkwd_rbac_sec_sec_getuserkat_in			170
#define hkwd_rbac_sec_sec_getuserkat_ret1		171
#define hkwd_rbac_sec_sec_getuserkat_ret2		172
#define hkwd_rbac_sec_sec_getuserkat_ret3		173
#define hkwd_rbac_sec_sec_getuserkat_ret4		174
#define hkwd_rbac_sec_sec_getuserkat_ret5		175
#define hkwd_rbac_sec_sec_getuserkat_var1		176
#define hkwd_rbac_sec_sec_getuserkat_ret6		177
#define hkwd_rbac_sec_sec_getuserkat_ret7		178
#define hkwd_rbac_sec_sec_getuserkat_ret8		179
#define hkwd_rbac_sec_authidtoname_in			180
#define hkwd_rbac_sec_authidtoname_ret1			181
#define hkwd_rbac_sec_authidtoname_ret2			182
#define hkwd_rbac_sec_authidtoname_ret3			183
#define hkwd_rbac_sec_authidtoname_ret4			184
#define hkwd_rbac_sec_authidtoname_ret5			185
#define hkwd_rbac_sec_authidtoname_ret6			186
#define hkwd_rbac_sec_authidtoname_ret7			187
#define hkwd_rbac_sec_authidtoname_ret8			188
#define hkwd_rbac_sec_authidtoname_ret9			189
#define hkwd_rbac_sec_authidtoname_ret11		190
#define hkwd_rbac_sec_authidtoname_ret12		191
#define hkwd_rbac_sec_authnametoid_in			192
#define hkwd_rbac_sec_authnametoid_ret1			193
#define hkwd_rbac_sec_authnametoid_ret2			194
#define hkwd_rbac_sec_authnametoid_ret3			195
#define hkwd_rbac_sec_authnametoid_ret4			196
#define hkwd_rbac_sec_authnametoid_ret5			197
#define hkwd_rbac_sec_authnametoid_ret6			198
#define hkwd_rbac_sec_authnametoid_ret7			199
#define hkwd_rbac_sec_authnametoid_ret8			200
#define hkwd_rbac_sec_authnametoid_ret9			201
#define hkwd_rbac_sec_checkauth_in			202
#define	hkwd_rbacsec_checkauth_ret1			203
#define hkwd_rbacsec_checkauth_ret2			204
#define	hkwd_rbacsec_checkauth_ret3			205
#define	hkwd_rbacsec_checkauth_ret4			206
#define hkwd_rbac_sec_checkauthid_in			207
#define hkwd_rbac_sec_checkauthid_ret1			208
#define hkwd_rbac_sec_checkauthid_ret2			209
#define hkwd_rbac_sec_getkatids_in			210
#define hkwd_rbac_sec_getkatids_ret1			211
#define hkwd_rbac_sec_getkatids_ret2			212
#define hkwd_rbac_sec_getkatids_ret3			213
#define hkwd_rbac_sec_getkatids_ret4			214
#define hkwd_rbac_sec_getkatids_ret5			215
#define hkwd_rbac_sec_getkatids_var1			216
#define hkwd_rbac_sec_getkatids_ret6			217
#define hkwd_rbac_sec_getkatids_ret7			218
#define hkwd_rbac_sec_getkatids_ret8			219
#define hkwd_rbac_init_sys_KAT_ret1			220
#define hkwd_rbac_init_sys_KAT_ret2			221
#define hkwd_rbac_is_sys_KAT_id_in			222
#define hkwd_rbac_init_sys_KAT_id_ret			223
#define hkwd_rbac_sec_getauths_in			224
#define hkwd_rbac_sec_getauths_ret1			225
#define hkwd_rbac_sec_getauths_ret2			226
#define hkwd_rbac_sec_getauths_ret3			227
#define hkwd_rbac_sec_getauths_ret4			228
#define hkwd_rbac_sec_getauths_ret5			229
#define hkwd_rbac_sec_getauths_ret6			230

			
/* KPCDT sub component : Reserved sub hook ids between 300 and 399 */
#define hkwd_rbac_setkpcdt_in1				300
#define hkwd_rbac_setkpcdt_in2				301
#define hkwd_rbac_setkpcdt_ret1				302
#define hkwd_rbac_setkpcdt_ret2				303
#define hkwd_rbac_setkpcdt_var1				304
#define hkwd_rbac_setkpcdt_ret3				305
#define hkwd_rbac_getkpct_in				306
#define hkwd_rbac_getkpct_var1				307
#define hkwd_rbac_getkpct_var2				308
#define hkwd_rbac_getkpct_ret				309
#define hkwd_rbac_find_rbac_rule_in			310
#define hkwd_rbac_find_rbac_rule_var1			311
#define hkwd_rbac_find_rbac_rule_var2			312
#define hkwd_rbac_find_rbac_rule_ret1			313
#define hkwd_rbac_sec_getkpct_in			314
#define hkwd_rbac_sec_getkpct_ret1			315
#define hkwd_rbac_sec_getkpct_ret			316
#define hkwd_rbac_sec_getkpdt_in			317
#define hkwd_rbac_sec_getkpdt_ret1			318
#define hkwd_rbac_sec_getkpdt_ret			319
#define hkwd_rbac_sec_getcmdattrs_in			320
#define hkwd_rbac_sec_getcmdattrs_ret1			321
#define hkwd_rbac_sec_getcmdattrs_ret2			322
#define hkwd_rbac_sec_getdevattrs_in			323
#define hkwd_rbac_sec_getdevattrs_ret1			324
#define hkwd_rbac_sec_getdevattrs_ret2			325
#define hkwd_rbac_sec_setwpscid_in			326
#define hkwd_rbac_sec_setwpscid_ret1			327
#define hkwd_rbac_sec_setwpscid_ret2			328
#define hkwd_rbac_getwpscid_in				329
#define hkwd_rbac_getwpscid_ret1			330
#define hkwd_rbac_getwpscid_ret2			331
#define hkwd_rbac_free_a_wps_in				332
#define hkwd_rbac_sec_getsysprivs_in			333
#define hkwd_rbac_sec_getsysprivs_var1			334
#define hkwd_rbac_sec_getsysprivs_ret			335

/* KST sub component : Reserved sub hook ids between 400 and 499 */
#define hkwd_rbac_sec_setkst_in				400
#define hkwd_rbac_sec_setkst_ret1			401
#define hkwd_rbac_sec_setkst_ret2			402
#define hkwd_rbac_sec_setkst_ret3			403
#define hkwd_rbac_sec_setkst_ret4			404
#define hkwd_rbac_sec_setkst_var1			405
#define hkwd_rbac_sec_setkst_ret5			406
#define hkwd_rbac_sec_setkst_var2			407
#define hkwd_rbac_sec_setkst_ret6			408
#define hkwd_rbac_sec_setkst_var3			409
#define hkwd_rbac_sec_setkst_ret7			410
#define hkwd_rbac_sec_setkst_var4			411
#define hkwd_rbac_sec_setkst_ret8			412
#define hkwd_rbac_sec_setkst_ret9			413
#define hkwd_rbac_sec_setkst_var5			414
#define hkwd_rbac_sec_setkst_ret10			415
#define hkwd_rbac_sec_setkst_ret11			416
#define hkwd_rbac_sec_setkst_ret12			417
#define hkwd_rbac_sec_setrbacsyslog_ret1		418
#define hkwd_rbac_sec_setrbacsyslog_ret2		419
#define hkwd_rbac_sec_getrbacsyslog_ret1 		420
#define hkwd_rbac_sec_getrbacsyslog_ret2		421


/* KPRT sub component : Reserved sub hook ids between 500 and 699 */
#define hkwd_rbac_set_kprt_in1				500
#define hkwd_rbac_set_kprt_in2				501
#define hkwd_rbac_set_kprt_ret1				502
#define hkwd_rbac_set_kprt_ret2				503
#define hkwd_rbac_set_kprt_ret3				504
#define hkwd_rbac_set_kprt_ret4				505
#define hkwd_rbac_set_kprt_ret5				506
#define hkwd_rbac_set_kprt_ret6				507
#define hkwd_rbac_set_kprt_ret7				508
#define hkwd_rbac_set_kprt_ret8				509
#define hkwd_rbac_set_kprt_var1				510
#define hkwd_rbac_set_kprt_var2				511
#define hkwd_rbac_set_kprt_ret9				512
#define hkwd_rbac_set_kprt_ret10			513
#define hkwd_rbac_create_kprt_htbl_var1			514
#define hkwd_rbac_create_kprt_htbl_ret			515
#define hkwd_rbac_populate_base_htbl_in			516
#define hkwd_rbac_populate_base_htbl_ret1		517
#define hkwd_rbac_populate_base_htbl_ret2		518
#define hkwd_rbac_populate_base_htbl_ret3		519
#define hkwd_rbac_populate_base_htbl_var1		520
#define hkwd_rbac_populate_base_htbl_ret4		521
#define hkwd_rbac_rk_hash_in				522
#define hkwd_rbac_rk_hash_ret				523
#define hkwd_rbac_populate_fid_htbl_in			524
#define hkwd_rbac_populate_fid_htbl_ret1		525
#define hkwd_rbac_populate_fid_htbl_ret2		526
#define hkwd_rbac_populate_fid_htbl_var1		527
#define hkwd_rbac_populate_fid_htbl_ret3		528
#define hkwd_rbac_insert_fid_node_in			529
#define hkwd_rbac_delete_fid_node_in			530
#define hkwd_rbac_update_fid_node_in			531
#define hkwd_rbac_update_fid_node_ret1			532
#define hkwd_rbac_update_fid_node_ret2			533
#define hkwd_rbac_free_a_kprt_in			534
#define hkwd_rbac_free_a_kprt_ret1			535
#define hkwd_rbac_free_a_kprt_ret2			536
#define hkwd_rbac_free_a_kprt_var1			537
#define hkwd_rbac_free_a_kprt_var2			538
#define hkwd_rbac_free_a_kprt_var3			539
#define hkwd_rbac_free_a_kprt_ret3			540
#define hkwd_rbac_get_kprt_in				541
#define hkwd_rbac_get_kprt_ret1				542
#define hkwd_rbac_get_kprt_ret2				543
#define hkwd_rbac_get_kprt_var1				544
#define hkwd_rbac_get_kprt_var2				545
#define hkwd_rbac_get_kprt_var3				546
#define hkwd_rbac_get_kprt_ret3				547
#define hkwd_rbac_find_kprt_rule_in1			548
#define hkwd_rbac_find_kprt_rule_ret1			549
#define hkwd_rbac_find_kprt_rule_ret2			550
#define hkwd_rbac_find_kprt_rule_var1			551
#define hkwd_rbac_find_kprt_rule_ret3			552
#define hkwd_rbac_find_kprt_rule_var2			553
#define hkwd_rbac_find_kprt_rule_ret4			554
#define hkwd_rbac_find_kprt_rule_ret5			555
#define hkwd_rbac_find_rule_method_basename_in1		556
#define hkwd_rbac_find_rule_method_basename_in2		557
#define hkwd_rbac_find_rule_method_basename_ret1	558
#define hkwd_rbac_find_rule_method_basename_ret2	559
#define hkwd_rbac_find_rule_method_basename_var1	560
#define hkwd_rbac_find_rule_method_basename_ret3	561
#define hkwd_rbac_find_rule_method_basename_ret4	562
#define hkwd_rbac_find_rule_method_basename_fid_in	563
#define hkwd_rbac_find_rule_method_basename_fid_ret1	564
#define hkwd_rbac_find_rule_method_basename_fid_var1	565
#define hkwd_rbac_find_rule_method_basename_fid_var2	566
#define hkwd_rbac_find_rule_method_basename_fid_ret2	567
#define hkwd_rbac_find_rule_method_basename_fid_ret3	568
#define hkwd_rbac_resolve_basename_in			569
#define hkwd_rbac_resolve_basename_ret1			570
#define hkwd_rbac_resolve_basename_ret2			571
#define hkwd_rbac_get_dirname_len_in			572
#define hkwd_rbac_get_dirname_len_ret			573
#define hkwd_rbac_compare_vnodes_in			574
#define hkwd_rbac_compare_vnodes_ret1			575
#define hkwd_rbac_compare_vnodes_ret2			576
#define hkwd_rbac_compare_vnodes_ret3			577
#define hkwd_rbac_compare_vnodes_ret4			578
#define hkwd_rbac_update_kprt_rule_in			579
#define hkwd_rbac_update_kprt_rule_ret1			580
#define hkwd_rbac_update_kprt_rule_ret2			581
#define hkwd_rbac_update_kprt_rule_var1			582
#define hkwd_rbac_update_kprt_rule_var2			583
#define hkwd_rbac_update_kprt_rule_var3			584
#define hkwd_rbac_update_kprt_rule_ret3			585



/* KRT sub component : Reserved sub hook ids between 700 and 999 */

/* 731 to 824 is unused */

#define hkwd_rbac_setkrt_in				700
#define hkwd_rbac_setkrt_ret1				701
#define hkwd_rbac_setkrt_ret2				702
#define hkwd_rbac_setkrt_ret3				703
#define hkwd_rbac_setkrt_ret4				704
#define hkwd_rbac_setkrt_ret5				705
#define hkwd_rbac_setkrt_ret6				706
#define hkwd_rbac_setkrt_ret7				707
#define hkwd_rbac_setkrt_ret8				708
#define hkwd_rbac_sort_roles_by_id_in			709
#define hkwd_rbac_sort_roles_by_id_ret1			710
#define hkwd_rbac_sort_roles_by_name_in			711
#define hkwd_rbac_sort_roles_by_name_ret1		712
#define hkwd_rbac_getrole4num_in			713
#define hkwd_rbac_getrole4name_in			714
#define hkwd_rbac_get_role_t_size_in			715
#define hkwd_rbac_get_role_t_size_ret			716
#define hkwd_rbac_get_role_k_t_size_in			717
#define hkwd_rbac_get_role_k_t_size_ret			718
#define hkwd_rbac_convert_2_role_k_in			719
#define hkwd_rbac_convert_2_role_k_ret			720
#define hkwd_rbac_get_krt_ptrs_ret			721
#define hkwd_rbac_check_auths_in_roles_in		722
#define hkwd_rbac_check_auths_in_roles_ret1		723
#define hkwd_rbac_check_auths_in_roles_ret2		724
#define hkwd_rbac_check_auths_in_roles_ret3		725
#define hkwd_rbac_check_auth_bitmap_in_roles_in		726
#define hkwd_rbac_check_auth_bitmap_in_roles_ret1	727
#define hkwd_rbac_check_auth_bitmap_in_roles_ret2	728
#define hkwd_rbac_check_auth_bitmap_in_roles_ret3	729
#define hkwd_rbac_free_a_krt_in				730

#define hkwd_rbac_sec_setkrt_in				825
#define hkwd_rbac_sec_setkrt_ret1			826
#define hkwd_rbac_sec_setkrt_ret2			827
#define hkwd_rbac_sec_setkrt_ret3			828
#define hkwd_rbac_sec_setkrt_ret4			829
#define hkwd_rbac_sec_setkrt_ret5			830
#define hkwd_rbac_getkrtroles_common_in			831
#define hkwd_rbac_getkrtroles_common_ret1		832
#define hkwd_rbac_getkrtroles_common_ret2		833
#define hkwd_rbac_getkrtroles_common_ret3		834
#define hkwd_rbac_getkrtroles_common_ret4		835
#define hkwd_rbac_getkrtroles_common_ret5		836
#define hkwd_rbac_sec_getkrt_in				837
#define hkwd_rbac_sec_getkrt_ret1			838
#define hkwd_rbac_sec_getkrt_ret2			839
#define hkwd_rbac_sec_getkrt_ret3			840
#define hkwd_rbac_sec_getkrt_ret4			841
#define hkwd_rbac_sec_getrolebyid_in			842
#define hkwd_rbac_sec_getrolebyid_ret1			843
#define hkwd_rbac_sec_getrolebyid_ret2			844
#define hkwd_rbac_sec_getrolebyid_ret3			845
#define hkwd_rbac_sec_getrolebyid_ret4			846
#define hkwd_rbac_sec_getrolebyid_ret5			847
#define hkwd_rbac_sec_getrolebyid_ret6			848
#define hkwd_rbac_sec_getrolebyid_ret7			849
#define hkwd_rbac_sec_getrolebyname_in			850
#define hkwd_rbac_sec_getrolebyname_ret1		851
#define hkwd_rbac_sec_getrolebyname_ret2		852
#define hkwd_rbac_sec_getrolebyname_ret3		853
#define hkwd_rbac_sec_getrolebyname_ret4		854
#define hkwd_rbac_sec_getrolebyname_ret5		855
#define hkwd_rbac_sec_roleidtoname_in			856
#define hkwd_rbac_sec_roleidtoname_ret1			857
#define hkwd_rbac_sec_roleidtoname_ret2			858
#define hkwd_rbac_sec_roleidtoname_ret3			859
#define hkwd_rbac_sec_roleidtoname_ret4			860
#define hkwd_rbac_sec_roleidtoname_ret5			861
#define hkwd_rbac_sec_roleidtoname_ret6			862
#define hkwd_rbac_sec_roleidtoname_ret7			863
#define hkwd_rbac_sec_rolenametoid_in			864
#define hkwd_rbac_sec_rolenametoid_ret1			865
#define hkwd_rbac_sec_rolenametoid_ret2			866
#define hkwd_rbac_sec_rolenametoid_ret3			867
#define hkwd_rbac_sec_rolenametoid_ret4			868
#define hkwd_rbac_sec_rolenametoid_ret5			869
#define hkwd_rbac_sec_rolenametoid_ret6			870
#define hkwd_rbac_sec_rolenametoid_ret7			871


/* REFMON HOOK ids and sub hooks */
#define HKWD_REFMON                                     0x64D00000
#define hkwd_refmon_auth_callback_in                    1
#define hkwd_refmon_auth_callback_err                   2
#define hkwd_refmon_auth_callback_out                   3
#define hkwd_refmon_dac_callback_in                     4
#define hkwd_refmon_dac_callback_err                    5
#define hkwd_refmon_dac_callback_out                    6
#define hkwd_refmon_fs_callback_in                      7
#define hkwd_refmon_fs_callback_err                     8
#define hkwd_refmon_fs_callback_out                     9
#define hkwd_refmon_fsf_callback_in                     10
#define hkwd_refmon_fsf_callback_err                    11
#define hkwd_refmon_fsf_callback_out                    12
#define hkwd_refmon_label_callback_out                  13
#define hkwd_refmon_label_callback_err                  14
#define hkwd_refmon_label_callback_in                   15
#define hkwd_refmon_mac_callback_in                     16
#define hkwd_refmon_mac_callback_err                    17
#define hkwd_refmon_mac_callback_out                    18
#define hkwd_refmon_objsec_callback_in                  19
#define hkwd_refmon_objsec_callback_err                 20
#define hkwd_refmon_objsec_callback_out                 21
#define hkwd_refmon_priv_callback_in                    22
#define hkwd_refmon_priv_callback_err                   23
#define hkwd_refmon_priv_callback_out                   24
#define hkwd_refmon_policy_callback_in                  25
#define hkwd_refmon_policy_callback_err                 26
#define hkwd_refmon_policy_callback_out                 27

#define HKWD_RR_LCT3        0x658  /* Red River CT3 Library */

/* 
 * Trace hook for OFED-ported code
 */
#define HKWD_OFED		0x10010000

/* 
 * Track hook for External Interrupt Disablement (sysios) 
 */

#define HKWD_KERN_CPUEXTINTPRI_CTL			0x10260000

/* 
 * Transactional Memory hook and sub-hook IDs
 */
#define HKWD_KERN_TM              0x67500000
#define hkwd_KERN_TM_DISOWN       0x0
#define hkwd_KERN_TM_RESTORE      0x1
#define hkwd_KERN_TM_BADTHING     0x2
#define hkwd_KERN_TM_UNAV         0x3
#define hkwd_KERN_TM_FP_UNAV      0x4
#define hkwd_KERN_TM_VMX_UNAV     0x5
#define hkwd_KERN_TM_VSX_UNAV     0x6
#define hkwd_KERN_TM_SIG_DISCARD  0x7
#define hkwd_KERN_TM_INV_OP       0x8
#define hkwd_KERN_TM_ALIGN_INT    0x9
#define hkwd_KERN_TM_PIN_FAIL     0xA

/*
 * Trace hook for BPF 
 */
#define HKWD_BPF					0x10510000
#define hkwd_bpf_aix_tap_in				1
#define hkwd_bpf_aix_tap_generic			2
#define hkwd_bpf_aix_tap_err1				3
#define hkwd_bpf_aix_tap_filterout1			4
#define hkwd_bpf_aix_tap_filterout2			5
#define hkwd_bpf_aix_tap_err2				6
#define hkwd_bpf_aix_mtap_in				7
#define hkwd_bpf_aix_mtap_filter			8
#define hkwd_process_ipv6_options_in			9
#define hkwd_process_ipv6_options_err1			10
#define hkwd_process_ipv6_options_err2			11
#define hkwd_process_ipv4_options_in			12
#define hkwd_process_ipv4_options_err1			13
#define hkwd_process_ipv4_options_err2			14
#define hkwd_process_ipv4_options_err3			15
#define hkwd_process_ipv4_options_err4			16
#define hkwd_process_ipv4_options_err5			17
#define hkwd_inp_match_in				18
#define hkwd_inp_match_err1				19
#define hkwd_inp_match_ipv6				20
#define hkwd_inp_match_debug1				21
#define hkwd_inp_match_debug2				22
#define hkwd_inp_match_err2				23
#define hkwd_inp_match_ipv4				24
#define hkwd_inp_match_debug3				25
#define hkwd_inp_match_debug4				26
#define hkwd_inp_match_socket1				27
#define hkwd_inp_match_socket2				28
#define hkwd_inp_match_socket3				29
#define hkwd_inp_match_socket4				30
#define hkwd_inp_match_invalid_header			31

/*
 * CAA HOOK ids and Sub hooks
 */
#define HKWD_KERN_CLUST                                 0x102f0000
#define hkwd_XCluster_Zone_Query                        10
#define hkwd_XCluster_Zone_Create                       13
#define hkwd_XCluster_Zone_Delete                       14
#define hkwd_XCluster_Zones_Query                       15
#define hkwd_XCluster_Zone_Modify                       16
#define hkwd_Cluster_Prod_Unlock                        20
#define hkwd_XDisk_Query                                21
#define hkwd_XInterface_Query                           22
#define hkwd_Clust_Handle_Ours                          23
#define hkwd_Fragment_Process                           24
#define hkwd_Clust_Handled                              25
#define hkwd_Clust_Handle_Eth                           26
#define hkwd_KClust_Clust_Wide                          27
#define hkwd_Clust_Recv_Offlvl                          28
#define hkwd_Clust_Input                                29
#define hkwd_Clust_Output                               30
#define hkwd_Clsock_Recv                                31
#define hkwd__If_Set                                    32
#define hkwd_If_Reset                                   33
#define hkwd_KClust_Sendmsg_Ext                         34
#define hkwd__KClust_Sendmsg                            35
#define hkwd_Mbuf_Fixup                                 36
#define hkwd_ahafs_storage_event                        37
#define hkwd_generate_event                             38
#define hkwd_set_cluster                                39
#define hkwd_unset_cluster                              40
#define hkwd_get_clusterid                              41
#define hkwd_create_pkt					42
#define hkwd_Process_Msg_Lock				43
/*
 * vTPM HOOK ids
 */
#define HKWD_VTPM					0x10210000
/* Virtual log hook id */
#define HKWD_VLOG					0x10230000

#define HKWD_ACF_HW					0x103a0000
#define HKWD_ACF_P11					0x103b0000

/* Security trusted execution events */
#define HKWD_SEC_TE					0x10740000
#define hkwd_TE_verify_reg_enter			0x01
#define hkwd_TE_verify_reg_exit				0x02
#define hkwd_TE_verify_reg_error			0x03
#define hkwd_TE_verify_unreg_enter			0x04
#define hkwd_TE_verify_unreg_exit			0x05
#define hkwd_TE_verify_unreg_error			0x06
#define hkwd_TE_verify_fn_invoked			0x07
#define hkwd_TE_verify_fn_returned			0x08
#define hkwd_TE_verify_enter				0x09
#define hkwd_TE_verify_exit				0x0a

#ifdef _H_TRCHKID_EXTENDED

#define PV_HKWD_TRACE_CALIB           			0x00900000
#define PV_HKWD_KERN                  			0x10000000
#define PV_HKWD_IB_ERR           			0x17D00000
#define PV_HKWD_ATA_BLOCK           			0x17E00000
#define PV_HKWD_ATA_CTRL           			0x17F00000
#define PV_HKWD_NFS_VOPSRW           			0x21100000
#define hkwd_NFS_READ             			1
#define hkwd_NFS_WRITE            			2
#define hkwd_NFS3_READ            			3
#define hkwd_NFS3_WRITE           			4
#define hkwd_NFS3_NFS3WRITE       			5
#define hkwd_NFS3_NFS3READ        			6
#define hkwd_NFS3_READDIRPLUS     			7
#define hkwd_NFS3_BIO             			8
#define hkwd_NFS3_BINVAL          			9
#define hkwd_NFS3_ASYSTART       			10
#define hkwd_NFS3_ASYWKUP        			11
#define hkwd_NFS3_ASYOP          			12
#define hkwd_NFS3_ASYSTOP        			13
#define hkwd_NFS3_ASYNC_STOP     			14
#define hkwd_NFS3_WRITERP        			15
#define hkwd_NFS_FLUSHVP         			16
#define hkwd_NFS3_ERROR          			17
#define hkwd_NFS3_RECOVERY       			18
#define hkwd_NFS3_COMMIT         			19
#define hkwd_NFS_BIO            		 	33

#define PV_HKWD_NFS_VOPS           			0x21200000
#define hkwd_NFS_SELECT       				1
#define hkwd_NFS_LOOKUP       				2
#define hkwd_NFS_OPEN         				3
#define hkwd_NFS_CLOSE        				4
#define hkwd_NFS_IOCTL        				5
#define hkwd_NFS_GETATTR      				6
#define hkwd_NFS_SETATTR      				7
#define hkwd_NFS_ACCESS       				8
#define hkwd_NFS_CREATE       				9
#define hkwd_NFS_REMOVE       				10
#define hkwd_NFS_LINK         				11
#define hkwd_NFS_RENAME       				12
#define hkwd_NFS_MKDIR        				13
#define hkwd_NFS_RMDIR        				14
#define hkwd_NFS_READDIR      				15
#define hkwd_NFS_SYMLINK      				16
#define hkwd_NFS_READLINK     				17
#define hkwd_NFS_FSYNC        				18
#define hkwd_NFS_INACTIVE     				19
#define hkwd_NFS_BMAP         				20
#define hkwd_NFS_BADOP        				21
#define hkwd_NFS_STRATEGY     				22
#define hkwd_NFS_LOCKCTL      				23
#define hkwd_NFS_NOOP         				24
#define hkwd_NFS_CMP          				26
#define hkwd_NFS_UTILITY      				28
#define hkwd_NFS_VN_H_R       				29

#define hkwd_NFS3_SELECT       				31
#define hkwd_NFS3_LOOKUP       				32
#define hkwd_NFS3_OPEN         				33
#define hkwd_NFS3_CLOSE        				34
#define hkwd_NFS3_IOCTL        				35
#define hkwd_NFS3_GETATTR      				36
#define hkwd_NFS3_SETATTR      				37
#define hkwd_NFS3_ACCESS       				38
#define hkwd_NFS3_CREATE       				39
#define hkwd_NFS_DNLC_ENTER    				40
#define hkwd_NFS_DNLC_LOOKUP   				41
#define hkwd_NFS_DNLC_REMOVE   				42
#define hkwd_NFS_DNLC_PURGE    				43
#define hkwd_NFS_DNLC_PURGE_VP 				44
#define hkwd_NFS_DNLC_PURGE_VFSP 			45
#define hkwd_NFS_DNLC_UPDATE_ENTER 			46
#define hkwd_NFS3_REMOVE       				310
#define hkwd_NFS3_LINK         				311
#define hkwd_NFS3_RENAME       				312
#define hkwd_NFS3_MKDIR        				313
#define hkwd_NFS3_RMDIR        				314
#define hkwd_NFS3_READDIR      				315
#define hkwd_NFS3_SYMLINK      				316
#define hkwd_NFS3_READLINK     				317
#define hkwd_NFS3_FSYNC        				318
#define hkwd_NFS3_INACTIVE     				319
#define hkwd_NFS3_BMAP         				320
#define hkwd_NFS3_BADOP        				321
#define hkwd_NFS3_STRATEGY     				322
#define hkwd_NFS3_LOCKCTL      				323
#define hkwd_NFS3_NOOP         				324
#define hkwd_NFS3_CMP          				326
#define hkwd_NFS3_PATHCONF     				327
#define hkwd_NFS3_UTILITY      				328
#define hkwd_NFS_FSYNC_RANGE   				329

#define hkwd_NFS3_MOUNT        				350
#define hkwd_NFS3_UMOUNT       				351
#define hkwd_NFS3_STATVFS      				352

#define hkwd_NFS_ALLOC_PDT     				353
#define hkwd_NFS_PDT_HOLD      				354
#define hkwd_NFS_PDT_RELE      				355
#define hkwd_NFS_GET_PDT       				356
#define hkwd_NFS_IP_EQUAL      				357
#define hkwd_NFS_SERV_HOLD     				358
#define hkwd_NFS_SERV_RELE     				359
#define hkwd_NFS_GET_SERV      				360

#define hkwd_NFS_VMM_REGISTER   			361
#define hkwd_NFS_VMM_UNREGISTER 			362
#define hkwd_NFS_AM_BIOD        			363

#define hkwd_NFS3_CNTL          			400
#define hkwd_NFS_REMOUNT        			401
#define hkwd_NFS_V3_ADJ_ARGS    			402
#define hkwd_NFS_V3_REMOUNT     			403

/* swap nfs */
#define hkwd_swapnfs_config             		450
#define hkwd_setup_swap_file            		451
#define hkwd_nfs_config_swap_dev        		452
#define hkwd_nfs_swapvp                 		453
#define hkwd_nfs4_setup_swap_file       		454

#define PV_HKWD_NFS_RFSRW           			0x21300000
#define hkwd_RFS_READ        				1
#define hkwd_RFS_WRITE       				2
#define hkwd_RFS3_READ       				3
#define hkwd_RFS3_WRITE      				4
#define hkwd_RFS4_READ       				5
#define hkwd_RFS4_WRITE      				6

#define PV_HKWD_NFS_RFS       				0x21400000
#define hkwd_RFS_NULL          				1
#define hkwd_RFS_GETATTR       				2
#define hkwd_RFS_SETATTR       				3
#define hkwd_RFS_ERROR         				4
#define hkwd_RFS_LOOKUP        				5
#define hkwd_RFS_READLINK      				6
#define hkwd_RFS_CREATE        				8
#define hkwd_RFS_REMOVE        				9
#define hkwd_RFS_RENAME        				10
#define hkwd_RFS_LINK          				11
#define hkwd_RFS_SYMLINK       				12
#define hkwd_RFS_MKDIR         				13
#define hkwd_RFS_RMDIR         				14
#define hkwd_RFS_READDIR       				15
#define hkwd_RFS_STATFS        				16
#define hkwd_NFS_LOCKFH        				30
#define hkwd_NFS_NFSWRITE      				31
#define hkwd_NFS_NFSREAD       				32
#define hkwd_RFS3_OPERR        				33

#define PV_HKWD_NFS_DISPATCH           			0x21500000
#define hkwd_NFS_DISP_ENTRY    				1
#define hkwd_NFS_DISP_EXIT     				2

#define PV_HKWD_NFS_CALL           			0x21600000
#define hkwd_NFS_CALL_ENTRY             		1
#define hkwd_NFS_CALL_EXIT              		2
#define hkwd_NFS_CLNT_KCREATE           		3

#define PV_HKWD_NFS_RPC_DEBUG           		0x21700000
#define hkwd_KDES_CREATE_FAIL_1         		1
#define hkwd_KDES_CREATE_FAIL_2         		2
#define hkwd_KDES_CREATE_FAIL_3         		3
#define hkwd_KDES_MARSHAL_FAIL          		4
#define hkwd_KDES_VALIDATE_FAIL_1       		5
#define hkwd_KDES_VALIDATE_FAIL_2       		6
#define hkwd_KDES_REFRESH_FAIL_1        		7
#define hkwd_KDES_REFRESH_FAIL_2        		8
#define hkwd_KDES_RTIME_FAIL_SEND       		9
#define hkwd_KDES_RTIME_FAIL_RECV       		10
#define hkwd_KRPC_UDPCREATE_FAIL_1      		11
#define hkwd_KRPC_UDPCREATE_FAIL_2      		12
#define hkwd_KRPC_UDPCREATE_FAIL_3      		13
#define hkwd_KRPC_KURECVFROM_1          		14
#define hkwd_KRPC_KURECVFROM_2          		15
#define hkwd_KRPC_SVCAUTH_U             		16
#define hkwd_KRPC_SVCKUDP_SEND          		17
#define hkwd_KRPC_SVCKUDP_DUPMEM        		18
#define hkwd_KRPC_SVCKUDP_DUPNUMBER     		19
#define hkwd_KRPC_XDRMBUF_1             		20
#define hkwd_KRPC_XDRMBUF_2             		21
#define hkwd_KRPC_XDRMBUF_3             		22
#define hkwd_KRPC_XDRMBUF_4             		23
#define hkwd_NFSSRV_SETSOCK             		24
#define hkwd_NFSSRV_BADPROC             		25
#define hkwd_NFSSRV_BADVERS             		26
#define hkwd_NFSSRV_BADGETARGS          		27
#define hkwd_NFSSRV_WEAKAUTH            		28
#define hkwd_NFSSRV_BADFREEARGS         		29
#define hkwd_NFSSRV_BADSENDREPLY        		30
#define hkwd_NFSSRV_UNPRIVPORT          		31
#define hkwd_KRPC_MBUF_GET_FAIL         		32
#define hkwd_NFSCLNT_MNT_REGMIN         		33
#define hkwd_NFSCLNT_MNT_REGMAX         		34
#define hkwd_NFSCLNT_MNT_DIRMIN         		35
#define hkwd_NFSCLNT_MNT_DIRMAX         		36
#define hkwd_NFSCLNT_KLMLCK_1           		37
#define hkwd_NFSCLNT_KLMLCK_2           		38
#define hkwd_NFSCLNT_KLMLCK_3           		39
#define hkwd_NFSCLNT_KLMLCK_4           		40
#define hkwd_NFSCLNT_KLMLCK_5           		41
#define hkwd_NFSCLNT_AUTHGET_DESFAIL    		42
#define hkwd_NFSCLNT_AUTHGET_UNKNOWN    		43
#define hkwd_NFSCLNT_AUTHFREE_UNKNOWN   		44
#define hkwd_NFSSRVACL_BADSENDREPLY     		45
#define hkwd_NFSSRVACL_BADFREEARGS      		46
#define hkwd_NFSSRV_RFSGETBAD0          		47
#define hkwd_NFSSRV_RFSGETBAD1          		48
#define hkwd_NFSSRV_RFSGETBAD2          		49
#define hkwd_NFSSRV_INPROGRESS          		50
#define hkwd_NFSSRV_BADDUPSTAT          		51
#define hkwd_NFSSRV_NULLRECV            		52
#define hkwd_NFSSRV_BADLEN              		53
#define hkwd_NFSSRV_BADXDRCALL          		54
#define hkwd_NFSCLNT_BADATTACH          		55
#define hkwd_NFSCLNT_BADENCODE          		56
#define hkwd_NFSCLNT_CANTSEND           		57
#define hkwd_NFSCLNT_EINTR              		58
#define hkwd_NFSCLNT_RCTIMEOUT          		59
#define hkwd_NFSCLNT_RCBADXID           		60
#define hkwd_NFSCLNT_RCRETRANS          		61
#define hkwd_NFSCLNT_RCBADCALL          		62
#define hkwd_NFSCLNT_BADCLGET           		63
#define hkwd_NFSCLNT_CLNTCALLBAD        		64
#define hkwd_CLNTTLI_KCREAT_BADCFG      		65
#define hkwd_CLNTCLTS_NOMBUFS           		66
#define hkwd_SVCGEN_BAD_TRANSPORT       		67
#define hkwd_KRPC_SVCKTCP_SEND          		68
#define hkwd_KRPC_NOT_LAST_FRAG         		69
#define hkwd_KRPC_SVC_LISTEN_SO_FAIL    		70
#define hkwd_KRPC_RTCMCREATE_FAIL_1     		71
#define hkwd_KRPC_RTCMCREATE_FAIL_2     		72
#define hkwd_KRPC_RTCMCREATE_FAIL_3     		73
#define hkwd_NFSSRV_BAD_PERFORM_SM_DSB  		74
#define hkwd_RTCM_CONNECT_WAIT          		75
#define hkwd_NFSCLNT_BADDECODE          		76
#define hkwd_NFSCLNT_ERROR              		77
#define hkwd_CLNTTCP_CREATE_FAIL        		78
#define hkwd_CLNTTCP_INIT_FAIL          		79
#define hkwd_CLNTTCP_CALL_FAIL          		80
#define hkwd_CLNTRTCM_SOR_FAIL          		81
#define hkwd_CLNTRTCM_SOR_FAIL_1        		82
#define hkwd_CLNTRTCM_SOR_FAIL_2        		83
#define hkwd_CLNTRTCM_SOR_FAIL_3        		84
#define hkwd_CLNTRTCM_SOR_FAIL_4        		85
#define hkwd_KRPCTCP_SOSND_ERROR        		86
#define hkwd_KRPC_MBUFGET_FAIL_READ     		87
#define hkwd_CLNTKUDP_SOSENDFAIL        		88
#define hkwd_KRPC_SVC_CONNECT_FAILED    		89
#define hkwd_KRPC_SORESERVE_FAILED0     		90
#define hkwd_KRPC_XDRR_INLINE           		91
#define hkwd_KRPC_XDRR_FAIL1            		92
#define hkwd_KRPC_XDRR_FAIL2           		 	93
#define hkwd_KRPC_XDRR_FAIL3            		94
#define hkwd_KRPC_XDRR_FAIL4            		95
#define hkwd_KRPC_XDRR_FAIL5            		96
#define hkwd_KRPC_XDRR_FAIL6            		97
#define hkwd_KRPC_XDRR_SUCCESS          		98
#define hkwd_KRPC_XDRR_PROG_MIS         		99
#define hkwd_KRPC_XDRR_FAIL7            		100
#define hkwd_KRPC_XDRR_FAIL8            		101
#define hkwd_CLNTRTCM_SOR_FAIL_5        		102
#define hkwd_NFS_MAX_CONNECTS_TOO_LOW   		103
#define hkwd_KRPC_MAYB_NOT_LAST_FRAG    		104
#define hkwd_XDRMBUF_GL_X_BASE          		105
#define hkwd_XDRMBUF_GL_EMPTY           		106
#define hkwd_KRPC_SPINTQ_FULL           		107
#define hdwd_KRPC_SET_RFC1323_FAIL      		108
#define hkwd_KRPC_XDRMBUF_PB_EXT        		109
#define hkwd_KRPC_XDRMBUF_GB_EXT        		110
#define hkwd_KRPC_XDRMEM_PB_EXT         		111
#define hkwd_KRPC_XDRMEM_GB_EXT         		112
#define hkwd_CLNTRTCM_START1            		113
#define hkwd_CLNTRTCM_START2            		114
#define hkwd_CLNTRTCM_START3            		115
#define hkwd_CLNTRTCM_START4            		116
#define hkwd_CLNTRTCM_START5            		117
#define hkwd_CLNTRTCM_START6            		118
#define hkwd_CLNTRTCM_START7            		119
#define hkwd_CLNTRTCM_LISTEN1           		120
#define hkwd_CLNTRTCM_LISTEN2           		121
#define hkwd_CLNTRTCM_LISTEN3           		122
#define hkwd_CLNTRTCM_LISTEN4           		123
#define hkwd_CLNTRTCM_LISTEN5           		124
#define hkwd_CLNTRTCM_REPLY1            		125
#define hkwd_CLNTRTCM_RSVPORT1          		126
#define hkwd_CLNTRTCM_RSVPORT2          		127
#define hkwd_NFSCLNT_RCBADCALLX         		128
#define hkwd_NFSCLNT_TCPX               		129
#define hkwd_KTCP_CONNECT_EXT           		130
#define hkwd_MONITOR_EXT                		131
#define hkwd_AUX_EXT                    		132
#define hkwd_OGRE_EXT                   		133

#define PV_HKWD_RPC_LOCKD           			0x21800000
#define hkwd_LOCKD_KLM_PROG     			1
#define hkwd_LOCKD_NLM_REQ      			2
#define hkwd_LOCKD_NLM_RES      			3
#define hkwd_LOCKD_KLM_REPLY    			4
#define hkwd_LOCKD_NLM_REPLY    			5
#define hkwd_LOCKD_NLM_CALL     			6
#define hkwd_LOCKD_NLM_CALL_UDP 			7

#define PV_HKWD_DD_MPADD           			0x22C00000
#define PV_HKWD_DD_SCARRAYDD           			0x23200000
#define PV_HKWD_DD_ROUTERDD           			0x23300000
#define PV_HKWD_CDLI_MON_XMIT           		0x26A00000
#define PV_HKWD_CDLI_MON_RECV          			0x26B00000
#define PV_HKWD_CDLI_LCE_XMIT          			0x27D00000
#define PV_HKWD_CDLI_LCE_ERR           			0x27E00000
#define PV_HKWD_DD_IDEDD           			0x2A000000
#define PV_HKWD_DD_IDEDISKDD           			0x2A100000
#define PV_HKWD_STOK_SFF_XMIT          			0x2A700000
#define PV_HKWD_STOK_SFF_RECV           		0x2A800000
#define PV_HKWD_STOK_SFF_OTHER           		0x2AA00000
#define PV_HKWD_IFPPP           			0x2AB00000
#define PV_HKWD_HDLC           				0x2AC00000
#define PV_HKWD_SLCP           				0x2AD00000
#define PV_HKWD_CS_RECV           			0x2DB00000
#define PV_HKWD_IPSEC_FILTER           			0x2DE00000
#define PV_HKWD_IPSEC_FILTER_INFO           		0x2DF00000
#define PV_HKWD_IPSEC_CAPSUL           			0x2E000000
#define PV_HKWD_IPSEC_CAPSUL_INFO           		0x2E100000
#define PV_HKWD_IPSEC_CRYPTO           			0x2E200000
#define PV_HKWD_IPSEC_CRYPTO_INFO           		0x2E300000
#define PV_HKWD_IPSEC_TUNNEL           			0x2E400000
#define PV_HKWD_IPSEC_TUNNEL_INFO           		0x2E500000
#define PV_HKWD_PHXENT_XMIT           			0x2E600000
#define PV_HKWD_PHXENT_RECV           			0x2E700000
#define PV_HKWD_PHXENT_OTHER           			0x2E800000
#define PV_HKWD_GXENT_RECV           			0x2EB00000
#define PV_HKWD_GXENT_OTHER           			0x2EC00000
#define PV_HKWD_ETHCHAN_XMIT           			0x2FA00000
#define PV_HKWD_DD_FCS_RCV           			0x31000000
#define PV_HKWD_DD_FCS_TX           			0x31100000
#define PV_HKWD_DD_FCS_OTH           			0x31200000
#define PV_HKWD_DD_SCBDMX_RCV          			0x31300000
#define PV_HKWD_DD_SCBDMX_OTH          			0x31400000
#define PV_HKWD_DD_SCBNDD_RCV          			0x31500000
#define PV_HKWD_DD_SCBNDD_TX           			0x31600000
#define PV_HKWD_DD_SCBNDD_MBUF         			0x31700000
#define PV_HKWD_DD_SCBNDD_OTH           		0x31800000
#define PV_HKWD_IENT_XMIT           			0x32000000
#define PV_HKWD_IENT_RECV           			0x32100000
#define PV_HKWD_IENT_OTHER           			0x32200000
#define PV_HKWD_IENT_ERR           			0x32300000
#define PV_HKWD_CDLI_LCE_RECV           		0x32700000
#define PV_HKWD_CDLI_LCE_OTHER           		0x32800000
#define PV_HKWD_CDLI_MPS_XMIT          			0x32D00000
#define PV_HKWD_CDLI_MPS_RECV          			0x32E00000
#define PV_HKWD_CDLI_MPS_ERR           			0x32F00000
#define PV_HKWD_IEN_ISA_XMIT           			0x33000000
#define PV_HKWD_IEN_ISA_RECV           			0x33100000
#define PV_HKWD_IEN_ISA_OTHER          			0x33200000
#define PV_HKWD_IEN_ISA_ERR           			0x33300000
#define PV_HKWD_ITOK_ISA_XMIT          			0x33400000
#define PV_HKWD_ITOK_ISA_RECV          			0x33500000
#define PV_HKWD_ITOK_ISA_OTHER         			0x33600000
#define PV_HKWD_ITOK_ISA_ERR           			0x33700000
#define PV_HKWD_CDLI_MPS_OTHER           		0x33800000
#define PV_HKWD_IFAT           				0x33A00000
#define PV_HKWD_CIOEM_RECV           			0x33D00000
#define PV_HKWD_CIOEM_XMIT           			0x33E00000
#define PV_HKWD_CIOEM_OTHER           			0x33F00000
#define PV_HKWD_EN3COM_XMIT           			0x35100000
#define PV_HKWD_EN3COM_OTHER           			0x35300000
#define PV_HKWD_EN3COM_ERR           			0x35400000
#define PV_HKWD_DGX_ERR           			0x35500000
#define PV_HKWD_ATMCM           			0x3A000000
#define PV_HKWD_ATM_LEC_ERR           			0x3A400000
#define PV_HKWD_DPMP_PCI_XMIT          			0x3A900000
#define PV_HKWD_DPMP_PCI_RECV          			0x3AA00000
#define PV_HKWD_DPMP_PCI_OTHER         			0x3AB00000
#define PV_HKWD_DD_SCIE        				0x3AC00000

#define PV_HKWD_CACHEFS           			0x3AF00000
#define hkwd_I_CFS_OPEN         			1
#define hkwd_O_CFS_OPEN         			2
#define hkwd_I_CFS_CLOSE        			3
#define hkwd_O_CFS_CLOSE        			4
#define hkwd_I_CFS_READ         			5
#define hkwd_O_CFS_READ         			6
#define hkwd_I_CFS_WRITE        			7
#define hkwd_O_CFS_WRITE        			8
#define hkwd_I_CFS_CHARGE_PG    			9
#define hkwd_O_CFS_CHARGE_PG    			10
#define hkwd_I_CFS_WRITEPG      			11
#define hkwd_O_CFS_WRITEPG      			12
#define hkwd_I_CFS_PUSH         			13
#define hkwd_O_CFS_PUSH         			14
#define hkwd_I_CFS_IOCTL        			15
#define hkwd_O_CFS_IOCTL        			16
#define hkwd_I_CFS_GETATTR      			17
#define hkwd_O_CFS_GETATTR      			18
#define hkwd_I_CFS_SETATTR      			19
#define hkwd_O_CFS_SETATTR      			20
#define hkwd_I_CFSACCESS        			21
#define hkwd_O_CFSACCESS        			22
#define hkwd_I_CFS_ACCESS       			23
#define hkwd_O_CFS_ACCESS       			24
#define hkwd_I_CFS_READLINK     			25
#define hkwd_O_CFS_READLINK     			26
#define hkwd_I_CFS_FSYNC        			27
#define hkwd_O_CFS_FSYNC        			28
#define hkwd_I_CFS_SYNC_METAD   			29
#define hkwd_O_CFS_SYNC_METAD   			30
#define hkwd_I_CFS_INACTIVEQ    			31
#define hkwd_O_CFS_INACTIVEQ    			32
#define hkwd_I_CFS_INACTIVE     			33
#define hkwd_O_CFS_INACTIVE     			34
#define hkwd_I_CFS_INITSTATE    			35
#define hkwd_O_CFS_INITSTATE    			36
#define hkwd_I_CFS_LOOKUP       			37
#define hkwd_O_CFS_LOOKUP       			38
#define hkwd_I_CFS_LOOKBACK     			39
#define hkwd_O_CFS_LOOKBACK     			40
#define hkwd_I_CFS_CREATENLOCAL 			41
#define hkwd_O_CFS_CREATENLOCAL 			42
#define hkwd_I_CFS_CREATE       			43
#define hkwd_O_CFS_CREATE       			44
#define hkwd_I_CFS_REMOVE       			45
#define hkwd_O_CFS_REMOVE       			46
#define hkwd_I_CFS_LINK         			47
#define hkwd_O_CFS_LINK         			48
#define hkwd_I_CFS_RENAME       			49
#define hkwd_O_CFS_RENAME       			50
#define hkwd_I_CFS_MKDIR        			51
#define hkwd_O_CFS_MKDIR        			52
#define hkwd_I_CFS_RMDIR        			53
#define hkwd_O_CFS_RMDIR        			54
#define hkwd_I_CFS_SYMLINK      			55
#define hkwd_O_CFS_SYMLINK      			56
#define hkwd_I_CFS_READDIR      			57
#define hkwd_O_CFS_READDIR      			58
#define hkwd_I_CFS_READDIR_BACK 			59
#define hkwd_O_CFS_READDIR_BACK 			60
#define hkwd_I_CFS_FID          			61
#define hkwd_O_CFS_FID          			62
#define hkwd_I_CFS_RWLOCK       			63
#define hkwd_O_CFS_RWLOCK       			64
#define hkwd_I_CFS_RWUNLOCK     			65
#define hkwd_O_CFS_RWUNLOCK     			66
#define hkwd_I_CFS_GET_PAGE     			67
#define hkwd_O_CFS_GET_PAGE     			68
#define hkwd_I_CFS_GETAPAGE     			69
#define hkwd_O_CFS_GETAPAGE     			70
#define hkwd_I_CFS_PUTPAGE      			71
#define hkwd_O_CFS_PUTPAGE      			72
#define hkwd_I_CFS_MAP          			73
#define hkwd_O_CFS_MAP          			74
#define hkwd_I_CFS_FRLOCK       			75
#define hkwd_O_CFS_FRLOCK       			76
#define hkwd_I_CFS_SPACE        			77
#define hkwd_O_CFS_SPACE        			78
#define hkwd_I_CFS_PIN          			79
#define hkwd_O_CFS_PIN          			80
#define hkwd_I_CFS_PINLOCKED    			81
#define hkwd_O_CFS_PINLOCKED    			82
#define hkwd_I_CFS_UNPIN        			83
#define hkwd_O_CFS_UNPIN        			84
#define hkwd_I_CFS_CONVERTMT    			85
#define hkwd_O_CFS_CONVERTMT    			86
#define hkwd_I_CFS_SETSECATTR   			87
#define hkwd_O_CFS_SETSECATTR   			88
#define hkwd_I_CFS_GETSECATTR   			89
#define hkwd_O_CFS_GETSECATTR   			90
#define hkwd_I_FLGRP_CREATE             		91
#define hkwd_O_FLGRP_CREATE             		92
#define hkwd_I_FLGRP_DESTROY            		93
#define hkwd_O_FLGRP_DESTROY            		94
#define hkwd_I_FLGRP_ALLOCATEATTR       		95
#define hkwd_O_FLGRP_ALLOCATEATTR       		96
#define hkwd_I_FLGRP_HOLD               		97
#define hkwd_O_FLGRP_HOLD               		98
#define hkwd_I_FLGRP_RELE               		99
#define hkwd_O_FLGRP_RELE               		100
#define hkwd_I_FLGRP_FFHOLD             		101
#define hkwd_O_FLGRP_FFHOLD             		102
#define hkwd_I_FLGRP_FFRELE             		103
#define hkwd_O_FLGRP_FFRELE             		104
#define hkwd_I_FLGRP_SYNC               		105
#define hkwd_O_FLGRP_SYNC               		106
#define hkwd_I_FLGRP_READ_METAD         		107
#define hkwd_O_FLGRP_READ_METAD         		108
#define hkwd_I_FLGRP_CREATE_METAD       		109
#define hkwd_O_FLGRP_CREATE_METAD       		110
#define hkwd_I_FLGRP_WRITE_METAD        		111
#define hkwd_O_FLGRP_WRITE_METAD        		112
#define hkwd_I_FLGRP_DESTROY_METAD      		113
#define hkwd_O_FLGRP_DESTROY_METAD      		114
#define hkwd_I_FLGRP_LIST_FIND          		115
#define hkwd_O_FLGRP_LIST_FIND          		116
#define hkwd_I_FLGRP_LIST_ADD           		117
#define hkwd_O_FLGRP_LIST_ADD           		118
#define hkwd_I_FLGRP_LIST_REMOVE        		119
#define hkwd_O_FLGRP_LIST_REMOVE        		120
#define hkwd_I_FLGRP_LIST_GC            		121
#define hkwd_O_FLGRP_LIST_GC            		122
#define hkwd_I_FLGRP_SETUP              		123
#define hkwd_O_FLGRP_SETUP              		124
#define hkwd_I_FLGRP_LIST_EN_CACH_RO    		125
#define hkwd_O_FLGRP_LIST_EN_CACH_RO    		126
#define hkwd_I_FLGRP_LIST_EN_CACH_RW    		127
#define hkwd_O_FLGRP_LIST_EN_CACH_RW    		128
#define hkwd_I_FLGRP_DIR_FIND           		129
#define hkwd_O_FLGRP_DIR_FIND           		130
#define hkwd_I_FLGRP_ATTR_FIND          		131
#define hkwd_O_FLGRP_ATTR_FIND          		132
#define hkwd_I_FLGRP_DIR_CREATE         		133
#define hkwd_O_FLGRP_DIR_CREATE         		134
#define hkwd_I_FLGRP_ATTR_CREATE        		135
#define hkwd_O_FLGRP_ATTR_CREATE        		136
#define hkwd_I_FLGRP_FILENO_TOSLOT      		137
#define hkwd_O_FLGRP_FILENO_TOSLOT      		138
#define hkwd_I_FLGRP_WRITE_SPACE        		139
#define hkwd_O_FLGRP_WRITE_SPACE        		140
#define hkwd_I_CFS_CACHE_CREATE         		141
#define hkwd_O_CFS_CACHE_CREATE         		142
#define hkwd_I_CFS_CACHE_DESTROY        		143
#define hkwd_O_CFS_CACHE_DESTROY        		144
#define hkwd_I_CFS_CACHE_ACTIVERO       		145
#define hkwd_O_CFS_CACHE_ACTIVERO       		146
#define hkwd_I_CFS_CACHE_ACTIVERW       		147
#define hkwd_O_CFS_CACHE_ACTIVERW       		148
#define hkwd_I_CFS_CACHE_DIRTY          		149
#define hkwd_O_CFS_CACHE_DIRTY          		150
#define hkwd_I_CFS_CACHE_RESSYNC        		151
#define hkwd_O_CFS_CACHE_RESSYNC        		152
#define hkwd_I_CFS_CACHE_SYNC           		153
#define hkwd_O_CFS_CACHE_SYNC           		154
#define hkwd_I_CFS_CACHE_UNIQUE         		155
#define hkwd_O_CFS_CACHE_UNIQUE         		156
#define hkwd_I_CFS_CREATE_FFILE         		157
#define hkwd_O_CFS_CREATE_FFILE         		158
#define hkwd_I_CFS_REMOVE_FFILE         		159
#define hkwd_O_CFS_REMOVE_FFILE         		160
#define hkwd_I_CFS_GET_FFILE            		161
#define hkwd_O_CFS_GET_FFILE            		162
#define hkwd_I_CFS_INVAL_OBJ            		163
#define hkwd_O_CFS_INVAL_OBJ            		164
#define hkwd_I_CFS_NOCACHE              		165
#define hkwd_O_CFS_NOCACHE              		166
#define hkwd_I_CFS_CHECK_ALLOCM         		167
#define hkwd_O_CFS_CHECK_ALLOCM         		168
#define hkwd_I_CFS_UPDATE_ALLOCM        		169
#define hkwd_O_CFS_UPDATE_ALLOCM        		170
#define hkwd_I_CFS_POPULATE             		171
#define hkwd_O_CFS_POPULATE             		172
#define hkwd_I_CFS_CLUSTER_ALLOCM       		173
#define hkwd_O_CFS_CLUSTER_ALLOCM       		174
#define hkwd_I_CFS_CSYMLINK             		175
#define hkwd_O_CFS_CSYMLINK             		176
#define hkwd_I_CFS_GETBACKVP            		177
#define hkwd_O_CFS_GETBACKVP            		178
#define hkwd_I_CFS_GETCOOKIE            		179
#define hkwd_O_CFS_GETCOOKIE            		180
#define hkwd_I_CFS_ASYNCSTART           		181
#define hkwd_O_CFS_ASYNCSTART           		182
#define hkwd_I_CFS_ASYNCHALT            		183
#define hkwd_O_CFS_ASYNCHALT            		184
#define hkwd_I_CFS_ADDQUEUE             		185
#define hkwd_O_CFS_ADDQUEUE             		186
#define hkwd_I_CFS_ASYNC_PUTP           		187
#define hkwd_O_CFS_ASYNC_PUTP           		188
#define hkwd_I_CFS_DO_REQ               		189
#define hkwd_O_CFS_DO_REQ               		190
#define hkwd_I_CFS_KMEM_ALLOC           		191
#define hkwd_O_CFS_KMEM_ALLOC           		192
#define hkwd_I_CFS_KMEM_ZALLOC          		193
#define hkwd_O_CFS_KMEM_ZALLOC          		194
#define hkwd_I_CFS_KMEM_FREE            		195
#define hkwd_O_CFS_KMEM_FREE            		196
#define hkwd_I_CFS_KSTAT_SNAP           		197
#define hkwd_O_CFS_KSTAT_SNAP           		198
#define hkwd_I_CFS_CATC                 		199
#define hkwd_O_CFS_CATC                 		200
#define hkwd_I_CFS_GET_CFS_WORK         		201
#define hkwd_O_CFS_GET_CFS_WORK         		202
#define hkwd_I_CFS_THROW_ARGS           		203
#define hkwd_O_CFS_THROW_ARGS           		204
#define hkwd_I_CFS_ADDFREE              		205
#define hkwd_O_CFS_ADDFREE              		206
#define hkwd_I_CFS_REMFREE              		207
#define hkwd_O_CFS_REMFREE              		208
#define hkwd_I_CFS_ADDHASH              		209
#define hkwd_O_CFS_ADDHASH              		210
#define hkwd_I_CFS_REMHASH              		211
#define hkwd_O_CFS_REMHASH              		212
#define hkwd_I_CFS_CFIND                		213
#define hkwd_O_CFS_CFIND                		214
#define hkwd_I_CFS_INACTIVATE           		215
#define hkwd_O_CFS_INACTIVATE           		216
#define hkwd_I_CFS_INITCNODE            		217
#define hkwd_O_CFS_INITCNODE            		218
#define hkwd_I_CFS_MAKECNODE            		219
#define hkwd_O_CFS_MAKECNODE            		220
#define hkwd_I_CFS_MOUNT                		221
#define hkwd_O_CFS_MOUNT                		222
#define hkwd_I_CFS_UNMOUNT              		223
#define hkwd_O_CFS_UNMOUNT              		224
#define hkwd_I_CFS_SYNC                 		225
#define hkwd_O_CFS_SYNC                 		226
#define hkwd_I_CFS_VGET                 		227
#define hkwd_O_CFS_VGET                 		228
#define hkwd_I_CFS_STATVFS              		229
#define hkwd_O_CFS_STATVFS              		230
#define hkwd_CFS_VMM                    		231
#define hkwd_I_CFS_INIT_FID             		240
#define hkwd_O_CFS_INIT_FID             		241
#define hkwd_I_CFS_FID_HASH             		242
#define hkwd_O_CFS_FID_HASH             		243
#define hkwd_I_CFS_ADD_FID              		244
#define hkwd_O_CFS_ADD_FID              		245
#define hkwd_I_CFS_RM_FID_VP            		246
#define hkwd_O_CFS_RM_FID_VP            		247
#define hkwd_I_CFS_RM_FID               		248
#define hkwd_O_CFS_RM_FID               		249
#define hkwd_I_CFS_FIND_FID             		250
#define hkwd_O_CFS_FIND_FID             		251
#define hkwd_I_CFS_PURGE_FID            		252
#define hkwd_O_CFS_PURGE_FID            		253
#define hkwd_CFS_FID                    		254
#define hkwd_CFS_STALE                  		255
#define hkwd_I_CFS_FSCACHE_SETUP        		256
#define hkwd_O_CFS_FSCACHE_SETUP        		257
#define hkwd_I_CFS_CREATE_EDGE          		258
#define hkwd_O_CFS_CREATE_EDGE          		259
#define hkwd_I_CFS_FSCACHE_SYNC         		260
#define hkwd_O_CFS_FSCACHE_SYNC         		261
#define hkwd_I_CFS_FSCACHE_SYNC_UM      		262
#define hkwd_O_CFS_FSCACHE_SYNC_UM      		263
#define hkwd_I_CFS_FLCKINIT             		264
#define hkwd_O_CFS_FLCKINIT             		265
#define hkwd_I_CFS_FLOCK_ALLOC          		266
#define hkwd_O_CFS_FLOCK_ALLOC          		267
#define hkwd_I_CFS_FLOCK_FREE           		268
#define hkwd_O_CFS_FLOCK_FREE           		269
#define hkwd_I_CFS_INS_FLOCK            		270
#define hkwd_O_CFS_INS_FLOCK            		271
#define hkwd_I_CFS_DEL_FLOCK            		272
#define hkwd_O_CFS_DEL_FLOCK            		273
#define hkwd_I_CFS_REG_FLOCK            		274
#define hkwd_O_CFS_REG_FLOCK            		275
#define hkwd_I_CFS_FLOCK_ADJ            		276
#define hkwd_O_CFS_FLOCK_ADJ            		277
#define hkwd_I_CFS_UNLOCKED             		278
#define hkwd_O_CFS_UNLOCKED             		279
#define hkwd_I_CFS_CHK_LOCK             		280
#define hkwd_O_CFS_CHK_LOCK             		281
#define hkwd_I_CFS_BLOCKED              		282
#define hkwd_O_CFS_BLOCKED              		283
#define hkwd_I_CFS_ULCK_ALL             		284
#define hkwd_O_CFS_ULCK_ALL             		285
#define hkwd_I_CFS_RECLOCK              		286
#define hkwd_O_CFS_RECLOCK              		287
#define hkwd_I_CFS_CONVOFF              		288
#define hkwd_O_CFS_CONVOFF              		289
#define hkwd_I_CFS_DEAD_FLOCK           		290
#define hkwd_O_CFS_DEAD_FLOCK           		291
#define hkwd_I_CFS_LCK_WKUP             		292
#define hkwd_O_CFS_LCK_WKUP             		293
#define hkwd_I_CFS_FLOCK_GROW           		294
#define hkwd_O_CFS_FLOCK_GROW           		295
#define hkwd_I_CFS_ASYNCIOSTART         		296
#define hkwd_O_CFS_ASYNCIOSTART         		297
#define hkwd_I_CFS_ADDIOQUEUE           		298
#define hkwd_O_CFS_ADDIOQUEUE           		299
#define hkwd_CFS_MKMNTDEV_EDGE          		300
#define hkwd_I_CFS_VGET_EDGE            		301
#define hkwd_O_CFS_VGET_EDGE            		302
#define hkwd_I_CFS_HOLD_GN_CNT          		303
#define hkwd_O_CFS_HOLD_GN_CNT          		304
#define hkwd_I_CFS_RELE_GN_CNT          		305
#define hkwd_O_CFS_RELE_GN_CNT          		306
#define hkwd_CFS_FSYNC_RANGE            		307
#define hkwd_I_CFS_FSYNC_OFFSET         		308
#define hkwd_O_CFS_FSYNC_OFFSET         		309
#define hkwd_I_CFS_CREATE_EDGE_FID      		310
#define hkwd_O_CFS_CREATE_EDGE_FID      		311
#define hkwd_I_CFS_FID_EDGE             		312
#define hkwd_O_CFS_FID_EDGE             		313
#define hkwd_CFS_UNLOCK                 		314
#define hkwd_I_CFS_HANDLE_ULCK          		315
#define hkwd_O_CFS_HANDLE_ULCK          		316
#define hkwd_I_CFS_HANDLE_LCK_T         		317
#define hkwd_O_CFS_HANDLE_LCK_T         		318
#define hkwd_I_CFS_FINFO                		319
#define hkwd_O_CFS_FINFO                		320
#define hkwd_CFS_WRITE_LCK              		321
#define hkwd_CFS_WRITE_ULCK             		322
#define hkwd_I_CFS_WRITE_FID_EDGE       		323
#define hkwd_O_CFS_WRITE_FID_EDGE       		324
#define hkwd_I_CFS_LAST_CLOSE           		325
#define hkwd_O_CFS_LAST_CLOSE           		326
#define hkwd_I_CFS_ADD_PROXY_FILE       		327
#define hkwd_O_CFS_ADD_PROXY_FILE       		328
#define hkwd_I_CFS_RM_PROXY_FILE        		329
#define hkwd_O_CFS_RM_PROXY_FILE        		330
#define hkwd_I_CFS_PURGE_PROXY_FILE     		331
#define hkwd_O_CFS_PURGE_PROXY_FILE     		332
#define hkwd_I_CFS_INIT_PROXY_FILE      		333
#define hkwd_O_CFS_INIT_PROXY_FILE      		334
#define hkwd_I_CFS_FILL_PROXY_FILE      		335
#define hkwd_O_CFS_FILL_PROXY_FILE      		336
#define hkwd_I_CFS_INS_PROXY_FILE       		337
#define hkwd_O_CFS_INS_PROXY_FILE       		338
#define hkwd_I_CFS_CREATE_EDGE_STRUCT   		339
#define hkwd_O_CFS_CREATE_EDGE_STRUCT   		340
#define hkwd_I_CFS_GET_FSCACHE          		341
#define hkwd_O_CFS_GET_FSCACHE          		342
#define hkwd_I_CFS_GET_PARTIAL_EDGE     		343
#define hkwd_O_CFS_GET_PARTIAL_EDGE     		344
#define hkwd_I_CFS_COMMIT_AIX           		345
#define hkwd_O_CFS_COMMIT_AIX           		346
#define hkwd_I_CFS_COMMIT               		347
#define hkwd_O_CFS_COMMIT               		348
#define hkwd_I_CFS_GETBACKVP_NOCNODE    		349
#define hkwd_O_CFS_GETBACKVP_NOCNODE    		350
#define hkwd_I_CFS_MAP_LLOFF            		351
#define hkwd_O_CFS_MAP_LLOFF            		352

#define PV_HKWD_AUTOFS          			0x3B000000
#define hkwd_AuFS_MOUNT                 		1
#define hkwd_AuFS_MOUNT_ARGSZ           		2
#define hkwd_AuFS_MOUNT_ERROUT          		3
#define hkwd_AuFS_MOUNT_EXIT            		4
#define hkwd_AuFS_MOUNT_PREM            		5
#define hkwd_AuFS_UNMOUNT               		6
#define hkwd_AuFS_UNMOUNT_EXIT          		7
#define hkwd_AuFS_UNMOUNT_PERM          		8
#define hkwd_AuFS_UNMOUNT_VCOUNT        		9
#define hkwd_I_AuFS_ACCESS              		10
#define hkwd_I_AuFS_AUTODIR_LOOKUP      		11
#define hkwd_I_AuFS_AUTO_DIRENTER       		12
#define hkwd_I_AuFS_BUSY                		13
#define hkwd_I_AuFS_CALL_AUTOMOUNTD     		14
#define hkwd_I_AuFS_CREATE              		15
#define hkwd_I_AuFS_DO_MOUNT            		16
#define hkwd_I_AuFS_DO_UNMOUNT          		17
#define hkwd_I_AuFS_FORCE_REMOUNT       		18
#define hkwd_I_AuFS_FREEAUTONODE        		19
#define hkwd_I_AuFS_GETATTR             		20
#define hkwd_I_AuFS_GET_HIER_MOUNTS     		21
#define hkwd_I_AuFS_INACTIVE            		22
#define hkwd_I_AuFS_LOOKUP_ENTRY        		23
#define hkwd_I_AuFS_LOOKUP_INFO         		24
#define hkwd_I_AuFS_MAKEAUTONODE        		25
#define hkwd_I_AuFS_MAKE_UNMOUNTED_L    		26
#define hkwd_I_AuFS_MKDIR               		27
#define hkwd_I_AuFS_READDIR             		28
#define hkwd_I_AuFS_REMOVE              		29
#define hkwd_I_AuFS_RENAME              		30
#define hkwd_I_AuFS_RMDIR               		31
#define hkwd_I_AuFS_RM_AUTONODE         		32
#define hkwd_I_AuFS_RM_HIERARCHY        		33
#define hkwd_I_AuFS_RWLOCK              		34
#define hkwd_I_AuFS_SEND_UNMOUNT_REQ    		35
#define hkwd_I_AuFS_SYMLINK             		36
#define hkwd_I_AuFS_UNMOUNT_HIERARCHY   		37
#define hkwd_I_AuFS_XDR_UMOUNTR         		38
#define hkwd_O_AuFS_ACCESS_BAD          		39
#define hkwd_O_AuFS_ACCESS_OK           		40
#define hkwd_O_AuFS_AUTODIR_LOOKUP      		41
#define hkwd_O_AuFS_AUTO_DIRENTER       		42
#define hkwd_O_AuFS_BUSY                		43
#define hkwd_O_AuFS_CALL_AUTOMOUNTD     		44
#define hkwd_O_AuFS_CREATE_EXIT         		45
#define hkwd_O_AuFS_CREATE_NO_VFS       		46
#define hkwd_O_AuFS_CREATE_VFS_ROOT     		47
#define hkwd_O_AuFS_DO_MOUNT            		48
#define hkwd_O_AuFS_DO_UNMOUNT          		49
#define hkwd_O_AuFS_FORCE_REMOUNT       		50
#define hkwd_O_AuFS_FREEAUTONODE        		51
#define hkwd_O_AuFS_GETATTR             		52
#define hkwd_O_AuFS_GET_HIER_MOUNTS     		53
#define hkwd_O_AuFS_INACTIVE_EXIT       		54
#define hkwd_O_AuFS_INACTIVE_VCOUNT     		55
#define hkwd_O_AuFS_LOOKUP_ANDIR        		56
#define hkwd_O_AuFS_LOOKUP_ENOSYS       		57
#define hkwd_O_AuFS_LOOKUP_EXIT         		58
#define hkwd_O_AuFS_LOOKUP_INTR         		59
#define hkwd_O_AuFS_LOOKUP_MNT          		60
#define hkwd_O_AuFS_LOOKUP_MNTERR       		61
#define hkwd_O_AuFS_LOOKUP_OK_DOT       		62
#define hkwd_O_AuFS_LOOKUP_OK_DOTDOT    		63
#define hkwd_O_AuFS_LOOKUP_SPMKDIR      		64
#define hkwd_O_AuFS_LOOKUP_UMINTR       		65
#define hkwd_O_AuFS_LOOKUP_VFSROOT      		66
#define hkwd_O_AuFS_LOOKUP_VFSROOT_1    		67
#define hkwd_O_AuFS_LOOKUP_VOPACC       		68
#define hkwd_O_AuFS_LOOKUP_VOPLKU       		69
#define hkwd_O_AuFS_LOOKUP_VOPLKU_1     		70
#define hkwd_O_AuFS_MAKEAUTONODE        		71
#define hkwd_O_AuFS_MAKE_UNMOUNTED_L    		72
#define hkwd_O_AuFS_MKDIR_DOT           		73
#define hkwd_O_AuFS_MKDIR_EXIT          		74
#define hkwd_O_AuFS_MKDIR_LOOKUP        		75
#define hkwd_O_AuFS_MKDIR_NOTSPECIAL    		76
#define hkwd_O_AuFS_MKDIR_VACC          		77
#define hkwd_O_AuFS_MKDIR_VFS_ROOT      		78
#define hkwd_O_AuFS_READDIR_EXIT        		79
#define hkwd_O_AuFS_READDIR_INTR        		80
#define hkwd_O_AuFS_READDIR_IOVCNT      		81
#define hkwd_O_AuFS_READDIR_MNT         		82
#define hkwd_O_AuFS_READDIR_VFSROOT     		83
#define hkwd_O_AuFS_READDIR_VRDIR       		84
#define hkwd_O_AuFS_READDIR_WAITMNT     		85
#define hkwd_O_AuFS_REMOVE_EXIT         		86
#define hkwd_O_AuFS_REMOVE_NO_VFS       		87
#define hkwd_O_AuFS_REMOVE_VFS_ROOT     		88
#define hkwd_O_AuFS_RENAME_EXIT         		89
#define hkwd_O_AuFS_RENAME_NO_VFS       		90
#define hkwd_O_AuFS_RENAME_VFS_ROOT1    		91
#define hkwd_O_AuFS_RENAME_VFS_ROOT2    		92
#define hkwd_O_AuFS_RMDIR_BAD           		93
#define hkwd_O_AuFS_RMDIR_DOT           		94
#define hkwd_O_AuFS_RMDIR_DOTDOT        		95
#define hkwd_O_AuFS_RMDIR_EXIT          		96
#define hkwd_O_AuFS_RMDIR_LKUP          		97
#define hkwd_O_AuFS_RMDIR_NOTSPECIAL    		98
#define hkwd_O_AuFS_RMDIR_VFS_ROOT      		99
#define hkwd_O_AuFS_RMDIR_VRMDIR        		100
#define hkwd_O_AuFS_RM_AUTONODE         		101
#define hkwd_O_AuFS_RM_HIERARCHY        		102
#define hkwd_O_AuFS_RWLOCK              		103
#define hkwd_O_AuFS_SEND_UNMOUNT_REQ    		104
#define hkwd_O_AuFS_SYMLINK_EXIT        		105
#define hkwd_O_AuFS_SYMLINK_NO_VFS      		106
#define hkwd_O_AuFS_SYMLINK_VFS_ROOT    		107
#define hkwd_O_AuFS_UNMOUNT_HIERARCHY   		108
#define hkwd_O_AuFS_XDR_UMOUNTR         		109
#define hkwd_AuFS_INKER_MOUNT           		110
#define hkwd_AuFS_INKER_MOUNT_ROOT      		111
#define hkwd_AuFS_INKER_VFS_MOUNT       		112
#define hkwd_AuFS_INKER_MOUNT_EXIT      		113
#define hkwd_AuFS_INKER_MOUNT_PERM      		114
#define hkwd_AuFS_AUTOFS_TEST2          		115
#define hkwd_AuFS_MOUNT_ERROR           		116
#define hkwd_AuFS_UNMOUNT_BUSY          		117
#define hkwd_AuFS_ROOT                  		118
#define hkwd_AuFS_STATVFS               		119
#define hkwd_AuFS_MOUNT_PERM            		120
#define hkwd_AuFS_SYMLINK               		122
#define hkwd_AuFS_SYMLINK_DONE          		123
#define hkwd_AuFS_READLINK_DONE         		124
#define hkwd_AuFS_INACTIVE              		125
#define hkwd_AuFS_INACTIVE_DONE         		126
#define hkwd_AuFS_TRIG_MOUNT            		127
#define hkwd_AuFS_TRIG_MOUNT_DONE       		128
#define hkwd_AuFS_SETATTR               		129
#define hkwd_AuFS_SETATTR_DONE          		130
#define hkwd_AuFS_ACCESS                		131
#define hkwd_AuFS_ACCESS_DONE           		132
#define hkwd_AuFS_LOOKUP                		133
#define hkwd_AuFS_LOOKUP_TOP            		134
#define hkwd_AuFS_LOOKUP_EXIT           		135
#define hkwd_AuFS_CREATE                		136
#define hkwd_AuFS_CREATE_DONE           		137
#define hkwd_AuFS_REMOVE                		138
#define hkwd_AuFS_REMOVE_DONE           		139
#define hkwd_AuFS_LINK                  		140
#define hkwd_AuFS_LINK_DONE             		141
#define hkwd_AuFS_RENAME                		142
#define hkwd_AuFS_RENAME_DONE           		143
#define hkwd_AuFS_MKDIR                 		144
#define hkwd_AuFS_MKDIR_DONE            		145
#define hkwd_AuFS_RMDIR                 		146
#define hkwd_AuFS_RMDIR_DONE            		147
#define hkwd_AuFS_READDIR               		148
#define hkwd_AuFS_READDIR_EINVAL        		149
#define hkwd_AuFS_READDIR_DONE          		150
#define hkwd_AuFS_POLL                  		151
#define hkwd_AuFS_PATHCONF              		152
#define hkwd_AuFS_OPEN                  		153
#define hkwd_AuFS_GETATTR               		154
#define hkwd_AuFS_GETATTR_DONE          		155
#define hkwd_AuFS_READLINK              		156
#define hkwd_AuFS_FREEFNNODE            		157
#define hkwd_AuFS_FREEFNNODE_DONE       		158
#define hkwd_AuFS_DISCONNECT            		159
#define hkwd_AuFS_DISCONNECT_DONE       		160
#define hkwd_AuFS_ENTER                 		161
#define hkwd_AuFS_ENTER_DONE            		162
#define hkwd_AuFS_SEARCH                		163
#define hkwd_AuFS_SEARCH_DONE           		164
#define hkwd_AuFS_GETMNTPNT             		165
#define hkwd_AuFS_GETMNTPNT_DONE        		166
#define hkwd_AuFS_INKER_UMOUNT          		167
#define hkwd_AuFS_INKER_UMOUNT_DONE     		168
#define hkwd_AuFS_TRIGGERS              		169
#define hkwd_AuFS_TRIGGERS_BUSY         		170
#define hkwd_AuFS_TRIGGERS_BUSY_DONE    		171
#define hkwd_AuFS_TRIGGERS_DONE         		172
#define hkwd_AuFS_UNMOUNT_NODE          		173
#define hkwd_AuFS_UNMOUNT_NODE_DONE     		174
#define hkwd_AuFS_AUTO_NODE             		175
#define hkwd_AuFS_AUTO_NODE_DONE        		176
#define hkwd_AuFS_UNMOUNT_ROOT          		177
#define hkwd_AuFS_UNMOUNT_ROOT_DONE     		178
#define hkwd_AuFS_UNMOUNT_TREE_NAME     		180
#define hkwd_AuFS_UNMOUNT_TREE_DONE     		181
#define hkwd_AuFS_DO_UNMOUNT            		182
#define hkwd_AuFS_UNMOUNT_THREAD        		183
#define hkwd_AuFS_UNMOUNT_THR_FAIL      		184
#define hkwd_AuFS_NULL_REQ              		185
#define hkwd_AuFS_NULL_REQ_DONE         		186
#define hkwd_AuFS_LOOKUP_REQ            		187
#define hkwd_AuFS_LOOKUP_REQ_DONE       		188
#define hkwd_AuFS_MOUNT_REQ             		189
#define hkwd_AuFS_MOUNT_REQ_DONE        		190
#define hkwd_AuFS_POSTMOUNT_REQ         		191
#define hkwd_AuFS_POSTMOUNT_REQ_DONE    		192
#define hkwd_AuFS_SEND_UMOUNT_REQ       		193
#define hkwd_AuFS_SEND_UMOUNT_REQ_DONE  		194
#define hkwd_AuFS_POST_UMOUNT_REQ       		195
#define hkwd_AuFS_POST_UMOUNT_REQ_DONE  		196
#define hkwd_AuFS_PERFORM_ACT           		197
#define hkwd_AuFS_PERFORM_ACT_DONE      		198
#define hkwd_AuFS_PERFORM_LINK          		199
#define hkwd_AuFS_DO_UNMOUNT_THR_FAIL   		200
#define hkwd_AuFS_WAIT4MOUNT            		201
#define hkwd_AuFS_WAIT4MOUNT_DONE       		202
#define hkwd_AuFS_LOOKUP_AUX            		203
#define hkwd_AuFS_LOOKUP_AUX_DONE       		204
#define hkwd_AuFS_MOUNT_THREAD          		205
#define hkwd_AuFS_MOUNT_THREAD_STOP     		206
#define hkwd_AuFS_NEW_MOUNT_THREAD      		207
#define hkwd_AuFS_NEW_MOUNT_THREAD_DONE 		208
#define hkwd_AuFS_CALLDEAMON            		209
#define hkwd_AuFS_CALLDEAMONPORT        		210
#define hkwd_AuFS_CALLDEAMON_ENOENT     		211
#define hkwd_AuFS_CALLDEAMON_DONE       		212
#define hkwd_AuFS_POSTUMOUNT_REQ        		213
#define hkwd_AuFS_POSTUMOUNT_REQ_DONE   		214
#define hkwd_AuFS_UNMOUNT_TREE          		215
#define hkwd_AuFS_START_UM_THR          		216
#define hkwd_AuFS_FREEFNNODE2           		217
#define hkwd_AuFS_UNMOUNT_ROOT2         		218
#define hkwd_AuFS_INACTIVE2             		219
#define hkwd_AuFS_INACTIVE3             		220
#define hkwd_AuFS_HOLD                  		221
#define hkwd_AuFS_RELE                  		222
#define hkwd_AuFS_UNMOUNT2              		223
#define hkwd_AuFS_VMNT_INIT             		224
#define hkwd_AuFS_PATH_NAME             		225
#define hkwd_AuFS_CLNT                  		226
#define hkwd_AuFS_RELE_EXIT             		227
#define hkwd_AuFS_PATHCONF_DONE         		228
#define hkwd_AuFS_OPEN_DONE             		229
#define hkwd_AuFS_CHECK_ACCESS          		230
#define hkwd_AuFS_TRIGGERS_UNLOCK       		231
#define hkwd_AuFS_CHECK_DIRENT_MNTED    		232

#define PV_HKWD_ECPDD          				0x3B500000
#define PV_HKWD_ECPDD_PRTCL           			0x3B600000
#define PV_HKWD_DD_FCDD           			0x3B900000
#define PV_HKWD_ECPSND          			0x3C100000
#define PV_HKWD_ECPRCV           			0x3C200000
#define PV_HKWD_DD_FCPS         			0x3C400000
#define PV_HKWD_ECP_ODATA           			0x3E300000
#define PV_HKWD_ECP_IDATA           			0x3E400000
#define PV_HKWD_VLAN_XMIT           			0x3FD00000
#define PV_HKWD_VLAN_RECV           			0x3FE00000
#define PV_HKWD_VLAN_OTHER           			0x3FF00000
#define PV_HKWD_DD_SSAADAPDD           			0x45A00000
#define PV_HKWD_DD_SSADISKDD           			0x45B00000
#define PV_HKWD_ISCSISW         			0x46F00000
#define PV_HKWD_SCENT_XMIT           			0x47000000
#define PV_HKWD_SCENT_RECV           			0x47100000
#define PV_HKWD_SCENT_OTHER           			0x47200000
#define PV_HKWD_GOENT_XMIT           			0x47300000
#define PV_HKWD_GOENT_RECV           			0x47400000
#define PV_HKWD_GOENT_OTHER           			0x47500000
#define PV_HKWD_DD_QLISCDD           			0x47900000
#define PV_HKWD_DD_QLISCSIDD           			0x47A00000
#define PV_HKWD_DD_SC2DISKDD_ERR           		0x47E00000

#define PV_HKWD_RPCSECCLIENT           			0x48200000
#define hkwd_rpcsecclient_nomem              		1
#define hkwd_rpcsecclient_notbuilding        		2
#define hkwd_rpcsecclient_alreadybuilding    		3
#define hkwd_rpcsecclient_alreadyincache     		4
#define hkwd_rpcsecclient_mustrestart        		5
#define hkwd_rpcsecclient_mustwait           		6
#define hkwd_rpcsecclient_rpccall            		7
#define hkwd_rpcsecclient_nullhandle         		8
#define hkwd_rpcsecclient_refreshing         		9
#define hkwd_rpcsecclient_xdrfailed         		10
#define hkwd_rpcsecclient_badseq            		11
#define hkwd_rpcsecclient_getmic            		12
#define hkwd_rpcsecclient_vermic            		13
#define hkwd_rpcsecclient_wrap              		14
#define hkwd_rpcsecclient_unwrap            		15
#define hkwd_rpcsecclient_gssinit           		16
#define hkwd_rpcsecclient_servreply         		17

#define PV_HKWD_RPCSECSERVER           			0x48300000
#define hkwd_rpcsecserver_begingetfreeentry  		1
#define hkwd_rpcsecserver_freeentryfromlist  		2
#define hkwd_rpcsecserver_freeentryfromidle  		3
#define hkwd_rpcsecserver_freeentryfromalloc 		4
#define hkwd_rpcsecserver_freeentryfrompurge 		5
#define hkwd_rpcsecserver_nofreeentries      		6
#define hkwd_rpcsecserver_fillcredfailed     		7
#define hkwd_rpcsecserver_buildrventry       		8
#define hkwd_rpcsecserver_replytoolong       		9
#define hkwd_rpcsecserver_verifyhentry      		10
#define hkwd_rpcsecserver_credtooshort      		11
#define hkwd_rpcsecserver_badhandle         		12
#define hkwd_rpcsecserver_credtoolong       		13
#define hkwd_rpcsecserver_badseqnum         		14
#define hkwd_rpcsecserver_nomem             		15
#define hkwd_rpcsecserver_xdrfailed         		16
#define hkwd_rpcsecserver_seqnumdrop        		17
#define hkwd_rpcsecserver_integreply        		18
#define hkwd_rpcsecserver_privacyreply      		19
#define hkwd_rpcsecserver_rpcsecdata        		20
#define hkwd_rpcsecserver_badreqlen         		21
#define hkwd_rpcsecserver_seqnummatch       		22
#define hkwd_rpcsecserver_setargsfailed     		23
#define hkwd_rpcsecserver_rpcsecinit        		24
#define hkwd_rpcsecserver_nocontext         		25
#define hkwd_rpcsecserver_contextcomplete   		26
#define hkwd_rpcsecserver_rpcsecdestroy     		27
#define hkwd_rpcsecserver_gotrequest        		28
#define hkwd_rpcsecserver_getmicfailed      		29
#define hkwd_rpcsecserver_verifymicfailed   		30
#define hkwd_rpcsecserver_wrapfailed        		31
#define hkwd_rpcsecserver_unwrapfailed      		32
#define hkwd_rpcsecserver_acceptfailed      		33
#define hkwd_rpcsecserver_badverf           		34

#define PV_HKWD_GSSD           				0x48400000
#define hkwd_GSSD_ACQUIRECRED_ENTER     		1
#define hkwd_GSSD_ACQUIRECRED_EXIT      		2
#define hkwd_GSSD_ADDCRED_ENTER         		3
#define hkwd_GSSD_ADDCRED_EXIT          		4
#define hkwd_GSSD_RELEASECRED_ENTER     		5
#define hkwd_GSSD_RELEASECRED_EXIT      		6
#define hkwd_GSSD_INITCONTEXT_ENTER     		7
#define hkwd_GSSD_INITCONTEXT_EXIT      		8
#define hkwd_GSSD_ACCEPTCONTEXT_ENTER   		9
#define hkwd_GSSD_ACCEPTCONTEXT_EXIT    		10
#define hkwd_GSSD_DELETECONTEXT_ENTER   		11
#define hkwd_GSSD_DELETECONTEXT_EXIT    		12
#define hkwd_GSSD_EXPORTCONTEXT_ENTER   		13
#define hkwd_GSSD_EXPORTCONTEXT_EXIT    		14
#define hkwd_GSSD_GETMIC_ENTER          		15
#define hkwd_GSSD_GETMIC_EXIT           		16
#define hkwd_GSSD_VERIFYMIC_ENTER       		17
#define hkwd_GSSD_VERIFYMIC_EXIT        		18
#define hkwd_GSSD_WRAP_ENTER            		19
#define hkwd_GSSD_WRAP_EXIT             		20
#define hkwd_GSSD_UNWRAP_ENTER          		21
#define hkwd_GSSD_UNWRAP_EXIT           		22
#define hkwd_GSSD_INQUIRECRED_ENTER     		23
#define hkwd_GSSD_INQUIRECRED_EXIT      		24
#define hkwd_GSSD_CREDENTIAL            		25
#define hkwd_GSSD_CONTEXT               		26
#define hkwd_GSSD_IMPORTCONTEXT_ENTER   		27
#define hkwd_GSSD_IMPORTCONTEXT_EXIT    		28

#define PV_HKWD_KGSS           				0x48500000

#define PV_HKWD_NFS_SYSCALL           			0x48700000
#define hkwd_EXPORT_ENTER       			0x01
#define hkwd_EXPORT_EXIT        			0x02
#define hkwd_GETFH_ENTER        			0x03
#define hkwd_GETFH_EXIT         			0x04

#define PV_HKWD_NFS4_VOPS           			0x48800000
#define hkwd_NFS4_LINK                  		1
#define hkwd_NFS4_MKDIR                 		2
#define hkwd_NFS4_MKNOD                 		3
#define hkwd_NFS4_REMOVE                		4
#define hkwd_NFS4_RENAME                		5
#define hkwd_NFS4_RMDIR                 		6
#define hkwd_NFS4_LOOKUP                		7
#define hkwd_NFS4_FID                   		8
#define hkwd_NFS4_OPEN                  		9
#define hkwd_NFS4_CREATE                		10
#define hkwd_NFS4_HOLD                  		11
#define hkwd_NFS4_RELE                  		12
#define hkwd_NFS4_CLOSE                 		13
#define hkwd_NFS4_MAP                   		14
#define hkwd_NFS4_UNMAP                 		15
#define hkwd_NFS4_ACCESS                		16
#define hkwd_NFS4_GETATTR               		17
#define hkwd_NFS4_SETATTR               		18
#define hkwd_NFS4_FCLEAR                		19
#define hkwd_NFS4_FSYNC                 		20
#define hkwd_NFS4_FTRUNC                		21
#define hkwd_NFS4_RDWR                  		22
#define hkwd_NFS4_READ                  		23
#define hkwd_NFS4_WRITE                 		24
#define hkwd_NFS4_LOCKCTL               		25
#define hkwd_NFS4_IOCTL                 		26
#define hkwd_NFS4_READLINK              		27
#define hkwd_NFS4_SELECT                		28
#define hkwd_NFS4_SYMLINK               		29
#define hkwd_NFS4_READDIR               		30
#define hkwd_NFS4_STRATEGY              		31
#define hkwd_NFS4_REVOKE                		32
#define hkwd_NFS4_GETACL                		33
#define hkwd_NFS4_SETACL                		34
#define hkwd_NFS4_GETPCL                		35
#define hkwd_NFS4_SETPCL                		36
#define hkwd_NFS4_SEEK                  		37
#define hkwd_NFS4_FSYNC_RANGE           		38
#define hkwd_NFS4_CREATE_ATTR           		39
#define hkwd_NFS4_FINFO                 		40
#define hkwd_NFS4_MAP_LLOFF             		41
#define hkwd_NFS4_READDIR_EOFP          		42
#define hkwd_NFS4_RDWR_ATTR             		43
#define hkwd_NFS4_MEMCNTL               		44
#define hkwd_NFS4_CHECK_ACCESS          		45
#define hkwd_NFS4_UPDATE_ACCESS         		46
#define hkwd_NFS4_SETATTR2              		47
#define hkwd_NFS4_ACCESS_MISS           		48
#define hkwd_NFS4_ACCESS_EXPIRED        		49
#define hkwd_NFS4_DNLC_MISS             		50
#define hkwd_NFS4_LOOKUP1               		51
#define hkwd_NFS4_WRITERP               		52
#define hkwd_NFS4_COMMIT                		53
#define hkwd_NFS4_NFS4WRITE             		54
#define hkwd_NFS4_COPY_MBUF             		55
#define hkwd_NFS4_NFS4READ              		56
#define hkwd_NFS4_READ_NC               		57
#define hkwd_NFS4_READLINK_CACHED       		58
#define hkwd_NFS4_NFS4READLINK          		59
#define hkwd_NFS4_DO_NFS4READDIR        		60
#define hkwd_NFS4_RWLOCK                		61
#define hkwd_NFS4_RWUNLOCK              		62
#define hkwd_NFS4_INACTIVE              		63
#define hkwd_NFS4_NFS4CREATE            		64
#define hkwd_NFS4_BP_COMMIT             		65
#define hkwd_NFS4_BIO                   		66
#define hkwd_NFS4_BMAP                  		67
#define hkwd_NFS4_NFS4RENAME            		68
#define hkwd_NFS4_IO_STATEID            		69
#define hkwd_NFS4_GETXACL               		70
#define hkwd_NFS4_SETXACL               		71
#define hkwd_NFS4_EIO                   		72
#define hkwd_NFS4_NFS4RENAME_OTW        		73

#define PV_HKWD_NFS4_VFSOPS           			0x48900000
#define hkwd_NFS4_LINK                  		1
#define hkwd_NFS4_MKDIR                 		2
#define hkwd_NFS4_MKNOD                 		3
#define hkwd_NFS4_REMOVE                		4
#define hkwd_NFS4_RENAME                		5
#define hkwd_NFS4_RMDIR                 		6
#define hkwd_NFS4_LOOKUP                		7
#define hkwd_NFS4_FID                   		8
#define hkwd_NFS4_OPEN                  		9
#define hkwd_NFS4_CREATE                		10
#define hkwd_NFS4_HOLD                  		11
#define hkwd_NFS4_RELE                  		12
#define hkwd_NFS4_CLOSE                 		13
#define hkwd_NFS4_MAP                   		14
#define hkwd_NFS4_UNMAP                 		15
#define hkwd_NFS4_ACCESS                		16
#define hkwd_NFS4_GETATTR               		17
#define hkwd_NFS4_SETATTR               		18
#define hkwd_NFS4_FCLEAR                		19
#define hkwd_NFS4_FSYNC                 		20
#define hkwd_NFS4_FTRUNC                		21
#define hkwd_NFS4_RDWR                  		22
#define hkwd_NFS4_READ                  		23
#define hkwd_NFS4_WRITE                 		24
#define hkwd_NFS4_LOCKCTL               		25
#define hkwd_NFS4_IOCTL                 		26
#define hkwd_NFS4_READLINK              		27
#define hkwd_NFS4_SELECT                		28
#define hkwd_NFS4_SYMLINK               		29
#define hkwd_NFS4_READDIR               		30
#define hkwd_NFS4_STRATEGY              		31
#define hkwd_NFS4_REVOKE                		32
#define hkwd_NFS4_GETACL                		33
#define hkwd_NFS4_SETACL                		34
#define hkwd_NFS4_GETPCL                		35
#define hkwd_NFS4_SETPCL                		36
#define hkwd_NFS4_SEEK                  		37
#define hkwd_NFS4_FSYNC_RANGE           		38
#define hkwd_NFS4_CREATE_ATTR           		39
#define hkwd_NFS4_FINFO                 		40
#define hkwd_NFS4_MAP_LLOFF             		41
#define hkwd_NFS4_READDIR_EOFP          		42
#define hkwd_NFS4_RDWR_ATTR             		43
#define hkwd_NFS4_MEMCNTL               		44
#define hkwd_NFS4_CHECK_ACCESS          		45
#define hkwd_NFS4_UPDATE_ACCESS         		46
#define hkwd_NFS4_SETATTR2              		47
#define hkwd_NFS4_ACCESS_MISS           		48
#define hkwd_NFS4_ACCESS_EXPIRED        		49
#define hkwd_NFS4_DNLC_MISS             		50
#define hkwd_NFS4_LOOKUP1               		51
#define hkwd_NFS4_WRITERP               		52
#define hkwd_NFS4_COMMIT                		53
#define hkwd_NFS4_NFS4WRITE             		54
#define hkwd_NFS4_COPY_MBUF             		55
#define hkwd_NFS4_NFS4READ              		56
#define hkwd_NFS4_READ_NC               		57
#define hkwd_NFS4_READLINK_CACHED       		58
#define hkwd_NFS4_NFS4READLINK          		59
#define hkwd_NFS4_DO_NFS4READDIR        		60
#define hkwd_NFS4_RWLOCK                		61
#define hkwd_NFS4_RWUNLOCK              		62
#define hkwd_NFS4_INACTIVE              		63
#define hkwd_NFS4_NFS4CREATE            		64
#define hkwd_NFS4_BP_COMMIT             		65
#define hkwd_NFS4_BIO                   		66
#define hkwd_NFS4_BMAP                  		67
#define hkwd_NFS4_NFS4RENAME            		68
#define hkwd_NFS4_IO_STATEID            		69
#define hkwd_NFS4_GETXACL               		70
#define hkwd_NFS4_SETXACL               		71
#define hkwd_NFS4_EIO                   		72
#define hkwd_NFS4_NFS4RENAME_OTW        		73

#define PV_HKWD_NFS4_MISCOPS           			0x48A00000
#define hkwd_NFS4_GET_UID_GID            		1
#define hkwd_NFS4_GET_USER_GROUP_NAME    		2
#define hkwd_NFS4_UPDATE_TIME            		3
#define hkwd_NFS4_TO_VATTR               		4
#define hkwd_NFS4_TO_FATTR4              		5
#define hkwd_NFS4_CACHE_CHECK            		6
#define hkwd_NFS4_NULL_ATTR              		7
#define hkwd_NFS4_ATTRCACHE              		8
#define hkwd_NFS4_POST_OP_ATTR           		9
#define hkwd_NFS4_VALIDATE_CACHES       		10
#define hkwd_NFS4_ADDLIST4              		11
#define hkwd_NFS4_RMLIST4               		12
#define hkwd_NFS4_N4STHREAD             		13
#define hkwd_NFS4_NFS4SYNC              		14
#define hkwd_NFS4_NFS4SYNC_K            		15
#define hkwd_NFS4_NFS4GETATTR           		16
#define hkwd_NFS4_CHECK_DIR_CACHE       		17
#define hkwd_NFS4_NFS4TSIZE             		18
#define hkwd_NFS4_TO_UNIX               		19
#define hkwd_NFS4_GETERRNO4             		20
#define hkwd_NFS4_INIT_ARGS             		21
#define hkwd_NFS4_PUT_MASK              		22
#define hkwd_NFS4_ADD_PUTFH             		23
#define hkwd_NFS4_ADD_NVERIFY           		24
#define hkwd_NFS4_ADD_GETATTR           		25
#define hkwd_NFS4_GETSEC                		26
#define hkwd_NFS4_FH4FREE               		27
#define hkwd_NFS4_FH4CMP                		28
#define hkwd_NFS4_RFIND4                		29
#define hkwd_NFS4_PATH4_TO_STR          		30
#define hkwd_NFS4_STRDUP4               		31
#define hkwd_NFS4_PATH4_CMP             		32
#define hkwd_NFS4_FS_LOC4               		33
#define hkwd_NFS4_GET_FSID              		34
#define hkwd_NFS4_MAKE_RNODE4           		35
#define hkwd_NFS4_LOOKUP_PATH           		36
#define hkwd_NFS4_MAKENFS4NODE          		37
#define hkwd_NFS4_RFS4CALL              		38
#define hkwd_NFS4_ADD_SETATTR           		39
#define hkwd_NFS4_HAS_ATTR4             		40
#define hkwd_NFS4_RM_ATTR4              		41
#define hkwd_NFS4_ADD_ATTR4             		42
#define hkwd_NFS4_EXPIREDFH             		43
#define hkwd_NFS4_PUT_SLASHES           		44
#define hkwd_NFS4_PATHLOOKUP            		45
#define hkwd_NFS4_FREE_F_LOC            		46
#define hkwd_NFS4_RELEASE_FSID          		47
#define hkwd_NFS4_PUT_WORK              		48
#define hkwd_NFS4_GET_WORK              		49
#define hkwd_NFS4_PUTFH_WRONGSEC        		50
#define hkwd_NFS4_VMM_INIT4             		51
#define hkwd_NFS4_REMOVE_FSID_SEARCH    		52
#define hkwd_NFS4_FIND_FSID             		53
#define hkwd_NFS4_UPDATE_OPTS           		54
#define hkwd_NFS4_SET_N4INFO            		55
#define hkwd_NFS4_TO_OPTS               		56
#define hkwd_NFS4_CP_OUT_FS_LOC         		57
#define hkwd_NFS4_CP_OUT_STR            		58
#define hkwd_NFS4_CP_OUT                		59
#define hkwd_NFS4_SIZE_ERROR            		60
#define hkwd_NFS4_INFO                  		61
#define hkwd_NFS4_CACHE_ATTR_OTW_RESULT 		62
#define hkwd_NFS4_GET_ROOT              		63
#define hkwd_NFS4_RM_WORK               		64
#define hkwd_NFS4_ERRORS                		65
#define hkwd_NFS4_FSID_HOLD             		66
#define hkwd_NFS4_FSID_RELE             		67
#define hkwd_NFS4_GET_SYMLINK_FH        		68
#define hkwd_NFS4_LOOKUP_FH             		69
#define hkwd_NFS4_HANDLE_PN_SYMLINK     		70
#define hkwd_NFS4_GETATTR_FH            		71
#define hkwd_NFS4_LOOKUP_ROOTFH         		72
#define hkwd_NFS4_ALLOC_GAP             		73
#define hkwd_NFS4_FREE_GAP_LIST         		74
#define hkwd_NFS4_GAP_2_STR             		75
#define hkwd_NFS4_FH4ALLOC              		76

#define PV_HKWD_NRD           				0x48B00000
#define hkwd_NRD_NULL                   		0x01
#define hkwd_NRD_GET_CRED_ENTER         		0x02
#define hkwd_NRD_GET_CRED_EXIT          		0x03
#define hkwd_NRD_IDS_TO_STRINGS_ENTER   		0x04
#define hkwd_NRD_IDS_TO_STRINGS_EXIT    		0x05
#define hkwd_NRD_STRINGS_TO_IDS_ENTER   		0x06
#define hkwd_NRD_STRINGS_TO_IDS_EXIT    		0x07
#define hkwd_NRD_GET_SEC_LIST_ENTER     		0x08
#define hkwd_NRD_GET_SEC_LIST_EXIT      		0x09
#define hkwd_NRD_GET_CB_INFO_ENTER      		0x0a
#define hkwd_NRD_GET_CB_INFO_EXIT       		0x0b
#define hkwd_NRD_HOST_TO_IP_ENTER       		0x0c
#define hkwd_NRD_HOST_TO_IP_EXIT        		0x0d
#define hkwd_NRD_USER                   		0x0e
#define hkwd_NRD_GROUP                  		0x0f
#define hkwd_NRD_PRINCIPAL              		0x10
#define hkwd_NRD_HOSTNAME               		0x11
#define hkwd_NRD_GET_NOBODY_IDS_ENTER   		0x12
#define hkwd_NRD_GET_NOBODY_IDS_EXIT    		0x13

#define PV_HKWD_NRS           				0x48C00000
#define hkwd_NRS_IDS_TO_STRINGS_ENTER           	1
#define hkwd_NRS_IDS_TO_STRINGS_EXIT            	2
#define hkwd_NRS_STRINGS_TO_IDS_ENTER           	3
#define hkwd_NRS_STRINGS_TO_IDS_EXIT            	4
#define hkwd_NRS_PRINCIPAL_TO_CRED_ENTER        	5
#define hkwd_NRS_PRINCIPAL_TO_CRED_EXIT         	6
#define hkwd_NRS_GET_SEC_LIST_ENTER             	7
#define hkwd_NRS_GET_SEC_LIST_EXIT              	8
#define hkwd_NRS_GET_CB_INFO_ENTER              	9
#define hkwd_NRS_GET_CB_INFO_EXIT               	10
#define hkwd_NRS_GET_IP_ADDR_ENTER              	11
#define hkwd_NRS_GET_IP_ADDR_EXIT               	12
#define hkwd_NRS_USER                           	13
#define hkwd_NRS_GROUP                          	14
#define hkwd_NRS_PRINCIPAL                      	15
#define hkwd_NRS_HOSTNAME                       	16
#define hkwd_NRS_GET_NOBODY_IDS_ENTER           	17
#define hkwd_NRS_GET_NOBODY_IDS_EXIT            	18
#define hkwd_NRS_BADUSER                        	19
#define hkwd_NRS_BADGROUP                       	20
#define hkwd_NRS_BADPRINCIPAL                   	21
#define hkwd_NRS_BADHOSTNAME                    	22
#define hkwd_NRS_NODAEMON                       	23

#define PV_HKWD_RFS4           				0x48D00000
#define hkwd_RFS4_DISPATCH_ENTER          		1
#define hkwd_RFS4_DISPATCH_NULL           		2
#define hkwd_RFS4_DISPATCH_BAD_PROC       		3
#define hkwd_RFS4_DISPATCH_BAD_XDR        		4
#define hkwd_RFS4_DISPATCH_NO_STATE       		5
#define hkwd_RFS4_DISPATCH_BAD_OP_XDR     		6
#define hkwd_RFS4_DISPATCH_BAD_OP         		7
#define hkwd_RFS4_DISPATCH_WEAKAUTH       		8
#define hkwd_RFS4_DISPATCH_BAD_DUP_XDR    		9
#define hkwd_RFS4_DISPATCH_BAD_COMBO    		0xa
#define hkwd_RFS4_DISPATCH_INPROG       		0xb
#define hkwd_RFS4_DISPATCH_DUP          		0xc
#define hkwd_RFS4_DISPATCH_BAD_DUP      		0xd
#define hkwd_RFS4_DISPATCH_OP_ENTER     		0xe
#define hkwd_RFS4_DISPATCH_OP_EXIT      		0xf
#define hkwd_RFS4_DISPATCH_EXIT        			0x10
#define hkwd_RFS4_RESOURCE             			0x11
#define hkwd_RFS4_SERVERFAULT          			0x12
#define hkwd_RFS4_EXPORT_ENTER         			0x13
#define hkwd_RFS4_EXPORT_EXIT          			0x14
#define hkwd_RFS4_UNEXPORT_ENTER       			0x15
#define hkwd_RFS4_UNEXPORT_EXIT        			0x16
#define hkwd_RFS4_UNEXPORTED           			0x17
#define hkwd_RFS4_DISPATCH_OP_EXIT2    			0x18
#define hkwd_RFS4_DISPATCH_TIMEDOUT    			0x19

#define PV_HKWD_SEA           				0x48F00000
#define hkwd_sea_config_in                      	0x01
#define hkwd_sea_cfg_lock_fail                  	0x02
#define hkwd_pincode_fail                       	0x03
#define hkwd_sea_config_threadstart_fail        	0x04
#define hkwd_sea_config_uiomove_fail            	0x05
#define hkwd_sea_config_acs_found               	0x06
#define hkwd_sea_config_copyin_fail             	0x07
#define hkwd_sea_config_attach_sea_fail         	0x08
#define hkwd_sea_config_devtype_notsup          	0x09
#define hkwd_sea_config_attach_fail             	0x0A
#define hkwd_sea_config_nnd_open                	0x0B
#define hkwd_sea_config_nnd_ctl_promisc         	0x0C
#define hkwd_sea_config_nnd_ctl_addrchk         	0x0D
#define hkwd_sea_config_acs_notfound            	0x0E
#define hkwd_sea_config_detach_fail             	0x0F
#define hkwd_sea_config_out                     	0x10
#define hkwd_sea_config_attach_sea_succ         	0x11
#define hkwd_change_sea_in                      	0x20
#define hkwd_change_sea_notfound                	0x21
#define hkwd_change_sea_out                     	0x22
#define hkwd_list_sea_in                        	0x23
#define hkwd_list_sea_notfound                  	0x24
#define hkwd_list_sea_out                       	0x25
#define hkwd_sea_real_input_in                  	0x30
#define hkwd_sri_pktinfo                        	0x31
#define hkwd_sri_ours                           	0x32
#define hkwd_sri_bcast                          	0x33
#define hkwd_sri_bridged                        	0x34
#define hkwd_sea_real_input_out                 	0x35
#define hkwd_sea_input                          	0x40
#define hkwd_sea_thread                         	0x41
#define hkwd_sea_output_in                      	0x42
#define hkwd_sea_output_pktinfo                 	0x43
#define hkwd_sea_output_out                     	0x44
#define hkwd_sea_virt_input_in                  	0x50
#define hkwd_svi_pktinfo                        	0x51
#define hkwd_svi_ours                           	0x52
#define hkwd_svi_bcast                          	0x53
#define hkwd_svi_bridged                        	0x54
#define hkwd_sea_virt_input_out                 	0x55
#define hkwd_sea_frag_in                        	0x60
#define hkwd_sea_frag_out                       	0x61
#define hkwd_sea_frag_ip4_in                    	0x62
#define hkwd_sea_frag_ip4_data                  	0x63
#define hkwd_sea_frag_ip4_out                   	0x64
#define hkwd_sea_frag_ip6_in                    	0x65
#define hkwd_sea_frag_ip6_data                  	0x66
#define hkwd_sea_frag_ip6_out                   	0x67
#define hkwd_modify_sea_in                      	0x68
#define hkwd_modify_sea_out                     	0x69
#define hkwd_modify_sea_error_out               	0x70
#define hkwd_get_num_chil_in                    	0x71
#define hkwd_get_num_chil_args                  	0x72
#define hkwd_get_num_chil_out                   	0x73
#define hkwd_get_chil_in                        	0x74
#define hkwd_get_chil_args                      	0x75
#define hkwd_get_chil_stats                     	0x76
#define hkwd_get_chil_phys_stats                	0x77
#define hkwd_get_chil_phys_tree                 	0x78
#define hkwd_get_chil_virt_stats                	0x79
#define hkwd_get_chil_ha_stats                  	0x7A
#define hkwd_get_chil_out                       	0x7B
#define hkwd_sea_config_configure_large_receive 	0x7C
#define hkwd_modify_large_receive               	0x7D
#define hwkd_send_rarp                          	0x7E
#define hkwd_sea_change_handler                 	0x80
#define hkwd_sea_child_update                   	0x81

#define hkwd_seaha_setup_in                     	0x100
#define hkwd_attach_seaha_fail                  	0x101
#define hkwd_attach_seaha_succ                  	0x102
#define hkwd_seaha_notvirt                      	0x103
#define hkwd_seaha_setup_out                    	0x104
#define hkwd_change_seaha_in                    	0x105
#define hkwd_change_seaha_out                   	0x106
#define hkwd_m_gethdr                           	0x107
#define hkwd_cnddp_output                       	0x108
#define hkwd_bridgemode_all                     	0x109
#define hkwd_bridgemode_none                    	0x10A
#define hkwd_ctlrec_len                         	0x10B

#define hkwd_seaha_set_link_fail                	0x10C
#define hkwd_seaha_pkt_create                   	0x10D
#define hkwd_seaha_pkt_send                     	0x10E
#define hkwd_seaha_ctlrecv                      	0x10F
#define hkwd_bridgemode_unicast                 	0x110
#define hkwd_undef_state                        	0x111
#define hkwd_received_pkt_recovery              	0x112
#define hkwd_received_pkt_notify                	0x113
#define hkwd_received_pkt_limbo                 	0x114
#define hkwd_undef_pkt                          	0x115
#define hkwd_seaha_init_timeout                 	0x116
#define hkwd_seaha_primary_timeout              	0x117
#define hkwd_seaha_backup_timeout               	0x118
#define hkwd_seaha_recovery_snd_timeout         	0x119
#define hkwd_seaha_recovery_rcv_timeout         	0x11A
#define hkwd_seaha_notify_snd_timeout           	0x11B
#define hkwd_seaha_notify_rcv_timeout           	0x11C
#define hkwd_seaha_limbo_timeout                	0x11D
#define hkwd_seaha_timer_initialize             	0x11E
#define hkwd_seaha_timer_stop                   	0x11F
#define hkwd_seaha_link_status_callback_func    	0x120
#define hkwd_seaha_bcast_delay_timeout          	0x121
#define hkwd_seaha_ping_timeout                 	0x122
#define hkwd_sea_config_real_adapter_fail       	0x123
#define hkwd_sea_config_virt_adapter_fail       	0x124
#define hkwd_sea_config_checksum_real_fail      	0x125
#define hkwd_sea_config_checksum_virt_fail      	0x126
#define hkwd_sea_config_vioent_attribute_fail   	0x127
#define hkwd_sea_config_vioent_trunk_priority   	0x128
#define hkwd_seahstr_xmalloc_fail               	0x129
#define hkwd_ctrl_channel_open_fail             	0x12A
#define hkwd_seahap_null                        	0x12B
#define hkwd_maxpriority                        	0x12C
#define hkwd_seap_null                          	0x12D
#define hkwd_seaha_icmp_output_in               	0x12E
#define hkwd_seaha_icmp_output_out              	0x12F
#define hkwd_seaha_icmp_input_in                	0x130
#define hkwd_seaha_icmp_input_out               	0x131
#define hkwd_icmp_pkt_not_ours                  	0x132
#define hkwd_sea_config_bad_priority            	0x133
#define hkwd_sea_config_seaha_setup_fail        	0x134
#define hkwd_vioent_get_vidlist_fail            	0x135
#define hkwd_seaha_ctlrecv1                     	0x136
#define hkwd_vlanid_vswitch_in                  	0x137
#define hkwd_vlanid_vswitch_out                 	0x138
#define hkwd_vioent_get_switch_id               	0x139
#define hkwd_vioent_get_switch_id_missmatch     	0x13A
#define hkwd_seaha_icmp_output_error_out        	0x13B
#define hkwd_shnotify_reg_fail                  	0x13C
#define hkwd_shnotify_unreg_fail                	0x13D
#define hkwd_shnotify_func_in                   	0x13E

#define hkwd_sea_gvrp_config_in				0x200
#define hkwd_sea_gvrp_config_table_setup		0x201
#define hkwd_sea_gvrp_config_add_filter_fail		0x202
#define hkwd_sea_gvrp_config_rem_filter_fail		0x203
#define hkwd_sea_gvrp_config_table_remove		0x204
#define hkwd_sea_gvrp_config_out			0x205
#define hkwd_sea_gvrp_config_demux_filter_in		0x206
#define hkwd_sea_gvrp_config_demux_filter_dup_filter	0x207
#define hkwd_sea_gvrp_config_demux_filter_out		0x208
#define hkwd_sea_gvrp_change_vlan_in			0x209
#define hkwd_sea_gvrp_change_vlan_out			0x210
#define hkwd_sea_gvrp_insert_vlan_in			0x211
#define hkwd_sea_gvrp_insert_vlan_middle		0x212
#define hkwd_sea_gvrp_insert_vlan_head			0x213
#define hkwd_sea_gvrp_insert_vlan_out			0x214
#define hkwd_sea_gvrp_remove_vlan_in			0x215
#define hkwd_sea_gvrp_remove_vlan			0x216
#define hkwd_sea_gvrp_remove_vlan_out			0x217
#define hkwd_sea_bpdu_process_packet_in			0x218
#define hkwd_sea_bpdu_process_packet_inval_bpdu_length	0x219
#define hkwd_sea_bpdu_process_packet_no_memory		0x220
#define hkwd_sea_bpdu_process_packet_unknown_protocol_id	0x221
#define hkwd_sea_bpdu_process_packet_out		0x222
#define hkwd_sea_garp_process_messages_in		0x223
#define hkwd_sea_garp_process_messages_inval_att	0x224
#define hkwd_sea_garp_process_messages_out		0x225
#define hkwd_sea_gvrp_process_attributes_in		0x226
#define hkwd_sea_gvrp_process_attributes_inval_length	0x227
#define hkwd_sea_gvrp_process_attributes_inval_value	0x228
#define hkwd_sea_gvrp_process_attributes_out		0x229
#define hkwd_sea_gvrp_process_event_in			0x230
#define hkwd_sea_gvrp_process_event_out			0x231
#define hkwd_sea_gvrp_recv_leave_all			0x232
#define hkwd_sea_gvrp_recv_join_empty			0x233
#define hkwd_sea_gvrp_recv_join_in			0x234
#define hkwd_sea_gvrp_recv_leave_empty			0x235
#define hkwd_sea_gvrp_recv_leave_in			0x236
#define hkwd_sea_gvrp_recv_empty			0x237
#define hkwd_sea_gvrp_process_events_out		0x238
#define hkwd_sea_gvrp_output_prepare_packet_in		0x239
#define hkwd_sea_gvrp_output_prepare_packet_inval_anxious	0x240
#define hkwd_sea_gvrp_output_prepare_packet_inval_event_type	0x241
#define hkwd_sea_gvrp_output_prepare_packet_no_memory	0x242
#define hkwd_sea_gvrp_output_prepare_packet_err_in_pkt	0x243
#define hkwd_sea_gvrp_output_prepare_packet_free_memory	0x244
#define hkwd_sea_gvrp_xmit_leave_in			0x245
#define hkwd_sea_gvrp_output_prepare_packet_out		0x246
#define hkwd_sea_gvrp_output_prepare_join_in		0x247
#define hkwd_sea_gvrp_output_prepare_join_inval_anxious	0x248
#define hkwd_sea_gvrp_xmit_join_in			0x249
#define hkwd_sea_gvrp_output_prepare_join_out		0x250
#define hkwd_sea_gvrp_output_prepare_leave_in		0x251
#define hkwd_sea_gvrp_output_prepare_leave_inval_vlan	0x252
#define hkwd_sea_gvrp_output_prepare_leave_out		0x253
#define hkwd_sea_gvrp_output_prepare_header_in		0x254
#define hkwd_sea_gvrp_output_prepare_header_out		0x255
#define hkwd_sea_gvrp_output_insert_attribute_in	0x256
#define hkwd_sea_gvrp_output_insert_attribute_out	0x257
#define hkwd_sea_gvrp_output_join_timeout_in		0x258
#define hkwd_sea_gvrp_output_join_timeout_out		0x259
#define hkwd_sea_gvrp_update_vlan_list_in		0x260
#define hkwd_sea_gvrp_update_vlan_list_out		0x261
#define hkwd_sea_load_kdb_in				0x262
#define hkwd_sea_load_kdb_loading			0x263
#define hkwd_sea_load_kdb_entry_ptr_zero		0x264
#define hkwd_sea_load_kdb_func_ptr_undefined		0x265
#define hkwd_sea_load_kdb_error_loading			0x266
#define hkwd_sea_load_kdb_out				0x267
#define hkwd_sea_unload_kdb_in				0x268
#define hkwd_sea_unload_kdb_unloading 			0x269
#define hkwd_sea_unload_kdb_entry_ptr_zero		0x270
#define hkwd_sea_unload_kdb_func_ptr_undefined		0x271
#define hkwd_sea_unload_kdb_error_not_loaded		0x272
#define hkwd_sea_unload_kdb_out				0x273
#define hkwd_sea_gvrp_process_attributes_wrong_att_value	0x274
#define hkwd_sea_gvrp_insert_vlan_bounds		0x275


#define hkwd_sea_input_in 				0x300
#define hkwd_sea_input_acs_error			0x301
#define hkwd_sea_input_bridge_unicast			0x302
#define hkwd_sea_input_bridge_none			0x303
#define hkwd_sea_input_thread_mode_disabled		0x304
#define hkwd_sea_input_loop				0x305
#define hkwd_sea_input_loop_queue_chosen		0x306
#define hkwd_sea_input_loop_packet_dropped		0x307
#define hkwd_sea_input_out				0x308
#define hkwd_sea_thread_init				0x310
#define hkwd_sea_thread_start_in			0x320
#define hkwd_sea_thread_start_loop			0x321
#define hkwd_sea_thread_start_out			0x322
#define hkwd_sea_thread_in				0x330
#define hkwd_sea_thread_strict_loop			0x331
#define hkwd_sea_thread_loose_loop			0x332
#define hkwd_sea_thread_loose_reset			0x333
#define hkwd_sea_thread_send_priority_packet		0x334
#define hkwd_sea_thread_send_disabled_packet		0x335
#define hkwd_sea_thread_sleeping			0x336
#define hkwd_sea_thread_waking				0x337
#define hkwd_sea_send_packet_in 			0x340
#define hkwd_sea_send_packet_out			0x341
#define hkwd_sea_thread_term				0x350


#define hkwd_sea_acct_config_in				0x400
#define hkwd_sea_acct_config_invalid_param		0x401
#define hkwd_sea_acct_config_out 			0x402
#define hkwd_sea_acct_update_stats_in			0x403
#define hkwd_sea_acct_update_stats_packet_info		0x404
#define hkwd_sea_acct_update_stats_broadcast_out	0x405
#define hkwd_sea_acct_update_stats_incoming_match_out	0x406
#define hkwd_sea_acct_update_stats_incoming_nomatch_out	0x407
#define hkwd_sea_acct_update_stats_outgoing_match_out	0x408
#define hkwd_sea_acct_update_stats_invalid_param	0x409
#define hkwd_sea_acct_update_stats_add_new_element_out	0x410
#define hkwd_sea_get_acct_size_in  			0x411
#define hkwd_sea_get_acct_size_flag_disabled		0x412
#define hkwd_sea_get_acct_size_out			0x413
#define hkwd_sea_get_acct_data_in			0x414
#define hkwd_sea_get_acct_data_flag_disabled		0x415
#define hkwd_sea_get_acct_data_out			0x416
#define hkwd_sea_clear_acct_data_in			0x417
#define hkwd_sea_clear_acct_data_flag_disabled		0x418
#define hkwd_sea_clear_acct_data_out			0x419
#define hkwd_sea_acct_update_stats_no_memory		0x420
#define hkwd_sea_acct_update_stats_too_big		0x421


/* Hookwords which were not originally dropped */

#define hkwd_sea_config_acs_no_mem			0x500
#define hkwd_sea_config_dds_copyin_failure		0x501
#define hkwd_sea_config_real_adapter_ndd_open_fail	0x502
#define hkwd_sea_config_real_adapter_promisc_fail	0x503
#define hkwd_sea_config_real_adapter_disable_addrchk_fail	0x504
#define hkwd_sea_config_virt_adapter_ndd_open_fail	0x505
#define hkwd_sea_config_virt_adapter_promisc_fail	0x506
#define hkwd_sea_config_virt_adapter_not_trunk		0x507
#define hkwd_sea_config_virt_adapter_disable_addrchk_fail	0x508
#define hkwd_sea_config_vioent_bad_attributes		0x509
#define hkwd_sea_config_gvrp_setup_fail			0x50A
#define hkwd_sea_config_sea_error_copyin_failure	0x50B
#define hkwd_sea_config_sea_error_copyout_failure	0x50C
#define hkwd_sea_config_no_pvid_adapter			0x50D
#define hkwd_sea_config_acct_setup_fail 		0x50E
#define hkwd_sea_config_ndd_set_pointer_fail		0x50F


#define hkwd_change_sea_attach_real_adapter_fail 	0x510
#define hkwd_change_sea_attach_virt_adapters_fail	0x511
#define hkwd_change_sea_attach_sea_succ  		0x512
#define hkwd_change_sea_devtype_notsup 			0x513
#define hkwd_change_sea_checksum_real_fail 		0x514
#define hkwd_change_sea_large_receive 			0x515
#define hkwd_change_sea_checksum_virt_fail		0x516
#define hkwd_change_sea_vioent_attribute_fail		0x517
#define hkwd_change_sea_bad_priority   			0x518
#define hkwd_change_sea_vioent_trunk_priority 		0x519
#define hkwd_change_sea_ndd_open 			0x51A
#define hkwd_change_sea_ndd_ctl_promisc			0x51B
#define hkwd_change_sea_ndd_ctl_addrchk 		0x51C
#define hkwd_change_sea_ndd_set_pointer_fail		0x51D



#define hkwd_sea_svm_bad_recv_rc			0x600
#define hkwd_sea_svm_output_in				0x601
#define hkwd_sea_svm_output_bad_flag			0x602
#define hkwd_sea_svm_output_acs_error			0x603
#define hkwd_sea_svm_output_out 			0x604
#define hkwd_sea_svm_register_in			0x605
#define hkwd_sea_svm_register_eagain			0x606
#define hkwd_sea_svm_register_eexist			0x607
#define hkwd_sea_svm_register_out			0x608
#define hkwd_sea_svm_unregister_in			0x609
#define hkwd_sea_svm_unregister_eagain 			0x60A
#define hkwd_sea_svm_unregister_enoent			0x60B
#define hkwd_sea_svm_unregister_out			0x60C


#define hwkd_seaha_add_vcmac_enter 			0x700
#define hwkd_seaha_add_vcmac_exit    			0x701
#define hwkd_seaha_pkt_create_failed         		0x702
#define hwkd_seaha_send_vcmac                		0x703
#define hwkd_seaha_send_vcmac_table          		0x704
#define hwkd_seaha_pkt_send_failed           		0x705
#define hwkd_seaha_rarp_all_vclients         		0x706
#define hwkd_seaha_rarp_vclient              		0x707
#define hwkd_seaha_rarp_vclient_fail         		0x708
#define hwkd_seaha_update_vcmac              		0x709
#define hwkd_seaha_del_vcmac_enter           		0x70A
#define hwkd_seaha_vcmac_wdt_timeout         		0x70B
#define hwkd_seaha_add_and_update_vcmac      		0x70C

#define PV_HKWD_SM4_NORM           			0x49300000
#define PV_HKWD_SM4_ERR         			0x49400000
#define PV_HKWD_SM4_DBG           			0x49500000
#define PV_HKWD_DD_FCPS_ERR           			0x49700000
#define PV_HKWD_DD_FCDD_ERR           			0x49800000
#define PV_HKWD_DD_SCDISKDD_ERR        			0x49900000

#define PV_HKWD_NFS4_STATE           			0x4A000000
#define update_renew_time_exit           		1
#define allocate_state_info              		2
#define free_state_info                  		3
#define update_state_info                		4
#define fsid_hold_enter                 		10
#define fsid_hold_exit_1                		11
#define fsid_hold_exit_2                		12
#define fsid_rele_enter                 		13
#define start_state_change_enter        		20
#define start_state_change_exit         		21
#define state_change_nohold_1           		22
#define state_change_nohold_2           		23
#define end_state_change_exit           		24
#define block_state_change_enter        		25
#define block_state_change_exit_1       		26
#define block_state_change_exit_2       		27
#define start_io_enter                  		30
#define start_io_exit_1                 		31
#define start_io_exit_2                 		32
#define start_io_exit_3                 		33
#define end_io_exit                     		34
#define flush_io_enter                  		35
#define flush_io_exit                   		36
#define get_open_owner_enter            		40
#define get_open_owner_exit_1           		41
#define get_open_owner_exit_2           		42
#define unlock_open_owner_exit          		43
#define invalidate_oo_enter             		44
#define invalidate_oo_exit              		45
#define open_owner_delay_enter          		50
#define open_owner_delay_exit_1         		51
#define open_owner_delay_exit_2         		52
#define open_owner_delay_exit_3         		53
#define open_owner_delay_exit_4         		54
#define get_lock_owner_enter            		60
#define get_lock_owner_exit_1           		61
#define get_lock_owner_exit_2           		62
#define get_lock_owner_exit_3           		63
#define get_lock_owner_exit_4           		64
#define update_lock_owner_exit          		65
#define lock_delay_enter                		66
#define lock_delay_exit                 		67
#define get_io_stateid_exit_1           		70
#define get_io_stateid_exit_2           		71
#define get_io_stateid_exit_3           		72
#define get_io_stateid_exit_4           		73
#define call_server_enter               		80
#define call_server_exit_1              		81
#define call_server_exit_2              		82
#define new_open_owner_exit             		90

#define open_nocreate_enter_1          			100
#define open_nocreate_enter_2          			101
#define open_nocreate_call_done        			102
#define open_nocreate_add_deleg        			103
#define open_nocreate_exit_1           			104
#define open_create_enter              			110
#define open_create_call_done          			111
#define open_create_add_deleg          			112
#define open_create_exit_1             			113
#define open_close_enter               			120
#define open_close_call_done           			121
#define open_close_exit_1              			122
#define open_close_exit_2              			123
#define open_downgrade_enter           			130
#define open_downgrade_call_done       			131
#define open_downgrade_exit            			132
#define open_confirm_enter             			140
#define open_confirm_call_done         			141
#define open_confirm_exit              			142
#define open_reply_enter               			150
#define open_reply_bump                			151
#define open_reply_non_state           			152
#define open_reply_state               			153
#define open_reply_race                			154
#define open_reply_no_fh               			155
#define open_reply_no_attr             			156
#define open_reply_no_node             			157
#define open_reply_exit                			158
#define open_create_attrs              			160
#define create_race_enter              			170
#define create_race_confirm            			171
#define create_race_call_done          			172
#define create_race_exit               			173
#define open_race_enter                			180
#define open_race_confirm              			181
#define open_race_exit                 			182
#define open_race_bg_enter             			183
#define open_race_bg_notreg            			184
#define open_race_bg_no_oo             			185
#define open_race_bg_no_work           			186
#define open_race_bg_exit              			187
#define close_ord_enter                			188
#define close_ord_exit                 			189

#define lock_lock_enter_1              			200
#define lock_lock_enter_2              			201
#define lock_lock_call_done            			202
#define lock_lock_exit_1               			203
#define lock_lock_exit_2               			204
#define lock_unlock_enter              			210
#define lock_unlock_call_done          			211
#define lock_unlock_exit_1             			212
#define lock_unlock_exit_2             			213
#define lock_test_enter                			220
#define lock_test_call_done            			221
#define lock_test_exit                 			222
#define release_locker                 			230

#define add_deleg_enter                			300
#define add_deleg_recall               			301
#define add_deleg_exit_1               			302
#define add_deleg_exit_2               			303
#define remove_deleg_enter             			310
#define remove_deleg_exit_1            			320
#define remove_deleg_exit_2            			321
#define return_deleg_enter             			330
#define return_deleg_sync              			331
#define return_deleg_inprog            			332
#define return_deleg_open              			333
#define return_deleg_rpc_done          			334
#define return_deleg_exit              			335
#define return_deleg_vfs_enter         			340
#define return_deleg_vfs_intr          			341
#define return_deleg_vfs_busy          			342
#define return_deleg_vfs_exit          			343
#define return_deleg_stale_enter       			350
#define return_deleg_stale_exit        			351
#define return_deleg_fh_enter          			360
#define return_deleg_resource          			370
#define return_deleg_admin_enter       			380
#define return_deleg_admin_exit        			381

#define reclaim_fsid_enter             			400
#define reclaim_fsid_skip              			401
#define reclaim_fsid_add               			402
#define reclaim_fsid_loop_done         			403
#define reclaim_fsid_ntm_start         			404
#define reclaim_fsid_wait              			405
#define reclaim_fsid_exit_1            			406
#define reclaim_fsid_exit_2            			407
#define recover_fsid_enter             			410
#define recover_fsid_call              			411
#define recover_fsid_exit              			412
#define recover_file_enter             			420
#define recover_file_ret_deleg         			421
#define recover_file_open_prev_call    			422
#define recover_file_open_prev_ret     			423
#define recover_file_null_call         			424
#define recover_file_null_ret          			425
#define recover_file_no_grace          			426
#define recover_file_exit_1            			427
#define recover_file_exit_2            			428
#define recover_lock_enter             			430
#define recover_lock_call              			431
#define recover_lock_bad               			432
#define recover_lock_scan              			433
#define recover_lock_exit_1            			434
#define recover_lock_exit_2            			435
#define revoked_file_enter             			440
#define revoked_file_nowork            			441
#define revoked_file_nostate           			442
#define revoked_file_changed           			443
#define revoked_file_dead              			444
#define revoked_file_exit              			445

#define get_clientid_otw_enter         			800
#define get_clientid_otw_exit          			801
#define get_clientid_otw_error         			802
#define get_clientid_otw_auth_error   			803 
#define renew_enter                    			804
#define renew_exit                     			805
#define renew_error                    			806
#define get_clientid_data_enter       		 	807
#define get_clientid_data_exit         			808
#define server_recovery_enter          			809
#define server_recovery_inprog         			810
#define server_recovery_mark_fsid     		 	811
#define server_recovery_exit           			812
#define updateid_enter                 			813
#define updateid_exit                  			814
#define trash_id_enter                 			815
#define trash_id_error                 			816
#define trash_id_bad_rpc               			817
#define trash_id_exit                  			818
#define renew_40_enter                 			819
#define renew_40_exit                  			820
#define renew_40_error                 			821
#define renew_41_enter                 			822
#define renew_41_exit                  			823
#define renew_41_error                 			824
#define get_lease_time_enter           			825
#define get_lease_time_exit            			826
#define get_lease_time_error           			827
#define trash_40_id_enter              			828
#define trash_40_id_error              			829
#define trash_40_id_bad_rpc            			830
#define trash_40_id_exit               			831
#define trash_41_id_enter              			832
#define trash_41_id_error              			833
#define trash_41_id_bad_rpc            			834
#define trash_41_id_exit               			835

#define n4cb_dispatch_enter            			900
#define n4cb_dispatch_null             			901
#define n4cb_dispatch_noproc           			902
#define n4cb_dispatch_minvers          			903
#define n4cb_dispatch_newop            			904
#define n4cb_dispatch_getattr          			905
#define n4cb_dispatch_recall           			906
#define n4cb_dispatch_reply            			907
#define n4cb_dispatch_exit             			908
#define n4cb_getattr                   			910

#define PV_HKWD_PCIKN_XMIT           			0x4A100000
#define PV_HKWD_PCIKN_RCV           			0x4A200000
#define PV_HKWD_PCIKN_GEN           			0x4A300000

#define PV_HKWD_URPCSEC           				0x4A400000
/* rpcsec_gss.c tracehooks */

#define hkwd_URPCSEC_SECCREATE_ENTER  			1
#define hkwd_URPCSEC_SECCREATE_EXIT_1 			2
#define hkwd_URPCSEC_SECCREATE_EXIT_2 			3
#define hkwd_URPCSEC_SECCREATE_EXIT_3 			4
#define hkwd_URPCSEC_SECCREATE_EXIT_4 			5
#define hkwd_URPCSEC_SECCREATE_EXIT_5 			6
#define hkwd_URPCSEC_SECCREATE_EXIT_6 			7
#define hkwd_URPCSEC_SECCREATE_EXIT_7 			8

#define hkwd_URPCSEC_SECCREATE_PVT_ENTER    		9
#define hkwd_URPCSEC_SECCREATE_PVT_TOKEN   		10
#define hkwd_URPCSEC_SECCREATE_PVT_EXIT_1  		11
#define hkwd_URPCSEC_SECCREATE_PVT_EXIT_2  		12
#define hkwd_URPCSEC_SECCREATE_PVT_EXIT_3  		13
#define hkwd_URPCSEC_SECCREATE_PVT_EXIT_4  		14
#define hkwd_URPCSEC_SECCREATE_PVT_EXIT_5  		15
#define hkwd_URPCSEC_SECCREATE_PVT_EXIT_6  		16
#define hkwd_URPCSEC_SECCREATE_PVT_EXIT_7  		17
#define hkwd_URPCSEC_SECCREATE_PVT_EXIT_8 	 	18
#define hkwd_URPCSEC_SECCREATE_PVT_EXIT_9  		19
#define hkwd_URPCSEC_SECCREATE_PVT_EXIT_10 		20
#define hkwd_URPCSEC_SECCREATE_PVT_EXIT_11 		21

#define hkwd_URPCSEC_SET_DEFAULTS_ENTER   		22
#define hkwd_URPCSEC_SET_DEFAULTS_EXIT_1  		23
#define hkwd_URPCSEC_SET_DEFAULTS_EXIT_2  		24
#define hkwd_URPCSEC_SET_DEFAULTS_EXIT_3  		25
#define hkwd_URPCSEC_SET_DEFAULTS_EXIT_4  		26

#define hkwd_URPCSEC_MARSHALL_ENTER  			27
#define hkwd_URPCSEC_MARSHALL_EXIT_1 			28
#define hkwd_URPCSEC_MARSHALL_EXIT_2 			29
#define hkwd_URPCSEC_MARSHALL_EXIT_3 			30

#define hkwd_URPCSEC_MARSHALL_VERF_ENTER  		31
#define hkwd_URPCSEC_MARSHALL_VERF_EXIT_1 		32
#define hkwd_URPCSEC_MARSHALL_VERF_EXIT_2 		33
#define hkwd_URPCSEC_MARSHALL_VERF_EXIT_3 		34

#define hkwd_URPCSEC_GSS_MARSHALL_ENTER  		35
#define hkwd_URPCSEC_GSS_MARSHALL_EXIT_1 		36
#define hkwd_URPCSEC_GSS_MARSHALL_EXIT_2 		37

#define hkwd_URPCSEC_NEXTVERF  				38

#define hkwd_URPCSEC_GSS_VALIDATE_ENTER  		39

#define hkwd_URPCSEC_GSS_VALIDATE_EXIT_1 		40
#define hkwd_URPCSEC_GSS_VALIDATE_EXIT_2 		41
#define hkwd_URPCSEC_GSS_VALIDATE_EXIT_3 		42

#define hkwd_URPCSEC_REFRESH_ENTER  			43
#define hkwd_URPCSEC_REFRESH_DATA_1 			44
#define hkwd_URPCSEC_REFRESH_EXIT_1 			45
#define hkwd_URPCSEC_REFRESH_EXIT_2 			46
#define hkwd_URPCSEC_REFRESH_EXIT_3 			47
#define hkwd_URPCSEC_REFRESH_EXIT_4 			48

#define hkwd_URPCSEC_DESTROY_ENTER  			49
#define hkwd_URPCSEC_DESTROY_EXIT   			50

#define hkwd_URPCSEC_DESTROY_PVT_ENTER  		51
#define hkwd_URPCSEC_DESTROY_PVT_REMOTE 		52
#define hkwd_URPCSEC_DESTROY_PVT_LOCAL  		53
#define hkwd_URPCSEC_DESTROY_PVT_CRED   		54
#define hkwd_URPCSEC_DESTROY_PVT_NAME   		55
#define hkwd_URPCSEC_DESTROY_PVT_EXIT   		56

#define hkwd_URPCSEC_WRAP_ENTER  			57
#define hkwd_URPCSEC_WRAP_EXIT_1 			58
#define hkwd_URPCSEC_WRAP_SEQNUM 			59
#define hkwd_URPCSEC_WRAP_EXIT_2 			60
#define hkwd_URPCSEC_WRAP_EXIT_3 			61
#define hkwd_URPCSEC_WRAP_EXIT_4 			62
#define hkwd_URPCSEC_WRAP_EXIT_5 			63
#define hkwd_URPCSEC_WRAP_EXIT_6 			64
#define hkwd_URPCSEC_WRAP_EXIT_7 			65

#define hkwd_URPCSEC_UNWRAP_ENTER  			66
#define hkwd_URPCSEC_UNWRAP_EXIT_1 			67
#define hkwd_URPCSEC_UNWRAP_EXIT_2 			68

#define hkwd_URPCSEC_MAX_DATA_ENTER  			69
#define hkwd_URPCSEC_MAX_DATA_EXIT_1 			70
#define hkwd_URPCSEC_MAX_DATA_EXIT_2 			71
#define hkwd_URPCSEC_ERROR_ENTER  			72
#define hkwd_URPCSEC_ERROR_EXIT_1 			73
#define hkwd_URPCSEC_ERROR_EXIT_2 			74
#define hkwd_URPCSEC_ERROR_EXIT_3 			75
#define hkwd_URPCSEC_ERROR_EXIT_4 			76
#define hkwd_URPCSEC_ERROR_EXIT_5 			77
#define hkwd_URPCSEC_ERROR_EXIT_6 			78

#define hkwd_URPCSEC_GET_ERROR_ENTER  			79
#define hkwd_URPCSEC_GET_ERROR_EXIT   			80

/* svc_rpcsec_gss.c tracehooks */

#define hkwd_URPCSEC_CTX_CLEANUP_ENTER 			81
#define hkwd_URPCSEC_CTX_CLEANUP_EXIT  			82

#define hkwd_URPCSEC_SET_SERVER_PARMS_ENTER 		83

#define hkwd_URPCSEC_SET_SERVER_PARMS_EXIT  		84

#define hkwd_URPCSEC_SHIFT_BITS_ENTER 			85
#define hkwd_URPCSEC_SHIFT_BITS_EXIT  			86

#define hkwd_URPCSEC_CHECK_SEQ_ENTER  			87
#define hkwd_URPCSEC_CHECK_SEQ_EXIT_1 			88
#define hkwd_URPCSEC_CHECK_SEQ_EXIT_2 			89
#define hkwd_URPCSEC_CHECK_SEQ_EXIT_3 			90
#define hkwd_URPCSEC_CHECK_SEQ_EXIT_4 			91
#define hkwd_URPCSEC_CHECK_SEQ_EXIT_5 			92

#define hkwd_URPCSEC_MAKE_PRINCIPAL_ENTER  		93
#define hkwd_URPCSEC_MAKE_PRINCIPAL_EXIT_1 		94
#define hkwd_URPCSEC_MAKE_PRINCIPAL_EXIT_2 		95

#define hkwd_URPCSEC_SET_CL_PRINCIPAL_ENTER  		96
#define hkwd_URPCSEC_SET_CL_PRINCIPAL_EXIT_1 		97
#define hkwd_URPCSEC_SET_CL_PRINCIPAL_EXIT_2 		98

#define hkwd_URPCSEC_SET_CALLBACK_ENTER   		99
#define hkwd_URPCSEC_SET_CALLBACK_EXIT_1 		100
#define hkwd_URPCSEC_SET_CALLBACK_EXIT_2 		101
#define hkwd_URPCSEC_SET_CALLBACK_EXIT_3 		102

#define hkwd_URPCSEC_DO_CALLBACK_ENTER    		103
#define hkwd_URPCSEC_DO_CALLBACK_FOUND    		104
#define hkwd_URPCSEC_DO_CALLBACK_NOTFOUND 		105
#define hkwd_URPCSEC_DO_CALLBACK_EXIT     		106

#define hkwd_URPCSEC_GETCRED_ENTER    			107
#define hkwd_URPCSEC_GETCRED_MECHFAIL 			108
#define hkwd_URPCSEC_GETCRED_GSSNAME  			109
#define hkwd_URPCSEC_GETCRED_GSSGROUP 			110
#define hkwd_URPCSEC_GETCRED_EXIT     			111

#define hkwd_URPCSEC_SVCRPCSEC_ENTER          		112
#define hkwd_URPCSEC_SVCRPCSEC_OA_ZERO        		113
#define hkwd_URPCSEC_SVCRPCSEC_ERROR_1        		114
#define hkwd_URPCSEC_SVCRPCSEC_BADSERVICE     		115
#define hkwd_URPCSEC_SVCRPCSEC_BADHLEN        		116
#define hkwd_URPCSEC_SVCRPCSEC_BADCRCL        		117
#define hkwd_URPCSEC_SVCRPCSEC_NOHLEN         		118
#define hkwd_URPCSEC_SVCRPCSEC_BADGETCL       		119
#define hkwd_URPCSEC_SVCRPCSEC_STALECL        		120
#define hkwd_URPCSEC_SVCRPCSEC_NOTINIT        		121
#define hkwd_URPCSEC_SVCRPCSEC_NOTDATA        		122
#define hkwd_URPCSEC_SVCRPCSEC_GETARGS        		123
#define hkwd_URPCSEC_SVCRPCSEC_ACCEPT         		124
#define hkwd_URPCSEC_SVCRPCSEC_ACCEPT_2       		125

#define hkwd_URPCSEC_SVCRPCSEC_REFRESH_FAILED 		126
#define hkwd_URPCSEC_SVCRPCSEC_ERROR_2        		127
#define hkwd_URPCSEC_SVCRPCSEC_ERROR_3        		128
#define hkwd_URPCSEC_SVCRPCSEC_ERROR_4        		129
#define hkwd_URPCSEC_SVCRPCSEC_SETVERF        		130
#define hkwd_URPCSEC_SVCRPCSEC_CHECKVERF      		131
#define hkwd_URPCSEC_SVCRPCSEC_CBACK_FAILED   		132
#define hkwd_URPCSEC_SVCRPCSEC_ERROR_5        		133
#define hkwd_URPCSEC_SVCRPCSEC_CHECK_SEQ      		134
#define hkwd_URPCSEC_SVCRPCSEC_SETVERF_2      		135
#define hkwd_URPCSEC_SVCRPCSEC_PROC           		136
#define hkwd_URPCSEC_SVCRPCSEC_ERROR_6        		137
#define hkwd_URPCSEC_SVCRPCSEC_ERROR_7        		138
#define hkwd_URPCSEC_SVCRPCSEC_EXIT_1         		139
#define hkwd_URPCSEC_SVCRPCSEC_EXIT_2         		140

#define hkwd_URPCSEC_CHECK_VERF_ENTER 			141
#define hkwd_URPCSEC_CHECK_VERF_EXIT  			142

#define hkwd_URPCSEC_SET_VERF_ENTER  			143
#define hkwd_URPCSEC_SET_VERF_EXIT_1 			144
#define hkwd_URPCSEC_SET_VERF_EXIT_2 			145

#define hkwd_URPCSEC_CREATE_CLIENT_ENTER  		146
#define hkwd_URPCSEC_CREATE_CLIENT_EXIT_1 		147
#define hkwd_URPCSEC_CREATE_CLIENT_EXIT_2 		148
#define hkwd_URPCSEC_CREATE_CLIENT_EXIT_3 		149

#define hkwd_URPCSEC_INSERT_CLIENT_ENTER 		150
#define hkwd_URPCSEC_INSERT_CLIENT_EXIT  		151

#define hkwd_URPCSEC_GET_CLIENT_ENTER 			152
#define hkwd_URPCSEC_GET_CLIENT_STALE 			153
#define hkwd_URPCSEC_GET_CLIENT_EXIT  			154

#define hkwd_URPCSEC_FIND_CLIENT_ENTER 			155
#define hkwd_URPCSEC_FIND_CLIENT_EXIT  			156

#define hkwd_URPCSEC_DESTROY_CLIENT_ENTER 		157
#define hkwd_URPCSEC_DESTROY_CLIENT_EXIT  		158

#define hkwd_URPCSEC_SWEEP_CLIENTS_ENTER 		159
#define hkwd_URPCSEC_SWEEP_CLIENTS_EXIT  		160

#define hkwd_URPCSEC_DROP_LRU_CLIENT_ENTER 		161
#define hkwd_URPCSEC_DROP_LRU_CLIENT_EXIT  		162

#define hkwd_URPCSEC_FIND_SVC_CRED_ENTER  		163
#define hkwd_URPCSEC_FIND_SVC_CRED_EXIT_1 		164
#define hkwd_URPCSEC_FIND_SVC_CRED_EXIT_2 		165
#define hkwd_URPCSEC_FIND_SVC_CRED_EXIT_3 		166

#define hkwd_URPCSEC_SET_SVC_NAME_ENTER   		167
#define hkwd_URPCSEC_SET_SVC_NAME_EXIT_1  		168
#define hkwd_URPCSEC_SET_SVC_NAME_EXIT_2  		169
#define hkwd_URPCSEC_SET_SVC_NAME_ADDCRED 		170
#define hkwd_URPCSEC_SET_SVC_NAME_EXIT_3  		171
#define hkwd_URPCSEC_SET_SVC_NAME_EXIT_4  		172
#define hkwd_URPCSEC_SET_SVC_NAME_EXIT_5  		173
#define hkwd_URPCSEC_SET_SVC_NAME_EXIT_6  		174
#define hkwd_URPCSEC_SET_SVC_NAME_EXIT_7  		175
#define hkwd_URPCSEC_SET_SVC_NAME_EXIT_8  		176
#define hkwd_URPCSEC_SET_SVC_NAME_EXIT_9  		177
#define hkwd_URPCSEC_SET_SVC_NAME_EXIT_10 		178
#define hkwd_URPCSEC_SET_SVC_NAME_EXIT_11 		179

#define hkwd_URPCSEC_REFRESH_SVC_CRED_ENTER  		180
#define hkwd_URPCSEC_REFRESH_SVC_CRED_EXIT_1 		181
#define hkwd_URPCSEC_REFRESH_SVC_CRED_EXIT_2 		182

#define hkwd_URPCSEC_SVC_WRAP_ENTER  			183
#define hkwd_URPCSEC_SVC_WRAP_EXIT_1 			184
#define hkwd_URPCSEC_SVC_WRAP_EXIT_2 			185

#define hkwd_URPCSEC_SVC_UNWRAP_ENTER  			186
#define hkwd_URPCSEC_SVC_UNWRAP_EXIT_1 			187
#define hkwd_URPCSEC_SVC_UNWRAP_EXIT_2 			188

#define hkwd_URPCSEC_SVC_MAXDATA_ENTER  		189
#define hkwd_URPCSEC_SVC_MAXDATA_EXIT_1 		190
#define hkwd_URPCSEC_SVC_MAXDATA_EXIT_2 		191

#define hkwd_URPCSEC_GETGINFO_IDTOUSER  		193
#define hkwd_URPCSEC_GETGINFO_GETUATTR  		194
#define hkwd_URPCSEC_GETGINFO_GETGATTR  		195
#define hkwd_URPCSEC_GETGINFO_GETUATTR2 		196
#define hkwd_URPCSEC_GETGINFO_MALLOC    		197
#define hkwd_URPCSEC_GETGINFO_GETGATTR2 		198
#define hkwd_URPCSEC_GETGINFO_EXIT      		199

#define hkwd_URPCSEC_NAME2CRED_ENTER  			200
#define hkwd_URPCSEC_NAME2CRED_EXIT_1 			201
#define hkwd_URPCSEC_NAME2CRED_EXIT_2 			202
#define hkwd_URPCSEC_NAME2CRED_EXIT_3 			203
#define hkwd_URPCSEC_NAME2CRED_EXIT_4 			204

/* rpcsec_gss_misc.c tracehooks */

#define hkwd_URPCSEC_XDR_GSS_BUF_ENTER  		205
#define hkwd_URPCSEC_XDR_GSS_BUF_EXIT_1 		206
#define hkwd_URPCSEC_XDR_GSS_BUF_EXIT_2 		207

#define hkwd_URPCSEC_XDR_GSS_CREDS_ENTER  		208
#define hkwd_URPCSEC_XDR_GSS_CREDS_EXIT_1 		209
#define hkwd_URPCSEC_XDR_GSS_CREDS_EXIT_2 		210

#define hkwd_URPCSEC_XDR_GSS_INIT_ARG_ENTER  		211
#define hkwd_URPCSEC_XDR_GSS_INIT_ARG_EXIT_1 		212
#define hkwd_URPCSEC_XDR_GSS_INIT_ARG_EXIT_2 		213

#define hkwd_URPCSEC_XDR_GSS_INIT_RES_ENTER  		214
#define hkwd_URPCSEC_XDR_GSS_INIT_RES_EXIT_1 		215
#define hkwd_URPCSEC_XDR_GSS_INIT_RES_EXIT_2 		216

#define hkwd_URPCSEC_WRAP_DATA_ENTER   			217
#define hkwd_URPCSEC_WRAP_DATA_EXIT_1  			218
#define hkwd_URPCSEC_WRAP_DATA_EXIT_2  			219
#define hkwd_URPCSEC_WRAP_DATA_EXIT_3  			220
#define hkwd_URPCSEC_WRAP_DATA_EXIT_4  			221
#define hkwd_URPCSEC_WRAP_DATA_EXIT_5  			222
#define hkwd_URPCSEC_WRAP_DATA_EXIT_6  			223
#define hkwd_URPCSEC_WRAP_DATA_EXIT_7  			224
#define hkwd_URPCSEC_WRAP_DATA_EXIT_8  			225
#define hkwd_URPCSEC_WRAP_DATA_EXIT_9  			226
#define hkwd_URPCSEC_WRAP_DATA_EXIT_10 			227


#define hkwd_URPCSEC_UNWRAP_DATA_ENTER   		228
#define hkwd_URPCSEC_UNWRAP_DATA_EXIT_1  		229
#define hkwd_URPCSEC_UNWRAP_DATA_EXIT_2  		230
#define hkwd_URPCSEC_UNWRAP_DATA_EXIT_3  		231
#define hkwd_URPCSEC_UNWRAP_DATA_EXIT_4  		232
#define hkwd_URPCSEC_UNWRAP_DATA_EXIT_5  		233
#define hkwd_URPCSEC_UNWRAP_DATA_EXIT_6  		234
#define hkwd_URPCSEC_UNWRAP_DATA_EXIT_7  		235
#define hkwd_URPCSEC_UNWRAP_DATA_EXIT_8  		236
#define hkwd_URPCSEC_UNWRAP_DATA_EXIT_9  		237
#define hkwd_URPCSEC_UNWRAP_DATA_EXIT_10 		238
#define hkwd_URPCSEC_UNWRAP_DATA_EXIT_11 		239

#define hkwd_URPCSEC_MAX_DATA_LENGTH_ENTER  		240
#define hkwd_URPCSEC_MAX_DATA_LENGTH_EXIT_1 		241
#define hkwd_URPCSEC_MAX_DATA_LENGTH_EXIT_2 		242
#define hkwd_URPCSEC_MAX_DATA_LENGTH_EXIT_3 		243

/* rpcsec_gss_utils.c tracehooks */

#define hkwd_URPCSEC_MECH_TO_OID_ENTER  		244
#define hkwd_URPCSEC_MECH_TO_OID_EXIT_1 		245
#define hkwd_URPCSEC_MECH_TO_OID_EXIT_2 		246

#define hkwd_URPCSEC_OID_TO_MECH_ENTER  		247
#define hkwd_URPCSEC_OID_TO_MECH_EXIT_1 		248
#define hkwd_URPCSEC_OID_TO_MECH_EXIT_2 		249

#define hkwd_URPCSEC_QOP_TO_NUM_ENTER  			250
#define hkwd_URPCSEC_QOP_TO_NUM_EXIT_1 			251
#define hkwd_URPCSEC_QOP_TO_NUM_EXIT_2 			252
#define hkwd_URPCSEC_QOP_TO_NUM_EXIT_3 			253

#define hkwd_URPCSEC_NUM_TO_QOP_ENTER  			254
#define hkwd_URPCSEC_NUM_TO_QOP_EXIT_1 			255
#define hkwd_URPCSEC_NUM_TO_QOP_EXIT_2 			256
#define hkwd_URPCSEC_NUM_TO_QOP_EXIT_3 			257


#define hkwd_URPCSEC_SVC_TO_NUM_ENTER  			258
#define hkwd_URPCSEC_SVC_TO_NUM_EXIT_1		 	259
#define hkwd_URPCSEC_SVC_TO_NUM_EXIT_2 			260

#define hkwd_URPCSEC_NUM_TO_SVC_ENTER 			261
#define hkwd_URPCSEC_NUM_TO_SVC_EXIT  			262

#define hkwd_URPCSEC_GETPNAME_ENTER  			263
#define hkwd_URPCSEC_GETPNAME_EXIT_1 			264
#define hkwd_URPCSEC_GETPNAME_EXIT_2 			265
#define hkwd_URPCSEC_GETPNAME_EXIT_3 			266
#define hkwd_URPCSEC_GETPNAME_EXIT_4 			267
#define hkwd_URPCSEC_GETPNAME_EXIT_5 			268
#define hkwd_URPCSEC_GETPNAME_EXIT_6 			269
#define hkwd_URPCSEC_GETPNAME_EXIT_7 			270

#define hkwd_URPCSEC_GET_MECHANISMS 			271

#define hkwd_URPCSEC_GET_MECH_INFO_ENTER  		272
#define hkwd_URPCSEC_GET_MECH_INFO_EXIT_1 		273
#define hkwd_URPCSEC_GET_MECH_INFO_EXIT_2 		274

#define hkwd_URPCSEC_GET_VERSIONS_ENTER 		275
#define hkwd_URPCSEC_GET_VERSIONS_EXIT  		276

#define hkwd_URPCSEC_IS_INSTALLED_ENTER  		277
#define hkwd_URPCSEC_IS_INSTALLED_EXIT_1 		278
#define hkwd_URPCSEC_IS_INSTALLED_EXIT_2 		279
#define hkwd_URPCSEC_IS_INSTALLED_EXIT_3 		280
#define hkwd_URPCSEC_IS_INSTALLED_EXIT_4 		281

/* Tracehooks added later */

#define hkwd_URPCSEC_NAME2CRED_EXIT_5 			282

#define hkwd_URPCSEC_SECCREATE_EXIT_8  			283
#define hkwd_URPCSEC_SECCREATE_EXIT_9  			284
#define hkwd_URPCSEC_SECCREATE_EXIT_10 			285


#define PV_HKWD_DD_QLFCDD           			0x4AC00000
#define PV_HKWD_DD_QLFCPS           			0x4AD00000
#define PV_HKWD_MOVER           			0x4EE00000
#define PV_HKWD_IBL_PATH           			0x4F300000
#define	PV_HKWD_IBL_ERR          			0x4F400000
#define	PV_HKWD_GXL_PATH           			0x4F500000
#define PV_HKWD_GXL_ERR         			0x4F600000
#define PV_HKWD_XCRYPT      				0x4F700000
#define PV_HKWD_NDAF           				0x4F800000
#define PV_HKWD_USB_EHCI           			0x4FA00000
#define PV_HKWD_USB_TRANSACTION           		0x4FB00000
#define PV_HKWD_ICA_TRC_ERR           			0x52200000
#define PV_HKWD_ICA_TRC_VRBOS          			0x52300000
#define PV_HKWD_ICA_TRC_INTR_VRBOS           		0x52400000

#define PV_HKWD_SMBFS          				0x52500000
#define hkwd_cn_link_in         			1
#define hkwd_cn_link_out        			2
#define hkwd_cn_mkdir_in        			3
#define hkwd_cn_mkdir_out       			4
#define hkwd_cn_remove_in       			5
#define hkwd_cn_remove_out      			6
#define hkwd_cn_rename_in       			7
#define hkwd_cn_rename_out      			8
#define hkwd_cn_rmdir_in        			9
#define hkwd_cn_rmdir_out       			10
#define hkwd_cn_lookup_in       			11
#define hkwd_cn_lookup_out      			12
#define hkwd_cn_fid_in          			13
#define hkwd_cn_fid_out         			14
#define hkwd_cn_open_in         			15
#define hkwd_cn_open_out        			16
#define hkwd_cn_create_in       			17
#define hkwd_cn_create_out     			 	18
#define hkwd_cn_hold_in         			19
#define hkwd_cn_hold_out        			20
#define hkwd_cn_rele_in         			21
#define hkwd_cn_rele_out        			22
#define hkwd_cn_close_in        			23
#define hkwd_cn_close_out       			24
#define hkwd_cn_map_in          			25
#define hkwd_cn_map_out         			26
#define hkwd_cn_unmap_in        			27
#define hkwd_cn_unmap_out       			28
#define hkwd_cn_access_in       			29
#define hkwd_cn_access_out      			30
#define hkwd_cn_getattr_in      			31
#define hkwd_cn_getattr_out     			32
#define hkwd_cn_setattr_in      			33
#define hkwd_cn_setattr_out     			34
#define hkwd_cn_ftrunc_in       			35
#define hkwd_cn_ftrunc_out      			36
#define hkwd_cn_rdwr_in         			37
#define hkwd_cn_rdwr_out        			38
#define hkwd_cn_readdir_in      			39
#define hkwd_cn_readdir_out     			40
#define hkwd_cn_getacl_in       			41
#define hkwd_cn_getacl_out      			42
#define hkwd_cn_setacl_in       			43
#define hkwd_cn_setacl_out      			44
#define hkwd_cifs_mount_in      			45
#define hkwd_cifs_mount_out     			46
#define hkwd_cifs_unmount_in    			47
#define hkwd_cifs_unmount_out   			48
#define hkwd_cifs_root_in       			49
#define hkwd_cifs_root_out      			50
#define hkwd_cifs_statfs_in     			51
#define hkwd_cifs_statfs_out    			52
#define hkwd_cifs_vget_in       			53
#define hkwd_cifs_vget_out      			54
#define hkwd_nsmb_dev_ioctl_in  			55
#define hkwd_nsmb_dev_ioctl_out 			56

#define PV_HKWD_MOBIP6           			0x53A00000
#define hkwd_kmobip6_config_in          		1
#define hkwd_kmobip6_config_out         		2
#define hkwd_mobip6_dispatch_badcmd     		3
#define hkwd_mobip6_ctrl_in             		5
#define hkwd_mobip6_ctrl_out            		6
#define hkwd_ip6ip6_input_in            		7
#define hkwd_ip6ip6_input_out           		8
#define hkwd_new_bul_in                 		9
#define hkwd_new_bul_out                		10
#define hkwd_new_bcl_in                 		11
#define hkwd_new_bcl_out                		12
#define hkwd_free_bul_in                		13
#define hkwd_free_bul_out               		14
#define hkwd_free_bcl_in                		15
#define hkwd_free_bcl_out               		16
#define hkwd_scan_bul_in                		17
#define hkwd_scan_bul_out               		18
#define hkwd_scan_binding_in            		19
#define hkwd_scan_binding_out           		20
#define hkwd_scan_bcl_ha_in             		21
#define hkwd_scan_bcl_ha_out            		22
#define hkwd_scan_bcl_lha_in            		23
#define hkwd_scan_bcl_lha_out           		24
#define hkwd_scan_bcl_in                		27
#define hkwd_scan_bcl_out               		28
#define hkwd_scan_bcl_dad_in            		29
#define hkwd_scan_bcl_dad_out           		30
#define hkwd_add_bul_in                 		31
#define hkwd_add_bul_out                		32
#define hkwd_add_bcl_in                 		33
#define hkwd_add_bcl_out                		34
#define hkwd_del_bul_in                 		36
#define hkwd_del_bul_out                		37
#define hkwd_del_bcl_in                 		38
#define hkwd_del_bcl_out                		39
#define hkwd_binding_timer_in           		40
#define hkwd_binding_timer_out          		41
#define hkwd_init_timer_in              		42
#define hkwd_init_timer_out             		43
#define hkwd_term_timer_in              		44
#define hkwd_term_timer_out             		45
#define hkwd_reset_bul_in               		46
#define hkwd_reset_bul_out              		47
#define hkwd_reset_bcl_in               		48
#define hkwd_reset_bcl_out              		49
#define hkwd_update_bul_in              		50
#define hkwd_update_bul_out             		51
#define hkwd_get_bul_in                 		52
#define hkwd_get_bul_out                		53
#define hkwd_get_bcl_in                 		54
#define hkwd_get_bcl_out                		55
#define hkwd_ctrl_add_bul_in            		56
#define hkwd_ctrl_add_bul_out           		57
#define hkwd_ctrl_del_bul_in            		58
#define hkwd_ctrl_del_bul_out           		59
#define hkwd_ctrl_add_bcl_in            		60
#define hkwd_ctrl_add_bcl_out           		61
#define hkwd_ctrl_del_bcl_in            		63
#define hkwd_ctrl_del_bcl_out           		64
#define hkwd_dopt6_add_in               		66
#define hkwd_dopt6_add_out              		67
#define hkwd_dopt6_del_in               		68
#define hkwd_dopt6_del_out              		69
#define hkwd_init_proto_in              		70
#define hkwd_init_proto_out             		71
#define hkwd_term_proto_in              		72
#define hkwd_term_proto_out             		73
#define hkwd_build_ha_opt_in            		74
#define hkwd_build_ha_opt_out           		75
#define hkwd_build_bu_opt_in            		76
#define hkwd_build_bu_opt_out           		77
#define hkwd_build_ba_opt_in            		78
#define hkwd_build_ba_opt_out           		80
#define hkwd_build_br_opt_in            		81
#define hkwd_build_br_opt_out           		82
#define hkwd_build_rh_opt_in            		83
#define hkwd_build_rh_opt_out           		84
#define hkwd_build_ba_in                		85
#define hkwd_build_ba_out               		86
#define hkwd_build_bu_in                		90
#define hkwd_build_bu_out               		91
#define hkwd_build_br_in                		95
#define hkwd_build_br_out               		96
#define hkwd_add_bu_opt_in              		100
#define hkwd_add_bu_opt_out             		103
#define hkwd_add_br_opt_in              		104
#define hkwd_add_br_opt_out             		107
#define hkwd_add_ha_opt_in              		108
#define hkwd_add_ha_opt_out             		109
#define hkwd_add_rh_opt_in              		112
#define hkwd_add_rh_opt_out             		113
#define hkwd_opt6_ha_input_in           		116
#define hkwd_opt6_ha_input_out          		117
#define hkwd_opt6_bu_input_in           		118
#define hkwd_opt6_bu_input_out          		119
#define hkwd_opt6_ba_input_in           		125
#define hkwd_opt6_ba_input_out          		127
#define hkwd_opt6_br_input_in           		129
#define hkwd_opt6_br_input_out          		130
#define hkwd_extract_addrs_in           		131
#define hkwd_extract_addrs_out          		132
#define hkwd_packet_check_in            		137
#define hkwd_packet_check_out           		138
#define hkwd_mobip6_checkopt_in         		139
#define hkwd_mobip6_checkopt_out        		140
#define hkwd_encapsulate_in             		141
#define hkwd_encapsulate_out            		142
#define hkwd_mobip6_output_in           		144
#define hkwd_mobip6_output_out          		145
#define hkwd_mobip6_extrasize_in        		148
#define hkwd_mobip6_extrasize_out       		149
#define hkwd_mobip6_registration_in     		150
#define hkwd_mobip6_registration_out    		151
#define hkwd_request_tun_in             		152
#define hkwd_request_tun_out            		153
#define hkwd_request_ndp_in             		155
#define hkwd_request_ndp_out            		156
#define hkwd_ack_req_in                 		158
#define hkwd_ack_req_out                		159
#define hkwd_read_req_in                		160
#define hkwd_read_req_out               		161
#define hkwd_reset_req_in               		163
#define hkwd_reset_req_out              		164
#define hkwd_mob_icmp6_input_in         		165
#define hkwd_mob_icmp6_input_out        		166

#define hkwd_get_if_name_in             		170
#define hkwd_get_if_name_out            		171
#define hkwd_check_reg_in               		172
#define hkwd_check_reg_out              		173
#define hkwd_get_home_addr_in           		174
#define hkwd_get_home_addr_out          		175
#define hkwd_get_careof_addr_in         		176
#define hkwd_get_careof_addr_out        		177

#define hkwd_mh_opts_input_in           		200
#define hkwd_mh_opts_input_out          		201
#define hkwd_mh_brr_input_in            		202
#define hkwd_mh_brr_input_out           		203
#define hkwd_mh_hoti_input_in           		204
#define hkwd_mh_hoti_input_out          		205
#define hkwd_mh_coti_input_in           		206
#define hkwd_mh_coti_input_out          		207
#define hkwd_mh_hot_input_in            		208
#define hkwd_mh_hot_input_out           		209
#define hkwd_mh_cot_input_in            		210
#define hkwd_mh_cot_input_out           		211
#define hkwd_mh_bu_input_in             		212
#define hkwd_mh_bu_input_out            		213
#define hkwd_mh_ba_input_in             		214
#define hkwd_mh_ba_input_out            		215
#define hkwd_mh_be_input_in             		216
#define hkwd_mh_be_input_out            		217
#define hkwd_build_mh_hoti_in           		220
#define hkwd_build_mh_hoti_out          		221
#define hkwd_build_mh_coti_in           		222
#define hkwd_build_mh_coti_out          		223
#define hkwd_build_mh_bu_in             		224
#define hkwd_build_mh_bu_out            		225
#define hkwd_build_mh_ba_in             		226
#define hkwd_build_mh_ba_out            		227
#define hkwd_build_mh_brr_in            		228
#define hkwd_build_mh_brr_out           		229
#define hkwd_send_mh_hot_in             		230
#define hkwd_send_mh_hot_out            		231
#define hkwd_send_mh_cot_in             		232
#define hkwd_send_mh_cot_out            		233
#define hkwd_send_mh_be_in              		234
#define hkwd_send_mh_be_out             		235
#define hkwd_mh_bu_input_after_dad_in   		236
#define hkwd_mh_bu_input_after_dad_out  		237
#define hkwd_mob_relay_icmp6_in         		238
#define hkwd_mob_relay_icmp6_out        		239


#define hkwd_mob_unreach_icmp6_in       		240
#define hkwd_mob_unreach_icmp6_out      		241
#define hkwd_check_cnbuba_in            		242
#define hkwd_check_cnbuba_out           		243


#define PV_HKWD_VIOENT_XMIT           			0x53B00000
#define PV_HKWD_VIOENT_RECV           			0x53C00000
#define PV_HKWD_VIOENT_OTHER           			0x53D00000
#define PV_HKWD_VSCSI_CLIENT           			0x53E00000
#define PV_HKWD_VSCSI_SERVER           			0x53F00000
#define PV_HKWD_VSCSI_COMMON           			0x59600000
#define PV_HKWD_VENT_XMIT           			0x59800000
#define PV_HKWD_VENT_RECV           			0x59900000
#define PV_HKWD_VENT_OTHER           			0x59A00000
#define PV_HKWD_VSCSI_CLIENT_L2        			0x59E00000
#define PV_HKWD_VSCSI_CLIENT_PERF           		0x59F00000
#define PV_HKWD_FCIP           				0x5A500000
#define PV_HKWD_DD_QFCDD           			0x5A800000
#define PV_HKWD_DD_QFCPS           			0x5A900000
#define PV_HKWD_VMC_DEBUG           			0x5AE00000
#define PV_HKWD_VMC_PERF           			0x5AF00000
#define PV_HKWD_BENT_XMIT           			0x5B200000
#define PV_HKWD_BENT_RECV           			0x5B300000
#define PV_HKWD_BENT_OTHER           			0x5B400000
#define PV_HKWD_NFS4_DSET           			0x5BB00000
#define PV_HKWD_KDAPL           			0x5C100000
#define PV_HKWD_KDAPL_ERR           			0x5C200000
#define PV_HKWD_UDAPL           			0x5C300000
#define PV_HKWD_UDAPL_ERR           			0x5C400000
#define PV_HKWD_KDAT           				0x5C500000
#define PV_HKWD_UDAT           				0x5C700000
#define PV_HKWD_UDAT_ERR           			0x5C800000
#define PV_HKWD_DD_SISRAID_ERR           		0x5C900000
#define PV_HKWD_DD_MPTADAPDD           			0x5CC00000
#define PV_HKWD_DD_CSCSIDD           			0x5CD00000
#define PV_HKWD_NFS_WPAR           			0x5D000000
#define PV_HKWD_TSIB_USER           			0x5D100000
#define PV_HKWD_TSIB_USER_ERR          			0x5D200000
#define PV_HKWD_MCRK           				0x5D300000
#define PV_HKWD_SISSAS_ERR           			0x5DD00000
#define PV_HKWD_HEADD_XMT           			0x5DF00000
#define PV_HKWD_HEADD_RCV           			0x5E000000
#define PV_HKWD_HEADD_GEN           			0x5E100000
#define PV_HKWD_ISCSITM_SERVER         			0x5E300000
#define PV_HKWD_ISCSITM_COMMON         			0x5E400000
#define PV_HKWD_ISCSITM_PERF           			0x5E500000
#define PV_HKWD_DD_SCTAPE_ERR          			0x5E800000
#define PV_HKWD_DD_IDECDROM_ERR           		0x5E900000
#define PV_HKWD_KXENT_XMIT           			0x5ED00000
#define PV_HKWD_KXENT_RECV           			0x5EE00000
#define PV_HKWD_KXENT_OTHER           			0x5EF00000

#define PV_HKWD_VRM_PAGER          	 		0x5F300000
/* Hookwords for pager_config() in pager_config.c */

#define hkwd_pager_config_forwarder_table_setup			0x001
#define hkwd_pager_config_configuring_kdb			0x002
#define hkwd_pager_config_initial_setup_completed		0x003
#define hkwd_pager_config_cfg_init_start			0x004
#define hkwd_pager_config_cfg_init_failed			0x005
#define hkwd_pager_config_cfg_init_finish			0x006
#define hkwd_pager_config_cfg_term_start			0x007
#define hkwd_pager_config_no_pagers				0x008
#define hkwd_pager_config_cfg_term_failed 			0x009
#define hkwd_pager_config_cfg_term_finish			0x00A
#define hkwd_pager_config_invalid_command			0x00B
#define hkwd_pager_config_cleanup_completed			0x00C

/* Hookwords for pager_cfg_init() in pager_config.c */

#define hkwd_pager_cfg_init_in					0x010
#define hkwd_pager_cfg_init_pager_allocated			0x011
#define hkwd_pager_cfg_init_uiomove_failed 			0x012
#define hkwd_pager_cfg_init_local_ras_register_failed 		0x013
#define hkwd_pager_cfg_init_error_ras_register_failed		0x014
#define hkwd_pager_cfg_init_forwarder_config_failed		0x015
#define hkwd_pager_cfg_init_set_pager_head 			0x016
#define hkwd_pager_cfg_init_set_pager_next 			0x017
#define hkwd_pager_cfg_init_out  				0x018


/* Hookwords for pager_cfg_term() in pager_config.c */

#define hkwd_pager_cfg_term_in 					0x020
#define hkwd_pager_cfg_term_no_pager_found  			0x021
#define hkwd_pager_cfg_term_pager_acs_found			0x022
#define hkwd_pager_cfg_term_pager_in_use   			0x023
#define hkwd_pager_cfg_term_pager_not_ready  			0x024
#define hkwd_pager_cfg_term_forwarder_config_failed 		0x025
#define hkwd_pager_cfg_term_pager_acs_freed   			0x026
#define hkwd_pager_cfg_term_out					0x027

/********** Hookwords for pager_ctl.c ***********************************/

/* Hookwords for pager_ctl() in pager_ctl.c */

#define hkwd_pager_ctl_in      					0x100
#define hkwd_pager_ctl_copyin_fail   				0x101
#define hkwd_pager_ctl_pager_not_found  			0x102
#define hkwd_pager_ctl_add_stream_start 			0x103
#define hkwd_pager_ctl_add_stream_copyin_fail 			0x104
#define hkwd_pager_ctl_add_stream_fail  			0x105
#define hkwd_pager_ctl_add_stream_finish 			0x106
#define hkwd_pager_ctl_del_stream_start  			0x107
#define hkwd_pager_ctl_del_stream_fail 				0x108
#define hkwd_pager_ctl_del_stream_finish  			0x109
#define hkwd_pager_ctl_get_stream_stats_start 			0x10A
#define hkwd_pager_ctl_get_stream_stats_fail   			0x10B
#define hkwd_pager_ctl_get_stream_stats_finish 			0x10C
#define hkwd_pager_ctl_invalid_command 				0x10D
#define hkwd_pager_ctl_free_data 				0x10E
#define hkwd_pager_ctl_out  					0x10F


/* Hookwords for pager_ctl_find_pager() in pager_ctl.c */

#define hkwd_pager_ctl_find_pager_in   				0x110
#define hkwd_pager_ctl_find_pager_return_acs_null		0x111
#define hkwd_pager_ctl_find_pager_lockl_fail  			0x112
#define hkwd_pager_ctl_find_pager_no_pager_found		0x113
#define hkwd_pager_ctl_find_pager_out     			0x114



/********** Hookwords for pager_util.c ***********************************/

/* Hookwords for pager_initiate_stream_closure() in pager_util.c */

#define hkwd_pager_initiate_stream_closure_in			0x200
#define hkwd_pager_initiate_stream_closure_close_failed		0x201
#define hkwd_pager_initiate_stream_closure_send_signal_failed	0x202
#define hkwd_pager_initiate_stream_closure_out 			0x203



/* Hookwords for pager_process_stream_state_change() in pager_util.c */

#define hkwd_pager_process_stream_state_change_in  			0x210
#define hkwd_pager_process_stream_state_change_completed 		0x211
#define hkwd_pager_process_stream_state_change_close_stream_error	0x212
#define hkwd_pager_process_stream_state_change_stopped   		0x213
#define hkwd_pager_process_stream_state_change_issue_signal_failed 	0x214
#define hkwd_pager_process_stream_state_change_default   		0x215
#define hkwd_pager_process_stream_state_change_out  			0x216

/* Hookwords for pager_shutdown_callback() in pager_util.c */

#define hkwd_pager_shutdown_callback_in  				0x220
#define hkwd_pager_shutdown_callback_out 				0x221

/* Hookwords for pager_process_received_modifier() in pager_util.c */

#define hkwd_pager_process_received_modifier_in 			0x230
#define hkwd_pager_process_received_modifier_out 			0x231

#define PV_HKWD_MXIB           				0x5F700000
#define PV_HKWD_MXIB_GENERAL           			0x5F800000
#define PV_HKWD_MXIB_ERROR           			0x5F900000
#define PV_HKWD_MXIB_DEBUG           			0x5FA00000
#define PV_HKWD_MXIB_USER           			0x5FB00000
#define PV_HKWD_LIBC_MALL_COMMON           		0x60A00000
#define PV_HKWD_USB_OHCI           			0x61C00000
#define PV_HKWD_USB_OHCI_TRANSACTION           		0x61D00000
#define PV_HKWD_USB_AUDIO           			0x61E00000
#define PV_HKWD_DD_VFCDD           			0x63000000
#define PV_HKWD_DD_VFCDD_PERF           		0x63100000
#define PV_HKWD_GXL_PATH           			0x63700000
#define PV_HKWD_GXL_ERR         			0x63800000
#define PV_HKWD_DD_QLFCPS_ERR          			0x63A00000
#define PV_HKWD_DD_QLFCDD_ERR          			0x63B00000
#define PV_HKWD_RRENT_OTHER           			0x64400000
#define PV_HKWD_RRENT_XMIT           			0x64500000
#define PV_HKWD_RRENT_RECV          		 	0x64600000
#define PV_HKWD_RRHBA_XMIT           			0x64800000
#define PV_HKWD_RRHBA_RECV           			0x64900000

#define PV_HKWD_Y4CRYPT          			0x64E00000

/* y4 fast path constants */
#define Y4_SUCCESS                      		0
#define Y4_ERR_FP_MM_BUSY               		0x1
#define Y4_ERR_FP_MM_DISABLED           		0x2
#define Y4_ERR_REQUEST_DMA_NOACC        		0x3
#define Y4_ERR_REPLY_DMA_NOACC          		0x4

#define PV_HKWD_USBTAPE           			0x65000000
#define PV_HKWD_DD_USBTAPE_ERR          		0x65100000
#define PV_HKWD_OFED_RDMACM           			0x65600000
#define PV_HKWD_OFED_IBV           			0x65700000
#define PV_HKWD_SCTP           				0x65900000
#define PV_HKWD_SCTP_ERR           			0x65A00000
#define PV_HKWD_MPT2ADAPDD_ERR           		0x65C00000
#define PV_HKWD_ELXENT_XMIT           			0x65D00000
#define PV_HKWD_ELXENT_RECV           			0x65E00000
#define PV_HKWD_ELXENT_OTHER         		  	0x65F00000
#define PV_HKWD_NMENT_XMIT           			0x66000000
#define PV_HKWD_NMENT_RECV           			0x66100000
#define PV_HKWD_NMENT_OTHER           			0x66200000

#define PV_HKWD_CLUSTER_USR           			0x66300000
#define hkwd_clutil_crlm_out                   		0x01
#define hkwd_clutil_crlm_out2                  		0x02
#define hkwd_clutil_crlm_out3                  		0x03
#define hkwd_clutil_crlm_err                   		0x04
#define hkwd_clutil_crlm_err2                  		0x05
#define hkwd_clutil_crlm_err3                  		0x06

#define PV_HKWD_MUSENT_RECV           			0x66400000
#define PV_HKWD_MUSENT_XMIT           			0x66500000
#define PV_HKWD_MUSENT_OTHER           			0x66600000

#define PV_HKWD_CLUST_LINK           			0x66B00000
#define hkwd_cluster_handle_tcpsock_ndd_entry 		0x01
#define hkwd_cluster_handle_tcpsock_ndd_err1		0x02
#define hkwd_cluster_handle_tcpsock_ndd_err2		0x03
#define hkwd_cluster_handle_tcpsock_ndd_exit		0x04
#define hkwd_update_site_state_entry  			0x10
#define hkwd_update_site_state_err1   			0x11
#define hkwd_update_site_state_info1  			0x12
#define hkwd_update_site_state_exit  			0x13
/* kcluster_link.c */
#define hkwd_xcluster_link_query_entry			0x20
#define hkwd_xcluster_link_query_err			0x21
#define hkwd_xcluster_link_query_exit			0x22
#define hkwd_send_link_init_entry  			0x23
#define hkwd_send_link_init_exit  			0x24
#define hkwd_link_proc_entry   				0x25
#define hkwd_link_proc_err1 				0x26
#define hkwd_process_msg_link_entry  			0x27
#define hkwd_process_msg_link_exit  			0x28
#define hkwd_link_query_info1  				0x29

#define hkwd_multisite_init_entry   			0x40
#define hkwd_multisite_init_err1    			0x41
#define hkwd_multisite_init_err2   			0x42
#define hkwd_multisite_init_exit  			0x43
#define hkwd_multisite_connection_monitor_entry 	0x44
#define hkwd_multisite_connection_monitor_info1  	0x45
#define hkwd_multisite_connection_monitor_info2 	0x46
#define hkwd_multisite_connection_monitor_exit 		0x47
#define hkwd_multisite_findtcpsock_ifdatap_entry	0x48
#define hkwd_multisite_findtcpsock_ifdatap_exit	 	0x49
#define hkwd_multisite_cleanup_entry  			0x4a
#define hkwd_multisite_cleanup_exit   			0x4b
/* kcluster_tcpsock.c */
#define hkwd_tcpsock_listen_entry 			0x70
#define hkwd_tcpsock_listen_err1   			0x71
#define hkwd_tcpsock_listen_err2  			0x72
#define hkwd_tcpsock_listen_err3 			0x73
#define hkwd_tcpsock_listen_err4  			0x74
#define hkwd_tcpsock_listen_exit 			0x75
#define hkwd_tcpsock_accept_entry 			0x76
#define hkwd_tcpsock_accept_err1   			0x77
#define hkwd_tcpsock_accept_exit  			0x78
#define hkwd_tcpsock_connect_entry 			0x79
#define hkwd_tcpsock_connect_err1     			0x7a
#define hkwd_tcpsock_connect_err2     			0x7b
#define hkwd_tcpsock_connect_info1			0x7c
#define hkwd_tcpsock_connect_info2   			0x7d
#define hkwd_tcpsock_connect_err3   			0x7e
#define hkwd_tcpsock_connect_err4     			0x7f
#define hkwd_tcpsock_connect_err5     			0x80
#define hkwd_tcpsock_connect_exit     			0x81
#define hkwd_tcpsock_recv_entry          		0x82
#define hkwd_tcpsock_recv_err1        			0x83
#define hkwd_tcpsock_recv_err2     			0x84
#define hkwd_tcpsock_recv_err3      			0x85
#define hkwd_tcpsock_recv_exit       			0x86
#define hkwd_tcpsock_send_entry   			0x87
#define hkwd_tcpsock_send_err1    			0x88
#define hkwd_tcpsock_send_err2   			0x89
#define hkwd_tcpsock_send_err3 				0x8a
#define hkwd_tcpsock_send_exit   			0x8b
/* kcluster_tcpsock_ndd.c */
#define hkwd_tcpsock_ndd_close_exit 			0x100
#define hkwd_tcpsock_ns_alloc_entry   			0x101
#define hkwd_tcpsock_ns_alloc_err1  			0x102
#define hkwd_tcpsock_ns_alloc_exit    			0x103
#define hkwd_tcpsock_ndd_ctl_entry   			0x104
#define hkwd_tcpsock_ndd_ctl_tcpconnect			0x105
#define hkwd_tcpsock_ndd_ctl_tcpaccept  		0x106
#define hkwd_tcpsock_ndd_ctl_exit 			0x107
#define hkwd_tcpsock_ndd_ctl_err1   			0x108
#define hkwd_tcpsock_ndd_set_entry  			0x109
#define hkwd_tcpsock_ndd_send_thread_entry 		0x10a
#define hkwd_tcpsock_ndd_send_thread_err1 		0x10b
#define hkwd_tcpsock_ndd_send_thread_exit  		0x10c
#define hkwd_tcpsock_ndd_recv_thread_entry  		0x10d
#define hkwd_tcpsock_ndd_recv_thread_err1 		0x10e
#define hkwd_tcpsock_ndd_recv_thread_err2 		0x10f
#define hkwd_tcpsock_ndd_recv_thread_exit 		0x110
#define hkwd_tcpsock_ndd_add2_sendq_entry 		0x111
#define hkwd_tcpsock_ndd_add2_sendq_err1 		0x112
#define hkwd_tcpsock_ndd_add2_sendq_exit 		0x113
#define hkwd_tcpsock_ndd_create_threads_entry		0x114
#define hkwd_tcpsock_ndd_create_threads_err1		0x115
#define hkwd_tcpsock_ndd_create_threads_err2		0x116
#define hkwd_tcpsock_ndd_create_threads_exit 		0x117
#define hkwd_tcpsock_ns_free_entry   			0x118
#define hkwd_tcpsock_ns_free_exit  			0x119
#define hkwd_tcpsock_ndd_unset_entry   			0x11a
#define hkwd_tcpsock_ndd_unset_exit			0x11b

#define PV_HKWD_MLXENT_OTHER           			0x66C00000
#define PV_HKWD_MLXENT_RESPONSE        			0x66D00000
#define PV_HKWD_MLXENT_TRANSMIT        			0x66E00000
#define PV_HKWD_MLXENT_RECEIVE           		0x66F00000
#define PV_HKWD_MLXENT_RDMA           			0x67000000

#define PV_HKWD_STNFS_GENERAL           		0x10020000
#define hkwd_stnfs_storage_init                 	0x00000001
#define hkwd_stnfs_storage_uninit               	0x00000002
#define hkwd_stnfs_ras_init                     	0x00000003
#define hkwd_stnfs_ras_uninit                   	0x00000004
#define hkwd_stnfs_dr_event                     	0x00000005
#define hkwd_stnfs_config                       	0x00000006
#define hkwd_stnfs_create_remote_node           	0x00000007
#define hkwd_stnfs_create_local_node            	0x00000008
#define hkwd_stnfs_destroy_gnode                	0x00000009
#define hkwd_stnfs_destroy_node                 	0x0000000A
#define hkwd_stnfs_fetch_attrs                  	0x0000000B
#define hkwd_stnfs_fetch_symlink_data           	0x0000000C
#define hkwd_stnfs_populate_node                	0x0000000D
#define hkwd_stnfs_free_dir_list                	0x0000000E
#define hkwd_stnfs_check_access                 	0x0000000F
#define hkwd_stnfs_change_node_name             	0x00000010
#define hkwd_stnfs_link_node                    	0x00000011
#define hkwd_stnfs_option_cntl                  	0x00000012
#define hkwd_inet_pton6                         	0x00000013
#define hkwd_inet_pton4                         	0x00000014
#define hkwd_inet_aton                          	0x00000015
#define hkwd_stnfs_worker_init                  	0x00000016
#define hkwd_stnfs_worker_uninit                	0x00000017
#define hkwd_stnfs_put_work                     	0x00000018
#define hkwd_stnfs_get_work                     	0x00000019
#define hkwd_stnfs_worker                       	0x0000001A
#define hkwd_stnfs_work                         	0x0000001B
#define hkwd_stnfs_do_replication               	0x0000001C
#define hkwd_stnfs_compatible                   	0x0000001D
#define hkwd_stnfs_check_fs_locations           	0x0000001E
#define hkwd_stnfs_recover_node                 	0x0000001F
#define hkwd_stnfs_do_lookup                    	0x00000020
#define hkwd_stnfs_do_getattr                   	0x00000021
#define hkwd_stnfs_recover_fh                   	0x00000022
#define hkwd_stnfs_submit_get_node              	0x00000023
#define hkwd_stnfs_submit_replication_getattr   	0x00000024

#define PV_HKWD_STNFS_VNOPS           			0x10030000
#define hkwd_stnfs_lookup                       	0x00000001
#define hkwd_stnfs_readdir                      	0x00000002
#define hkwd_stnfs_remove                       	0x00000003
#define hkwd_stnfs_rmdir                        	0x00000004
#define hkwd_stnfs_mkdir                        	0x00000005
#define hkwd_stnfs_symlink                      	0x00000006
#define hkwd_stnfs_readlink                     	0x00000007
#define hkwd_stnfs_mknod                        	0x00000008
#define hkwd_stnfs_rename                      	 	0x00000009
#define hkwd_stnfs_readdir_eofp                 	0x0000000A
#define hkwd_stnfs_link                         	0x0000000B
#define hkwd_stnfs_open                         	0x0000000C
#define hkwd_stnfs_close                        	0x0000000D
#define hkwd_stnfs_create                       	0x0000000E
#define hkwd_stnfs_ftrunc                       	0x0000000F
#define hkwd_stnfs_fsync                        	0x00000010
#define hkwd_stnfs_fsync_range                  	0x00000011
#define hkwd_stnfs_lockctl                      	0x00000012
#define hkwd_stnfs_unmap                        	0x00000013
#define hkwd_stnfs_seek                         	0x00000014
#define hkwd_stnfs_create_attr                  	0x00000015
#define hkwd_stnfs_finfo                        	0x00000016
#define hkwd_stnfs_map_lloff                    	0x00000017
#define hkwd_stnfs_memcntl                      	0x00000018
#define hkwd_stnfs_getea                        	0x00000019
#define hkwd_stnfs_setea                        	0x0000001A
#define hkwd_stnfs_listea                       	0x0000001B
#define hkwd_stnfs_statea                       	0x0000001C
#define hkwd_stnfs_removeea                     	0x0000001D
#define hkwd_stnfs_getxacl                      	0x0000001E
#define hkwd_stnfs_setxacl                      	0x0000001F
#define hkwd_stnfs_getattr                      	0x00000020
#define hkwd_stnfs_setattr                      	0x00000021
#define hkwd_stnfs_access                       	0x00000022
#define hkwd_stnfs_ioctl                        	0x00000023
#define hkwd_stnfs_select                       	0x00000024
#define hkwd_stnfs_fid                          	0x00000025
#define hkwd_stnfs_revoke                       	0x00000026
#define hkwd_stnfs_getacl                       	0x00000027
#define hkwd_stnfs_setacl                       	0x00000028
#define hkwd_stnfs_getpcl                       	0x00000029
#define hkwd_stnfs_setpcl                       	0x0000002A
#define hkwd_stnfs_vnop_nosys                   	0x0000002B
#define hkwd_stnfs_rdwr                         	0x0000002C
#define hkwd_stnfs_rdwr_attr                    	0x0000002D
#define hkwd_stnfs_fclear                       	0x0000002E

#define PV_HKWD_STNFS_HOLD_RELE        			0x10040000
#define hkwd_stnfs_hold                         	0x00000001
#define hkwd_stnfs_rele                         	0x00000002

#define PV_HKWD_STNFS_ID           			0x10050000
#define hkwd_stnfs_id_init                      	0x00000001
#define hkwd_stnfs_id_uninit                    	0x00000002
#define hkwd_stnfs_id_read                      	0x00000003
#define hkwd_stnfs_string_to_uid                	0x00000004
#define hkwd_stnfs_string_to_gid                	0x00000005
#define hkwd_stnfs_populate_pw                  	0x00000006
#define hkwd_stnfs_populate_gr                  	0x00000007
#define hkwd_stnfs_strtok                       	0x00000008
#define hkwd_stnfs_insert_uid_table             	0x00000009
#define hkwd_stnfs_insert_gid_table             	0x0000000A
#define hkwd_stnfs_free_id_table                	0x0000000B
#define hkwd_stnfs_host_to_addr                 	0x0000000C


#define PV_HKWD_STNFS_IO           			0x10060000
#define hkwd_stnfs_io_init                      	0x00000001
#define hkwd_stnfs_io_uninit                    	0x00000002
#define hkwd_stnfs_io_set_pages                 	0x00000003
#define hkwd_stnfs_create_segment               	0x00000004
#define hkwd_stnfs_truncate_segment             	0x00000005
#define hkwd_stnfs_delete_segment               	0x00000006
#define hkwd_stnfs_io                           	0x0000000A
#define hkwd_stnfs_pager                        	0x0000000B
#define hkwd_stnfs_pager_thread                 	0x0000000C


#define PV_HKWD_STNFS_OTW           			0x10070000
#define hkwd_stnfs_get_root_fh3                 	0x00000001
#define hkwd_stnfs_get_root_fh4                 	0x00000002
#define hkwd_stnfs_getattr_otw                  	0x00000003
#define hkwd_stnfs_lookup_otw                   	0x00000004
#define hkwd_stnfs_readlink_otw                 	0x00000005
#define hkwd_stnfs_read_otw                     	0x00000006
#define hkwd_stnfs_readdir_otw                  	0x00000007
#define hkwd_call_mountd                        	0x00000008
#define hkwd_call_server                        	0x00000009
#define hkwd_xdr_lookup_str_res                 	0x0000000A
#define hkwd_xdr_lookup_str_arg4                	0x0000000B
#define hkwd_xdr_lookup_str_res4                	0x0000000C
#define hkwd_xdr_lookup_arg4                    	0x0000000D
#define hkwd_xdr_lookup_res4                    	0x0000000E
#define hkwd_xdr_getattr_arg4                   	0x0000000F
#define hkwd_xdr_getattr_res4                   	0x00000010
#define hkwd_xdr_readlink_arg4                  	0x00000011
#define hkwd_xdr_readlink_res4                  	0x00000012
#define hkwd_xdr_read_arg4                      	0x00000013
#define hkwd_xdr_read_res4                      	0x00000014
#define hkwd_xdr_readdir_arg4                   	0x00000015
#define hkwd_xdr_readdir_res4                   	0x00000016
#define hkwd_xdr_stg_filehandle                 	0x00000017
#define hkwd_xdr_stp_lookup                     	0x00000018
#define hkwd_xdr_vattr_result                   	0x00000019
#define hkwd_xdr_vattr                          	0x0000001A
#define hkwd_xdr_vattr_fattr4                   	0x0000001B
#define hkwd_xdr_lookup_result                 	 	0x0000001C
#define hkwd_xdr_readlink_result                	0x0000001D
#define hkwd_xdr_readdir_arg                    	0x0000001E
#define hkwd_xdr_readdirplus_arg                	0x0000001F
#define hkwd_xdr_read_arg                      	 	0x00000020
#define hkwd_xdr_read_res                      	 	0x00000021
#define hkwd_xdr_readdir_res                    	0x00000022
#define hkwd_xdr_readdirplus_res                	0x00000023
#define hkwd_xdr_stnfs_string                   	0x00000024
#define hkwd_xdr_pmap                           	0x00000025
#define hkwd_stnfs_get_fs_locations_otw         	0x00000026
#define hkwd_stnfs_free_fs_locations            	0x00000027
#define hkwd_stnfs_fetch_mount_attr             	0x00000028
#define hkwd_stnfs_start_call_server            	0x00000029
#define hkwd_stnfs_end_call_server              	0x0000002A
#define hkwd_stnfs_check_replication           	 	0x0000002B
#define hkwd_stnfs_end_replication              	0x0000002C
#define hkwd_stnfs_get_fsattr_otw               	0x0000002D
#define hkwd_stnfs_check_fs_gen                 	0x0000002E
#define hkwd_stnfs_get_fh                       	0x0000002F
#define hkwd_stnfs_recover_rootfh_otw           	0x00000030
#define hkwd_stnfs_recover_fh_otw               	0x00000031
#define hkwd_stnfs_submit_get_fh                	0x00000032

#define PV_HKWD_STNFS_TREE           			0x10080000
#define hkwd_stnfs_add_child                    	0x00000001
#define hkwd_stnfs_remove_child                 	0x00000002
#define hkwd_stnfs_node_t                       	0x00000003
#define hkwd_stnfs_find_child                   	0x00000004
#define hkwd_stnfs_delete_children             	 	0x00000005
#define hkwd_stnfs_balance_tree                 	0x00000006
#define hkwd_remove_subdirectory                	0x00000007
#define hkwd_stnfs_add_child_again              	0x00000008

#define PV_HKWD_STNFS_VFSOPS           			0x10090000
#define hkwd_stnfs_mount                        	0x00000001
#define hkwd_stnfs_unmount                      	0x00000002
#define hkwd_stnfs_root                         	0x00000003
#define hkwd_stnfs_statfs                       	0x00000004
#define hkwd_stnfs_sync                         	0x00000005
#define hkwd_stnfs_vget                         	0x00000006
#define hkwd_stnfs_cntl                         	0x00000007
#define hkwd_stnfs_quotactl                     	0x00000008
#define hkwd_stnfs_syncvfs                      	0x00000009
#define hkwd_stnfs_aclxcntl                     	0x0000000A
#define hkwd_stnfs_statfsvp                     	0x0000000B
#define hkwd_stnfs_vfsop_notsup                 	0x0000000C

#define PV_HKWD_DD_MSTOR_ERR           			0x10220000

#define PV_HKWD_SVM           				0x10240000
/* hkIDs used in svm_dd_config.c */
#define hkwd_svm_cfg_mpx           			1
#define hkwd_svm_cfg_open          			2
#define hkwd_svm_cfg_close         			3
#define hkwd_svm_cfg_devswadd_fail 			4
#define hkwd_svm_cfg_devswdel_fail 			5
#define hkwd_svm_cfg_unreg_fail    			6
#define hkwd_svm_dd_read           			7
#define hkwd_svm_cfg_pamlook_fail  			8
#define hkwd_svm_cfg_term          			9

/* hkIDs used in svm_pam_init.c */
#define hkwd_svm_init_report          			100
#define hkwd_svm_init_malloc_fail     			101
#define hkwd_svm_init_dpiqueue_fail   			102
#define hkwd_svm_init_luk_fail        			103
#define hkwd_svm_init_lukcret_fail    			104
#define hkwd_svm_init_lukmem_fail     			105
#define hkwd_svm_init_lukconntab_fail 			106
#define hkwd_svm_init_lukmeminit_fail 			107
#define hkwd_svm_init_lukmematt_fail  			108
#define hkwd_svm_init_getstats_fail   			109
#define hkwd_svm_init_statsmemsz      			110
#define hkwd_svm_init_statsmem_fail   			111
#define hkwd_svm_init_lukmem_sz       			112

/* hkIDs used in svm_dd_ioctl.c */
#define hkwd_svm_unregsea_fail             		200
#define hkwd_svm_regsea_fail               		201
#define hkwd_svm_ioctl_stats_fail          		202
#define hkwd_svm_ioctl_finalize_cpin_fail  		203
#define hkwd_svm_ioctl_regsea_fail         		204
#define hkwd_svm_ioctl_unregsea_fail       		205
#define hkwd_svm_ioctl_wait_invalid_pktsz  		206
#define hkwd_svm_ioctl_wait_cpout_fail     		207
#define hkwd_svm_ioctl_wait_mcpout_fail    		208
#define hkwd_svm_ioctl_wait_mcpout2_fail   		209
#define hkwd_svm_ioctl_send_cpin_fail      		210
#define hkwd_svm_ioctl_send_invalid_pkthdl 		211
#define hkwd_svm_ioctl_send_newsz          		212
#define hkwd_svm_ioctl_send_mcpin_fail     		213
#define hkwd_svm_ioctl_send_mcpin2_fail    		214
#define hkwd_svm_ioctl_send_invalid_newsz  		215
#define hkwd_svm_ioctl_inject              		216
#define hkwd_svm_ioctl_inject_cpin_fail    		217
#define hkwd_svm_ioctl_inject_bad_pkt      		218
#define hkwd_svm_ioctl_inject_bad_pkt_sz   		219
#define hkwd_svm_ioctl_inject_mcpin_fail   		220
#define hkwd_svm_ioctl_inject_sentpkt      		221
#define hkwd_svm_ioctl_inject_invalid_pktsrc 		222
#define hkwd_svm_ioctl_test                		223
#define hkwd_svm_ioctl_test_cpin_fail      		224
#define hkwd_svm_ioctl_test_xmalloc_fail   		225
#define hkwd_svm_ioctl_test_mcpin_fail     		226
#define hkwd_svm_ioctl_setconf             		227
#define hkwd_svm_ioctl_setconf_cpin_fail   		228
#define hkwd_svm_ioctl_setconf_luksetparam_fail 	229
#define hkwd_svm_ioctl_setconf_unknown_param 		230
#define hkwd_svm_ioctl_setconf_param_set   		231
#define hkwd_svm_tmout_unregsea_fail       		232

/* hkIDs used in svm_receive.c */
#define hkwd_svm_recsea_notrun        			300
#define hkwd_svm_recsea_small         			301
#define hkwd_svm_recsea_large         			302
#define hkwd_svm_recsea_noluksystem   			303
#define hkwd_svm_recsea_pkt           			304
#define hkwd_svm_recsea_shortcut      			305
#define hkwd_svm_sea_rmdev            			306
#define hkwd_svm_testpam_notrun       			307
#define hkwd_svm_testpam_noluksystem  			308
#define hkwd_svm_testpam_pkt          			309
#define hkwd_svm_testpam_shortcut     			310
#define hkwd_svm_recsea_drop_pkt      			311

/* hkIDs used in svm_queue.c */
#define hkwd_svm_queue_no_mem         			400
#define hkwd_svm_queue_no_elemt       			401
#define hkwd_svm_queue_notrun         			402
#define hkwd_svm_queue_wait_pkt       			403

/* hkIDs used in svm_notify.c */
#define hkwd_svm_notify_no_luksystem  			500
#define hkwd_svm_notify_skipdpi_drop  			501
#define hkwd_svm_notify_skipdpi_fwd   			502
#define hkwd_svm_notify_approve       			503

#define hkwd_svm_notify_forward       			504
#define hkwd_svm_notify_modify        			505
#define hkwd_svm_notify_block         			506
#define hkwd_svm_notify_reject        			507
#define hkwd_svm_notify_unknown       			508
#define hkwd_svm_stats_fail           			600

#define PV_HKWD_DD_SFWCOM           			0x10250000

#define PV_HKWD_AHA_LFS_OPS           			0x102b0000
#define hkwd_ahafs_rdwr_enter                   	0x00000001
#define hkwd_ahafs_rdwr_exit                    	0x00000002
#define hkwd_ahafsFileReadUio_evProdsList_enter 	0x00000003
#define hkwd_ahafsFileReadUio_evProdsList_exit  	0x00000005
#define hkwd_ahafsMonFileReadUio_enter          	0x00000006
#define hkwd_ahafsMonFileReadUio                	0x00000007
#define hkwd_ahafsMonFileReadUio_exit           	0x00000008
#define hkwd_ahafsCopyOutBuf_enter              	0x00000009
#define hkwd_ahafsCopyOutBuf_exit               	0x0000000A
#define hkwd_ahafsMonFileWriteUio_enter         	0x0000000B
#define hkwd_ahafsMonFileWriteUio_exit          	0x0000000C
#define hkwd_ahafsStrtouint64_enter             	0x0000000E
#define hkwd_ahafsStrtouint64_exit              	0x0000000F
#define hkwd_parse_buf_enter                    	0x00000010
#define hkwd_parse_buf_name                     	0x00000011
#define hkwd_parse_buf_exit                     	0x00000012
#define hkwd_ahafs_readdir_readdir_enter        	0x00000013
#define hkwd_ahafs_readdir_readdir              	0x00000014
#define hkwd_ahafs_readdir_readdir_exit         	0x00000015
#define hkwd_ahafsReaddirAll_enter              	0x00000016
#define hkwd_ahafsReaddirAll_exit               	0x00000017
#define hkwd_ahafsCreateDirent_enter            	0x00000018
#define hkwd_ahafsCreateDirent_exit             	0x0000001A
#define hkwd_ahafsReadDirents_enter             	0x0000001B
#define hkwd_ahafsReadDirents_exit              	0x0000001D
#define hkwd_ahafs_select_enter                 	0x0000001E
#define hkwd_ahafs_select                       	0x0000001F
#define hkwd_ahafs_select_exit                  	0x00000020
#define hkwd_ahafs_nosys                        	0x00000021
#define hkwd_ahafs_access_enter                 	0x00000022
#define hkwd_ahafs_access_exit                  	0x00000023
#define hkwd_ahafs_open_enter                   	0x00000024
#define hkwd_ahafs_open                         	0x00000025
#define hkwd_ahafs_open_exit                    	0x00000026
#define hkwd_ahafs_close_enter                  	0x00000027
#define hkwd_ahafs_close_exit                   	0x00000028
#define hkwd_ahafs_seek_enter                   	0x00000029
#define hkwd_ahafs_seek_exit                    	0x0000002A
#define hkwd_ahafs_create_enter                 	0x0000002B
#define hkwd_ahafs_create_name                  	0x0000002C
#define hkwd_ahafs_create_exit                  	0x0000002E
#define hkwd_ahafs_remove_enter                 	0x0000002F
#define hkwd_ahafs_remove_exit                  	0x00000030
#define hkwd_ahafs_hold_enter                   	0x00000031
#define hkwd_ahafs_hold                         	0x00000032
#define hkwd_ahafs_hold_exit                    	0x00000033
#define hkwd_ahafs_rele_enter                   	0x00000034
#define hkwd_ahafs_rele                         	0x00000035
#define hkwd_ahafs_rele_exit                    	0x00000036
#define hkwd_ahafs_lookup_enter                 	0x00000037
#define hkwd_ahafs_lookup_name                  	0x00000038
#define hkwd_ahafs_lookup_exit                  	0x00000039
#define hkwd_ahafs_mkdir_enter                  	0x0000003A
#define hkwd_ahafs_mkdir_name                   	0x0000003B
#define hkwd_ahafs_mkdir_exit                   	0x0000003C
#define hkwd_ahafs_rmdir_enter                  	0x0000003D
#define hkwd_ahafs_rmdir_exit                   	0x0000003E
#define hkwd_ahafs_getattr_enter                	0x0000003F
#define hkwd_ahafs_getattr_exit                 	0x00000040
#define hkwd_ahafs_setattr_enter                	0x00000041
#define hkwd_ahafs_setattr_exit                 	0x00000042
#define hkwd_ahafs_getacl_enter                 	0x00000043
#define hkwd_ahafs_getacl_exit                  	0x00000044
#define hkwd_ahafs_setacl_enter                 	0x00000045
#define hkwd_ahafs_setacl_exit                  	0x00000046
#define hkwd_ahafs_fsync_exit                   	0x00000047
#define hkwd_ahafs_ahafsGetNewNodeType_enter    	0x00000048
#define hkwd_ahafs_ahafsGetNewNodeType_name     	0x00000049
#define hkwd_ahafs_ahafsGetNewNodeType_exit     	0x0000004A
#define hkwd_ahafs_mount_enter                  	0x0000004B
#define hkwd_ahafs_mount_exit                   	0x0000004D
#define hkwd_ahafs_unmount_enter                	0x0000004E
#define hkwd_ahafs_unmount_exit                 	0x0000004F
#define hkwd_ahafs_root_enter                   	0x00000050
#define hkwd_ahafs_root_exit                    	0x00000051
#define hkwd_ahafs_vget                         	0x00000052
#define hkwd_ahafs_statfs_enter                 	0x00000053
#define hkwd_ahafs_statfs_exit                  	0x00000054
#define hkwd_ahafs_sync                         	0x00000055
#define hkwd_ahafs_cntl                         	0x00000056
#define hkwd_ahafs_quotactl                     	0x00000057

#define PV_HKWD_AHA_KERN           			0x102d0000
#define hkwd_ahafs_initialize_enter             	0x00000002
#define hkwd_ahafs_initialize_exit              	0x00000003
#define hkwd_ahafs_uninitialize                 	0x00000004
#define hkwd_ahafs_evprod_register_enter        	0x00000005
#define hkwd_ahafs_evprod_register_name         	0x00000006
#define hkwd_ahafs_evprod_register_dirName      	0x00000007
#define hkwd_ahafs_evprod_register_exit         	0x00000008
#define hkwd_aha_evprod_unreg_enter            	 	0x0000000B
#define hkwd_aha_evprod_unreg_exit              	0x0000000C
#define hkwd_aha_evprod_get_enter               	0x0000000D
#define hkwd_aha_evprod_get_name                	0x0000000E
#define hkwd_aha_evprod_get_exit                	0x0000000F
#define hkwd_aha_evprods_enter                  	0x00000010
#define hkwd_aha_evprods_exit                   	0x00000012
#define hkwd_aha_cbfn_register_enter            	0x00000013
#define hkwd_aha_cbfn_register_exit             	0x00000014
#define hkwd_aha_evprods_list_enter             	0x00000015
#define hkwd_aha_evprods_list_exit              	0x00000016
#define hkwd_aha_cbfn_wrapper_enter             	0x00000017
#define hkwd_aha_cbfn_wrapper_exit              	0x00000018
#define hkwd_ahafs_get_curthrd_info_enter       	0x00000019
#define hkwd_ahafs_get_curthrd_info_exit        	0x0000001A
#define hkwd_aha_utilFs_register_enter          	0x0000001B
#define hkwd_aha_utilFs_register_exit           	0x0000001C
#define hkwd_get_localFs_info_name              	0x0000001E
#define hkwd_get_localFs_info_exit              	0x0000001F
#define hkwd_aha_modFile_register_enter         	0x00000020
#define hkwd_aha_modFile_register_exit          	0x00000021
#define hkwd_aha_process_vnop_enter             	0x00000023
#define hkwd_aha_process_vnop_name              	0x00000024
#define hkwd_aha_process_umount_enter           	0x00000026
#define hkwd_aha_process_umount_exit            	0x00000027
#define hkwd_aha_process_rename_enter           	0x00000028
#define hkwd_aha_process_rename_name            	0x00000029
#define hkwd_aha_process_rename_name_t          	0x0000002A
#define hkwd_aha_process_rename_exit            	0x0000002B
#define hkwd_aha_svfs_init_enter                	0x0000002C
#define hkwd_aha_svfs_init_exit                 	0x0000002D
#define hkwd_aha_modFileAttr_register_enter     	0x0000002E
#define hkwd_aha_modFileAttr_register_exit      	0x0000002F
#define hkwd_aha_process_attr_enter             	0x00000030

#define PV_HKWD_AHA_MISC           			0x102e0000
#define hkwd_ahafsCfg_enter                     	0x00000001
#define hkwd_ahafsCfg_exit                      	0x00000002
#define hkwd_ahafsGfsInit                       	0x00000003
#define hkwd_ahafsGfsRtIn                       	0x00000004
#define hkwd_find_mf_data_enter                 	0x00000005
#define hkwd_find_mf_data_exit                  	0x00000006
#define hkwd_ahafsCollectEventData_enter        	0x00000007
#define hkwd_ahafsCollectEventData              	0x00000008
#define hkwd_ahafsCollectEventData_exit         	0x00000009
#define hkwd_ahafsStkTrace_enter                	0x0000000A
#define hkwd_ahafsStkTrace                      	0x0000000B
#define hkwd_ahafsStkTrace_exit                 	0x0000000C
#define hkwd_ahafsDuplicateEvent_enter          	0x0000000D
#define hkwd_ahafsDuplicateEvent_exit           	0x0000000E
#define hkwd_ahafsCopyEvent_enter               	0x0000000F
#define hkwd_ahafsCopyEvent                     	0x00000010
#define hkwd_ahafsCopyEvent_exit                	0x00000011
#define hkwd_ahafsFindSubstring_enter           	0x00000012
#define hkwd_ahafsFindSubstring_exit            	0x00000013
#define hkwd_ahafsFindNextEvent_enter           	0x00000014
#define hkwd_ahafsFindNextEvent_exit            	0x00000015
#define hkwd_ahafsLogEvent_enter                	0x00000016
#define hkwd_ahafsLogEvent                      	0x00000017
#define hkwd_ahafsLogEvent_exit                 	0x00000018
#define hkwd_ahafsLogExceptionEvent_enter       	0x00000019
#define hkwd_ahafsLogExceptionEvent_exit        	0x0000001A
#define hkwd_ahafsRemoveBranch_enter            	0x0000001B
#define hkwd_ahafsRemoveBranch                  	0x0000001C
#define hkwd_ahafsRemoveBranch_exit             	0x0000001D
#define hkwd_ahafsGroupRemove_enter             	0x0000001E
#define hkwd_ahafsGroupRemove_exit              	0x0000001F
#define hkwd_ahafsFindSelSlot_enter             	0x00000020
#define hkwd_ahafsFindSelSlot_exit              	0x00000021
#define hkwd_ahafsGetUniqueId_enter             	0x00000022
#define hkwd_ahafsGetUniqueId_exit              	0x00000023
#define hkwd_ahafsPutUniqueId_enter             	0x00000024
#define hkwd_ahafsMfHold                        	0x00000026
#define hkwd_ahafsMfRele_enter                  	0x00000027
#define hkwd_ahafsMfRele_exit                   	0x00000028
#define hkwd_ahafsNodeInit_enter                	0x00000029
#define hkwd_ahafsNodeInit_exit                 	0x0000002B
#define hkwd_ahafsNodeUninit_enter              	0x0000002C
#define hkwd_ahafsNodeUninit_exit               	0x0000002D
#define hkwd_ahafsQVnodeToVfs_enter             	0x0000002E
#define hkwd_ahafsQVnodeToVfs_exit              	0x0000002F
#define hkwd_ahafsDeqVnodeFromVfs_enter         	0x00000030
#define hkwd_ahafsDeqVnodeFromVfs_exit          	0x00000031
#define hkwd_ahafsInactivateVnode_enter         	0x00000032
#define hkwd_ahafsInactivateVnode_exit          	0x00000033
#define hkwd_ahafsAllocDataArea_enter           	0x00000034
#define hkwd_ahafsAllocDataArea_exit            	0x00000035
#define hkwd_ahafsDeallocDataAreas_enter        	0x00000036
#define hkwd_ahafsDeallocDataAreas_exit         	0x00000038
#define hkwd_ahafsFindAvailDirSlot_enter        	0x00000039
#define hkwd_ahafsFindAvailDirSlot_exit         	0x0000003A
#define hkwd_ahafsCreateDirEntry_enter          	0x0000003B
#define hkwd_ahafsCreateDirEntry_exit           	0x0000003C
#define hkwd_ahafsRemoveDirEntry_enter          	0x0000003D
#define hkwd_ahafsRemoveDirEntry_exit           	0x0000003E
#define hkwd_ahafsFindDirEntryByName_enter      	0x0000003F
#define hkwd_ahafsFindDirEntryByName_exit       	0x00000040
#define hkwd_ahafsFindDirEntryByNode_enter      	0x00000041
#define hkwd_ahafsFindDirEntryByNode_exit       	0x00000042
#define hkwd_ahafsGetNextUnvisitedNode_enter    	0x00000043
#define hkwd_ahafsGetNextUnvisitedNode_exit     	0x00000044
#define hkwd_ahafsNodeCreate_enter              	0x00000045
#define hkwd_ahafsNodeCreate_name               	0x00000046
#define hkwd_ahafsNodeCreate_exit               	0x00000048
#define hkwd_ahafsGetVattr_enter                	0x00000049
#define hkwd_ahafsGetVattr_exit                 	0x0000004A
#define hkwd_ahafsGetBaseName_enter             	0x0000004B
#define hkwd_ahafsGetBaseName_name              	0x0000004C
#define hkwd_ahafsGetBaseName_exit              	0x0000004D
#define hkwd_ahafsGetNodePath_enter             	0x0000004E
#define hkwd_ahafsGetNodePath_exit              	0x00000050
#define hkwd_ahafsGetMonFactory_enter           	0x00000051
#define hkwd_ahafsGetMonFactory_exit            	0x00000052
#define hkwd_ahafsPrepend_string_enter          	0x00000053
#define hkwd_ahafsPrepend_string_exit           	0x00000054
#define hkwd_ahafsDoChown_enter                 	0x00000055
#define hkwd_ahafsDoChown_exit                  	0x00000056
#define hkwd_ahafsChkFsBusy                     	0x00000057
#define hkwd_ahafsCreateMonFactory_enter        	0x00000058
#define hkwd_ahafsCreateMonFactory_exit         	0x0000005A
#define hkwd_ahafsCreateMFNode_enter            	0x0000005B
#define hkwd_ahafsCreateMFNode_exit             	0x0000005C
#define hkwd_ahafsAllocTmpEventData_enter       	0x0000005D
#define hkwd_ahafsAllocTmpEventData_exit        	0x0000005E
#define hkwd_ahafsDoChmod_enter                 	0x0000005F
#define hkwd_ahafsDoChmod_exit                  	0x00000060

#define PV_HKWD_CLUST_COMM           			0x10310000
#define hkwd_clust_sock_init_domain_err     		0x01
#define hkwd_clust_sock_init_err            		0x02
#define hkwd_clust_input_args               		0x03
#define hkwd_clust_input_socket_details     		0x04
#define hkwd_clust_input_err1               		0x05
#define hkwd_clust_input_err2               		0x06
#define hkwd_clust_input_err3               		0x07
#define hkwd_clust_input_err4               		0x08
#define hkwd_clust_input_exit               		0x09
#define hkwd_clust_output_args              		0x0a
#define hkwd_clust_output_err               		0x0b
#define hkwd_clust_output_err1              		0x0c
#define hkwd_clust_output_exit              		0x0d
#define hkwd_clsock_recv_args               		0x0e
#define hkwd_clsock_recv_err1               		0x0f
#define hkwd_clsock_recv_err2               		0x10
#define hkwd_clsock_recv_exit               		0x11
/* cluster_net_init */
#define hkwd_clust_net_init_called          		0x20
#define hkwd_clust_net_init2_called         		0x21
#define hkwd_clust_net_init2_err1           		0x32
#define hkwd_clust_net_init2_err2           		0x23
#define hkwd_clust_net_init2_err3           		0x24
#define hkwd_clust_net_init2_err4           		0x25
#define hkwd_clust_net_init2_err5           		0x26
#define hkwd_clust_net_init2_err6           		0x27
#define hkwd_clust_net_init2_err7           		0x28
#define hkwd_clust_net_init2_err8           		0x29
#define hkwd_clust_net_init2_err9           		0x2a
#define hkwd_clust_net_init2_err            		0x2b
#define hkwd_clust_net_init2_exit           		0x2c
/* clusterwide */
#define hkwd_clusterwide_args               		0x40
#define hkwd_clusterwide_err                		0x41
#define hkwd_clusterwide_err1               		0x42
#define hkwd_clusterwide_exit               		0x43
#define hkwd_clustrcv_offlvl_args           		0x44
#define hkwd_clustrcv_offlvl_err1           		0x45
#define hkwd_clustrcv_offlvl_err2           		0x46
#define hkwd_clustrcv_offlvl_err3           		0x47
#define hkwd_clustrcv_offlvl_err4           		0x48
#define hkwd_clustrcv_offlvl_err5           		0x49
#define hkwd_clustrcv_offlvl_err6           		0x4a
#define hkwd_clustrcv_offlvl_err7           		0x4b
#define hkwd_clustrcv_offlvl_exit           		0x4c
#define hkwd_clustrcv_offlvl_cmd            		0x4d
/* net_syscalls */
#define hkwd_disk_query_entry               		0x60
#define hkwd_disk_query_exit                		0x61
#define hkwd_disk_query_err                 		0x62
#define hkwd_disk_query_details             		0x63
#define hkwd_interface_query_entry          		0x64
#define hkwd_interface_query_exit           		0x65
#define hkwd_interface_query_err            		0x66
#define hkwd_interface_query_err1           		0x67
#define hkwd_interface_query_details        		0x68
#define hkwd_if_restrict_entry              		0x69
#define hkwd_if_restrict_exit               		0x6a
#define hkwd_if_restrict_err                		0x6b
/* kcluster_io */
#define hkwd_cluster_handled_args           		0x80
#define hkwd_cluster_handled_err            		0x81
#define hkwd_cluster_handled_exit           		0x82
#define hkwd_clust_handle_eth_args          		0x83
#define hkwd_cluster_handle_eth_err         		0x84
#define hkwd_cluster_handle_eth_exit        		0x85
/* kcluster_ip */
#define hkwd_fragment_processing_create_packet  	0xa0
#define hkwd_fragment_processing_args           	0xa1
#define hkwd_fragment_processing_err            	0xa2
#define hkwd_fragment_processing_exit           	0xa3
#define hkwd_cluster_handler_args               	0xa4
#define hkwd_cluster_handler_packet             	0xa5
#define hkwd_cluster_handler_err                	0xa6
#define hkwd_cluster_handler_ours_info1         	0xa7
#define hkwd_cluster_handler_ours_info2         	0xa8
#define hkwd_cluster_handler_exit               	0xa9
/* kcluster_net_utils */
#define hkwd_if_set_args                    		0xc0
#define hkwd_if_set_err1                    		0xc1
#define hkwd_if_set_err2                    		0xc2
#define hkwd_if_set_err3                    		0xc3
#define hkwd_if_set_err4                    		0xc4
#define hkwd_if_set_err5                    		0xc5
#define hkwd_if_set_err6                    		0xc6
#define hkwd_if_set_err7                    		0xc7
#define hkwd_if_set_exit                    		0xc8
#define hkwd_if_reset_args                  		0xc9
#define hkwd_if_reset_args1                 		0xca
#define hkwd_if_reset_err                   		0xcb
#define hkwd_if_reset_exit                  		0xcc
#define hkwd_ndd_set_arg                    		0xcd
#define hkwd_ndd_set_err1                   		0xce
#define hkwd_ndd_set_err2                   		0xcf
#define hkwd_ndd_set_err3                   		0xd0
#define hkwd_ndd_set_exit                   		0xd1
#define hkwd_ndd_config_enter               		0xd2
#define hkwd_ndd_config_err1                		0xd3
#define hkwd_ndd_config_err2                		0xd4
#define hkwd_ndd_config_err3                		0xd5
#define hkwd_ndd_config_err4                		0xd6
#define hkwd_ndd_config_err5                		0xd7
#define hkwd_ndd_config_err6                		0xd8
#define hkwd_ndd_config_exit                		0xd9
#define hkwd_kcluster_sendmsg_ext_args      		0xda
#define hkwd_kcluster_sendmsg_ext_err1      		0xdb
#define hkwd_kcluster_sendmsg_ext_err2      		0xdc
#define hkwd_kcluster_sendmsg_ext_err3     	 	0xdd
#define hkwd_kcluster_sendmsg_ext_exit      		0xde
#define hkwd_kcluster_sendmsg_args          		0xdf
#define hkwd_kcluster_sendmsg_err1          		0xe0
#define hkwd_kcluster_sendmsg_err2          		0xe1
#define hkwd_kcluster_sendmsg_err3          		0xe2
#define hkwd_kcluster_sendmsg_err4          		0xe3
#define hkwd_kcluster_sendmsg_err5          		0xe4
#define hkwd_kcluster_sendmsg_err6          		0xe5
#define hkwd_kcluster_sendmsg_err7          		0xe6
#define hkwd_kcluster_sendmsg_err8          		0xe7
#define hkwd_kcluster_sendmsg_exit          		0xe8
#define hkwd_kcluster_sendmsg_info1         		0xe9
#define hkwd_mbuf_fixup_args                		0xea
#define hkwd_mbuf_fixup_err1                		0xeb
#define hkwd_mbuf_fixup_err2                		0xec
#define hkwd_mbuf_fixup_err3                		0xed
#define hkwd_mbuf_fixup_err4                		0xee
#define hkwd_mbuf_fixup_exit                		0xef
#define hkwd_do_pacing_err1                 		0xf0
#define hkwd_tcpsock_if_set_entry           		0xf1
#define hkwd_tcpsock_if_set_info1           		0xf2
#define hkwd_tcpsock_if_set_err1            		0xf3
#define hkwd_tcpsock_if_set_exit            		0xf4
#define hkwd_tcpsock_if_reset_entry         		0xf5
#define hkwd_tcpsock_if_reset_exit          		0xf6

/* TCPIP Pseudo cluster interface hook ids */
#define hkwd_clif_config_in                 		0x100
#define hkwd_clif_config_err1               		0x101
#define hkwd_clif_config_err2               		0x102
#define hkwd_clif_config_err3               		0x103
#define hkwd_clif_config_err4               		0x104
#define hkwd_clif_config_err5               		0x105
#define hkwd_clif_config_err6               		0x106
#define hkwd_clif_config_err7               		0x107
#define hkwd_clif_config_err8               		0x108
#define hkwd_clif_config_err9               		0x109
#define hkwd_clif_config_err10              		0x10A
#define hkwd_clif_config_err11              		0x10B
#define hkwd_clif_config_out                		0x10C
#define hkwd_clif_attach_in                 		0x10D
#define hkwd_clif_attach_err1               		0x10E
#define hkwd_clif_attach_out                		0x10F
#define hkwd_clif_ioctl_in                  		0x110
#define hkwd_clif_ioctl_err1                		0x111
#define hkwd_clif_ioctl_err2                		0x112
#define hkwd_clif_ioctl_err3                		0x113
#define hkwd_clif_ioctl_err4                		0x114
#define hkwd_clif_ioctl_err5                		0x115
#define hkwd_clif_ioctl_err6                		0x116
#define hkwd_clif_ioctl_err7                		0x117
#define hkwd_clif_ioctl_err8                		0x118
#define hkwd_clif_ioctl_out                 		0x119
#define hkwd_clif_output_in                 		0x11A
#define hkwd_clif_output_err1               		0x11B
#define hkwd_clif_output_err2               		0x11C
#define hkwd_clif_output_err3               		0x11D
#define hkwd_clif_output_err4               		0x11E
#define hkwd_clif_output_err5               		0x11F
#define hkwd_clif_output_out                		0x120
#define hkwd_clif_input_in                  		0x121
#define hkwd_clif_input_err1                		0x122
#define hkwd_clif_input_err2                		0x123
#define hkwd_clif_input_out                 		0x124


/* CAA Pseudo Interface hook ids */

#define hkwd_kcluster_arp_send_entry    		0x300
#define hkwd_kcluster_arp_send_err1     		0x301
#define hkwd_kcluster_arp_send_err2     		0x302
#define hkwd_kcluster_arp_send_err3     		0x303
#define hkwd_kcluster_arp_send_err      		0x304
#define hkwd_kcluster_arp_send_exit     		0x305
#define hkwd_kcluster_arp_recv_entry    		0x306
#define hkwd_kcluster_arp_recv_err1     		0x307
#define hkwd_kcluster_arp_recv_err2     		0x308
#define hkwd_kcluster_arp_recv_exit     		0x309
#define hkwd_kcluster_check_duplicate_pseudoip_entry	0x310
#define hkwd_kcluster_check_duplicate_pseudoip_err	0x311
#define hkwd_kcluster_check_duplicate_pseudoip_exit	0x312
#define hkwd_kcluster_pseudo_sendmsg_entry      	0x313
#define hkwd_kcluster_pseudo_sendmsg_err1       	0x314
#define hkwd_kcluster_pseudo_sendmsg_err2       	0x315
#define hkwd_kcluster_pseudo_sendmsg_err3       	0x316
#define hkwd_kcluster_pseudo_sendmsg_err4       	0x317
#define hkwd_kcluster_pseudo_sendmsg_err5       	0x318
#define hkwd_kcluster_pseudo_sendmsg_err        	0x319
#define hkwd_kcluster_pseudo_sendmsg_exit       	0x320
#define hkwd_preprocess_pseudo_sock_packet_entry	0x321
#define hkwd_preprocess_pseudo_sock_packet_err1		0x322
#define hkwd_preprocess_pseudo_sock_packet_exit		0x323

#define hkwd_net_monitor_err1       			0x400
#define hkwd_if_monitor_info1       			0x401
#define hkwd_if_monitor_info2       			0x402
#define hkwd_if_monitor_info3       			0x403
#define hkwd_topology_monitor_entry 			0x404
#define hkwd_topology_monitor_err1  			0x405
#define hkwd_topology_monitor_err2  			0x406
#define hkwd_topology_monitor_err3  			0x407
#define hkwd_topology_monitor_err4  			0x408
#define hkwd_topology_monitor_exit  			0x409
#define hkwd_print_can_contacts_entry  			0x40a
#define hkwd_print_can_contacts_info   			0x40b
#define hkwd_print_can_contacts_exit   			0x40c

/* kcluster_syscalls.c */
#define hkwd_xcluster_ctrl_info1            		0x500
#define hkwd_xcluster_ctrl_info2            		0x501
#define hkwd_xcluster_ctrl_info3            		0x502

#define PV_HKWD_CLUST_LOCK           			0x10320000
#define hkwd_clust_lock_updown_node         		0x01
#define hkwd_clust_lock_st_node_cnt1        		0x02
#define hkwd_clust_lock_st_node_cnt2        		0x03
#define hkwd_clust_lock_cnt_nodes1          		0x04
#define hkwd_clust_lock_cnt_nodes2          		0x05
#define hkwd_clust_lock_cnt_nodes3          		0x06
#define hkwd_clust_lock_wt_node_brgup1      		0x07
#define hkwd_clust_lock_wt_node_brgup2      		0x08
#define hkwd_clust_lock_wt_node_brgup3      		0x09
#define hkwd_clust_lock_wt_node_brgup4      		0x0a
#define hkwd_clust_lock_xcluster_lock1      		0x0b
#define hkwd_clust_lock_xcluster_lock2      		0x0c
#define hkwd_clust_lock_xcluster_lock3      		0x0d
#define hkwd_clust_lock_xcluster_lock4      		0x0e
#define hkwd_clust_lock_xcluster_lock5      		0x0f
#define hkwd_clust_lock_proc_msglck         		0x10
#define hkwd_clust_lock_lck_thrd1           		0x11
#define hkwd_clust_lock_lck_thrd2           		0x12
#define hkwd_clust_lock_lck_thrd3           		0x13
#define hkwd_clust_lock_lck_thrd4           		0x14
#define hkwd_clust_lock_lck_thrd5           		0x15
#define hkwd_clust_lock_lck_thrd6           		0x16
#define hkwd_clust_lock_lck_thrd7           		0x17
#define hkwd_clust_lock_lck_thrd8           		0x18
#define hkwd_clust_lock_lck_thrd9           		0x19
#define hkwd_clust_lock_lck_thrd10          		0x1a
#define hkwd_clust_lock_lck_thrd11          		0x1b
#define hkwd_clust_lock_lck_thrd12          		0x1c
#define hkwd_clust_lock_lck_thrd13          		0x1d
#define hkwd_clust_lock_lck_thrd14          		0x1e
#define hkwd_clust_lock_lck_thrd15          		0x1f
#define hkwd_clust_lock_lck_thrd16          		0x20
#define hkwd_clust_lock_lck_thrd17          		0x21
#define hkwd_clust_lock_lck_thrd18          		0x22
#define hkwd_clust_lock_lck_thrd19          		0x23
#define hkwd_clust_lock_lck_thrd20          		0x24
#define hkwd_clust_lock_lck_thrd21          		0x25
#define hkwd_clust_lock_lck_thrd22          		0x26
#define hkwd_clust_lock_lck_thrd23          		0x27
#define hkwd_clust_lock_lck_thrd24          		0x28
#define hkwd_clust_lock_lck_thrd25          		0x29
#define hkwd_clust_lock_lck_thrd26          		0x2a
#define hkwd_clust_lock_lck_thrd27          		0x2b
#define hkwd_clust_lock_lck_thrd28          		0x2c

#define PV_HKWD_CLUST_AHAFS           			0x10330000
#define hkwd_clust_ahafs_get_buf                	0x01
#define hkwd_clust_ahafs_process_msg            	0x02
#define hkwd_clust_ahafs_get_recv_nextseq       	0x03
#define hkwd_clust_ahafs_thrd_recv1             	0x04
#define hkwd_clust_ahafs_thrd_recv2             	0x05
#define hkwd_clust_ahafs_thrd_recv3             	0x06
#define hkwd_clust_ahafs_get_node_info          	0x07
#define hkwd_clust_ahafs_wraper_snd             	0x08
#define hkwd_clust_ahafs_get_nxtseq             	0x09
#define hkwd_clust_ahafs_thrd_queue1            	0x0a
#define hkwd_clust_ahafs_thrd_queue2            	0x0b
#define hkwd_clust_ahafs_sendrecv_init1         	0x0c
#define hkwd_clust_ahafs_sendrecv_init2         	0x0d
#define hkwd_clust_ahafs_gen_evnt1              	0x0e
#define hkwd_clust_ahafs_gen_evnt2              	0x0f
#define hkwd_clust_ahafs_gen_evnt3              	0x10
#define hkwd_clust_ahafs_gen_evnt4              	0x11
#define hkwd_clust_ahafs_gen_evnt5              	0x12
#define hkwd_clust_ahafs_gen_evnt6              	0x13
#define hkwd_clust_ahafs_gen_evnt7              	0x14
#define hkwd_clust_ahafs_gen_evnt8              	0x15
#define hkwd_clust_ahafs_gen_evnt9              	0x16
#define hkwd_clust_ahafs_gen_evnt10             	0x17
#define hkwd_clust_ahafs_gen_evnt11             	0x18
#define hkwd_clust_ahafs_set_clust1             	0x19
#define hkwd_clust_ahafs_set_clust2             	0x1a
#define hkwd_clust_ahafs_unset_clust1           	0x1b
#define hkwd_clust_ahafs_unset_clust2           	0x1c
#define hkwd_clust_ahafs_get_clustid1           	0x1d
#define hkwd_clust_ahafs_get_clustid2           	0x1e
#define hkwd_clust_ahafs_find_upd1              	0x1f
#define hkwd_clust_ahafs_find_upd2              	0x20
#define hkwd_clust_ahafs_find_upd3              	0x21
#define hkwd_clust_ahafs_find_upd4              	0x22
#define hkwd_clust_ahafs_find_upd5              	0x23
#define hkwd_clust_ahafs_stor_evnt1             	0x24
#define hkwd_clust_ahafs_stor_evnt2             	0x25
#define hkwd_clust_ahafs_stor_evnt3             	0x26
#define hkwd_clust_ahafs_stor_evnt4             	0x27
#define hkwd_clust_ahafs_stor_evnt5             	0x28
#define hkwd_clust_ahafs_stor_evnt6             	0x29
#define hkwd_clust_ahafs_evnt_gen               	0x2a
#define hkwd_clust_ahafs_evnt_post1             	0x2b
#define hkwd_clust_ahafs_evnt_post2             	0x2c
#define hkwd_clust_ahafs_evnt_post3             	0x2d
#define hkwd_clust_ahafs_evnt_post4             	0x2e
#define hkwd_clust_ahafs_evnt_post5             	0x2f
#define hkwd_clust_ahafs_svc_callback1          	0x30
#define hkwd_clust_ahafs_svc_callback2          	0x31
#define hkwd_clust_ahafs_svc_callback3          	0x32
#define hkwd_clust_ahafs_add_evnt_disk1         	0x33
#define hkwd_clust_ahafs_add_evnt_disk2         	0x34
#define hkwd_clust_ahafs_add_evnt_disk3         	0x35
#define hkwd_clust_ahafs_add_evnt_disk4         	0x36
#define hkwd_clust_ahafs_add_evnt_disk5         	0x37
#define hkwd_clust_ahafs_add_evnt_disk6         	0x38
#define hkwd_clust_ahafs_add_evnt_disk7         	0x39
#define hkwd_clust_ahafs_add_evnt_disk8         	0x3a
#define hkwd_clust_ahafs_add_evnt_disk9         	0x3b
#define hkwd_clust_ahafs_add_evnt_disk10        	0x3c
#define hkwd_clust_ahafs_add_evnt_disk11        	0x3d
#define hkwd_clust_ahafs_add_evnt_disk12        	0x3e
#define hkwd_clust_ahafs_add_evnt_disk13        	0x3f
#define hkwd_clust_ahafs_add_evnt_disk14        	0x40
#define hkwd_clust_ahafs_add_evnt_disk15        	0x41
#define hkwd_clust_ahafs_add_evnt_disk16        	0x42
#define hkwd_clust_ahafs_rem_evnt_disk1         	0x43
#define hkwd_clust_ahafs_rem_evnt_disk2         	0x44
#define hkwd_clust_ahafs_rem_evnt_disk3         	0x45
#define hkwd_clust_ahafs_vgstat_reg1            	0x46
#define hkwd_clust_ahafs_vgstat_reg2            	0x47
#define hkwd_clust_ahafs_vgstat_reg3            	0x48
#define hkwd_clust_ahafs_vgstat_reg4            	0x49
#define hkwd_clust_ahafs_vgstat_reg5            	0x4a
#define hkwd_clust_ahafs_diskstat_reg1          	0x4b
#define hkwd_clust_ahafs_diskstat_reg2          	0x4c
#define hkwd_clust_ahafs_diskstat_reg3          	0x4d
#define hkwd_clust_ahafs_diskstat_reg4          	0x4e
#define hkwd_clust_ahafs_diskstat_reg5          	0x4f
#define hkwd_clust_ahafs_diskstat_reg6          	0x50
#define hkwd_clust_ahafs_diskstat_reg7          	0x51
#define hkwd_clust_ahafs_diskstat_reg8          	0x52
#define hkwd_clust_ahafs_addr_reg1              	0x53
#define hkwd_clust_ahafs_addr_reg2              	0x54
#define hkwd_clust_ahafs_addr_reg3              	0x55
#define hkwd_clust_ahafs_addr_reg4              	0x56
#define hkwd_clust_ahafs_addr_reg5              	0x57
#define hkwd_clust_ahafs_interface_reg1         	0x58
#define hkwd_clust_ahafs_interface_reg2         	0x59
#define hkwd_clust_ahafs_interface_reg3         	0x5a
#define hkwd_clust_ahafs_interface_reg4         	0x5b
#define hkwd_clust_ahafs_interface_reg5         	0x5c
#define hkwd_clust_ahafs_contact_reg1           	0x5d
#define hkwd_clust_ahafs_contact_reg2           	0x5e
#define hkwd_clust_ahafs_contact_reg3           	0x5f
#define hkwd_clust_ahafs_contact_reg4           	0x60
#define hkwd_clust_ahafs_contact_reg5           	0x61
#define hkwd_clust_ahafs_nodeexit_reg1          	0x62
#define hkwd_clust_ahafs_nodeexit_reg2          	0x63
#define hkwd_clust_ahafs_nodeexit_reg3          	0x64
#define hkwd_clust_ahafs_nodeexit_reg4          	0x65
#define hkwd_clust_ahafs_nodeexit_reg5          	0x66
#define hkwd_clust_ahafs_nodelist_reg1          	0x67
#define hkwd_clust_ahafs_nodelist_reg2          	0x68
#define hkwd_clust_ahafs_nodelist_reg3          	0x69
#define hkwd_clust_ahafs_nodelist_reg4          	0x6a
#define hkwd_clust_ahafs_nodelist_reg5          	0x6b
#define hkwd_clust_ahafs_disklist_reg1          	0x6c
#define hkwd_clust_ahafs_disklist_reg2          	0x6d
#define hkwd_clust_ahafs_disklist_reg3          	0x6e
#define hkwd_clust_ahafs_disklist_reg4          	0x6f
#define hkwd_clust_ahafs_disklist_reg5          	0x70
#define hkwd_clust_ahafs_clDisk_state_reg1      	0x71
#define hkwd_clust_ahafs_clDisk_state_reg2      	0x72
#define hkwd_clust_ahafs_clDisk_state_reg3      	0x73
#define hkwd_clust_ahafs_clDisk_state_reg4      	0x74
#define hkwd_clust_ahafs_clDisk_state_reg5      	0x75
#define hkwd_clust_ahafs_repDisk_state_reg1     	0x76
#define hkwd_clust_ahafs_repDisk_state_reg2     	0x77
#define hkwd_clust_ahafs_repDisk_state_reg3     	0x78
#define hkwd_clust_ahafs_repDisk_state_reg4     	0x79
#define hkwd_clust_ahafs_repDisk_state_reg5     	0x7a
#define hkwd_clust_ahafs_lnkedCl_reg1           	0x7b
#define hkwd_clust_ahafs_lnkedCl_reg2           	0x7c
#define hkwd_clust_ahafs_lnkedCl_reg3           	0x7d
#define hkwd_clust_ahafs_lnkedCl_reg4           	0x7e
#define hkwd_clust_ahafs_lnkedCl_reg5           	0x7f
#define hkwd_clust_ahafs_clust_init1            	0x80
#define hkwd_clust_ahafs_clust_init2            	0X81
#define hkwd_clust_ahafs_clust_init3            	0X82
#define hkwd_clust_ahafs_clust_init4            	0X83
#define hkwd_clust_ahafs_clust_init5            	0X84
#define hkwd_clust_ahafs_clust_init6            	0X85
#define hkwd_clust_ahafs_clust_init7            	0X86
#define hkwd_clust_ahafs_clust_init8            	0X87
#define hkwd_clust_ahafs_clust_init9            	0X88
#define hkwd_clust_ahafs_clust_init10           	0X89
#define hkwd_clust_ahafs_clust_init11           	0X8a
#define hkwd_clust_ahafs_clust_uninit1          	0x8b
#define hkwd_clust_ahafs_clust_uninit2          	0X8c
#define hkwd_clust_ahafs_clust_uninit3          	0x8d
#define hkwd_clust_ahafs_clust_uninit4          	0x8e
#define hkwd_clust_ahafs_clust_uninit5          	0x8f
#define hkwd_clust_ahafs_clust_uninit6          	0x90
#define hkwd_clust_ahafs_clust_uninit7          	0x91
#define hkwd_clust_ahafs_clust_uninit8          	0x92
#define hkwd_clust_ahafs_clust_uninit9          	0x93
#define hkwd_clust_ahafs_clust_uninit10         	0x94
#define hkwd_clust_ahafs_cap_reg1               	0x95
#define hkwd_clust_ahafs_cap_reg2               	0x96
#define hkwd_clust_ahafs_cap_reg3               	0x97
#define hkwd_clust_ahafs_cap_reg4               	0x98
#define hkwd_clust_ahafs_cap_reg5               	0x99
#define hkwd_clust_ahafs_clust_init12           	0x9a
#define hkwd_clust_ahafs_clust_uninit11         	0x9b
#define hkwd_clust_ahafs_hostname_reg1          	0x9c

#define PV_HKWD_CLUST_CONFIG           			0x10340000
#define hkwd_clust_cfg_init_err1                	0x01
#define hkwd_clust_cfg_init_err2                	0x02
#define hkwd_clust_cfg_init_err3                	0x03
#define hkwd_clust_cfg_init_err4                	0x04
#define hkwd_clust_cfg_init_err5                	0x05
#define hkwd_clust_cfg_init_err6                	0x06
#define hkwd_clust_cfg_init_err7                	0x07
#define hkwd_clust_cfg_init_err8                	0x08
#define hkwd_clust_cfg_init_err9                	0x09
#define hkwd_clust_cfg_init_err10               	0x0a
#define hkwd_clust_cfg_xclust_parm1             	0x0b
#define hkwd_clust_cfg_xclust_parm2             	0x0c
#define hkwd_clust_cfg_xclust_parm3             	0x0d
#define hkwd_clust_cfg_xclust_qry1              	0x0e
#define hkwd_clust_cfg_xclust_qry2              	0x0f
#define hkwd_clust_cfg_xclust_qry3              	0x10
#define hkwd_clust_cfg_xclust_qry4              	0x11
#define hkwd_clust_cfg_xclust_qry5              	0x12
#define hkwd_clust_cfg_xclust_qry6              	0x13
#define hkwd_clust_cfg_xclust_qry7              	0x14
#define hkwd_clust_cfg_xclust_qry8              	0x15
#define hkwd_clust_cfg_xclust_qry9              	0x16
#define hkwd_clust_cfg_xclust_qry10             	0x17
#define hkwd_clust_cfg_xclust_qry11             	0x18
#define hkwd_clust_cfg_xclust_qry12             	0x19
#define hkwd_clust_cfg_xclust_qry13             	0x1a
#define hkwd_clust_cfg_xclust_qry14             	0x1b
#define hkwd_clust_cfg_xclust_creat1            	0x1c
#define hkwd_clust_cfg_xclust_creat2            	0x1d
#define hkwd_clust_cfg_xclust_creat3            	0x1e
#define hkwd_clust_cfg_xclust_creat4            	0x1f
#define hkwd_clust_cfg_xclust_creat5            	0x20
#define hkwd_clust_cfg__xclust_creat1           	0x21
#define hkwd_clust_cfg__xclust_creat2           	0x22
#define hkwd_clust_cfg__xclust_creat3           	0x23
#define hkwd_clust_cfg__xclust_creat4           	0x24
#define hkwd_clust_cfg__xclust_creat5           	0x25
#define hkwd_clust_cfg__xclust_creat6           	0x26
#define hkwd_clust_cfg__xclust_creat7           	0x27
#define hkwd_clust_cfg__xclust_creat8           	0x28
#define hkwd_clust_cfg__xclust_creat9           	0x29
#define hkwd_clust_cfg__xclust_creat10          	0x2a
#define hkwd_clust_cfg__xclust_creat11          	0x2b
#define hkwd_clust_cfg__xclust_creat12          	0x2c
#define hkwd_clust_cfg__xclust_creat13          	0x2d
#define hkwd_clust_cfg__xclust_creat14          	0x2e
#define hkwd_clust_cfg__xclust_creat15          	0x2f
#define hkwd_clust_cfg__xclust_creat16          	0x30
#define hkwd_clust_cfg__xclust_creat17          	0x31
#define hkwd_clust_cfg__xclust_creat18          	0x32
#define hkwd_clust_cfg__xclust_creat19          	0x33
#define hkwd_clust_cfg__xclust_creat20          	0x34
#define hkwd_clust_cfg__xclust_creat21          	0x35
#define hkwd_clust_cfg_xclust_mod1              	0x36
#define hkwd_clust_cfg_xclust_mod2              	0x37
#define hkwd_clust_cfg_xclust_mod3              	0x38
#define hkwd_clust_cfg_xclust_mod4              	0x39
#define hkwd_clust_cfg_xclust_mod5              	0x3a
#define hkwd_clust_cfg_xclust_mod6              	0x3b
#define hkwd_clust_cfg_xclust_mod7              	0x3c
#define hkwd_clust_cfg_xclust_mod8              	0x3d
#define hkwd_clust_cfg_xclust_mod9              	0x3e
#define hkwd_clust_cfg_xclust_mod10             	0x3f
#define hkwd_clust_cfg_xclust_mod11             	0x40
#define hkwd_clust_cfg_xclust_mod12             	0x41
#define hkwd_clust_cfg_xclust_mod13             	0x42
#define hkwd_clust_cfg_xclust_mod14             	0x43
#define hkwd_clust_cfg_xclust_mod15             	0x44
#define hkwd_clust_cfg_xclust_mod16             	0x45
#define hkwd_clust_cfg_xclust_mod17             	0x46
#define hkwd_clust_cfg_xclust_mod18             	0x47
#define hkwd_clust_cfg_xclust_mod19             	0x48
#define hkwd_clust_cfg_xclust_mod20             	0x49
#define hkwd_clust_cfg_xclust_mod21             	0x4a
#define hkwd_clust_cfg_xclust_mod22             	0x4b
#define hkwd_clust_cfg_xclust_mod23             	0x4c
#define hkwd_clust_cfg_xclust_mod24             	0x4d
#define hkwd_clust_cfg_xclust_mod25             	0x4e
#define hkwd_clust_cfg_xclust_del1              	0x4f
#define hkwd_clust_cfg_xclust_del2              	0x50
#define hkwd_clust_cfg_xclust_del3              	0x51
#define hkwd_clust_cfg_xclust_del4              	0x52
#define hkwd_clust_cfg_xclust_del5              	0x53
#define hkwd_clust_cfg_xclust_del6              	0x54
#define hkwd_clust_cfg_xclust_del7              	0x55
#define hkwd_clust_cfg_xclust_del8              	0x56
#define hkwd_clust_cfg_xclust_del9              	0x57
#define hkwd_clust_cfg_xclust_del10             	0x58
#define hkwd_clust_cfg_xclust_del11             	0x59
#define hkwd_clust_cfg_xclust_del12             	0x5a
#define hkwd_clust_cfg_xclust_del13             	0x5b
#define hkwd_clust_cfg_xclust_node_qry1         	0x5c
#define hkwd_clust_cfg_xclust_node_qry2         	0x5d
#define hkwd_clust_cfg_xclust_node_qry3         	0x5e
#define hkwd_clust_cfg_xclust_node_qry4         	0x5f
#define hkwd_clust_cfg_xclust_node_qry5         	0x60
#define hkwd_clust_cfg_xclust_node_qry6         	0x61
#define hkwd_clust_cfg_xclust_node_qry7         	0x62
#define hkwd_clust_cfg_xclust_node_qry8         	0x63
#define hkwd_clust_cfg_xclust_node_qry9         	0x64
#define hkwd_clust_cfg_xclust_node_qry10        	0x65
#define hkwd_clust_cfg_xclust_node_qry11        	0x66
#define hkwd_clust_cfg_xclust_node_qry12        	0x67
#define hkwd_clust_cfg_xclust_node_qry13        	0x68
#define hkwd_clust_cfg_xclust_node_qry14        	0x69
#define hkwd_clust_cfg_xclust_node_qry15        	0x6a
#define hkwd_clust_cfg_xclust_node_qry16        	0x6b
#define hkwd_clust_cfg_xclust_stat1             	0x6c
#define hkwd_clust_cfg_xclust_stat2             	0x6d
#define hkwd_clust_cfg_xclust_stat3             	0x6e
#define hkwd_clust_cfg_xclust_find_nod1         	0x6f
#define hkwd_clust_cfg_xclust_find_nod2         	0x70
#define hkwd_clust_cfg_xclust_find_nod3         	0x71
#define hkwd_clust_cfg_xclust_find_nod4         	0x72
#define hkwd_clust_cfg_xclust_find_nod5         	0x73
#define hkwd_clust_cfg_xclust_find_nod6         	0x74
#define hkwd_clust_cfg_xclust_loc_ndflags       	0x75
#define hkwd_clust_cfg_xclust_zones_qry1        	0x76
#define hkwd_clust_cfg_xclust_zones_qry2        	0x77
#define hkwd_clust_cfg_xclust_zones_qry3        	0x78
#define hkwd_clust_cfg_xclust_zones_qry4        	0x79
#define hkwd_clust_cfg_xclust_zones_qry5        	0x7a
#define hkwd_clust_cfg_xclust_zones_qry6        	0x7b
#define hkwd_clust_cfg_xclust_zones_qry7        	0x7c
#define hkwd_clust_cfg_xclust_zones_qry8        	0x7d
#define hkwd_clust_cfg_clust_rem_node1          	0x7e
#define hkwd_clust_cfg_clust_rem_node2          	0x7f
#define hkwd_clust_cfg_clust_rem_node3          	0x80
#define hkwd_clust_cfg_clust_rem_node4          	0x81
#define hkwd_clust_cfg_clust_free1              	0x82
#define hkwd_clust_cfg_clust_free2              	0x83
#define hkwd_clust_cfg_clust_free4              	0x85
#define hkwd_clust_cfg_clust_free5              	0x86
#define hkwd_clust_cfg_knd_init1                	0x87
#define hkwd_clust_cfg_knd_init2                	0x88
#define hkwd_clust_cfg_knd_init3                	0x89
#define hkwd_clust_cfg_knd_init4                	0x8a
#define hkwd_clust_cfg_knd_init5                	0x8b
#define hkwd_clust_cfg_valid_lnk1               	0x8c
#define hkwd_clust_cfg_valid_lnk2               	0x8d
#define hkwd_clust_cfg_valid_lnk3               	0x8e
#define hkwd_clust_cfg_valid_lnk4               	0x8f
#define hkwd_clust_cfg_valid_lnk5               	0x90
#define hkwd_clust_cfg_alloc_init1              	0x91
#define hkwd_clust_cfg_alloc_init2              	0x92
#define hkwd_clust_cfg_alloc_init3              	0x93
#define hkwd_clust_cfg_alloc_init4              	0x94
#define hkwd_clust_cfg_sec_encrypt1             	0x95
#define hkwd_clust_cfg_sec_encrypt2             	0x96
#define hkwd_clust_cfg_sec_encrypt3             	0x97
#define hkwd_clust_cfg_sec_encrypt4             	0x98
#define hkwd_clust_cfg_sec_encrypt5             	0x99
#define hkwd_clust_cfg_sec_encrypt6             	0x9a
#define hkwd_clust_cfg_sec_decrypt1             	0x9b
#define hkwd_clust_cfg_sec_decrypt2             	0x9c
#define hkwd_clust_cfg_sec_decrypt3             	0x9d
#define hkwd_clust_cfg_sec_decrypt4             	0x9e
#define hkwd_clust_cfg_sec_decrypt5             	0x9f
#define hkwd_clust_cfg_sec_decrypt6             	0xa0
#define hkwd_clust_cfg_init_err11               	0xa1
#define hkwd_clust_cfg_init_err12               	0xa2
#define hkwd_clust_cfg_process_msg_sec1         	0xa3
#define hkwd_clust_cfg_sec_thrd1                	0xa4
#define hkwd_clust_cfg_sec_thrd2                	0xa5
#define hkwd_clust_cfg_sec_thrd3                	0xa6
#define hkwd_clust_cfg_sec_thrd4                	0xa7
#define hkwd_clust_cfg_sec_thrd5                	0xa8
#define hkwd_clust_cfg_sec_thrd6                	0xa9
#define hkwd_clust_cfg_sec_thrd7                	0xaa
#define hkwd_clust_cfg_sec_thrd8                	0xab
#define hkwd_clust_cfg_sec_thrd9                	0xac
#define hkwd_clust_cfg_sec_proc                 	0xad
#define hkwd_clust_cfg_caa_security1            	0xae
#define hkwd_clust_cfg_caa_security2            	0xaf
#define hkwd_clust_cfg_caa_security3            	0xb0
#define hkwd_clust_cfg_caa_security4            	0xb1
#define hkwd_clust_cfg_caa_security5            	0xb2
#define hkwd_clust_cfg_caa_security6            	0xb3
#define hkwd_clust_cfg_caa_security7            	0xb4
#define hkwd_clust_cfg_caa_security8            	0xb5
#define hkwd_clust_cfg_caa_security9            	0xb6
#define hkwd_clust_cfg_caa_security10           	0xb7
#define hkwd_clust_cfg_caa_security11           	0xb8
#define hkwd_clust_cfg_caa_security12           	0xb9
#define hkwd_clust_cfg_caa_security13           	0xba
#define hkwd_clust_cfg_caa_security14           	0xbb
#define hkwd_clust_cfg_caa_security15           	0xbc
#define hkwd_clust_cfg_caa_security16           	0xbd
#define hkwd_clust_cfg_caa_security17           	0xbe
#define hkwd_clust_cfg_caa_security18           	0xbf
#define hkwd_clust_cfg_caa_security19           	0xc0
#define hkwd_clust_cfg_caa_security20           	0xc1
#define hkwd_clust_cfg_caa_security21           	0xc2
#define hkwd_clust_cfg_caa_security22           	0xc3
#define hkwd_clust_cfg_caa_security23           	0xc4
#define hkwd_clust_cfg_caa_security24           	0xc5
#define hkwd_clust_cfg_caa_security25           	0xc6
#define hkwd_clust_cfg_caa_security26           	0xc7

#define PV_HKWD_DD_EMFCS           			0x10350000
#define PV_HKWD_DD_EMFCS_DETAIL           		0x10360000
#define PV_HKWD_DD_EMFCP           			0x10370000
#define PV_HKWD_DD_EMFCP_DETAIL         		0x10380000
#define PV_HKWD_DD_EMFCS_DETAIL1           		0x10390000
#define PV_HKWD_LNCENT_OTHER           			0x103c0000
#define PV_HKWD_LNCENT_RESPONSE          		0x103d0000
#define PV_HKWD_LNCENT_TRANSMIT           		0x103e0000
#define PV_HKWD_LNCENT_RECEIVE         			0x103f0000
#define PV_HKWD_ENTCORE_NORMAL          		0x10450000
#define PV_HKWD_ENTCORE_ERROR           		0x10460000
#define PV_HKWD_DD_XHCIDD           			0x10560000
#define PV_HKWD_DD_XHCIDD_ERR           		0x10570000
#define PV_HKWD_DD_CORFPGA           			0x105C0000
#define PV_HKWD_SHIENT_OTHER           			0x105D0000
#define PV_HKWD_SHIENT_RESPONSE          		0x105E0000

#endif /* _H_TRCHKID_EXTENDED */


#endif /* _H_TRCHKID */
